#****************************************************************************
#         The scope of use of the material contained herein is limited
#         strictly to the terms of the agreement which grants permission
#         for the use of the material.  Distribution of this material
#            and all copies thereof to any entity other than the one
#           mentioned in the agreement, as the term is defined in the
#        agreement, is strictly forbidden without a prior written consent.
#****************************************************************************
#****************************************************************************
# 
#  Code generator script - top logic
#
#  Filename        :  chip_top-gen.py
#  Revision        :  $Revision: 1.0 $
#  Checkin Date    :  $Date: 2008/05/28 12:29:59 $
#  Last checkin by :  $Author: teleistad $
#  SVN State       :  $State: Exp $
#
#  Project         :  Master Thesis
#
#  Author          :  <Tor Erik Leistad>
#  Date            :  <02.2008>
#
#****************************************************************************


from sys import stdin

print ""
print "Chip_top"
print ""
print "Top module file, used to connect CUT to the rest of the chip"
print "only wire and assign statements are allowed, this is part of"
print "the netlist"
print ""

#variables
extscanchains = 0
intscanchains = 0

#read from conf file
confFile = open('../../../rtl/module/chip/include/chip_params.v', 'r')
topFile = open('../../../rtl/module/chip/verilog/chip_top.v', 'w')

#parse conf file
line = confFile.readline()
linecmd = line.partition(" ")

while line : 
    if linecmd[0][0:1] == "//" or linecmd[0] == "//\r\n" or linecmd[0] == "//\n":
        line = confFile.readline()
        linecmd = line.partition(" ")
    if linecmd[0] == "parameter" :
        linevar = linecmd[2].partition(" ")
        if linevar[0] == "NUM_SCAN_CHAINS" :
            var = linevar[2].partition("=")
            var = var[2].partition(";")
            intscanchains = int(var[0])
        if linevar[0] == "NUM_EXT_SCAN_CHAINS" :
            var = linevar[2].partition("=")
            var = var[2].partition(";")
            extscanchains = int(var[0])
    line = confFile.readline()
    linecmd = line.partition(" ")

confFile.close()

#write top file
topFile.write("//Autogenerated file - do not edit\n\n")
topFile.write("module chip_top(sdo, bist_done, conf_scan_out,ext_scan_out, sdi, rst_n,\n")
topFile.write("                ss_n, sclk, ext_scan_in, ext_scan_en, ext_test_en,\n")
topFile.write("                bist_start, ext_clk, conf_scan_in, conf_scan_en);\n")
topFile.write("   \n")
topFile.write("   output sdo;\n")
topFile.write("   output bist_done;\n")
topFile.write("   output conf_scan_out;\n")
topFile.write("   output ["+str(extscanchains-1)+":0] ext_scan_out;\n")
topFile.write("   \n")
topFile.write("   input sdi;\n")
topFile.write("   input rst_n;\n")
topFile.write("   input ss_n;\n")
topFile.write("   input sclk;\n")
topFile.write("   input ["+str(extscanchains-1)+":0] ext_scan_in;\n")
topFile.write("   input ext_scan_en;\n")
topFile.write("   input ext_test_en;\n")
topFile.write("   input bist_start;\n")
topFile.write("   input ext_clk;\n")
topFile.write("   input conf_scan_in;\n")
topFile.write("   input conf_scan_en;\n")
topFile.write("   \n")

for i in range(1,intscanchains+1):
    topFile.write("   wire test_si"+str(i)+";\n")
        
topFile.write("   \n")

for i in range(1,intscanchains+1):
    topFile.write("   wire test_so"+str(i)+";\n")
        
topFile.write("   \n")
topFile.write("   wire test_se;\n")
topFile.write("   \n")
topFile.write("   wire osc_clk;\n")
topFile.write("   wire sys_clk;\n")
topFile.write("   wire [2:0] debug;\n")
topFile.write("   wire ["+str(intscanchains-1)+":0] scan_inputs;\n")
topFile.write("   wire ["+str(intscanchains-1)+":0] scan_outputs;\n")
topFile.write("   \n")

topFile.write("   assign scan_outputs = {")
for i in range(1,intscanchains+1):
    topFile.write("test_so"+str(intscanchains-i+1))
    if i < (intscanchains):
        topFile.write(", ")
topFile.write("};\n")

topFile.write("   \n")
for i in range(1,intscanchains+1):
    topFile.write("   assign test_si"+str(i)+" = scan_inputs["+str(i-1)+"];\n")


topFile.write("   \n")

topFile.write("   chip U_CHIP(\n")
topFile.write("               .bist_done (bist_done),\n")
topFile.write("               .conf_scan_out (conf_scan_out),\n")
topFile.write("               .scan_inputs (scan_inputs),\n")
topFile.write("               .scan_en (test_se),\n")
topFile.write("               .ext_scan_out (ext_scan_out),\n")
topFile.write("               .sys_clk (sys_clk),\n")
topFile.write("               .rst_n (rst_n),\n")
topFile.write("               .ext_clk (ext_clk),\n")
topFile.write("               .bist_start (bist_start),\n")
topFile.write("               .ext_test_en (ext_test_en),\n")
topFile.write("               .ext_scan_en (ext_scan_en),\n")
topFile.write("               .ext_scan_in (ext_scan_in),\n")
topFile.write("               .conf_scan_en (conf_scan_en),\n")
topFile.write("               .conf_scan_in (conf_scan_in),\n")
topFile.write("               .scan_outputs (scan_outputs),\n")
topFile.write("               .osc_clk (osc_clk));\n")

topFile.write("   \n")

topFile.write("   spi_co_processor U_SPI_CO_PROCESSOR(\n")
topFile.write("               .sdo (sdo),\n")
topFile.write("               .debug (debug),\n")
topFile.write("               .rst_n (rst_n),\n")
topFile.write("               .clk (sys_clk),\n")
topFile.write("               .sdi (sdi),\n")
topFile.write("               .ss_n (ss_n),\n")
topFile.write("               .sclk (sclk),\n")
topFile.write("               .test_se (test_se),\n")
for i in range(1,intscanchains+1):
    topFile.write("               .test_si"+str(i)+" (test_si"+str(i)+"),\n")
    topFile.write("               .test_so"+str(i)+" (test_so"+str(i)+")")
    if i < intscanchains :
        topFile.write(",\n")
topFile.write(");\n")

topFile.write("   \n")
topFile.write("   osc U_OSC(.osc_clk(osc_clk));\n")
topFile.write("   \n")
topFile.write("endmodule\n")
topFile.write("   \n")

topFile.close()
