#****************************************************************************
#         The scope of use of the material contained herein is limited
#         strictly to the terms of the agreement which grants permission
#         for the use of the material.  Distribution of this material
#            and all copies thereof to any entity other than the one
#           mentioned in the agreement, as the term is defined in the
#        agreement, is strictly forbidden without a prior written consent.
#****************************************************************************
#****************************************************************************
# 
#  Code generator script - concentrator logic
#
#  Filename        :  concentrator-gen.py
#  Revision        :  $Revision: 1.0 $
#  Checkin Date    :  $Date: 2008/05/28 12:29:59 $
#  Last checkin by :  $Author: teleistad $
#  SVN State       :  $State: Exp $
#
#  Project         :  Master Thesis
#
#  Author          :  <Tor Erik Leistad>
#  Date            :  <02.2008>
#
#****************************************************************************

from sys import stdin
import math

print ""
print "Concentrator-generator"
print ""
print "Reads info from configuration file and generate an concentrator"
print ""

confFile  = open('../../../rtl/module/chip/include/chip_params.v','r')
CFile = open('../../../rtl/module/concentrator/custom/verilog/concentrator.v', 'w')

inputs = 1
outputs = 1

#pars conf file
line = confFile.readline()
linecmd = line.partition(" ")

while line : 
    if linecmd[0][0:1] == "//" or linecmd[0] == "//\r\n" or linecmd[0] == "//\n":
        line = confFile.readline()
        linecmd = line.partition(" ")
    if linecmd[0] == "parameter" :
        linevar = linecmd[2].partition(" ")
        if linevar[0] == "PS_OUTPUTS" :
            var = linevar[2].partition("=")
            var = var[2].partition(";")
            inputs = int(var[0])
        if linevar[0] == "MISR_BITS" :
            var = linevar[2].partition("=")
            var = var[2].partition(";")
            outputs = int(var[0])
    line = confFile.readline()
    linecmd = line.partition(" ")

print "Input bits :" + str(inputs)
print "Output bits:" + str(outputs)

confFile.close()

#generate verilog file
print "Generating verilog"
CFile.write("//Autogenerated file - do not edit\n\n")
CFile.write("module concentrator(\n")
CFile.write("   //outputs\n")
CFile.write("   concentrator_out,\n")
CFile.write("   //inputs\n")
CFile.write("   concentrator_in\n")
CFile.write("   );\n")
CFile.write("\n")
CFile.write("   output ["+str(outputs-1)+":0] concentrator_out;\n")
CFile.write("   input  ["+str(inputs-1)+":0]  concentrator_in;\n")
CFile.write("\n")
CFile.write("\n")

inxor = int(math.floor(inputs/outputs))
extranum = inputs%outputs
nonextra = outputs - extranum

incount = 0
for i in range(0,outputs) :
    CFile.write("   assign concentrator_out["+str(i)+"] = concentrator_in["+str(incount)+"]")
    incount = incount + 1
    for j in range(1,inxor) :
        CFile.write(" ^ concentrator_in["+str(incount)+"]")
        incount = incount + 1
    
    if i >= nonextra :
        CFile.write(" ^ concentrator_in["+str(incount)+"]")
        incount = incount + 1 
    
    CFile.write(";\n")

CFile.write("\n")
CFile.write("endmodule\n")

CFile.close()
