#****************************************************************************
#         The scope of use of the material contained herein is limited
#         strictly to the terms of the agreement which grants permission
#         for the use of the material.  Distribution of this material
#            and all copies thereof to any entity other than the one
#           mentioned in the agreement, as the term is defined in the
#        agreement, is strictly forbidden without a prior written consent.
#****************************************************************************
#****************************************************************************
# 
#  Code generator script - flipping logic
#
#  Filename        :  flipping-gen.py
#  Revision        :  $Revision: 1.0 $
#  Checkin Date    :  $Date: 2008/05/28 12:29:59 $
#  Last checkin by :  $Author: teleistad $
#  SVN State       :  $State: Exp $
#
#  Project         :  Master Thesis
#
#  Author          :  <Tor Erik Leistad>
#  Date            :  <02.2008>
#
#****************************************************************************

from sys import stdin

print ""
print "Bit Flipping-generator"
print ""
print "Reads info from configuration file and generate an bit flipping module"
print ""

#variables that will be read from conf files (added some test values)
bitwidth = 32

#read configuration files
confFile = open('../../../rtl/module/chip/include/chip_params.v','r')
BFFile = open('../../../rtl/module/flipping/custom/verilog/flipping.v', 'w')

#pars conf file
line = confFile.readline()
linecmd = line.partition(" ")

while line : 
    if linecmd[0][0:1] == "//" or linecmd[0] == "//\r\n" or linecmd[0] == "//\n":
        line = confFile.readline()
        linecmd = line.partition(" ")
    if linecmd[0] == "parameter" :
        linevar = linecmd[2].partition(" ")
        if linevar[0] == "PS_OUTPUTS" :
            var = linevar[2].partition("=")
            var = var[2].partition(";")
            bitwidth = int(var[0])
    line = confFile.readline()
    linecmd = line.partition(" ")

print "Bitwidth is " + str(bitwidth)

confFile.close()

print "Generating verilog for bit flipping"

#generate verilog:
BFFile.write("//Autogenerated file - do not edit\n\n")
BFFile.write("module flipping(\n")
BFFile.write("    //outputs\n")
BFFile.write("    flipping_out,\n")
BFFile.write("    //inputs\n")
BFFile.write("    flipping_in,\n")
BFFile.write("    flipping_sel\n")
BFFile.write("    );\n")
BFFile.write("\n")
BFFile.write("    output ["+str(bitwidth-1)+":0] flipping_out;\n")
BFFile.write("    input  ["+str(bitwidth-1)+":0] flipping_in;\n")
BFFile.write("    input  ["+str(bitwidth-1)+":0] flipping_sel;\n")
BFFile.write("\n")
BFFile.write("\n")
BFFile.write("    assign flipping_out = flipping_in ^ flipping_sel;\n")
BFFile.write("\n")
BFFile.write("\n")
BFFile.write("endmodule //flipping\n")


BFFile.close()