#****************************************************************************
#         The scope of use of the material contained herein is limited
#         strictly to the terms of the agreement which grants permission
#         for the use of the material.  Distribution of this material
#            and all copies thereof to any entity other than the one
#           mentioned in the agreement, as the term is defined in the
#        agreement, is strictly forbidden without a prior written consent.
#****************************************************************************
#****************************************************************************
# 
#  Code generator script - weighting logic
#
#  Filename        :  weighting-gen.py
#  Revision        :  $Revision: 1.0 $
#  Checkin Date    :  $Date: 2008/05/28 12:29:59 $
#  Last checkin by :  $Author: teleistad $
#  SVN State       :  $State: Exp $
#
#  Project         :  Master Thesis
#
#  Author          :  <Tor Erik Leistad>
#  Date            :  <02.2008>
#
#****************************************************************************

from sys import stdin
import math

print ""
print "Weighting-generator"
print ""
print "Reads info from configuration files and generate an weighting"
print "module"
print ""

weights = 0
weight_w = []
inouts = 0


confFile = open('../../../rtl/module/chip/include/chip_params.v', 'r')
WFile = open('../../../rtl/module/weighting/custom/verilog/weighting.v', 'w')

#pars conf file
line = confFile.readline()
linecmd = line.partition(" ")

weightcount = 0
while line : 
    if linecmd[0][0:1] == "//" or linecmd[0] == "//\r\n" or linecmd[0] == "//\n":
        line = confFile.readline()
        linecmd = line.partition(" ")
    if linecmd[0] == "parameter" :
        linevar = linecmd[2].partition(" ")
        if linevar[0] == "WEIGHTING_WEIGHTS" :
            var = linevar[2].partition("=")
            var = var[2].partition(";")
            weights = int(var[0])
        if linevar[0] == ("WEIGHTING_W"+str(weightcount)) :
            var = linevar[2].partition("=")
            var = var[2].partition(";")
            weight_w.append(int(var[0]))
            weightcount = weightcount + 1
        if linevar[0] == "PS_OUTPUTS" :
            var = linevar[2].partition("=")
            var = var[2].partition(";")
            inouts = int(var[0])
    line = confFile.readline()
    linecmd = line.partition(" ")

    
print "Number of weights : " + str(weights)
print "The weights are : " + str(weight_w)
print "Number of inputs and outputs : " + str(inouts)

confFile.close()

print " "
print "Generating verilog for weighting module"

WFile.write("//autogenerated file - do not edit\n\n")
WFile.write("module weighting(\n")
WFile.write("   //outputs\n")
WFile.write("   weighting_out,\n")
WFile.write("   //inputs\n")
WFile.write("   weighting_in,\n")
WFile.write("   weighting_sel\n")
WFile.write("   );\n")
WFile.write("\n")
WFile.write("   output ["+str(inouts-1)+":0] weighting_out;\n")
WFile.write("   input  ["+str(inouts-1)+":0] weighting_in;\n")
WFile.write("   input  ["+str(int(math.ceil(math.log(weights,2)))-1)+":0] weighting_sel;\n")
WFile.write("\n")

foo = 2;
signals = []
signals.append(foo)
while foo < weight_w[weights-1] :
    foo = foo*2
    signals.append(foo)

for i in signals:
    WFile.write("   wire ["+str(inouts-1)+":0] w"+str(i)+";\n")

WFile.write("\n")
WFile.write("   reg ["+str(inouts-1)+":0] weighting_out;\n")
WFile.write("\n")
WFile.write("   assign w2 = weighting_in;\n")

foo = 0
for i in signals :
    if i != 2:
        foo = foo + 1
        WFile.write("   assign w"+str(i)+" = w"+str(i/2))
        WFile.write(" & {weighting_in["+str(foo-1)+":"+str(0)+"],weighting_in["+str(inouts-1)+":"+str(foo)+"]};\n")

WFile.write("\n")

WFile.write("   always @ (weighting_in or weighting_sel");

for i in signals:
    WFile.write(" or w"+str(i))
WFile.write(")\n")

WFile.write("       case (weighting_sel)\n")
for i in range(0,len(weight_w)) :
    WFile.write("           "+str(i)+" : weighting_out = w"+str(weight_w[i])+";\n")
WFile.write("           default : weighting_out = w2;\n")
WFile.write("       endcase\n")
WFile.write("\n")
WFile.write("\n")
WFile.write("endmodule\n")


WFile.close()
