//****************************************************************************
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the agreement which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than the one
//           mentioned in the agreement, as the term is defined in the
//        agreement, is strictly forbidden without a prior written consent.
//****************************************************************************
//****************************************************************************
// 
//  RTL IMPLEMENTATION, Delay-fault BIST in low-power CMOS devices 
//
//  Filename        :  bistcontroller_params.v
//  Revision        :  $Revision: 1.0 $
//  Checkin Date    :  $Date: 2008/05/28 12:29:59 $
//  Last checkin by :  $Author: teleistad $
//  SVN State       :  $State: Exp $
//
//  Project         :  Master Thesis
//  Module name     :  <>
//  Description     :  <parameter file>
//
//  Author          :  <Tor Erik Leistad>
//  Date            :  <02.2008>
//
//
//****************************************************************************


//this parameters sets the number of patterns to apply during
//differen stages of the BIST test. these values are loaded to the
//patterncounter during bist. Maybe these should be implemented as an RAM
//that can be reconfigured?. In that case these parameters can be used as
//default values
parameter CONFCOUNTER           = 8; //7 test + 1 mode bit //modifications include _fsm.v
parameter CONFCOUNTERSIZE       = 3; //log2 of confcounter
parameter BIST_CONF             = 8'b01111110; //w4f,w4,w3f,w3,w2f,w2,r,mode

parameter PATTERNS              = 1023;//default number of patterns
parameter PATTERNCOUNTER_BITS   = 16; //limit to 65536 patterns max for each test, total 65536*7
parameter SHIFT_BITS            = 25; //number of bits to shift in
parameter SHIFTCOUNTER_BITS     = 8;  //this limits to maximum shift to 255, scan chains
                                      //must be shorter than 255 lements,

