//****************************************************************************
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the agreement which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than the one
//           mentioned in the agreement, as the term is defined in the
//        agreement, is strictly forbidden without a prior written consent.
//****************************************************************************
//****************************************************************************
// 
//  RTL IMPLEMENTATION, Delay-fault BIST in low-power CMOS devices 
//
//  Filename        :  mux.v
//  Revision        :  $Revision: 1.0 $
//  Checkin Date    :  $Date: 2008/05/28 12:29:59 $
//  Last checkin by :  $Author: teleistad $
//  SVN State       :  $State: Exp $
//
//  Project         :  Master Thesis
//  Module name     :  <mux>
//  Description     :  <n bit 2-to-1 multiplexer>
//
//  Author          :  <Tor Erik Leistad>
//  Date            :  <02.2008>
//
//
//****************************************************************************

module mux(/*AUTOARG*/
  // Outputs
  out,
  // Inputs
  sel, ina, inb
  );

  parameter SIZE = 4;

  //outputs
  output [SIZE-1:0] out;

  //input
  input             sel;
  input [SIZE-1:0]  ina;
  input [SIZE-1:0]  inb;

  /*AUTOWIRE*/

  /*AUTOREG*/
  
  assign            out = sel ? ina : inb;

endmodule // mux
