//****************************************************************************
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the agreement which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than the one
//           mentioned in the agreement, as the term is defined in the
//        agreement, is strictly forbidden without a prior written consent.
//****************************************************************************
//****************************************************************************
// 
//  RTL IMPLEMENTATION, Delay-fault BIST in low-power CMOS devices 
//
//  Filename        :  osc.v
//  Revision        :  $Revision: 1.0 $
//  Checkin Date    :  $Date: 2008/05/28 12:29:59 $
//  Last checkin by :  $Author: teleistad $
//  SVN State       :  $State: Exp $
//
//  Project         :  Master Thesis
//  Module name     :  <osc>
//  Description     :  <oscillator for testbench use>
//
//  Author          :  <Tor Erik Leistad>
//  Date            :  <02.2008>
//
//
//****************************************************************************


module osc(/*AUTOARG*/
   // Outputs
   osc_clk
   );

   parameter clock_period = 2;
   
   //outputs
   output osc_clk;

   reg 	  osc_clk;
   
   /*
    * Generate clock
    *
    */
   initial begin
      osc_clk = 'b1;
   end
   always #(clock_period/2) osc_clk = !osc_clk;


endmodule // osc
