//****************************************************************************
//         The scope of use of the material contained herein is limited
//         strictly to the terms of the agreement which grants permission
//         for the use of the material.  Distribution of this material
//            and all copies thereof to any entity other than the one
//           mentioned in the agreement, as the term is defined in the
//        agreement, is strictly forbidden without a prior written consent.
//****************************************************************************
//****************************************************************************
// 
//  RTL IMPLEMENTATION, Delay-fault BIST in low-power CMOS devices 
//
//  Filename        :  chip_params.v
//  Revision        :  $Revision: 1.0 $
//  Checkin Date    :  $Date: 2008/05/28 12:29:59 $
//  Last checkin by :  $Author: teleistad $
//  SVN State       :  $State: Exp $
//
//  Project         :  Master Thesis
//  Module name     :  <>
//  Description     :  <parameter file for chip>
//
//  Author          :  <Tor Erik Leistad>
//  Date            :  <02.2008>
//
//
//****************************************************************************
//
//general configuration
//if 1 code will be generated and stitched together
//if 0 code will not be generated, and only those with
//1 are stitched together,
parameter BIST                  = 1;
parameter LFSR                  = 1;
parameter MISR                  = 1;
parameter PHASESHIFTER          = 1;
parameter WEIGHTING             = 1;
parameter FLIPPING              = 1;
parameter PLAIN                 = 1;

//TEST/BIST configuration
parameter NUM_EXT_SCAN_CHAINS   = 4;
parameter NUM_SCAN_CHAINS       = 16;
parameter SCAN_CHAIN_MAP        = NUM_SCAN_CHAINS/NUM_EXT_SCAN_CHAINS;
parameter LEN_SCAN_CHAINS       = 25;

//configuration file for MISR build
parameter PS_OUTPUTS            = 16;
parameter PS_MINSHIFT           = 10;
parameter PS_MAXONES            = 4;

//configuration file for MISR build
parameter MISR_BITS             = 10;

//configuration file for LFSR build
parameter LFSR_BITS             = 10;

//configuration file for weighting build
parameter WEIGHTING_SEL         = 2;
parameter WEIGHTING_WEIGHTS     = 4;
parameter WEIGHTING_W0          = 2;
parameter WEIGHTING_W1          = 4;
parameter WEIGHTING_W2          = 8;
parameter WEIGHTING_W3          = 16;

