//this module is autogenerated, do not edit!
module lfsr(
    //outputs
    lfsr_out,
    lfsr_so,
    //inputs
    lfsr_clk,
    lfsr_rst_n,
    lfsr_en,
    lfsr_load,
    lfsr_si
    );

    //outputs
    output lfsr_so;
    output [9:0] lfsr_out;
    //inputs
    input lfsr_clk;
    input lfsr_rst_n;
    input lfsr_en;
    input lfsr_load;
    input lfsr_si;
    
    reg [9:0] lfsr_value;
    
    assign lfsr_so = lfsr_value[0];
    assign lfsr_out = lfsr_value;
    
    always @ (posedge lfsr_clk or negedge lfsr_rst_n)
    begin
        if (lfsr_rst_n == 'b0)
            lfsr_value <= 'b1;
        else
            begin
                if (lfsr_load == 1'b1)
                    lfsr_value <= {lfsr_si,lfsr_value[9:1]};
                else
                    if (lfsr_en == 1'b1)
                        begin
                            //lfsr feedback connections
                            lfsr_value[9] <= lfsr_value[0];
                            lfsr_value[8] <= lfsr_value[9];
                            lfsr_value[7] <= lfsr_value[8];
                            lfsr_value[6] <= lfsr_value[7] ^ lfsr_value[0];
                            lfsr_value[5] <= lfsr_value[6];
                            lfsr_value[4] <= lfsr_value[5];
                            lfsr_value[3] <= lfsr_value[4];
                            lfsr_value[2] <= lfsr_value[3];
                            lfsr_value[1] <= lfsr_value[2];
                            lfsr_value[0] <= lfsr_value[1];
                        end
                    else
                        lfsr_value <= lfsr_value;
            end
    end
    
endmodule //lfsr

