//this module is autogenerated, do not edit!
module misr(
    //outputs
    misr_so,
    //inputs
    misr_clk,
    misr_rst_n,
    misr_en,
    misr_load,
    misr_si,
    misr_in
    );

    //outputs
    output misr_so;
    //inputs
    input misr_clk;
    input misr_rst_n;
    input misr_en;
    input misr_load;
    input misr_si;
    input [9:0] misr_in;
    
    reg [9:0] misr_value;
    
    assign misr_so = misr_value[0];
    
    always @ (posedge misr_clk or negedge misr_rst_n)
    begin
        if (misr_rst_n == 'b0)
            misr_value <= 'b0;
        else
            begin
                if (misr_load == 1'b1)
                    misr_value <= {misr_si,misr_value[9:1]};
                else
                    if (misr_en == 1'b1)
                        begin
                            //misr feedback connections
                            misr_value[9] <= misr_value[0] ^ misr_in[0];
                            misr_value[8] <= misr_value[9] ^ misr_in[1];
                            misr_value[7] <= misr_value[8] ^ misr_in[2];
                            misr_value[6] <= misr_value[7] ^ misr_value[0] ^ misr_in[3];
                            misr_value[5] <= misr_value[6] ^ misr_in[4];
                            misr_value[4] <= misr_value[5] ^ misr_in[5];
                            misr_value[3] <= misr_value[4] ^ misr_in[6];
                            misr_value[2] <= misr_value[3] ^ misr_in[7];
                            misr_value[1] <= misr_value[2] ^ misr_in[8];
                            misr_value[0] <= misr_value[1] ^ misr_in[9];
                        end
                    else
                        misr_value <= misr_value;
            end
    end
    
endmodule //misr

