
module clockmux2_1 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n2;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aor22d1ll U2 ( .a1(clk1), .a2(en1), .b1(en2), .b2(clk2), .z(clk_out) );
  aoi21d1ll U3 ( .b1(en1), .b2(n2), .a(clk2), .zn(N5) );
  nr03d1ll U4 ( .a1(clk_sel), .a2(en1), .a3(clk2), .zn(N3) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n2), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n2) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_3 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net265, net267, net269, net270, net273, net276;
  assign net265 = EN;
  assign net267 = CLK;
  assign ENCLK = net269;
  assign net276 = TE;

  an02d1ll main_gate ( .a1(net273), .a2(net267), .z(net269) );
  lanlq1ll latch ( .d(net270), .en(net267), .q(net273) );
  or02d1ll test_or ( .a1(net265), .a2(net276), .z(net270) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_2 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net265, net267, net269, net270, net273, net276;
  assign net265 = EN;
  assign net267 = CLK;
  assign ENCLK = net269;
  assign net276 = TE;

  an02d1ll main_gate ( .a1(net273), .a2(net267), .z(net269) );
  lanlq1ll latch ( .d(net270), .en(net267), .q(net273) );
  or02d1ll test_or ( .a1(net265), .a2(net276), .z(net270) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_1 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net265, net267, net269, net270, net273, net276;
  assign net265 = EN;
  assign net267 = CLK;
  assign ENCLK = net269;
  assign net276 = TE;

  an02d1ll main_gate ( .a1(net273), .a2(net267), .z(net269) );
  lanlq1ll latch ( .d(net270), .en(net267), .q(net273) );
  or02d1ll test_or ( .a1(net265), .a2(net276), .z(net270) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_0 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net265, net267, net269, net270, net273, net276;
  assign net265 = EN;
  assign net267 = CLK;
  assign ENCLK = net269;
  assign net276 = TE;

  an02d1ll main_gate ( .a1(net273), .a2(net267), .z(net269) );
  lanlq1ll latch ( .d(net270), .en(net267), .q(net273) );
  or02d1ll test_or ( .a1(net265), .a2(net276), .z(net270) );
endmodule


module mux_SIZE4_6 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n1;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n1), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n1), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n1), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n1), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n1) );
endmodule


module mux_SIZE4_5 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n1;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n1), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n1), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n1), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n1), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n1) );
endmodule


module mux_SIZE4_4 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n1;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n1), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n1), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n1), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n1), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n1) );
endmodule


module mux_SIZE4_3 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n1;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n1), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n1), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n1), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n1), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n1) );
endmodule


module mux_SIZE4_2 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n1;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n1), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n1), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n1), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n1), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n1) );
endmodule


module mux_SIZE4_1 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n1;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n1), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n1), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n1), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n1), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n1) );
endmodule


module mux_SIZE4_0 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n1;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n1), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n1), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n1), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n1), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n1) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_fsm ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net302, net304, net306, net307, net310, net313;
  assign net302 = EN;
  assign net304 = CLK;
  assign ENCLK = net306;
  assign net313 = TE;

  an02d1ll main_gate ( .a1(net310), .a2(net304), .z(net306) );
  lanlq1ll latch ( .d(net307), .en(net304), .q(net310) );
  or02d1ll test_or ( .a1(net302), .a2(net313), .z(net307) );
endmodule


module SNPS_CLOCK_GATE_HIGH_misr ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net231, net233, net235, net236, net239, net242;
  assign net231 = EN;
  assign net233 = CLK;
  assign ENCLK = net235;
  assign net242 = TE;

  an02d1ll main_gate ( .a1(net239), .a2(net233), .z(net235) );
  lanlq1ll latch ( .d(net236), .en(net233), .q(net239) );
  or02d1ll test_or ( .a1(net231), .a2(net242), .z(net236) );
endmodule


module SNPS_CLOCK_GATE_HIGH_lfsr ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net248, net250, net252, net253, net256, net259;
  assign net248 = EN;
  assign net250 = CLK;
  assign ENCLK = net252;
  assign net259 = TE;

  an02d1ll main_gate ( .a1(net256), .a2(net250), .z(net252) );
  lanlq1ll latch ( .d(net253), .en(net250), .q(net256) );
  or02d1ll test_or ( .a1(net248), .a2(net259), .z(net253) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_4 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net265, net267, net269, net270, net273, net276;
  assign net265 = EN;
  assign net267 = CLK;
  assign ENCLK = net269;
  assign net276 = TE;

  an02d1ll main_gate ( .a1(net273), .a2(net267), .z(net269) );
  lanlq1ll latch ( .d(net270), .en(net267), .q(net273) );
  or02d1ll test_or ( .a1(net265), .a2(net276), .z(net270) );
endmodule


module bistcontroller_fsm ( bist_done, bist_en, bist_scan_en, bist_lfsr_en, 
        bist_misr_en, bist_weight_sel, bist_weight_load, bist_flip_en, 
        bist_flip_load, bitcounter_inc, patterncounter_inc, testcounter_inc, 
        patterncounter_rst, bitcounter_rst, testcounter_rst, misr_enable_set, 
        bist_clk, bist_rst_n, bist_start, bit_counter_r, bits_to_apply_r, 
        pattern_counter_r, pattern_to_apply_r, test_counter_r, conf_r, 
        misr_enable_r );
  output [1:0] bist_weight_sel;
  input [7:0] bit_counter_r;
  input [7:0] bits_to_apply_r;
  input [15:0] pattern_counter_r;
  input [15:0] pattern_to_apply_r;
  input [2:0] test_counter_r;
  input [7:0] conf_r;
  input bist_clk, bist_rst_n, bist_start, misr_enable_r;
  output bist_done, bist_en, bist_scan_en, bist_lfsr_en, bist_misr_en,
         bist_weight_load, bist_flip_en, bist_flip_load, bitcounter_inc,
         patterncounter_inc, testcounter_inc, patterncounter_rst,
         bitcounter_rst, testcounter_rst, misr_enable_set;
  wire   bitcounter_inc, testcounter_inc, bitcounter_rst, N116, net318, n3, n4,
         n5, n6, n7, n12, n13, n14, n15, n17, n18, n19, n20, n21, n22, n23,
         n24, n25, n26, n27, n28, n29, n30, n31, n32, n33, n34, n35, n36, n37,
         n38, n39, n40, n41, n42, n43, n44, n45, n46, n47, n48, n49, n50, n51,
         n52, n53, n54, n55, n56, n57, n58, n59, n60, n61, n62, n63, n64, n65,
         n66, n67, n68, n69, n70, n71, n72, n73, n74, n75, n76, n77, n78, n79,
         n80, n81, n82, n83, n84, n86, n87, n88, n89, n90, n91, n92, n93, n94,
         n95, n96, n97, n98, n99, n100, n101, n1, n2, n8, n9, n10;
  wire   [3:0] currentstate;
  wire   [3:0] nextstate;
  assign bist_scan_en = bitcounter_inc;
  assign bist_lfsr_en = bitcounter_inc;
  assign patterncounter_rst = testcounter_inc;
  assign patterncounter_inc = bitcounter_rst;

  dfcrq1ll \currentstate_reg[0]  ( .d(nextstate[0]), .cp(net318), .cdn(
        bist_rst_n), .q(currentstate[0]) );
  dfcrq1ll \currentstate_reg[1]  ( .d(nextstate[1]), .cp(net318), .cdn(
        bist_rst_n), .q(currentstate[1]) );
  dfcrn1ll \currentstate_reg[2]  ( .d(nextstate[2]), .cp(net318), .cdn(
        bist_rst_n), .qn(n3) );
  aon211d1ll U5 ( .c1(conf_r[0]), .c2(n5), .b(n6), .a(n7), .zn(nextstate[2])
         );
  oai211d1ll U12 ( .c1(currentstate[0]), .c2(currentstate[1]), .a(n19), .b(n12), .zn(nextstate[0]) );
  aoi31d1ll U14 ( .b1(bitcounter_rst), .b2(n13), .b3(n14), .a(n21), .zn(n19)
         );
  oan211d1ll U15 ( .c1(conf_r[4]), .c2(n22), .b(n23), .a(n24), .zn(n21) );
  nr03d1ll U16 ( .a1(n25), .a2(n26), .a3(n27), .zn(n23) );
  oai22d1ll U17 ( .a1(conf_r[2]), .a2(n28), .b1(conf_r[6]), .b2(n29), .zn(n27)
         );
  oai22d1ll U18 ( .a1(conf_r[5]), .a2(n30), .b1(conf_r[3]), .b2(n31), .zn(n26)
         );
  oai22d1ll U19 ( .a1(conf_r[1]), .a2(n15), .b1(conf_r[7]), .b2(n32), .zn(n25)
         );
  nr04d1ll U21 ( .a1(n35), .a2(n36), .a3(n37), .a4(n38), .zn(n14) );
  oai221d1ll U22 ( .b1(n39), .b2(pattern_counter_r[0]), .c1(n40), .c2(
        pattern_counter_r[1]), .a(n41), .zn(n38) );
  aoi22d1ll U23 ( .a1(pattern_counter_r[0]), .a2(n39), .b1(
        pattern_counter_r[1]), .b2(n40), .zn(n41) );
  oai221d1ll U26 ( .b1(n42), .b2(pattern_counter_r[2]), .c1(n43), .c2(
        pattern_counter_r[3]), .a(n44), .zn(n37) );
  aoi22d1ll U27 ( .a1(pattern_counter_r[2]), .a2(n42), .b1(
        pattern_counter_r[3]), .b2(n43), .zn(n44) );
  oai221d1ll U30 ( .b1(n45), .b2(pattern_counter_r[4]), .c1(n46), .c2(
        pattern_counter_r[5]), .a(n47), .zn(n36) );
  aoi22d1ll U31 ( .a1(pattern_counter_r[4]), .a2(n45), .b1(
        pattern_counter_r[5]), .b2(n46), .zn(n47) );
  oai221d1ll U34 ( .b1(n48), .b2(pattern_counter_r[6]), .c1(n49), .c2(
        pattern_counter_r[7]), .a(n50), .zn(n35) );
  aoi22d1ll U35 ( .a1(pattern_counter_r[6]), .a2(n48), .b1(
        pattern_counter_r[7]), .b2(n49), .zn(n50) );
  nr04d1ll U38 ( .a1(n51), .a2(n52), .a3(n53), .a4(n54), .zn(n13) );
  oai221d1ll U39 ( .b1(n55), .b2(pattern_counter_r[10]), .c1(n56), .c2(
        pattern_counter_r[11]), .a(n57), .zn(n54) );
  aoi22d1ll U40 ( .a1(pattern_counter_r[10]), .a2(n55), .b1(
        pattern_counter_r[11]), .b2(n56), .zn(n57) );
  oai221d1ll U43 ( .b1(n58), .b2(pattern_counter_r[12]), .c1(n59), .c2(
        pattern_counter_r[13]), .a(n60), .zn(n53) );
  aoi22d1ll U44 ( .a1(pattern_counter_r[12]), .a2(n58), .b1(
        pattern_counter_r[13]), .b2(n59), .zn(n60) );
  oai221d1ll U47 ( .b1(n61), .b2(pattern_counter_r[14]), .c1(n62), .c2(
        pattern_counter_r[15]), .a(n63), .zn(n52) );
  aoi22d1ll U48 ( .a1(pattern_counter_r[14]), .a2(n61), .b1(
        pattern_counter_r[15]), .b2(n62), .zn(n63) );
  oai221d1ll U51 ( .b1(n64), .b2(pattern_counter_r[8]), .c1(n65), .c2(
        pattern_counter_r[9]), .a(n66), .zn(n51) );
  aoi22d1ll U52 ( .a1(pattern_counter_r[8]), .a2(n64), .b1(
        pattern_counter_r[9]), .b2(n65), .zn(n66) );
  aoi21d1ll U59 ( .b1(n69), .b2(n17), .a(n24), .zn(bist_weight_sel[0]) );
  aoi21d1ll U61 ( .b1(n18), .b2(n17), .a(n24), .zn(bist_weight_load) );
  aoi21d1ll U62 ( .b1(conf_r[2]), .b2(n71), .a(n72), .zn(n17) );
  aoi211d1ll U66 ( .c1(conf_r[4]), .c2(n73), .a(n74), .b(n70), .zn(n18) );
  oai21d1ll U67 ( .b1(n75), .b2(n29), .a(n76), .zn(n70) );
  nr04d1ll U87 ( .a1(n24), .a2(n83), .a3(n34), .a4(n81), .zn(bist_done) );
  aoi21d1ll U93 ( .b1(n4), .b2(n84), .a(bitcounter_inc), .zn(N116) );
  oai221d1ll U100 ( .b1(n90), .b2(bit_counter_r[2]), .c1(n91), .c2(
        bit_counter_r[3]), .a(n92), .zn(n89) );
  aoi22d1ll U101 ( .a1(bit_counter_r[2]), .a2(n90), .b1(bit_counter_r[3]), 
        .b2(n91), .zn(n92) );
  oai221d1ll U104 ( .b1(n93), .b2(bit_counter_r[0]), .c1(n94), .c2(
        bit_counter_r[1]), .a(n95), .zn(n88) );
  aoi22d1ll U105 ( .a1(bit_counter_r[0]), .a2(n93), .b1(bit_counter_r[1]), 
        .b2(n94), .zn(n95) );
  oai221d1ll U108 ( .b1(n96), .b2(bit_counter_r[6]), .c1(n97), .c2(
        bit_counter_r[7]), .a(n98), .zn(n87) );
  aoi22d1ll U109 ( .a1(bit_counter_r[6]), .a2(n96), .b1(bit_counter_r[7]), 
        .b2(n97), .zn(n98) );
  oai221d1ll U112 ( .b1(n99), .b2(bit_counter_r[4]), .c1(n100), .c2(
        bit_counter_r[5]), .a(n101), .zn(n86) );
  aoi22d1ll U113 ( .a1(bit_counter_r[4]), .a2(n99), .b1(bit_counter_r[5]), 
        .b2(n100), .zn(n101) );
  nr03d1ll U117 ( .a1(currentstate[0]), .a2(currentstate[2]), .a3(
        currentstate[1]), .zn(n4) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_fsm clk_gate_currentstate_reg ( .CLK(
        bist_clk), .EN(N116), .ENCLK(net318), .TE(1'b0) );
  inv0d1ll U115 ( .i(bits_to_apply_r[4]), .zn(n99) );
  inv0d1ll U114 ( .i(bits_to_apply_r[5]), .zn(n100) );
  inv0d1ll U111 ( .i(bits_to_apply_r[6]), .zn(n96) );
  inv0d1ll U110 ( .i(bits_to_apply_r[7]), .zn(n97) );
  inv0d1ll U107 ( .i(bits_to_apply_r[0]), .zn(n93) );
  inv0d1ll U106 ( .i(bits_to_apply_r[1]), .zn(n94) );
  inv0d1ll U103 ( .i(bits_to_apply_r[2]), .zn(n90) );
  inv0d1ll U102 ( .i(bits_to_apply_r[3]), .zn(n91) );
  inv0d1ll U88 ( .i(test_counter_r[1]), .zn(n81) );
  nd02d1ll U71 ( .a1(test_counter_r[0]), .a2(n78), .zn(n22) );
  inv0d1ll U90 ( .i(test_counter_r[2]), .zn(n83) );
  nd02d1ll U83 ( .a1(n77), .a2(n34), .zn(n30) );
  inv0d1ll U82 ( .i(conf_r[5]), .zn(n82) );
  nr02d1ll U81 ( .a1(n30), .a2(n82), .zn(n74) );
  nd02d1ll U68 ( .a1(test_counter_r[0]), .a2(n77), .zn(n29) );
  nd12d1ll U74 ( .a1(n32), .a2(conf_r[7]), .zn(n76) );
  nd02d1ll U64 ( .a1(test_counter_r[0]), .a2(n33), .zn(n28) );
  nd02d1ll U79 ( .a1(n78), .a2(n34), .zn(n31) );
  nr02d1ll U77 ( .a1(n31), .a2(n80), .zn(n72) );
  an02d1ll U4 ( .a1(n4), .a2(bist_start), .z(testcounter_rst) );
  nd02d1ll U20 ( .a1(n33), .a2(n34), .zn(n15) );
  nd02d1ll U13 ( .a1(conf_r[0]), .a2(n20), .zn(n12) );
  an02d1ll U55 ( .a1(n20), .a2(n67), .z(misr_enable_set) );
  nr04d1ll U99 ( .a1(n86), .a2(n87), .a3(n88), .a4(n89), .zn(n67) );
  an02d1ll U72 ( .a1(bitcounter_inc), .a2(misr_enable_r), .z(bist_misr_en) );
  oai211d1ll U85 ( .c1(currentstate[2]), .c2(n5), .a(n68), .b(n7), .zn(bist_en) );
  nr02d1ll U96 ( .a1(currentstate[2]), .a2(n68), .zn(n20) );
  inv0d1ll U116 ( .i(bist_start), .zn(n84) );
  nr03d1ll U92 ( .a1(currentstate[2]), .a2(currentstate[1]), .a3(n5), .zn(
        testcounter_inc) );
  nr02d1ll U80 ( .a1(test_counter_r[2]), .a2(n81), .zn(n78) );
  inv0d1ll U70 ( .i(n22), .zn(n73) );
  nr02d1ll U84 ( .a1(test_counter_r[1]), .a2(n83), .zn(n77) );
  inv0d1ll U89 ( .i(test_counter_r[0]), .zn(n34) );
  inv0d1ll U69 ( .i(conf_r[6]), .zn(n75) );
  nd03d1ll U75 ( .a1(n34), .a2(test_counter_r[1]), .a3(test_counter_r[2]), 
        .zn(n32) );
  nr02d1ll U65 ( .a1(test_counter_r[2]), .a2(test_counter_r[1]), .zn(n33) );
  inv0d1ll U63 ( .i(n28), .zn(n71) );
  inv0d1ll U78 ( .i(conf_r[3]), .zn(n80) );
  nr02d1ll U76 ( .a1(n74), .a2(n72), .zn(n79) );
  inv0d1ll U54 ( .i(pattern_to_apply_r[8]), .zn(n64) );
  inv0d1ll U53 ( .i(pattern_to_apply_r[9]), .zn(n65) );
  inv0d1ll U50 ( .i(pattern_to_apply_r[14]), .zn(n61) );
  inv0d1ll U49 ( .i(pattern_to_apply_r[15]), .zn(n62) );
  inv0d1ll U46 ( .i(pattern_to_apply_r[12]), .zn(n58) );
  inv0d1ll U45 ( .i(pattern_to_apply_r[13]), .zn(n59) );
  inv0d1ll U42 ( .i(pattern_to_apply_r[10]), .zn(n55) );
  inv0d1ll U41 ( .i(pattern_to_apply_r[11]), .zn(n56) );
  inv0d1ll U37 ( .i(pattern_to_apply_r[6]), .zn(n48) );
  inv0d1ll U36 ( .i(pattern_to_apply_r[7]), .zn(n49) );
  inv0d1ll U33 ( .i(pattern_to_apply_r[4]), .zn(n45) );
  inv0d1ll U32 ( .i(pattern_to_apply_r[5]), .zn(n46) );
  inv0d1ll U29 ( .i(pattern_to_apply_r[2]), .zn(n42) );
  inv0d1ll U28 ( .i(pattern_to_apply_r[3]), .zn(n43) );
  inv0d1ll U25 ( .i(pattern_to_apply_r[0]), .zn(n39) );
  inv0d1ll U24 ( .i(pattern_to_apply_r[1]), .zn(n40) );
  nr02d1ll U58 ( .a1(n18), .a2(n24), .zn(bist_weight_sel[1]) );
  inv0d1ll U60 ( .i(n70), .zn(n69) );
  nd02d1ll U97 ( .a1(currentstate[1]), .a2(n5), .zn(n68) );
  inv0d1ll U91 ( .i(testcounter_inc), .zn(n24) );
  aoi21d1ll U73 ( .b1(n79), .b2(n76), .a(n24), .zn(bist_flip_en) );
  inv0d1ll U98 ( .i(currentstate[0]), .zn(n5) );
  nd02d0ll U6 ( .a1(currentstate[1]), .a2(n3), .zn(n6) );
  nd12d1ll U86 ( .a1(currentstate[1]), .a2(currentstate[2]), .zn(n7) );
  nr02d1ll U3 ( .a1(n3), .a2(n68), .zn(bitcounter_rst) );
  inv0d1ll U7 ( .i(n20), .zn(n1) );
  nr02d1ll U8 ( .a1(n67), .a2(n1), .zn(bitcounter_inc) );
  nd02d0ll U9 ( .a1(n14), .a2(n13), .zn(n2) );
  inv0d0ll U10 ( .i(conf_r[1]), .zn(n8) );
  oai211d1ll U11 ( .c1(n15), .c2(n8), .a(n17), .b(n18), .zn(n9) );
  aoi22d1ll U56 ( .a1(bitcounter_rst), .a2(n2), .b1(testcounter_inc), .b2(n9), 
        .zn(n10) );
  oai211d1ll U57 ( .c1(n5), .c2(n7), .a(n12), .b(n10), .zn(nextstate[1]) );
  inv0d1ll U94 ( .i(n3), .zn(currentstate[2]) );
endmodule


module SNPS_CLOCK_GATE_HIGH_clockcontroller ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net214, net216, net218, net219, net222, net225;
  assign net214 = EN;
  assign net216 = CLK;
  assign ENCLK = net218;
  assign net225 = TE;

  an02d1ll main_gate ( .a1(net222), .a2(net216), .z(net218) );
  lanlq1ll latch ( .d(net219), .en(net216), .q(net222) );
  or02d1ll test_or ( .a1(net214), .a2(net225), .z(net219) );
endmodule


module clockmux2_0 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n1;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aor22d1ll U2 ( .a1(clk1), .a2(en1), .b1(en2), .b2(clk2), .z(clk_out) );
  aoi21d1ll U3 ( .b1(en1), .b2(n1), .a(clk2), .zn(N5) );
  nr03d1ll U4 ( .a1(clk_sel), .a2(en1), .a3(clk2), .zn(N3) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n1), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n1) );
endmodule


module clockmux2_2 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n1;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aor22d1ll U2 ( .a1(clk1), .a2(en1), .b1(en2), .b2(clk2), .z(clk_out) );
  aoi21d1ll U3 ( .b1(en1), .b2(n1), .a(clk2), .zn(N5) );
  nr03d1ll U4 ( .a1(clk_sel), .a2(en1), .a3(clk2), .zn(N3) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n1), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n1) );
endmodule


module clockmux2_3 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n1;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n1), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n1) );
  nd02d0ll U2 ( .a1(en1), .a2(n1), .zn(N5) );
  nr02d1ll U3 ( .a1(clk_sel), .a2(en1), .zn(N3) );
  an02d1ll U4 ( .a1(clk1), .a2(en1), .z(clk_out) );
endmodule


module clockmux2_4 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n1;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aor22d1ll U2 ( .a1(clk1), .a2(en1), .b1(en2), .b2(clk2), .z(clk_out) );
  aoi21d1ll U3 ( .b1(en1), .b2(n1), .a(clk2), .zn(N5) );
  nr03d1ll U4 ( .a1(clk_sel), .a2(en1), .a3(clk2), .zn(N3) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n1), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n1) );
endmodule


module misr ( misr_so, misr_clk, misr_rst_n, misr_en, misr_load, misr_si, 
        misr_in );
  input [31:0] misr_in;
  input misr_clk, misr_rst_n, misr_en, misr_load, misr_si;
  output misr_so;
  wire   N1, N34, N35, N36, N37, N38, N39, N40, N41, N42, N43, N44, N45, N46,
         N47, N48, N49, N50, N51, N52, N53, N54, N55, N56, N57, N58, N59, N60,
         N61, N62, N63, N64, N65, net247, n1, n2, n4, n5, n6, n7, n8, n9, n10,
         n11, n12, n13, n14, n15, n16, n17, n18, n19, n20, n21, n22, n23, n24,
         n25, n26, n27, n28, n29, n30, n31, n32, n33, n34, n35, n36, n37, n38,
         n3;
  wire   [31:1] misr_value;

  dfcrq1ll \misr_value_reg[0]  ( .d(N34), .cp(net247), .cdn(misr_rst_n), .q(
        misr_so) );
  dfcrq1ll \misr_value_reg[31]  ( .d(N65), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[31]) );
  dfcrq1ll \misr_value_reg[30]  ( .d(N64), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[30]) );
  dfcrq1ll \misr_value_reg[29]  ( .d(N63), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[29]) );
  dfcrq1ll \misr_value_reg[28]  ( .d(N62), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[28]) );
  dfcrq1ll \misr_value_reg[27]  ( .d(N61), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[27]) );
  dfcrq1ll \misr_value_reg[26]  ( .d(N60), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[26]) );
  dfcrq1ll \misr_value_reg[25]  ( .d(N59), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[25]) );
  dfcrq1ll \misr_value_reg[24]  ( .d(N58), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[24]) );
  dfcrq1ll \misr_value_reg[23]  ( .d(N57), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[23]) );
  dfcrq1ll \misr_value_reg[22]  ( .d(N56), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[22]) );
  dfcrq1ll \misr_value_reg[21]  ( .d(N55), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[21]) );
  dfcrq1ll \misr_value_reg[20]  ( .d(N54), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[20]) );
  dfcrq1ll \misr_value_reg[19]  ( .d(N53), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[19]) );
  dfcrq1ll \misr_value_reg[18]  ( .d(N52), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[18]) );
  dfcrq1ll \misr_value_reg[17]  ( .d(N51), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[17]) );
  dfcrq1ll \misr_value_reg[16]  ( .d(N50), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[16]) );
  dfcrq1ll \misr_value_reg[15]  ( .d(N49), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[15]) );
  dfcrq1ll \misr_value_reg[14]  ( .d(N48), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[14]) );
  dfcrq1ll \misr_value_reg[13]  ( .d(N47), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[13]) );
  dfcrq1ll \misr_value_reg[12]  ( .d(N46), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[12]) );
  dfcrq1ll \misr_value_reg[11]  ( .d(N45), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[11]) );
  dfcrq1ll \misr_value_reg[10]  ( .d(N44), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[10]) );
  dfcrq1ll \misr_value_reg[9]  ( .d(N43), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[9]) );
  dfcrq1ll \misr_value_reg[8]  ( .d(N42), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[8]) );
  dfcrq1ll \misr_value_reg[7]  ( .d(N41), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[7]) );
  dfcrq1ll \misr_value_reg[6]  ( .d(N40), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[6]) );
  dfcrq1ll \misr_value_reg[5]  ( .d(N39), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[5]) );
  dfcrq1ll \misr_value_reg[4]  ( .d(N38), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[4]) );
  dfcrq1ll \misr_value_reg[3]  ( .d(N37), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[3]) );
  dfcrq1ll \misr_value_reg[2]  ( .d(N36), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[2]) );
  dfcrq1ll \misr_value_reg[1]  ( .d(N35), .cp(net247), .cdn(misr_rst_n), .q(
        misr_value[1]) );
  aon211d1ll U2 ( .c1(misr_so), .c2(misr_in[0]), .b(n1), .a(n2), .zn(N65) );
  oai21d1ll U4 ( .b1(misr_in[0]), .b2(misr_so), .a(n3), .zn(n1) );
  oai31d1ll U5 ( .b1(misr_load), .b2(misr_value[31]), .b3(n4), .a(n5), .zn(N64) );
  oai21d1ll U6 ( .b1(misr_load), .b2(n4), .a(misr_value[31]), .zn(n5) );
  aoim22d1ll U7 ( .a1(misr_in[1]), .a2(n6), .b1(n6), .b2(misr_in[1]), .zn(n4)
         );
  oaim22d1ll U8 ( .a1(n7), .a2(misr_value[30]), .b1(n7), .b2(misr_value[30]), 
        .zn(N63) );
  oaim22d1ll U10 ( .a1(n8), .a2(misr_value[29]), .b1(n8), .b2(misr_value[29]), 
        .zn(N62) );
  oaim22d1ll U12 ( .a1(n9), .a2(misr_value[28]), .b1(n9), .b2(misr_value[28]), 
        .zn(N61) );
  oaim22d1ll U14 ( .a1(n10), .a2(misr_value[27]), .b1(n10), .b2(misr_value[27]), .zn(N60) );
  oaim22d1ll U16 ( .a1(n11), .a2(misr_value[26]), .b1(n11), .b2(misr_value[26]), .zn(N59) );
  oaim22d1ll U18 ( .a1(n12), .a2(misr_value[25]), .b1(n12), .b2(misr_value[25]), .zn(N58) );
  oaim22d1ll U20 ( .a1(n13), .a2(misr_value[24]), .b1(n13), .b2(misr_value[24]), .zn(N57) );
  oaim22d1ll U22 ( .a1(n14), .a2(misr_value[23]), .b1(n14), .b2(misr_value[23]), .zn(N56) );
  oaim22d1ll U24 ( .a1(n15), .a2(misr_value[22]), .b1(n15), .b2(misr_value[22]), .zn(N55) );
  oaim22d1ll U26 ( .a1(n16), .a2(misr_value[21]), .b1(n16), .b2(misr_value[21]), .zn(N54) );
  oaim22d1ll U28 ( .a1(n17), .a2(misr_value[20]), .b1(n17), .b2(misr_value[20]), .zn(N53) );
  oaim22d1ll U30 ( .a1(n18), .a2(misr_value[19]), .b1(n18), .b2(misr_value[19]), .zn(N52) );
  oaim22d1ll U32 ( .a1(n19), .a2(misr_value[18]), .b1(n19), .b2(misr_value[18]), .zn(N51) );
  oaim22d1ll U34 ( .a1(n20), .a2(misr_value[17]), .b1(n20), .b2(misr_value[17]), .zn(N50) );
  oaim22d1ll U36 ( .a1(n21), .a2(misr_value[16]), .b1(n21), .b2(misr_value[16]), .zn(N49) );
  oaim22d1ll U38 ( .a1(n22), .a2(misr_value[15]), .b1(n22), .b2(misr_value[15]), .zn(N48) );
  oaim22d1ll U40 ( .a1(n23), .a2(misr_value[14]), .b1(n23), .b2(misr_value[14]), .zn(N47) );
  oaim22d1ll U42 ( .a1(n24), .a2(misr_value[13]), .b1(n24), .b2(misr_value[13]), .zn(N46) );
  oaim22d1ll U44 ( .a1(n25), .a2(misr_value[12]), .b1(n25), .b2(misr_value[12]), .zn(N45) );
  oaim22d1ll U46 ( .a1(n26), .a2(misr_value[11]), .b1(n26), .b2(misr_value[11]), .zn(N44) );
  oaim22d1ll U48 ( .a1(n27), .a2(misr_value[10]), .b1(n27), .b2(misr_value[10]), .zn(N43) );
  oaim22d1ll U50 ( .a1(n28), .a2(misr_value[9]), .b1(n28), .b2(misr_value[9]), 
        .zn(N42) );
  oaim22d1ll U52 ( .a1(n29), .a2(misr_value[8]), .b1(n29), .b2(misr_value[8]), 
        .zn(N41) );
  oaim22d1ll U54 ( .a1(n30), .a2(misr_value[7]), .b1(n30), .b2(misr_value[7]), 
        .zn(N40) );
  oaim22d1ll U56 ( .a1(n31), .a2(misr_value[6]), .b1(n31), .b2(misr_value[6]), 
        .zn(N39) );
  oai31d1ll U58 ( .b1(misr_load), .b2(misr_value[5]), .b3(n32), .a(n33), .zn(
        N38) );
  oai21d1ll U59 ( .b1(misr_load), .b2(n32), .a(misr_value[5]), .zn(n33) );
  aoim22d1ll U60 ( .a1(misr_in[27]), .a2(n6), .b1(n6), .b2(misr_in[27]), .zn(
        n32) );
  oai31d1ll U61 ( .b1(misr_load), .b2(misr_value[4]), .b3(n34), .a(n35), .zn(
        N37) );
  oai21d1ll U62 ( .b1(misr_load), .b2(n34), .a(misr_value[4]), .zn(n35) );
  aoim22d1ll U63 ( .a1(misr_in[28]), .a2(n6), .b1(n6), .b2(misr_in[28]), .zn(
        n34) );
  oaim22d1ll U65 ( .a1(n36), .a2(misr_value[3]), .b1(n36), .b2(misr_value[3]), 
        .zn(N36) );
  oaim22d1ll U67 ( .a1(n37), .a2(misr_value[2]), .b1(n37), .b2(misr_value[2]), 
        .zn(N35) );
  oaim22d1ll U69 ( .a1(n38), .a2(misr_value[1]), .b1(n38), .b2(misr_value[1]), 
        .zn(N34) );
  SNPS_CLOCK_GATE_HIGH_misr clk_gate_misr_value_reg ( .CLK(misr_clk), .EN(N1), 
        .ENCLK(net247), .TE(1'b0) );
  or02d1ll U72 ( .a1(misr_en), .a2(misr_load), .z(N1) );
  inv0d1ll U64 ( .i(misr_so), .zn(n6) );
  nd02d1ll U11 ( .a1(n3), .a2(misr_in[3]), .zn(n8) );
  nd02d1ll U27 ( .a1(n3), .a2(misr_in[11]), .zn(n16) );
  nd02d1ll U15 ( .a1(n3), .a2(misr_in[5]), .zn(n10) );
  nd02d1ll U37 ( .a1(n3), .a2(misr_in[16]), .zn(n21) );
  nd02d1ll U19 ( .a1(n3), .a2(misr_in[7]), .zn(n12) );
  nd02d1ll U21 ( .a1(n3), .a2(misr_in[8]), .zn(n13) );
  nd02d1ll U13 ( .a1(n3), .a2(misr_in[4]), .zn(n9) );
  nd02d1ll U25 ( .a1(n3), .a2(misr_in[10]), .zn(n15) );
  nd02d1ll U31 ( .a1(n3), .a2(misr_in[13]), .zn(n18) );
  nd02d1ll U29 ( .a1(n3), .a2(misr_in[12]), .zn(n17) );
  nd02d1ll U35 ( .a1(n3), .a2(misr_in[15]), .zn(n20) );
  nd02d1ll U33 ( .a1(n3), .a2(misr_in[14]), .zn(n19) );
  nd02d1ll U39 ( .a1(n3), .a2(misr_in[17]), .zn(n22) );
  nd02d1ll U41 ( .a1(n3), .a2(misr_in[18]), .zn(n23) );
  nd02d1ll U43 ( .a1(n3), .a2(misr_in[19]), .zn(n24) );
  nd02d1ll U23 ( .a1(n3), .a2(misr_in[9]), .zn(n14) );
  nd02d1ll U45 ( .a1(n3), .a2(misr_in[20]), .zn(n25) );
  nd02d1ll U3 ( .a1(misr_load), .a2(misr_si), .zn(n2) );
  nd02d1ll U57 ( .a1(n3), .a2(misr_in[26]), .zn(n31) );
  nd02d1ll U17 ( .a1(n3), .a2(misr_in[6]), .zn(n11) );
  nd02d1ll U53 ( .a1(n3), .a2(misr_in[24]), .zn(n29) );
  nd02d1ll U9 ( .a1(n3), .a2(misr_in[2]), .zn(n7) );
  nd02d1ll U68 ( .a1(n3), .a2(misr_in[30]), .zn(n37) );
  nd02d1ll U49 ( .a1(n3), .a2(misr_in[22]), .zn(n27) );
  nd02d1ll U51 ( .a1(n3), .a2(misr_in[23]), .zn(n28) );
  nd02d1ll U70 ( .a1(n3), .a2(misr_in[31]), .zn(n38) );
  nd02d1ll U55 ( .a1(n3), .a2(misr_in[25]), .zn(n30) );
  nd02d1ll U47 ( .a1(n3), .a2(misr_in[21]), .zn(n26) );
  nd02d1ll U66 ( .a1(n3), .a2(misr_in[29]), .zn(n36) );
  inv0d1ll U71 ( .i(misr_load), .zn(n3) );
endmodule


module concentrator ( concentrator_out, concentrator_in );
  output [31:0] concentrator_out;
  input [31:0] concentrator_in;

  assign concentrator_out[31] = concentrator_in[31];
  assign concentrator_out[30] = concentrator_in[30];
  assign concentrator_out[29] = concentrator_in[29];
  assign concentrator_out[28] = concentrator_in[28];
  assign concentrator_out[27] = concentrator_in[27];
  assign concentrator_out[26] = concentrator_in[26];
  assign concentrator_out[25] = concentrator_in[25];
  assign concentrator_out[24] = concentrator_in[24];
  assign concentrator_out[23] = concentrator_in[23];
  assign concentrator_out[22] = concentrator_in[22];
  assign concentrator_out[21] = concentrator_in[21];
  assign concentrator_out[20] = concentrator_in[20];
  assign concentrator_out[19] = concentrator_in[19];
  assign concentrator_out[18] = concentrator_in[18];
  assign concentrator_out[17] = concentrator_in[17];
  assign concentrator_out[16] = concentrator_in[16];
  assign concentrator_out[15] = concentrator_in[15];
  assign concentrator_out[14] = concentrator_in[14];
  assign concentrator_out[13] = concentrator_in[13];
  assign concentrator_out[12] = concentrator_in[12];
  assign concentrator_out[11] = concentrator_in[11];
  assign concentrator_out[10] = concentrator_in[10];
  assign concentrator_out[9] = concentrator_in[9];
  assign concentrator_out[8] = concentrator_in[8];
  assign concentrator_out[7] = concentrator_in[7];
  assign concentrator_out[6] = concentrator_in[6];
  assign concentrator_out[5] = concentrator_in[5];
  assign concentrator_out[4] = concentrator_in[4];
  assign concentrator_out[3] = concentrator_in[3];
  assign concentrator_out[2] = concentrator_in[2];
  assign concentrator_out[1] = concentrator_in[1];
  assign concentrator_out[0] = concentrator_in[0];

endmodule


module weighting ( weighting_out, weighting_in, weighting_sel );
  output [31:0] weighting_out;
  input [31:0] weighting_in;
  input [1:0] weighting_sel;
  wire   n1, n2, n4, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16, n17,
         n18, n19, n20, n21, n22, n23, n24, n25, n26, n27, n28, n29, n30, n31,
         n32, n33, n34, n35, n36, n37, n38, n39, n40, n41, n42, n43, n44, n45,
         n46, n47, n48, n49, n50, n51, n52, n53, n54, n55, n56, n57, n58, n59,
         n60, n61, n62, n63, n64, n65, n66, n67, n68, n69, n3, n5;

  oan211d1ll U1 ( .c1(n1), .c2(n2), .b(n5), .a(n4), .zn(weighting_out[9]) );
  oan211d1ll U2 ( .c1(n3), .c2(weighting_in[12]), .b(weighting_in[11]), .a(n6), 
        .zn(n1) );
  oan211d1ll U3 ( .c1(n7), .c2(n4), .b(n5), .a(n8), .zn(weighting_out[8]) );
  oan211d1ll U5 ( .c1(n3), .c2(weighting_in[11]), .b(weighting_in[10]), .a(n6), 
        .zn(n7) );
  oan211d1ll U6 ( .c1(n9), .c2(n8), .b(n5), .a(n10), .zn(weighting_out[7]) );
  oan211d1ll U8 ( .c1(n3), .c2(weighting_in[10]), .b(weighting_in[9]), .a(n6), 
        .zn(n9) );
  oan211d1ll U9 ( .c1(n11), .c2(n10), .b(n5), .a(n12), .zn(weighting_out[6])
         );
  oan211d1ll U11 ( .c1(n3), .c2(weighting_in[9]), .b(weighting_in[8]), .a(n6), 
        .zn(n11) );
  oan211d1ll U12 ( .c1(n13), .c2(n12), .b(n5), .a(n14), .zn(weighting_out[5])
         );
  oan211d1ll U14 ( .c1(n3), .c2(weighting_in[8]), .b(weighting_in[7]), .a(n6), 
        .zn(n13) );
  oan211d1ll U15 ( .c1(n15), .c2(n14), .b(n5), .a(n16), .zn(weighting_out[4])
         );
  oan211d1ll U17 ( .c1(n3), .c2(weighting_in[7]), .b(weighting_in[6]), .a(n6), 
        .zn(n15) );
  oan211d1ll U18 ( .c1(n17), .c2(n16), .b(n5), .a(n18), .zn(weighting_out[3])
         );
  oan211d1ll U20 ( .c1(n3), .c2(weighting_in[6]), .b(weighting_in[5]), .a(n6), 
        .zn(n17) );
  oan211d1ll U21 ( .c1(n19), .c2(n20), .b(n5), .a(n21), .zn(weighting_out[31])
         );
  oan211d1ll U22 ( .c1(weighting_in[2]), .c2(n3), .b(weighting_in[1]), .a(n6), 
        .zn(n19) );
  oan211d1ll U23 ( .c1(n22), .c2(n21), .b(n5), .a(n23), .zn(weighting_out[30])
         );
  oan211d1ll U25 ( .c1(weighting_in[1]), .c2(n3), .b(weighting_in[0]), .a(n6), 
        .zn(n22) );
  oan211d1ll U26 ( .c1(n24), .c2(n18), .b(n5), .a(n25), .zn(weighting_out[2])
         );
  oan211d1ll U28 ( .c1(n3), .c2(weighting_in[5]), .b(weighting_in[4]), .a(n6), 
        .zn(n24) );
  oan211d1ll U29 ( .c1(n26), .c2(n23), .b(n5), .a(n27), .zn(weighting_out[29])
         );
  oan211d1ll U31 ( .c1(weighting_in[0]), .c2(n3), .b(weighting_in[31]), .a(n6), 
        .zn(n26) );
  oan211d1ll U32 ( .c1(n28), .c2(n27), .b(n5), .a(n29), .zn(weighting_out[28])
         );
  oan211d1ll U34 ( .c1(n3), .c2(weighting_in[31]), .b(weighting_in[30]), .a(n6), .zn(n28) );
  oan211d1ll U35 ( .c1(n30), .c2(n29), .b(n5), .a(n31), .zn(weighting_out[27])
         );
  oan211d1ll U37 ( .c1(n3), .c2(weighting_in[30]), .b(weighting_in[29]), .a(n6), .zn(n30) );
  oan211d1ll U38 ( .c1(n32), .c2(n31), .b(n5), .a(n33), .zn(weighting_out[26])
         );
  oan211d1ll U40 ( .c1(n3), .c2(weighting_in[29]), .b(weighting_in[28]), .a(n6), .zn(n32) );
  oan211d1ll U41 ( .c1(n34), .c2(n33), .b(n5), .a(n35), .zn(weighting_out[25])
         );
  oan211d1ll U43 ( .c1(n3), .c2(weighting_in[28]), .b(weighting_in[27]), .a(n6), .zn(n34) );
  oan211d1ll U44 ( .c1(n36), .c2(n35), .b(n5), .a(n37), .zn(weighting_out[24])
         );
  oan211d1ll U46 ( .c1(n3), .c2(weighting_in[27]), .b(weighting_in[26]), .a(n6), .zn(n36) );
  oan211d1ll U47 ( .c1(n38), .c2(n37), .b(n5), .a(n39), .zn(weighting_out[23])
         );
  oan211d1ll U49 ( .c1(n3), .c2(weighting_in[26]), .b(weighting_in[25]), .a(n6), .zn(n38) );
  oan211d1ll U50 ( .c1(n40), .c2(n39), .b(n5), .a(n41), .zn(weighting_out[22])
         );
  oan211d1ll U52 ( .c1(n3), .c2(weighting_in[25]), .b(weighting_in[24]), .a(n6), .zn(n40) );
  oan211d1ll U53 ( .c1(n42), .c2(n41), .b(n5), .a(n43), .zn(weighting_out[21])
         );
  oan211d1ll U55 ( .c1(n3), .c2(weighting_in[24]), .b(weighting_in[23]), .a(n6), .zn(n42) );
  oan211d1ll U56 ( .c1(n44), .c2(n43), .b(n5), .a(n45), .zn(weighting_out[20])
         );
  oan211d1ll U58 ( .c1(n3), .c2(weighting_in[23]), .b(weighting_in[22]), .a(n6), .zn(n44) );
  oan211d1ll U59 ( .c1(n46), .c2(n25), .b(n5), .a(n47), .zn(weighting_out[1])
         );
  oan211d1ll U61 ( .c1(n3), .c2(weighting_in[4]), .b(weighting_in[3]), .a(n6), 
        .zn(n46) );
  oan211d1ll U62 ( .c1(n48), .c2(n45), .b(n5), .a(n49), .zn(weighting_out[19])
         );
  oan211d1ll U64 ( .c1(n3), .c2(weighting_in[22]), .b(weighting_in[21]), .a(n6), .zn(n48) );
  oan211d1ll U65 ( .c1(n50), .c2(n49), .b(n5), .a(n51), .zn(weighting_out[18])
         );
  oan211d1ll U67 ( .c1(n3), .c2(weighting_in[21]), .b(weighting_in[20]), .a(n6), .zn(n50) );
  oan211d1ll U68 ( .c1(n52), .c2(n51), .b(n5), .a(n53), .zn(weighting_out[17])
         );
  oan211d1ll U70 ( .c1(n3), .c2(weighting_in[20]), .b(weighting_in[19]), .a(n6), .zn(n52) );
  oan211d1ll U71 ( .c1(n54), .c2(n53), .b(n5), .a(n55), .zn(weighting_out[16])
         );
  oan211d1ll U73 ( .c1(n3), .c2(weighting_in[19]), .b(weighting_in[18]), .a(n6), .zn(n54) );
  oan211d1ll U74 ( .c1(n56), .c2(n55), .b(n5), .a(n57), .zn(weighting_out[15])
         );
  oan211d1ll U76 ( .c1(n3), .c2(weighting_in[18]), .b(weighting_in[17]), .a(n6), .zn(n56) );
  oan211d1ll U77 ( .c1(n58), .c2(n57), .b(n5), .a(n59), .zn(weighting_out[14])
         );
  oan211d1ll U79 ( .c1(n3), .c2(weighting_in[17]), .b(weighting_in[16]), .a(n6), .zn(n58) );
  oan211d1ll U80 ( .c1(n60), .c2(n59), .b(n5), .a(n61), .zn(weighting_out[13])
         );
  oan211d1ll U82 ( .c1(n3), .c2(weighting_in[16]), .b(weighting_in[15]), .a(n6), .zn(n60) );
  oan211d1ll U83 ( .c1(n62), .c2(n61), .b(n5), .a(n63), .zn(weighting_out[12])
         );
  oan211d1ll U85 ( .c1(n3), .c2(weighting_in[15]), .b(weighting_in[14]), .a(n6), .zn(n62) );
  oan211d1ll U86 ( .c1(n64), .c2(n63), .b(n5), .a(n65), .zn(weighting_out[11])
         );
  oan211d1ll U88 ( .c1(n3), .c2(weighting_in[14]), .b(weighting_in[13]), .a(n6), .zn(n64) );
  oan211d1ll U89 ( .c1(n66), .c2(n65), .b(n5), .a(n2), .zn(weighting_out[10])
         );
  oan211d1ll U92 ( .c1(n3), .c2(weighting_in[13]), .b(weighting_in[12]), .a(n6), .zn(n66) );
  oan211d1ll U93 ( .c1(n67), .c2(n47), .b(n5), .a(n20), .zn(weighting_out[0])
         );
  oan211d1ll U97 ( .c1(weighting_in[3]), .c2(n3), .b(weighting_in[2]), .a(n6), 
        .zn(n67) );
  inv0d1ll U101 ( .i(weighting_sel[1]), .zn(n69) );
  inv0d1ll U99 ( .i(weighting_sel[0]), .zn(n68) );
  nr02d1ll U98 ( .a1(weighting_sel[1]), .a2(n68), .zn(n6) );
  inv0d1ll U96 ( .i(weighting_in[1]), .zn(n47) );
  inv0d1ll U94 ( .i(weighting_in[0]), .zn(n20) );
  inv0d1ll U60 ( .i(weighting_in[2]), .zn(n25) );
  inv0d1ll U66 ( .i(weighting_in[19]), .zn(n49) );
  inv0d1ll U69 ( .i(weighting_in[18]), .zn(n51) );
  inv0d1ll U27 ( .i(weighting_in[3]), .zn(n18) );
  inv0d1ll U19 ( .i(weighting_in[4]), .zn(n16) );
  inv0d1ll U16 ( .i(weighting_in[5]), .zn(n14) );
  inv0d1ll U13 ( .i(weighting_in[6]), .zn(n12) );
  inv0d1ll U10 ( .i(weighting_in[7]), .zn(n10) );
  inv0d1ll U7 ( .i(weighting_in[8]), .zn(n8) );
  inv0d1ll U4 ( .i(weighting_in[9]), .zn(n4) );
  inv0d1ll U90 ( .i(weighting_in[10]), .zn(n2) );
  inv0d1ll U91 ( .i(weighting_in[11]), .zn(n65) );
  inv0d1ll U87 ( .i(weighting_in[12]), .zn(n63) );
  inv0d1ll U84 ( .i(weighting_in[13]), .zn(n61) );
  inv0d1ll U81 ( .i(weighting_in[14]), .zn(n59) );
  inv0d1ll U36 ( .i(weighting_in[28]), .zn(n29) );
  inv0d1ll U39 ( .i(weighting_in[27]), .zn(n31) );
  inv0d1ll U78 ( .i(weighting_in[15]), .zn(n57) );
  inv0d1ll U72 ( .i(weighting_in[17]), .zn(n53) );
  inv0d1ll U75 ( .i(weighting_in[16]), .zn(n55) );
  inv0d1ll U24 ( .i(weighting_in[31]), .zn(n21) );
  inv0d1ll U30 ( .i(weighting_in[30]), .zn(n23) );
  inv0d1ll U42 ( .i(weighting_in[26]), .zn(n33) );
  inv0d1ll U45 ( .i(weighting_in[25]), .zn(n35) );
  inv0d1ll U57 ( .i(weighting_in[21]), .zn(n43) );
  inv0d1ll U63 ( .i(weighting_in[20]), .zn(n45) );
  inv0d1ll U33 ( .i(weighting_in[29]), .zn(n27) );
  inv0d1ll U48 ( .i(weighting_in[24]), .zn(n37) );
  inv0d1ll U54 ( .i(weighting_in[22]), .zn(n41) );
  inv0d1ll U51 ( .i(weighting_in[23]), .zn(n39) );
  nd02d1ll U95 ( .a1(n68), .a2(n69), .zn(n5) );
  nr02d1ll U100 ( .a1(weighting_sel[0]), .a2(n69), .zn(n3) );
endmodule


module flipping ( flipping_out, flipping_in, flipping_sel );
  output [31:0] flipping_out;
  input [31:0] flipping_in;
  input [31:0] flipping_sel;


  aoim22d1ll U1 ( .a1(flipping_sel[9]), .a2(flipping_in[9]), .b1(
        flipping_in[9]), .b2(flipping_sel[9]), .zn(flipping_out[9]) );
  aoim22d1ll U2 ( .a1(flipping_sel[8]), .a2(flipping_in[8]), .b1(
        flipping_in[8]), .b2(flipping_sel[8]), .zn(flipping_out[8]) );
  aoim22d1ll U3 ( .a1(flipping_sel[7]), .a2(flipping_in[7]), .b1(
        flipping_in[7]), .b2(flipping_sel[7]), .zn(flipping_out[7]) );
  aoim22d1ll U4 ( .a1(flipping_sel[6]), .a2(flipping_in[6]), .b1(
        flipping_in[6]), .b2(flipping_sel[6]), .zn(flipping_out[6]) );
  aoim22d1ll U5 ( .a1(flipping_sel[5]), .a2(flipping_in[5]), .b1(
        flipping_in[5]), .b2(flipping_sel[5]), .zn(flipping_out[5]) );
  aoim22d1ll U6 ( .a1(flipping_sel[4]), .a2(flipping_in[4]), .b1(
        flipping_in[4]), .b2(flipping_sel[4]), .zn(flipping_out[4]) );
  aoim22d1ll U7 ( .a1(flipping_sel[3]), .a2(flipping_in[3]), .b1(
        flipping_in[3]), .b2(flipping_sel[3]), .zn(flipping_out[3]) );
  aoim22d1ll U8 ( .a1(flipping_sel[31]), .a2(flipping_in[31]), .b1(
        flipping_in[31]), .b2(flipping_sel[31]), .zn(flipping_out[31]) );
  aoim22d1ll U9 ( .a1(flipping_sel[30]), .a2(flipping_in[30]), .b1(
        flipping_in[30]), .b2(flipping_sel[30]), .zn(flipping_out[30]) );
  aoim22d1ll U10 ( .a1(flipping_sel[2]), .a2(flipping_in[2]), .b1(
        flipping_in[2]), .b2(flipping_sel[2]), .zn(flipping_out[2]) );
  aoim22d1ll U11 ( .a1(flipping_sel[29]), .a2(flipping_in[29]), .b1(
        flipping_in[29]), .b2(flipping_sel[29]), .zn(flipping_out[29]) );
  aoim22d1ll U12 ( .a1(flipping_sel[28]), .a2(flipping_in[28]), .b1(
        flipping_in[28]), .b2(flipping_sel[28]), .zn(flipping_out[28]) );
  aoim22d1ll U13 ( .a1(flipping_sel[27]), .a2(flipping_in[27]), .b1(
        flipping_in[27]), .b2(flipping_sel[27]), .zn(flipping_out[27]) );
  aoim22d1ll U14 ( .a1(flipping_sel[26]), .a2(flipping_in[26]), .b1(
        flipping_in[26]), .b2(flipping_sel[26]), .zn(flipping_out[26]) );
  aoim22d1ll U15 ( .a1(flipping_sel[25]), .a2(flipping_in[25]), .b1(
        flipping_in[25]), .b2(flipping_sel[25]), .zn(flipping_out[25]) );
  aoim22d1ll U16 ( .a1(flipping_sel[24]), .a2(flipping_in[24]), .b1(
        flipping_in[24]), .b2(flipping_sel[24]), .zn(flipping_out[24]) );
  aoim22d1ll U17 ( .a1(flipping_sel[23]), .a2(flipping_in[23]), .b1(
        flipping_in[23]), .b2(flipping_sel[23]), .zn(flipping_out[23]) );
  aoim22d1ll U18 ( .a1(flipping_sel[22]), .a2(flipping_in[22]), .b1(
        flipping_in[22]), .b2(flipping_sel[22]), .zn(flipping_out[22]) );
  aoim22d1ll U19 ( .a1(flipping_sel[21]), .a2(flipping_in[21]), .b1(
        flipping_in[21]), .b2(flipping_sel[21]), .zn(flipping_out[21]) );
  aoim22d1ll U20 ( .a1(flipping_sel[20]), .a2(flipping_in[20]), .b1(
        flipping_in[20]), .b2(flipping_sel[20]), .zn(flipping_out[20]) );
  aoim22d1ll U21 ( .a1(flipping_sel[1]), .a2(flipping_in[1]), .b1(
        flipping_in[1]), .b2(flipping_sel[1]), .zn(flipping_out[1]) );
  aoim22d1ll U22 ( .a1(flipping_sel[19]), .a2(flipping_in[19]), .b1(
        flipping_in[19]), .b2(flipping_sel[19]), .zn(flipping_out[19]) );
  aoim22d1ll U23 ( .a1(flipping_sel[18]), .a2(flipping_in[18]), .b1(
        flipping_in[18]), .b2(flipping_sel[18]), .zn(flipping_out[18]) );
  aoim22d1ll U24 ( .a1(flipping_sel[17]), .a2(flipping_in[17]), .b1(
        flipping_in[17]), .b2(flipping_sel[17]), .zn(flipping_out[17]) );
  aoim22d1ll U25 ( .a1(flipping_sel[16]), .a2(flipping_in[16]), .b1(
        flipping_in[16]), .b2(flipping_sel[16]), .zn(flipping_out[16]) );
  aoim22d1ll U26 ( .a1(flipping_sel[15]), .a2(flipping_in[15]), .b1(
        flipping_in[15]), .b2(flipping_sel[15]), .zn(flipping_out[15]) );
  aoim22d1ll U27 ( .a1(flipping_sel[14]), .a2(flipping_in[14]), .b1(
        flipping_in[14]), .b2(flipping_sel[14]), .zn(flipping_out[14]) );
  aoim22d1ll U28 ( .a1(flipping_sel[13]), .a2(flipping_in[13]), .b1(
        flipping_in[13]), .b2(flipping_sel[13]), .zn(flipping_out[13]) );
  aoim22d1ll U29 ( .a1(flipping_sel[12]), .a2(flipping_in[12]), .b1(
        flipping_in[12]), .b2(flipping_sel[12]), .zn(flipping_out[12]) );
  aoim22d1ll U30 ( .a1(flipping_sel[11]), .a2(flipping_in[11]), .b1(
        flipping_in[11]), .b2(flipping_sel[11]), .zn(flipping_out[11]) );
  aoim22d1ll U31 ( .a1(flipping_sel[10]), .a2(flipping_in[10]), .b1(
        flipping_in[10]), .b2(flipping_sel[10]), .zn(flipping_out[10]) );
  aoim22d1ll U32 ( .a1(flipping_sel[0]), .a2(flipping_in[0]), .b1(
        flipping_in[0]), .b2(flipping_sel[0]), .zn(flipping_out[0]) );
endmodule


module phaseshifter ( phaseshifter_out, phaseshifter_in );
  output [31:0] phaseshifter_out;
  input [31:0] phaseshifter_in;
  wire   n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16,
         n17, n18, n19, n20, n21, n22, n23, n24, n25, n26, n27, n28, n29, n30,
         n31, n32, n33, n34, n35, n36, n37, n38, n39, n40, n41, n42, n43, n44,
         n45, n46, n47, n48, n49;

  aoim22d1ll U2 ( .a1(phaseshifter_in[4]), .a2(n3), .b1(phaseshifter_in[4]), 
        .b2(n3), .zn(n2) );
  aoim22d1ll U4 ( .a1(n6), .a2(n7), .b1(n6), .b2(n7), .zn(n5) );
  aoim22d1ll U6 ( .a1(n10), .a2(phaseshifter_in[29]), .b1(n10), .b2(
        phaseshifter_in[29]), .zn(n9) );
  aoim22d1ll U8 ( .a1(phaseshifter_in[26]), .a2(n13), .b1(n13), .b2(
        phaseshifter_in[26]), .zn(n12) );
  xr03d1ll U9 ( .a1(phaseshifter_in[9]), .a2(phaseshifter_in[6]), .a3(n14), 
        .z(phaseshifter_out[5]) );
  aoi22d1ll U10 ( .a1(phaseshifter_in[31]), .a2(phaseshifter_in[28]), .b1(n15), 
        .b2(n16), .zn(n14) );
  aoim22d1ll U12 ( .a1(phaseshifter_in[15]), .a2(n18), .b1(phaseshifter_in[15]), .b2(n18), .zn(n17) );
  aoi22d1ll U14 ( .a1(phaseshifter_in[30]), .a2(n21), .b1(n22), .b2(n23), .zn(
        n20) );
  aoim22d1ll U16 ( .a1(n26), .a2(n27), .b1(n26), .b2(n27), .zn(n25) );
  xr03d1ll U17 ( .a1(n28), .a2(phaseshifter_in[4]), .a3(phaseshifter_in[14]), 
        .z(phaseshifter_out[30]) );
  aoim22d1ll U19 ( .a1(phaseshifter_in[22]), .a2(n21), .b1(phaseshifter_in[22]), .b2(n21), .zn(n29) );
  aoim22d1ll U22 ( .a1(n13), .a2(phaseshifter_in[29]), .b1(n13), .b2(
        phaseshifter_in[29]), .zn(n31) );
  aoim22d1ll U24 ( .a1(n34), .a2(phaseshifter_in[13]), .b1(n34), .b2(
        phaseshifter_in[13]), .zn(n33) );
  aoim22d1ll U26 ( .a1(phaseshifter_in[23]), .a2(n3), .b1(phaseshifter_in[23]), 
        .b2(n3), .zn(n36) );
  xr03d1ll U27 ( .a1(phaseshifter_in[24]), .a2(phaseshifter_in[13]), .a3(n13), 
        .z(phaseshifter_out[26]) );
  aoim22d1ll U28 ( .a1(phaseshifter_in[28]), .a2(phaseshifter_in[10]), .b1(
        phaseshifter_in[10]), .b2(phaseshifter_in[28]), .zn(n13) );
  xr03d1ll U29 ( .a1(phaseshifter_in[3]), .a2(n18), .a3(phaseshifter_in[13]), 
        .z(phaseshifter_out[25]) );
  aoim22d1ll U30 ( .a1(phaseshifter_in[27]), .a2(phaseshifter_in[12]), .b1(
        phaseshifter_in[12]), .b2(phaseshifter_in[27]), .zn(n18) );
  xr03d1ll U31 ( .a1(phaseshifter_in[3]), .a2(phaseshifter_in[24]), .a3(n37), 
        .z(phaseshifter_out[24]) );
  aoi22d1ll U32 ( .a1(phaseshifter_in[28]), .a2(phaseshifter_in[16]), .b1(n35), 
        .b2(n15), .zn(n37) );
  xr03d1ll U33 ( .a1(phaseshifter_in[23]), .a2(phaseshifter_in[14]), .a3(n38), 
        .z(phaseshifter_out[23]) );
  aoi22d1ll U34 ( .a1(phaseshifter_in[19]), .a2(phaseshifter_in[28]), .b1(n15), 
        .b2(n39), .zn(n38) );
  xr03d1ll U35 ( .a1(phaseshifter_in[11]), .a2(phaseshifter_in[3]), .a3(n3), 
        .z(phaseshifter_out[22]) );
  aoi22d1ll U36 ( .a1(phaseshifter_in[31]), .a2(phaseshifter_in[1]), .b1(n24), 
        .b2(n16), .zn(n3) );
  xr03d1ll U38 ( .a1(n30), .a2(n7), .a3(phaseshifter_in[10]), .z(
        phaseshifter_out[21]) );
  oai22d1ll U39 ( .a1(n40), .a2(n27), .b1(phaseshifter_in[17]), .b2(
        phaseshifter_in[27]), .zn(n7) );
  xr03d1ll U41 ( .a1(phaseshifter_in[21]), .a2(n41), .a3(phaseshifter_in[5]), 
        .z(phaseshifter_out[20]) );
  xr03d1ll U42 ( .a1(n15), .a2(n8), .a3(n42), .z(phaseshifter_out[1]) );
  aoi22d1ll U43 ( .a1(phaseshifter_in[20]), .a2(phaseshifter_in[26]), .b1(n32), 
        .b2(n19), .zn(n42) );
  xr03d1ll U45 ( .a1(phaseshifter_in[6]), .a2(phaseshifter_in[3]), .a3(n43), 
        .z(phaseshifter_out[19]) );
  aoi22d1ll U46 ( .a1(phaseshifter_in[18]), .a2(phaseshifter_in[1]), .b1(n24), 
        .b2(n11), .zn(n43) );
  xr03d1ll U47 ( .a1(n39), .a2(phaseshifter_in[4]), .a3(n22), .z(
        phaseshifter_out[18]) );
  oai22d1ll U48 ( .a1(n44), .a2(n15), .b1(phaseshifter_in[28]), .b2(
        phaseshifter_in[7]), .zn(n22) );
  xr03d1ll U49 ( .a1(phaseshifter_in[9]), .a2(n34), .a3(phaseshifter_in[5]), 
        .z(phaseshifter_out[17]) );
  aoi22d1ll U50 ( .a1(phaseshifter_in[28]), .a2(phaseshifter_in[15]), .b1(n6), 
        .b2(n15), .zn(n34) );
  oaim22d1ll U53 ( .a1(phaseshifter_in[26]), .a2(phaseshifter_in[8]), .b1(
        phaseshifter_in[8]), .b2(phaseshifter_in[26]), .zn(n26) );
  xr03d1ll U54 ( .a1(n4), .a2(n30), .a3(n41), .z(phaseshifter_out[15]) );
  aoi22d1ll U55 ( .a1(phaseshifter_in[1]), .a2(phaseshifter_in[30]), .b1(n23), 
        .b2(n24), .zn(n41) );
  xr03d1ll U60 ( .a1(phaseshifter_in[9]), .a2(n10), .a3(phaseshifter_in[22]), 
        .z(phaseshifter_out[14]) );
  aoi22d1ll U61 ( .a1(phaseshifter_in[27]), .a2(phaseshifter_in[20]), .b1(n19), 
        .b2(n40), .zn(n10) );
  xr03d1ll U63 ( .a1(phaseshifter_in[2]), .a2(phaseshifter_in[6]), .a3(n47), 
        .z(phaseshifter_out[13]) );
  aoi22d1ll U64 ( .a1(phaseshifter_in[27]), .a2(phaseshifter_in[19]), .b1(n39), 
        .b2(n40), .zn(n47) );
  xr03d1ll U66 ( .a1(n1), .a2(n8), .a3(n46), .z(phaseshifter_out[12]) );
  oai22d1ll U68 ( .a1(n40), .a2(n35), .b1(phaseshifter_in[16]), .b2(
        phaseshifter_in[27]), .zn(n45) );
  xr03d1ll U71 ( .a1(phaseshifter_in[11]), .a2(phaseshifter_in[2]), .a3(n48), 
        .z(phaseshifter_out[11]) );
  aoi22d1ll U72 ( .a1(phaseshifter_in[21]), .a2(phaseshifter_in[28]), .b1(n15), 
        .b2(n1), .zn(n48) );
  xr03d1ll U75 ( .a1(phaseshifter_in[9]), .a2(n28), .a3(phaseshifter_in[19]), 
        .z(phaseshifter_out[10]) );
  aoi22d1ll U76 ( .a1(phaseshifter_in[27]), .a2(phaseshifter_in[7]), .b1(n44), 
        .b2(n40), .zn(n28) );
  xr03d1ll U78 ( .a1(phaseshifter_in[31]), .a2(phaseshifter_in[8]), .a3(n49), 
        .z(phaseshifter_out[0]) );
  aoi22d1ll U79 ( .a1(phaseshifter_in[27]), .a2(phaseshifter_in[18]), .b1(n11), 
        .b2(n40), .zn(n49) );
  mx02d1ll U13 ( .i0(phaseshifter_in[20]), .i1(n19), .s(n20), .z(
        phaseshifter_out[3]) );
  mx02d1ll U18 ( .i0(phaseshifter_in[18]), .i1(n11), .s(n29), .z(
        phaseshifter_out[2]) );
  mx02d1ll U11 ( .i0(phaseshifter_in[21]), .i1(n1), .s(n17), .z(
        phaseshifter_out[4]) );
  mx02d1ll U7 ( .i0(phaseshifter_in[18]), .i1(n11), .s(n12), .z(
        phaseshifter_out[6]) );
  mx02d1ll U5 ( .i0(phaseshifter_in[25]), .i1(n8), .s(n9), .z(
        phaseshifter_out[7]) );
  mx02d1ll U3 ( .i0(phaseshifter_in[11]), .i1(n4), .s(n5), .z(
        phaseshifter_out[8]) );
  mx02d1ll U1 ( .i0(phaseshifter_in[21]), .i1(n1), .s(n2), .z(
        phaseshifter_out[9]) );
  mx02d1ll U52 ( .i0(n45), .i1(n46), .s(n26), .z(phaseshifter_out[16]) );
  mx02d1ll U21 ( .i0(phaseshifter_in[23]), .i1(n30), .s(n31), .z(
        phaseshifter_out[29]) );
  mx02d1ll U23 ( .i0(phaseshifter_in[26]), .i1(n32), .s(n33), .z(
        phaseshifter_out[28]) );
  mx02d1ll U25 ( .i0(phaseshifter_in[16]), .i1(n35), .s(n36), .z(
        phaseshifter_out[27]) );
  mx02d1ll U15 ( .i0(phaseshifter_in[1]), .i1(n24), .s(n25), .z(
        phaseshifter_out[31]) );
  inv0d1ll U62 ( .i(phaseshifter_in[20]), .zn(n19) );
  inv0d1ll U77 ( .i(phaseshifter_in[7]), .zn(n44) );
  inv0d1ll U74 ( .i(phaseshifter_in[28]), .zn(n15) );
  inv0d1ll U20 ( .i(n22), .zn(n21) );
  inv0d1ll U57 ( .i(phaseshifter_in[30]), .zn(n23) );
  inv0d1ll U81 ( .i(phaseshifter_in[18]), .zn(n11) );
  inv0d1ll U70 ( .i(phaseshifter_in[25]), .zn(n8) );
  inv0d1ll U44 ( .i(phaseshifter_in[26]), .zn(n32) );
  inv0d1ll U80 ( .i(phaseshifter_in[27]), .zn(n40) );
  inv0d1ll U73 ( .i(phaseshifter_in[21]), .zn(n1) );
  inv0d1ll U58 ( .i(phaseshifter_in[23]), .zn(n30) );
  inv0d1ll U40 ( .i(phaseshifter_in[17]), .zn(n27) );
  inv0d1ll U56 ( .i(phaseshifter_in[1]), .zn(n24) );
  inv0d1ll U65 ( .i(phaseshifter_in[19]), .zn(n39) );
  inv0d1ll U37 ( .i(phaseshifter_in[31]), .zn(n16) );
  inv0d1ll U59 ( .i(phaseshifter_in[11]), .zn(n4) );
  inv0d1ll U51 ( .i(phaseshifter_in[15]), .zn(n6) );
  inv0d1ll U69 ( .i(phaseshifter_in[16]), .zn(n35) );
  inv0d1ll U67 ( .i(n45), .zn(n46) );
endmodule


module lfsr ( lfsr_out, lfsr_so, lfsr_clk, lfsr_rst_n, lfsr_en, lfsr_load, 
        lfsr_si );
  output [31:0] lfsr_out;
  input lfsr_clk, lfsr_rst_n, lfsr_en, lfsr_load, lfsr_si;
  output lfsr_so;
  wire   N1, N5, N6, N7, N8, net264, n1, n2, n3;

  dfcrn1ll \lfsr_value_reg[0]  ( .d(n1), .cp(net264), .cdn(lfsr_rst_n), .qn(
        lfsr_so) );
  dfcrq1ll \lfsr_value_reg[31]  ( .d(N8), .cp(net264), .cdn(lfsr_rst_n), .q(
        lfsr_out[31]) );
  dfcrq1ll \lfsr_value_reg[30]  ( .d(N7), .cp(net264), .cdn(lfsr_rst_n), .q(
        lfsr_out[30]) );
  dfcrq1ll \lfsr_value_reg[29]  ( .d(lfsr_out[30]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[29]) );
  dfcrq1ll \lfsr_value_reg[28]  ( .d(lfsr_out[29]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[28]) );
  dfcrq1ll \lfsr_value_reg[27]  ( .d(lfsr_out[28]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[27]) );
  dfcrq1ll \lfsr_value_reg[26]  ( .d(lfsr_out[27]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[26]) );
  dfcrq1ll \lfsr_value_reg[25]  ( .d(lfsr_out[26]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[25]) );
  dfcrq1ll \lfsr_value_reg[24]  ( .d(lfsr_out[25]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[24]) );
  dfcrq1ll \lfsr_value_reg[23]  ( .d(lfsr_out[24]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[23]) );
  dfcrq1ll \lfsr_value_reg[22]  ( .d(lfsr_out[23]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[22]) );
  dfcrq1ll \lfsr_value_reg[21]  ( .d(lfsr_out[22]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[21]) );
  dfcrq1ll \lfsr_value_reg[20]  ( .d(lfsr_out[21]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[20]) );
  dfcrq1ll \lfsr_value_reg[19]  ( .d(lfsr_out[20]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[19]) );
  dfcrq1ll \lfsr_value_reg[18]  ( .d(lfsr_out[19]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[18]) );
  dfcrq1ll \lfsr_value_reg[17]  ( .d(lfsr_out[18]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[17]) );
  dfcrq1ll \lfsr_value_reg[16]  ( .d(lfsr_out[17]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[16]) );
  dfcrq1ll \lfsr_value_reg[15]  ( .d(lfsr_out[16]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[15]) );
  dfcrq1ll \lfsr_value_reg[14]  ( .d(lfsr_out[15]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[14]) );
  dfcrq1ll \lfsr_value_reg[13]  ( .d(lfsr_out[14]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[13]) );
  dfcrq1ll \lfsr_value_reg[12]  ( .d(lfsr_out[13]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[12]) );
  dfcrq1ll \lfsr_value_reg[11]  ( .d(lfsr_out[12]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[11]) );
  dfcrq1ll \lfsr_value_reg[10]  ( .d(lfsr_out[11]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[10]) );
  dfcrq1ll \lfsr_value_reg[9]  ( .d(lfsr_out[10]), .cp(net264), .cdn(
        lfsr_rst_n), .q(lfsr_out[9]) );
  dfcrq1ll \lfsr_value_reg[8]  ( .d(lfsr_out[9]), .cp(net264), .cdn(lfsr_rst_n), .q(lfsr_out[8]) );
  dfcrq1ll \lfsr_value_reg[7]  ( .d(lfsr_out[8]), .cp(net264), .cdn(lfsr_rst_n), .q(lfsr_out[7]) );
  dfcrq1ll \lfsr_value_reg[6]  ( .d(lfsr_out[7]), .cp(net264), .cdn(lfsr_rst_n), .q(lfsr_out[6]) );
  dfcrq1ll \lfsr_value_reg[5]  ( .d(lfsr_out[6]), .cp(net264), .cdn(lfsr_rst_n), .q(lfsr_out[5]) );
  dfcrq1ll \lfsr_value_reg[4]  ( .d(N6), .cp(net264), .cdn(lfsr_rst_n), .q(
        lfsr_out[4]) );
  dfcrq1ll \lfsr_value_reg[3]  ( .d(N5), .cp(net264), .cdn(lfsr_rst_n), .q(
        lfsr_out[3]) );
  dfcrq1ll \lfsr_value_reg[2]  ( .d(lfsr_out[3]), .cp(net264), .cdn(lfsr_rst_n), .q(lfsr_out[2]) );
  dfcrn1ll \lfsr_value_reg[1]  ( .d(lfsr_out[2]), .cp(net264), .cdn(lfsr_rst_n), .qn(n1) );
  aor21d1ll U3 ( .b1(lfsr_load), .b2(lfsr_si), .a(n2), .z(N8) );
  aoim22d1ll U4 ( .a1(n2), .a2(lfsr_out[31]), .b1(lfsr_out[31]), .b2(n2), .zn(
        N7) );
  aoim22d1ll U5 ( .a1(n2), .a2(lfsr_out[5]), .b1(lfsr_out[5]), .b2(n2), .zn(N6) );
  aoim22d1ll U6 ( .a1(n2), .a2(lfsr_out[4]), .b1(lfsr_out[4]), .b2(n2), .zn(N5) );
  SNPS_CLOCK_GATE_HIGH_lfsr clk_gate_lfsr_value_reg ( .CLK(lfsr_clk), .EN(N1), 
        .ENCLK(net264), .TE(1'b0) );
  nd12d1ll U8 ( .a1(lfsr_load), .a2(lfsr_so), .zn(n3) );
  or02d1ll U9 ( .a1(lfsr_load), .a2(lfsr_en), .z(N1) );
  inv0d1ll U2 ( .i(n1), .zn(lfsr_out[1]) );
  inv0d1ll U7 ( .i(n3), .zn(n2) );
endmodule


module bistcontroller ( bist_done, bist_en, bist_lfsr_en, bist_misr_en, 
        bist_scan_en, bist_weighting_sel, bist_flipping_sel, bist_delaytest, 
        bist_scan_conf_out, bist_start, bist_clk, bist_rst_n, 
        bist_scan_conf_in, bist_scan_conf_en );
  output [1:0] bist_weighting_sel;
  output [31:0] bist_flipping_sel;
  input bist_start, bist_clk, bist_rst_n, bist_scan_conf_in, bist_scan_conf_en;
  output bist_done, bist_en, bist_lfsr_en, bist_misr_en, bist_scan_en,
         bist_delaytest, bist_scan_conf_out;
  wire   n61, misr_enable_r, misr_enable_set, testcounter_rst,
         patterncounter_rst, N11, N12, N13, N14, N15, N16, N17, N18, N19, N20,
         N21, N22, N23, N24, N26, N27, N28, N29, N30, N31, N32, N33, N34, N35,
         N36, N37, N38, N39, N40, N41, N42, N48, N49, N50, N51, N52, N53, N55,
         N56, N57, N58, N59, N60, N61, N62, N63, testcounter_inc, N71, N72,
         N73, N74, bist_weight_load, bist_flip_en, N78, N79, N80, N81, N82,
         N83, N84, N85, N86, N87, N88, N89, N90, N91, N92, N93, N94, N95, N96,
         N97, N98, N99, N100, N101, N102, N103, N104, N105, N106, N107, N108,
         N109, net281, net286, net291, net296, net301, n2, n3, n4, n5, n6, n7,
         n8, n9, n10, n11, n12, n13, n14, n15, n16, n17, n18, n19, n20, n21,
         n22, n23, n24, n25, n26, n27, n28, n29, n30, n31, n32, n33, n34, n35,
         n36, n37, n38, n39, n40, n41, n42, n43, n44, n45, n46, n47, n48, n49,
         n50, n51, \add_x_102_0/carry[2] , \add_x_102_0/carry[3] ,
         \add_x_102_0/carry[4] , \add_x_102_0/carry[5] ,
         \add_x_102_0/carry[6] , \add_x_102_0/carry[7] , \add_x_87_0/carry[2] ,
         \add_x_87_0/carry[3] , \add_x_87_0/carry[4] , \add_x_87_0/carry[5] ,
         \add_x_87_0/carry[6] , \add_x_87_0/carry[7] , \add_x_87_0/carry[8] ,
         \add_x_87_0/carry[9] , \add_x_87_0/carry[10] , \add_x_87_0/carry[11] ,
         \add_x_87_0/carry[12] , \add_x_87_0/carry[13] ,
         \add_x_87_0/carry[14] , \add_x_87_0/carry[15] , n1, n52, n53, n54,
         n55, n58, n59, n60;
  wire   [30:0] flipping_conf_r;
  wire   [15:0] pattern_counter_r;
  wire   [7:0] bit_counter_r;
  wire   [2:0] test_counter_r;
  wire   [1:0] bist_weight_sel;
  wire   [15:0] pattern_to_apply_r;
  wire   [7:0] bits_to_apply_r;
  wire   [7:1] conf_r;

  dfcrq1ll \pattern_to_apply_r_reg[0]  ( .d(bist_scan_conf_in), .cp(net301), 
        .cdn(n60), .q(pattern_to_apply_r[0]) );
  dfcrq1ll \pattern_to_apply_r_reg[1]  ( .d(pattern_to_apply_r[0]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[1]) );
  dfcrq1ll \pattern_to_apply_r_reg[2]  ( .d(pattern_to_apply_r[1]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[2]) );
  dfcrq1ll \pattern_to_apply_r_reg[3]  ( .d(pattern_to_apply_r[2]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[3]) );
  dfcrq1ll \pattern_to_apply_r_reg[4]  ( .d(pattern_to_apply_r[3]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[4]) );
  dfcrq1ll \pattern_to_apply_r_reg[5]  ( .d(pattern_to_apply_r[4]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[5]) );
  dfcrq1ll \pattern_to_apply_r_reg[6]  ( .d(pattern_to_apply_r[5]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[6]) );
  dfcrq1ll \pattern_to_apply_r_reg[7]  ( .d(pattern_to_apply_r[6]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[7]) );
  dfcrq1ll \pattern_to_apply_r_reg[8]  ( .d(pattern_to_apply_r[7]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[8]) );
  dfcrq1ll \pattern_to_apply_r_reg[9]  ( .d(pattern_to_apply_r[8]), .cp(net301), .cdn(n60), .q(pattern_to_apply_r[9]) );
  dfcrn1ll \pattern_to_apply_r_reg[10]  ( .d(n45), .cp(net301), .cdn(n60), 
        .qn(pattern_to_apply_r[10]) );
  dfcrq1ll \pattern_to_apply_r_reg[11]  ( .d(pattern_to_apply_r[10]), .cp(
        net301), .cdn(n60), .q(pattern_to_apply_r[11]) );
  dfcrq1ll \pattern_to_apply_r_reg[12]  ( .d(pattern_to_apply_r[11]), .cp(
        net301), .cdn(n60), .q(pattern_to_apply_r[12]) );
  dfcrq1ll \pattern_to_apply_r_reg[13]  ( .d(pattern_to_apply_r[12]), .cp(
        net301), .cdn(n60), .q(pattern_to_apply_r[13]) );
  dfcrq1ll \pattern_to_apply_r_reg[14]  ( .d(pattern_to_apply_r[13]), .cp(
        net301), .cdn(n60), .q(pattern_to_apply_r[14]) );
  dfcrq1ll \pattern_to_apply_r_reg[15]  ( .d(pattern_to_apply_r[14]), .cp(
        net301), .cdn(n60), .q(pattern_to_apply_r[15]) );
  dfcrq1ll \bits_to_apply_r_reg[0]  ( .d(pattern_to_apply_r[15]), .cp(net301), 
        .cdn(n60), .q(bits_to_apply_r[0]) );
  dfcrn1ll \bits_to_apply_r_reg[1]  ( .d(n44), .cp(net301), .cdn(n60), .qn(
        bits_to_apply_r[1]) );
  dfcrn1ll \bits_to_apply_r_reg[2]  ( .d(n43), .cp(net301), .cdn(n60), .qn(
        bits_to_apply_r[2]) );
  dfcrn1ll \bits_to_apply_r_reg[3]  ( .d(n42), .cp(net301), .cdn(n60), .qn(
        bits_to_apply_r[3]) );
  dfcrq1ll \bits_to_apply_r_reg[4]  ( .d(bits_to_apply_r[3]), .cp(net301), 
        .cdn(n60), .q(bits_to_apply_r[4]) );
  dfcrn1ll \bits_to_apply_r_reg[5]  ( .d(n41), .cp(net301), .cdn(n60), .qn(
        bits_to_apply_r[5]) );
  dfcrq1ll \bits_to_apply_r_reg[6]  ( .d(bits_to_apply_r[5]), .cp(net301), 
        .cdn(n60), .q(bits_to_apply_r[6]) );
  dfcrq1ll \bits_to_apply_r_reg[7]  ( .d(bits_to_apply_r[6]), .cp(net301), 
        .cdn(n60), .q(bits_to_apply_r[7]) );
  dfcrq1ll \conf_r_reg[0]  ( .d(bits_to_apply_r[7]), .cp(net301), .cdn(n60), 
        .q(n61) );
  dfcrn1ll \conf_r_reg[1]  ( .d(n40), .cp(net301), .cdn(n60), .qn(conf_r[1])
         );
  dfcrn1ll \conf_r_reg[2]  ( .d(n39), .cp(net301), .cdn(n60), .qn(conf_r[2])
         );
  dfcrn1ll \conf_r_reg[3]  ( .d(n38), .cp(net301), .cdn(n60), .qn(conf_r[3])
         );
  dfcrn1ll \conf_r_reg[4]  ( .d(n37), .cp(net301), .cdn(n60), .qn(conf_r[4])
         );
  dfcrn1ll \conf_r_reg[5]  ( .d(n36), .cp(net301), .cdn(n60), .qn(conf_r[5])
         );
  dfcrn1ll \conf_r_reg[6]  ( .d(n35), .cp(net301), .cdn(n60), .qn(conf_r[6])
         );
  dfcrn1ll \conf_r_reg[7]  ( .d(n34), .cp(net301), .cdn(n60), .qn(conf_r[7])
         );
  dfcrq1ll misr_enable_r_reg ( .d(n51), .cp(bist_clk), .cdn(n60), .q(
        misr_enable_r) );
  dfcrq1ll \test_counter_r_reg[0]  ( .d(N71), .cp(net291), .cdn(n60), .q(
        test_counter_r[0]) );
  dfcrq1ll \test_counter_r_reg[1]  ( .d(N72), .cp(net291), .cdn(n60), .q(
        test_counter_r[1]) );
  dfcrq1ll \test_counter_r_reg[2]  ( .d(N74), .cp(net291), .cdn(n60), .q(
        test_counter_r[2]) );
  dfcrq1ll \pattern_counter_r_reg[15]  ( .d(N42), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[15]) );
  dfcrq1ll \pattern_counter_r_reg[0]  ( .d(N26), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[0]) );
  dfcrq1ll \pattern_counter_r_reg[1]  ( .d(N27), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[1]) );
  dfcrq1ll \pattern_counter_r_reg[2]  ( .d(N28), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[2]) );
  dfcrq1ll \pattern_counter_r_reg[3]  ( .d(N29), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[3]) );
  dfcrq1ll \pattern_counter_r_reg[4]  ( .d(N30), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[4]) );
  dfcrq1ll \pattern_counter_r_reg[5]  ( .d(N31), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[5]) );
  dfcrq1ll \pattern_counter_r_reg[6]  ( .d(N32), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[6]) );
  dfcrq1ll \pattern_counter_r_reg[7]  ( .d(N33), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[7]) );
  dfcrq1ll \pattern_counter_r_reg[8]  ( .d(N34), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[8]) );
  dfcrq1ll \pattern_counter_r_reg[9]  ( .d(N35), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[9]) );
  dfcrq1ll \pattern_counter_r_reg[10]  ( .d(N36), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[10]) );
  dfcrq1ll \pattern_counter_r_reg[11]  ( .d(N37), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[11]) );
  dfcrq1ll \pattern_counter_r_reg[12]  ( .d(N38), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[12]) );
  dfcrq1ll \pattern_counter_r_reg[13]  ( .d(N39), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[13]) );
  dfcrq1ll \pattern_counter_r_reg[14]  ( .d(N40), .cp(net281), .cdn(n60), .q(
        pattern_counter_r[14]) );
  dfcrq1ll \bit_counter_r_reg[7]  ( .d(N63), .cp(net286), .cdn(n60), .q(
        bit_counter_r[7]) );
  dfcrq1ll \bit_counter_r_reg[0]  ( .d(N55), .cp(net286), .cdn(n60), .q(
        bit_counter_r[0]) );
  dfcrq1ll \bit_counter_r_reg[1]  ( .d(N56), .cp(net286), .cdn(n60), .q(
        bit_counter_r[1]) );
  dfcrq1ll \bit_counter_r_reg[2]  ( .d(N57), .cp(net286), .cdn(n60), .q(
        bit_counter_r[2]) );
  dfcrq1ll \bit_counter_r_reg[3]  ( .d(N58), .cp(net286), .cdn(n60), .q(
        bit_counter_r[3]) );
  dfcrq1ll \bit_counter_r_reg[4]  ( .d(N59), .cp(net286), .cdn(n60), .q(
        bit_counter_r[4]) );
  dfcrq1ll \bit_counter_r_reg[5]  ( .d(N60), .cp(net286), .cdn(n60), .q(
        bit_counter_r[5]) );
  dfcrq1ll \bit_counter_r_reg[6]  ( .d(N61), .cp(net286), .cdn(n60), .q(
        bit_counter_r[6]) );
  dfcrq1ll \bist_weighting_sel_reg[0]  ( .d(bist_weight_sel[0]), .cp(net296), 
        .cdn(n60), .q(bist_weighting_sel[0]) );
  dfcrq1ll \bist_weighting_sel_reg[1]  ( .d(bist_weight_sel[1]), .cp(net296), 
        .cdn(n60), .q(bist_weighting_sel[1]) );
  dfcrn1ll \flipping_conf_r_reg[0]  ( .d(n33), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[0]) );
  dfcrn1ll \flipping_conf_r_reg[1]  ( .d(n32), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[1]) );
  dfcrn1ll \flipping_conf_r_reg[2]  ( .d(n31), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[2]) );
  dfcrn1ll \flipping_conf_r_reg[3]  ( .d(n30), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[3]) );
  dfcrn1ll \flipping_conf_r_reg[4]  ( .d(n29), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[4]) );
  dfcrn1ll \flipping_conf_r_reg[5]  ( .d(n28), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[5]) );
  dfcrn1ll \flipping_conf_r_reg[6]  ( .d(n27), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[6]) );
  dfcrn1ll \flipping_conf_r_reg[7]  ( .d(n26), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[7]) );
  dfcrn1ll \flipping_conf_r_reg[8]  ( .d(n25), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[8]) );
  dfcrn1ll \flipping_conf_r_reg[9]  ( .d(n24), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[9]) );
  dfcrn1ll \flipping_conf_r_reg[10]  ( .d(n23), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[10]) );
  dfcrn1ll \flipping_conf_r_reg[11]  ( .d(n22), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[11]) );
  dfcrn1ll \flipping_conf_r_reg[12]  ( .d(n21), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[12]) );
  dfcrn1ll \flipping_conf_r_reg[13]  ( .d(n20), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[13]) );
  dfcrn1ll \flipping_conf_r_reg[14]  ( .d(n19), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[14]) );
  dfcrn1ll \flipping_conf_r_reg[15]  ( .d(n18), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[15]) );
  dfcrn1ll \flipping_conf_r_reg[16]  ( .d(n17), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[16]) );
  dfcrn1ll \flipping_conf_r_reg[17]  ( .d(n16), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[17]) );
  dfcrn1ll \flipping_conf_r_reg[18]  ( .d(n15), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[18]) );
  dfcrn1ll \flipping_conf_r_reg[19]  ( .d(n14), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[19]) );
  dfcrn1ll \flipping_conf_r_reg[20]  ( .d(n13), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[20]) );
  dfcrn1ll \flipping_conf_r_reg[21]  ( .d(n12), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[21]) );
  dfcrn1ll \flipping_conf_r_reg[22]  ( .d(n11), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[22]) );
  dfcrn1ll \flipping_conf_r_reg[23]  ( .d(n10), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[23]) );
  dfcrn1ll \flipping_conf_r_reg[24]  ( .d(n9), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[24]) );
  dfcrn1ll \flipping_conf_r_reg[25]  ( .d(n8), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[25]) );
  dfcrn1ll \flipping_conf_r_reg[26]  ( .d(n7), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[26]) );
  dfcrn1ll \flipping_conf_r_reg[27]  ( .d(n6), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[27]) );
  dfcrn1ll \flipping_conf_r_reg[28]  ( .d(n5), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[28]) );
  dfcrn1ll \flipping_conf_r_reg[29]  ( .d(n4), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[29]) );
  dfcrn1ll \flipping_conf_r_reg[30]  ( .d(n3), .cp(net301), .cdn(n60), .qn(
        flipping_conf_r[30]) );
  dfcrn1ll \flipping_conf_r_reg[31]  ( .d(n2), .cp(net301), .cdn(n60), .qn(
        bist_scan_conf_out) );
  dfcrq1ll \bist_flipping_sel_reg[31]  ( .d(N109), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[31]) );
  dfcrq1ll \bist_flipping_sel_reg[30]  ( .d(N108), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[30]) );
  dfcrq1ll \bist_flipping_sel_reg[29]  ( .d(N107), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[29]) );
  dfcrq1ll \bist_flipping_sel_reg[28]  ( .d(N106), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[28]) );
  dfcrq1ll \bist_flipping_sel_reg[27]  ( .d(N105), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[27]) );
  dfcrq1ll \bist_flipping_sel_reg[26]  ( .d(N104), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[26]) );
  dfcrq1ll \bist_flipping_sel_reg[25]  ( .d(N103), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[25]) );
  dfcrq1ll \bist_flipping_sel_reg[24]  ( .d(N102), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[24]) );
  dfcrq1ll \bist_flipping_sel_reg[23]  ( .d(N101), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[23]) );
  dfcrq1ll \bist_flipping_sel_reg[22]  ( .d(N100), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[22]) );
  dfcrq1ll \bist_flipping_sel_reg[21]  ( .d(N99), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[21]) );
  dfcrq1ll \bist_flipping_sel_reg[20]  ( .d(N98), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[20]) );
  dfcrq1ll \bist_flipping_sel_reg[19]  ( .d(N97), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[19]) );
  dfcrq1ll \bist_flipping_sel_reg[18]  ( .d(N96), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[18]) );
  dfcrq1ll \bist_flipping_sel_reg[17]  ( .d(N95), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[17]) );
  dfcrq1ll \bist_flipping_sel_reg[16]  ( .d(N94), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[16]) );
  dfcrq1ll \bist_flipping_sel_reg[15]  ( .d(N93), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[15]) );
  dfcrq1ll \bist_flipping_sel_reg[14]  ( .d(N92), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[14]) );
  dfcrq1ll \bist_flipping_sel_reg[13]  ( .d(N91), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[13]) );
  dfcrq1ll \bist_flipping_sel_reg[12]  ( .d(N90), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[12]) );
  dfcrq1ll \bist_flipping_sel_reg[11]  ( .d(N89), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[11]) );
  dfcrq1ll \bist_flipping_sel_reg[10]  ( .d(N88), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[10]) );
  dfcrq1ll \bist_flipping_sel_reg[9]  ( .d(N87), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[9]) );
  dfcrq1ll \bist_flipping_sel_reg[8]  ( .d(N86), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[8]) );
  dfcrq1ll \bist_flipping_sel_reg[7]  ( .d(N85), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[7]) );
  dfcrq1ll \bist_flipping_sel_reg[6]  ( .d(N84), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[6]) );
  dfcrq1ll \bist_flipping_sel_reg[5]  ( .d(N83), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[5]) );
  dfcrq1ll \bist_flipping_sel_reg[4]  ( .d(N82), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[4]) );
  dfcrq1ll \bist_flipping_sel_reg[3]  ( .d(N81), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[3]) );
  dfcrq1ll \bist_flipping_sel_reg[2]  ( .d(N80), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[2]) );
  dfcrq1ll \bist_flipping_sel_reg[1]  ( .d(N79), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[1]) );
  dfcrq1ll \bist_flipping_sel_reg[0]  ( .d(N78), .cp(net296), .cdn(n60), .q(
        bist_flipping_sel[0]) );
  aor21d1ll U47 ( .b1(misr_enable_r), .b2(n46), .a(misr_enable_set), .z(n51)
         );
  aoi31d1ll U70 ( .b1(test_counter_r[2]), .b2(test_counter_r[0]), .b3(
        test_counter_r[1]), .a(n47), .zn(N74) );
  aon211d1ll U71 ( .c1(test_counter_r[0]), .c2(test_counter_r[1]), .b(
        test_counter_r[2]), .a(testcounter_inc), .zn(n47) );
  aoi221d1ll U74 ( .b1(test_counter_r[0]), .b2(test_counter_r[1]), .c1(n49), 
        .c2(n50), .a(n48), .zn(N72) );
  bistcontroller_fsm U_BISTCONTROLLER_FSM ( .bist_done(bist_done), .bist_en(
        bist_en), .bist_scan_en(bist_scan_en), .bist_lfsr_en(bist_lfsr_en), 
        .bist_misr_en(bist_misr_en), .bist_weight_sel(bist_weight_sel), 
        .bist_weight_load(bist_weight_load), .bist_flip_en(bist_flip_en), 
        .bitcounter_inc(n55), .patterncounter_inc(n59), .testcounter_inc(
        testcounter_inc), .patterncounter_rst(patterncounter_rst), 
        .bitcounter_rst(n58), .testcounter_rst(testcounter_rst), 
        .misr_enable_set(misr_enable_set), .bist_clk(bist_clk), .bist_rst_n(
        n60), .bist_start(bist_start), .bit_counter_r(bit_counter_r), 
        .bits_to_apply_r(bits_to_apply_r), .pattern_counter_r(
        pattern_counter_r), .pattern_to_apply_r(pattern_to_apply_r), 
        .test_counter_r(test_counter_r), .conf_r({conf_r, n61}), 
        .misr_enable_r(misr_enable_r) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_4 clk_gate_pattern_counter_r_reg ( .CLK(
        bist_clk), .EN(N41), .ENCLK(net281), .TE(1'b0) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_3 clk_gate_bit_counter_r_reg ( .CLK(
        bist_clk), .EN(N62), .ENCLK(net286), .TE(1'b0) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_2 clk_gate_test_counter_r_reg ( .CLK(
        bist_clk), .EN(N73), .ENCLK(net291), .TE(1'b0) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_1 clk_gate_bist_weighting_sel_reg ( 
        .CLK(bist_clk), .EN(bist_weight_load), .ENCLK(net296), .TE(1'b0) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_0 clk_gate_pattern_to_apply_r_reg ( 
        .CLK(bist_clk), .EN(bist_scan_conf_en), .ENCLK(net301), .TE(1'b0) );
  or02d1ll U89 ( .a1(n59), .a2(patterncounter_rst), .z(N41) );
  inv0d1ll U78 ( .i(testcounter_inc), .zn(n48) );
  inv0d1ll U73 ( .i(testcounter_rst), .zn(n46) );
  nd02d1ll U72 ( .a1(n48), .a2(n46), .zn(N73) );
  an02d1ll U90 ( .a1(n59), .a2(N24), .z(N40) );
  an02d1ll U85 ( .a1(n55), .a2(N49), .z(N57) );
  an02d1ll U84 ( .a1(n55), .a2(N50), .z(N58) );
  an02d1ll U82 ( .a1(n55), .a2(N52), .z(N60) );
  an02d1ll U83 ( .a1(n55), .a2(N51), .z(N59) );
  an02d1ll U86 ( .a1(n55), .a2(N48), .z(N56) );
  an02d1ll U81 ( .a1(n55), .a2(N53), .z(N61) );
  an02d1ll U91 ( .a1(n59), .a2(N23), .z(N39) );
  an02d1ll U48 ( .a1(bist_flip_en), .a2(flipping_conf_r[21]), .z(N99) );
  an02d1ll U50 ( .a1(bist_flip_en), .a2(flipping_conf_r[19]), .z(N97) );
  an02d1ll U49 ( .a1(bist_flip_en), .a2(flipping_conf_r[20]), .z(N98) );
  an02d1ll U105 ( .a1(bist_flip_en), .a2(bist_scan_conf_out), .z(N109) );
  an02d1ll U106 ( .a1(bist_flip_en), .a2(flipping_conf_r[30]), .z(N108) );
  an02d1ll U107 ( .a1(bist_flip_en), .a2(flipping_conf_r[29]), .z(N107) );
  an02d1ll U108 ( .a1(bist_flip_en), .a2(flipping_conf_r[28]), .z(N106) );
  an02d1ll U109 ( .a1(bist_flip_en), .a2(flipping_conf_r[27]), .z(N105) );
  an02d1ll U110 ( .a1(bist_flip_en), .a2(flipping_conf_r[26]), .z(N104) );
  an02d1ll U111 ( .a1(bist_flip_en), .a2(flipping_conf_r[25]), .z(N103) );
  an02d1ll U112 ( .a1(bist_flip_en), .a2(flipping_conf_r[24]), .z(N102) );
  an02d1ll U113 ( .a1(bist_flip_en), .a2(flipping_conf_r[23]), .z(N101) );
  an02d1ll U114 ( .a1(bist_flip_en), .a2(flipping_conf_r[22]), .z(N100) );
  an02d1ll U59 ( .a1(bist_flip_en), .a2(flipping_conf_r[10]), .z(N88) );
  an02d1ll U60 ( .a1(bist_flip_en), .a2(flipping_conf_r[9]), .z(N87) );
  an02d1ll U61 ( .a1(bist_flip_en), .a2(flipping_conf_r[8]), .z(N86) );
  an02d1ll U51 ( .a1(bist_flip_en), .a2(flipping_conf_r[18]), .z(N96) );
  an02d1ll U52 ( .a1(bist_flip_en), .a2(flipping_conf_r[17]), .z(N95) );
  an02d1ll U53 ( .a1(bist_flip_en), .a2(flipping_conf_r[16]), .z(N94) );
  an02d1ll U54 ( .a1(bist_flip_en), .a2(flipping_conf_r[15]), .z(N93) );
  an02d1ll U55 ( .a1(bist_flip_en), .a2(flipping_conf_r[14]), .z(N92) );
  an02d1ll U56 ( .a1(bist_flip_en), .a2(flipping_conf_r[13]), .z(N91) );
  an02d1ll U57 ( .a1(bist_flip_en), .a2(flipping_conf_r[12]), .z(N90) );
  an02d1ll U58 ( .a1(bist_flip_en), .a2(flipping_conf_r[11]), .z(N89) );
  an02d1ll U64 ( .a1(bist_flip_en), .a2(flipping_conf_r[5]), .z(N83) );
  an02d1ll U65 ( .a1(bist_flip_en), .a2(flipping_conf_r[4]), .z(N82) );
  an02d1ll U69 ( .a1(bist_flip_en), .a2(flipping_conf_r[0]), .z(N78) );
  an02d1ll U62 ( .a1(bist_flip_en), .a2(flipping_conf_r[7]), .z(N85) );
  an02d1ll U63 ( .a1(bist_flip_en), .a2(flipping_conf_r[6]), .z(N84) );
  an02d1ll U66 ( .a1(bist_flip_en), .a2(flipping_conf_r[3]), .z(N81) );
  an02d1ll U68 ( .a1(bist_flip_en), .a2(flipping_conf_r[1]), .z(N79) );
  an02d1ll U67 ( .a1(bist_flip_en), .a2(flipping_conf_r[2]), .z(N80) );
  an02d1ll U92 ( .a1(n59), .a2(N22), .z(N38) );
  an02d1ll U93 ( .a1(n59), .a2(N21), .z(N37) );
  an02d1ll U94 ( .a1(n59), .a2(N20), .z(N36) );
  an02d1ll U98 ( .a1(n59), .a2(N16), .z(N32) );
  an02d1ll U99 ( .a1(n59), .a2(N15), .z(N31) );
  an02d1ll U103 ( .a1(n59), .a2(N11), .z(N27) );
  an02d1ll U100 ( .a1(n59), .a2(N14), .z(N30) );
  an02d1ll U101 ( .a1(n59), .a2(N13), .z(N29) );
  an02d1ll U96 ( .a1(n59), .a2(N18), .z(N34) );
  an02d1ll U95 ( .a1(n59), .a2(N19), .z(N35) );
  an02d1ll U97 ( .a1(n59), .a2(N17), .z(N33) );
  an02d1ll U102 ( .a1(n59), .a2(N12), .z(N28) );
  inv0d1ll U75 ( .i(test_counter_r[1]), .zn(n50) );
  or02d1ll U80 ( .a1(n55), .a2(n58), .z(N62) );
  nr02d1ll U77 ( .a1(test_counter_r[0]), .a2(n48), .zn(N71) );
  inv0d1ll U40 ( .i(conf_r[1]), .zn(n39) );
  inv0d1ll U39 ( .i(conf_r[2]), .zn(n38) );
  inv0d1ll U41 ( .i(n61), .zn(n40) );
  inv0d1ll U37 ( .i(conf_r[4]), .zn(n36) );
  inv0d1ll U36 ( .i(conf_r[5]), .zn(n35) );
  inv0d1ll U35 ( .i(conf_r[6]), .zn(n34) );
  inv0d1ll U38 ( .i(conf_r[3]), .zn(n37) );
  inv0d1ll U45 ( .i(bits_to_apply_r[0]), .zn(n44) );
  inv0d1ll U42 ( .i(bits_to_apply_r[4]), .zn(n41) );
  inv0d1ll U46 ( .i(pattern_to_apply_r[9]), .zn(n45) );
  inv0d1ll U8 ( .i(flipping_conf_r[25]), .zn(n7) );
  inv0d1ll U5 ( .i(flipping_conf_r[28]), .zn(n4) );
  inv0d1ll U4 ( .i(flipping_conf_r[29]), .zn(n3) );
  inv0d1ll U12 ( .i(flipping_conf_r[21]), .zn(n11) );
  inv0d1ll U6 ( .i(flipping_conf_r[27]), .zn(n5) );
  inv0d1ll U11 ( .i(flipping_conf_r[22]), .zn(n10) );
  inv0d1ll U25 ( .i(flipping_conf_r[8]), .zn(n24) );
  inv0d1ll U7 ( .i(flipping_conf_r[26]), .zn(n6) );
  inv0d1ll U14 ( .i(flipping_conf_r[19]), .zn(n13) );
  inv0d1ll U13 ( .i(flipping_conf_r[20]), .zn(n12) );
  inv0d1ll U3 ( .i(flipping_conf_r[30]), .zn(n2) );
  inv0d1ll U16 ( .i(flipping_conf_r[17]), .zn(n15) );
  inv0d1ll U17 ( .i(flipping_conf_r[16]), .zn(n16) );
  inv0d1ll U18 ( .i(flipping_conf_r[15]), .zn(n17) );
  inv0d1ll U24 ( .i(flipping_conf_r[9]), .zn(n23) );
  inv0d1ll U19 ( .i(flipping_conf_r[14]), .zn(n18) );
  inv0d1ll U32 ( .i(flipping_conf_r[1]), .zn(n31) );
  inv0d1ll U20 ( .i(flipping_conf_r[13]), .zn(n19) );
  inv0d1ll U26 ( .i(flipping_conf_r[7]), .zn(n25) );
  inv0d1ll U21 ( .i(flipping_conf_r[12]), .zn(n20) );
  inv0d1ll U22 ( .i(flipping_conf_r[11]), .zn(n21) );
  inv0d1ll U23 ( .i(flipping_conf_r[10]), .zn(n22) );
  inv0d1ll U9 ( .i(flipping_conf_r[24]), .zn(n8) );
  inv0d1ll U10 ( .i(flipping_conf_r[23]), .zn(n9) );
  inv0d1ll U33 ( .i(flipping_conf_r[0]), .zn(n32) );
  inv0d1ll U28 ( .i(flipping_conf_r[5]), .zn(n27) );
  inv0d1ll U27 ( .i(flipping_conf_r[6]), .zn(n26) );
  inv0d1ll U29 ( .i(flipping_conf_r[4]), .zn(n28) );
  inv0d1ll U31 ( .i(flipping_conf_r[2]), .zn(n30) );
  inv0d1ll U15 ( .i(flipping_conf_r[18]), .zn(n14) );
  inv0d1ll U30 ( .i(flipping_conf_r[3]), .zn(n29) );
  inv0d1ll U43 ( .i(bits_to_apply_r[2]), .zn(n42) );
  inv0d1ll U44 ( .i(bits_to_apply_r[1]), .zn(n43) );
  ah01d1ll \add_x_102_0/U1_1_6  ( .a(bit_counter_r[6]), .b(
        \add_x_102_0/carry[6] ), .co(\add_x_102_0/carry[7] ), .s(N53) );
  ah01d1ll \add_x_102_0/U1_1_5  ( .a(bit_counter_r[5]), .b(
        \add_x_102_0/carry[5] ), .co(\add_x_102_0/carry[6] ), .s(N52) );
  ah01d1ll \add_x_102_0/U1_1_4  ( .a(bit_counter_r[4]), .b(
        \add_x_102_0/carry[4] ), .co(\add_x_102_0/carry[5] ), .s(N51) );
  ah01d1ll \add_x_102_0/U1_1_3  ( .a(bit_counter_r[3]), .b(
        \add_x_102_0/carry[3] ), .co(\add_x_102_0/carry[4] ), .s(N50) );
  ah01d1ll \add_x_102_0/U1_1_2  ( .a(bit_counter_r[2]), .b(
        \add_x_102_0/carry[2] ), .co(\add_x_102_0/carry[3] ), .s(N49) );
  ah01d1ll \add_x_102_0/U1_1_1  ( .a(bit_counter_r[1]), .b(bit_counter_r[0]), 
        .co(\add_x_102_0/carry[2] ), .s(N48) );
  ah01d1ll \add_x_87_0/U1_1_14  ( .a(pattern_counter_r[14]), .b(
        \add_x_87_0/carry[14] ), .co(\add_x_87_0/carry[15] ), .s(N24) );
  ah01d1ll \add_x_87_0/U1_1_13  ( .a(pattern_counter_r[13]), .b(
        \add_x_87_0/carry[13] ), .co(\add_x_87_0/carry[14] ), .s(N23) );
  ah01d1ll \add_x_87_0/U1_1_12  ( .a(pattern_counter_r[12]), .b(
        \add_x_87_0/carry[12] ), .co(\add_x_87_0/carry[13] ), .s(N22) );
  ah01d1ll \add_x_87_0/U1_1_11  ( .a(pattern_counter_r[11]), .b(
        \add_x_87_0/carry[11] ), .co(\add_x_87_0/carry[12] ), .s(N21) );
  ah01d1ll \add_x_87_0/U1_1_10  ( .a(pattern_counter_r[10]), .b(
        \add_x_87_0/carry[10] ), .co(\add_x_87_0/carry[11] ), .s(N20) );
  ah01d1ll \add_x_87_0/U1_1_9  ( .a(pattern_counter_r[9]), .b(
        \add_x_87_0/carry[9] ), .co(\add_x_87_0/carry[10] ), .s(N19) );
  ah01d1ll \add_x_87_0/U1_1_8  ( .a(pattern_counter_r[8]), .b(
        \add_x_87_0/carry[8] ), .co(\add_x_87_0/carry[9] ), .s(N18) );
  ah01d1ll \add_x_87_0/U1_1_7  ( .a(pattern_counter_r[7]), .b(
        \add_x_87_0/carry[7] ), .co(\add_x_87_0/carry[8] ), .s(N17) );
  ah01d1ll \add_x_87_0/U1_1_6  ( .a(pattern_counter_r[6]), .b(
        \add_x_87_0/carry[6] ), .co(\add_x_87_0/carry[7] ), .s(N16) );
  ah01d1ll \add_x_87_0/U1_1_5  ( .a(pattern_counter_r[5]), .b(
        \add_x_87_0/carry[5] ), .co(\add_x_87_0/carry[6] ), .s(N15) );
  ah01d1ll \add_x_87_0/U1_1_4  ( .a(pattern_counter_r[4]), .b(
        \add_x_87_0/carry[4] ), .co(\add_x_87_0/carry[5] ), .s(N14) );
  ah01d1ll \add_x_87_0/U1_1_3  ( .a(pattern_counter_r[3]), .b(
        \add_x_87_0/carry[3] ), .co(\add_x_87_0/carry[4] ), .s(N13) );
  ah01d1ll \add_x_87_0/U1_1_2  ( .a(pattern_counter_r[2]), .b(
        \add_x_87_0/carry[2] ), .co(\add_x_87_0/carry[3] ), .s(N12) );
  ah01d1ll \add_x_87_0/U1_1_1  ( .a(pattern_counter_r[1]), .b(
        pattern_counter_r[0]), .co(\add_x_87_0/carry[2] ), .s(N11) );
  inv0d0ll U34 ( .i(conf_r[7]), .zn(n33) );
  inv0d0ll U76 ( .i(test_counter_r[0]), .zn(n49) );
  inv0d0ll U79 ( .i(n55), .zn(n1) );
  nr02d0ll U87 ( .a1(bit_counter_r[0]), .a2(n1), .zn(N55) );
  inv0d0ll U88 ( .i(n59), .zn(n52) );
  nr02d0ll U104 ( .a1(pattern_counter_r[0]), .a2(n52), .zn(N26) );
  oai21d1ll U115 ( .b1(\add_x_102_0/carry[7] ), .b2(bit_counter_r[7]), .a(n55), 
        .zn(n53) );
  aoi21d1ll U116 ( .b1(\add_x_102_0/carry[7] ), .b2(bit_counter_r[7]), .a(n53), 
        .zn(N63) );
  oai21d1ll U117 ( .b1(\add_x_87_0/carry[15] ), .b2(pattern_counter_r[15]), 
        .a(n59), .zn(n54) );
  aoi21d1ll U118 ( .b1(\add_x_87_0/carry[15] ), .b2(pattern_counter_r[15]), 
        .a(n54), .zn(N42) );
  buffd7ll U119 ( .i(bist_rst_n), .z(n60) );
endmodule


module clockcontroller ( sys_clk, bist_clk, clockconf_scan_out, ext_clk, 
        osc_clk, rst_n, bist_en, ext_test_en, bist_scan_en, ext_scan_en, 
        clockconf_scan_in, clockconf_scan_en );
  input ext_clk, osc_clk, rst_n, bist_en, ext_test_en, bist_scan_en,
         ext_scan_en, clockconf_scan_in, clockconf_scan_en;
  output sys_clk, bist_clk, clockconf_scan_out;
  wire   N16, N17, N18, N19, N20, N21, N22, osc_clk_div, bist_scan_clk,
         scan_en, scan_enable_pipeline_sel, test_en, test_clk, lc_clk,
         scan_clk, net230, n1, n2, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13,
         n14, n15, n16, n17, n18, n19, \add_x_126_0/carry[2] ,
         \add_x_126_0/carry[3] , \add_x_126_0/carry[4] ,
         \add_x_126_0/carry[5] , \add_x_126_0/carry[6] ;
  wire   [1:0] mode;
  wire   [2:0] osc_clk_div_sel;
  wire   [1:0] bist_scan_clk_div_sel;
  wire   [6:0] osc_clockdivider;
  wire   [3:0] scan_enable_pipeline;

  dfnrq1ll \osc_clockdivider_reg[0]  ( .d(N16), .cp(osc_clk), .q(
        osc_clockdivider[0]) );
  dfnrq1ll \osc_clockdivider_reg[1]  ( .d(N17), .cp(osc_clk), .q(
        osc_clockdivider[1]) );
  dfnrq1ll \osc_clockdivider_reg[2]  ( .d(N18), .cp(osc_clk), .q(
        osc_clockdivider[2]) );
  dfnrq1ll \osc_clockdivider_reg[3]  ( .d(N19), .cp(osc_clk), .q(
        osc_clockdivider[3]) );
  dfnrq1ll \osc_clockdivider_reg[4]  ( .d(N20), .cp(osc_clk), .q(
        osc_clockdivider[4]) );
  dfnrq1ll \osc_clockdivider_reg[5]  ( .d(N21), .cp(osc_clk), .q(
        osc_clockdivider[5]) );
  dfnrq1ll \osc_clockdivider_reg[6]  ( .d(N22), .cp(osc_clk), .q(
        osc_clockdivider[6]) );
  dfcrn1ll \clockconf_reg[1]  ( .d(n2), .cp(net230), .cdn(rst_n), .qn(mode[1])
         );
  dfcrq1ll \clockconf_reg[2]  ( .d(mode[1]), .cp(net230), .cdn(rst_n), .q(
        osc_clk_div_sel[0]) );
  dfcrn1ll \clockconf_reg[3]  ( .d(n12), .cp(net230), .cdn(rst_n), .qn(
        osc_clk_div_sel[1]) );
  dfcrn1ll \clockconf_reg[4]  ( .d(n11), .cp(net230), .cdn(rst_n), .qn(
        osc_clk_div_sel[2]) );
  dfcrn1ll \clockconf_reg[5]  ( .d(n1), .cp(net230), .cdn(rst_n), .qn(
        bist_scan_clk_div_sel[0]) );
  dfcrn1ll \clockconf_reg[6]  ( .d(n19), .cp(net230), .cdn(rst_n), .qn(
        bist_scan_clk_div_sel[1]) );
  dfcrn1ll \clockconf_reg[7]  ( .d(n18), .cp(net230), .cdn(rst_n), .qn(
        clockconf_scan_out) );
  dfcrq1ll \scan_enable_pipeline_reg[0]  ( .d(scan_en), .cp(osc_clk_div), 
        .cdn(rst_n), .q(scan_enable_pipeline[0]) );
  dfcrq1ll \scan_enable_pipeline_reg[1]  ( .d(scan_enable_pipeline[0]), .cp(
        osc_clk_div), .cdn(rst_n), .q(scan_enable_pipeline[1]) );
  dfcrq1ll \scan_enable_pipeline_reg[2]  ( .d(scan_enable_pipeline[1]), .cp(
        osc_clk_div), .cdn(rst_n), .q(scan_enable_pipeline[2]) );
  dfcrq1ll \scan_enable_pipeline_reg[3]  ( .d(scan_enable_pipeline[2]), .cp(
        osc_clk_div), .cdn(rst_n), .q(scan_enable_pipeline[3]) );
  oai22d1ll U7 ( .a1(scan_enable_pipeline[2]), .a2(n4), .b1(
        scan_enable_pipeline[1]), .b2(n5), .zn(scan_enable_pipeline_sel) );
  oaim21d1ll U12 ( .b1(n9), .b2(n10), .a(osc_clk_div_sel[2]), .zn(n8) );
  oai221d1ll U13 ( .b1(osc_clk_div_sel[1]), .b2(osc_clockdivider[3]), .c1(n11), 
        .c2(osc_clockdivider[5]), .a(n12), .zn(n10) );
  oai221d1ll U14 ( .b1(osc_clk_div_sel[1]), .b2(osc_clockdivider[4]), .c1(n11), 
        .c2(osc_clockdivider[6]), .a(osc_clk_div_sel[0]), .zn(n9) );
  oai221d1ll U15 ( .b1(osc_clk_div_sel[1]), .b2(osc_clk), .c1(n11), .c2(
        osc_clockdivider[1]), .a(n12), .zn(n7) );
  oai221d1ll U17 ( .b1(osc_clk_div_sel[1]), .b2(osc_clockdivider[0]), .c1(n11), 
        .c2(osc_clockdivider[2]), .a(osc_clk_div_sel[0]), .zn(n6) );
  aon211d1ll U19 ( .c1(n13), .c2(n14), .b(clockconf_scan_out), .a(n15), .zn(
        bist_scan_clk) );
  oaim21d1ll U20 ( .b1(n16), .b2(n17), .a(clockconf_scan_out), .zn(n15) );
  oai221d1ll U21 ( .b1(n18), .b2(osc_clockdivider[5]), .c1(
        bist_scan_clk_div_sel[1]), .c2(osc_clockdivider[3]), .a(n19), .zn(n17)
         );
  oai221d1ll U22 ( .b1(n18), .b2(osc_clockdivider[6]), .c1(
        bist_scan_clk_div_sel[1]), .c2(osc_clockdivider[4]), .a(
        bist_scan_clk_div_sel[0]), .zn(n16) );
  oai221d1ll U23 ( .b1(n18), .b2(osc_clockdivider[1]), .c1(
        bist_scan_clk_div_sel[1]), .c2(osc_clk), .a(n19), .zn(n14) );
  oai221d1ll U25 ( .b1(n18), .b2(osc_clockdivider[2]), .c1(
        bist_scan_clk_div_sel[1]), .c2(osc_clockdivider[0]), .a(
        bist_scan_clk_div_sel[0]), .zn(n13) );
  clockmux2_4 U_CLOCKMUX2_0 ( .clk_out(sys_clk), .clk1(test_clk), .clk2(
        osc_clk_div), .clk_sel(test_en) );
  clockmux2_3 U_CLOCKMUX2_1 ( .clk_out(lc_clk), .clk1(osc_clk_div), .clk2(1'b0), .clk_sel(scan_enable_pipeline_sel) );
  clockmux2_2 U_CLOCKMUX2_2 ( .clk_out(test_clk), .clk1(scan_clk), .clk2(
        lc_clk), .clk_sel(scan_en) );
  clockmux2_1 U_CLOCKMUX2_3 ( .clk_out(bist_clk), .clk1(ext_clk), .clk2(
        bist_scan_clk), .clk_sel(ext_test_en) );
  clockmux2_0 U_CLOCKMUX2_4 ( .clk_out(scan_clk), .clk1(bist_scan_clk), .clk2(
        ext_clk), .clk_sel(bist_en) );
  SNPS_CLOCK_GATE_HIGH_clockcontroller clk_gate_clockconf_reg ( .CLK(bist_clk), 
        .EN(clockconf_scan_en), .ENCLK(net230), .TE(1'b0) );
  inv0d1ll U24 ( .i(bist_scan_clk_div_sel[0]), .zn(n19) );
  inv0d1ll U16 ( .i(osc_clk_div_sel[0]), .zn(n12) );
  inv0d1ll U26 ( .i(bist_scan_clk_div_sel[1]), .zn(n18) );
  inv0d1ll U18 ( .i(osc_clk_div_sel[1]), .zn(n11) );
  aon211d1ll U11 ( .c1(n6), .c2(n7), .b(osc_clk_div_sel[2]), .a(n8), .zn(
        osc_clk_div) );
  or02d1ll U6 ( .a1(bist_en), .a2(ext_test_en), .z(test_en) );
  inv0d1ll U3 ( .i(osc_clk_div_sel[2]), .zn(n1) );
  or02d1ll U10 ( .a1(bist_scan_en), .a2(ext_scan_en), .z(scan_en) );
  ah01d1ll \add_x_126_0/U1_1_5  ( .a(osc_clockdivider[5]), .b(
        \add_x_126_0/carry[5] ), .co(\add_x_126_0/carry[6] ), .s(N21) );
  ah01d1ll \add_x_126_0/U1_1_4  ( .a(osc_clockdivider[4]), .b(
        \add_x_126_0/carry[4] ), .co(\add_x_126_0/carry[5] ), .s(N20) );
  ah01d1ll \add_x_126_0/U1_1_3  ( .a(osc_clockdivider[3]), .b(
        \add_x_126_0/carry[3] ), .co(\add_x_126_0/carry[4] ), .s(N19) );
  ah01d1ll \add_x_126_0/U1_1_2  ( .a(osc_clockdivider[2]), .b(
        \add_x_126_0/carry[2] ), .co(\add_x_126_0/carry[3] ), .s(N18) );
  ah01d1ll \add_x_126_0/U1_1_1  ( .a(osc_clockdivider[1]), .b(
        osc_clockdivider[0]), .co(\add_x_126_0/carry[2] ), .s(N17) );
  nd02d0ll U9 ( .a1(scan_enable_pipeline[3]), .a2(mode[1]), .zn(n4) );
  nd02d0ll U8 ( .a1(scan_enable_pipeline[2]), .a2(mode[0]), .zn(n5) );
  dfprb1ll \clockconf_reg[0]  ( .d(clockconf_scan_in), .cp(net230), .sdn(rst_n), .q(mode[0]), .qn(n2) );
  inv0d0ll U4 ( .i(osc_clockdivider[0]), .zn(N16) );
  aoim22d1ll U5 ( .a1(\add_x_126_0/carry[6] ), .a2(osc_clockdivider[6]), .b1(
        osc_clockdivider[6]), .b2(\add_x_126_0/carry[6] ), .zn(N22) );
endmodule


module bisttop ( bist_en, bist_done, bist_scan_en, bist_scan_inputs, 
        bisttop_scan_conf_out, bist_clk, bist_rst_n, bist_start, 
        bist_scan_outputs, bisttop_scan_conf_in, bisttop_scan_conf_en );
  output [31:0] bist_scan_inputs;
  input [31:0] bist_scan_outputs;
  input bist_clk, bist_rst_n, bist_start, bisttop_scan_conf_in,
         bisttop_scan_conf_en;
  output bist_en, bist_done, bist_scan_en, bisttop_scan_conf_out;
  wire   misr_en, misr_si, lfsr_si, n1;
  wire   [31:0] phaseshifter_in;
  wire   [31:0] weighting_in;
  wire   [31:0] flipping_in;
  wire   [31:0] misr_in;
  wire   [31:0] flipping_sel;
  wire   [1:0] weighting_sel;
  wire   SYNOPSYS_UNCONNECTED__0;

  bistcontroller U_BISTCONTROLLER ( .bist_done(bist_done), .bist_en(bist_en), 
        .bist_lfsr_en(n1), .bist_misr_en(misr_en), .bist_scan_en(bist_scan_en), 
        .bist_weighting_sel(weighting_sel), .bist_flipping_sel(flipping_sel), 
        .bist_scan_conf_out(lfsr_si), .bist_start(bist_start), .bist_clk(
        bist_clk), .bist_rst_n(bist_rst_n), .bist_scan_conf_in(
        bisttop_scan_conf_in), .bist_scan_conf_en(bisttop_scan_conf_en) );
  lfsr U_LFSR ( .lfsr_out({phaseshifter_in[31:1], SYNOPSYS_UNCONNECTED__0}), 
        .lfsr_so(misr_si), .lfsr_clk(bist_clk), .lfsr_rst_n(bist_rst_n), 
        .lfsr_en(n1), .lfsr_load(bisttop_scan_conf_en), .lfsr_si(lfsr_si) );
  phaseshifter U_PHASESHIFTER ( .phaseshifter_out(weighting_in), 
        .phaseshifter_in({phaseshifter_in[31:1], 1'b0}) );
  flipping U_FLIPPING ( .flipping_out(bist_scan_inputs), .flipping_in(
        flipping_in), .flipping_sel(flipping_sel) );
  weighting U_WEIGHTING ( .weighting_out(flipping_in), .weighting_in(
        weighting_in), .weighting_sel(weighting_sel) );
  concentrator U_CONSENTRATOR ( .concentrator_out(misr_in), .concentrator_in(
        bist_scan_outputs) );
  misr U_MISR ( .misr_so(bisttop_scan_conf_out), .misr_clk(bist_clk), 
        .misr_rst_n(bist_rst_n), .misr_en(misr_en), .misr_load(
        bisttop_scan_conf_en), .misr_si(misr_si), .misr_in(misr_in) );
endmodule


module mux_SIZE4_7 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n1;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n1), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n1), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n1), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n1), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n1) );
endmodule


module chip ( bist_done, conf_scan_out, scan_inputs, scan_en, ext_scan_out, 
        sys_clk, rst_n, ext_clk, bist_start, ext_test_en, ext_scan_en, 
        ext_scan_in, conf_scan_en, conf_scan_in, scan_outputs, osc_clk );
  output [31:0] scan_inputs;
  output [3:0] ext_scan_out;
  input [3:0] ext_scan_in;
  input [31:0] scan_outputs;
  input rst_n, ext_clk, bist_start, ext_test_en, ext_scan_en, conf_scan_en,
         conf_scan_in, osc_clk;
  output bist_done, conf_scan_out, scan_en, sys_clk;
  wire   bisttop_scan_conf_in, bist_en, bist_clk, n1;
  wire   [31:0] bist_scan_inputs;
  assign ext_scan_out[3] = scan_outputs[31];
  assign ext_scan_out[2] = scan_outputs[30];
  assign ext_scan_out[1] = scan_outputs[29];
  assign ext_scan_out[0] = scan_outputs[28];

  mux_SIZE4_7 U_MUX_0 ( .out(scan_inputs[3:0]), .sel(bist_en), .ina(
        bist_scan_inputs[3:0]), .inb(ext_scan_in) );
  mux_SIZE4_6 \muxing[1].U_MUX_  ( .out(scan_inputs[7:4]), .sel(bist_en), 
        .ina(bist_scan_inputs[7:4]), .inb(scan_outputs[3:0]) );
  mux_SIZE4_5 \muxing[2].U_MUX_  ( .out(scan_inputs[11:8]), .sel(bist_en), 
        .ina(bist_scan_inputs[11:8]), .inb(scan_outputs[7:4]) );
  mux_SIZE4_4 \muxing[3].U_MUX_  ( .out(scan_inputs[15:12]), .sel(bist_en), 
        .ina(bist_scan_inputs[15:12]), .inb(scan_outputs[11:8]) );
  mux_SIZE4_3 \muxing[4].U_MUX_  ( .out(scan_inputs[19:16]), .sel(bist_en), 
        .ina(bist_scan_inputs[19:16]), .inb(scan_outputs[15:12]) );
  mux_SIZE4_2 \muxing[5].U_MUX_  ( .out(scan_inputs[23:20]), .sel(bist_en), 
        .ina(bist_scan_inputs[23:20]), .inb(scan_outputs[19:16]) );
  mux_SIZE4_1 \muxing[6].U_MUX_  ( .out(scan_inputs[27:24]), .sel(bist_en), 
        .ina(bist_scan_inputs[27:24]), .inb(scan_outputs[23:20]) );
  mux_SIZE4_0 \muxing[7].U_MUX_  ( .out(scan_inputs[31:28]), .sel(bist_en), 
        .ina(bist_scan_inputs[31:28]), .inb(scan_outputs[27:24]) );
  bisttop U_BISTTOP ( .bist_en(bist_en), .bist_done(bist_done), .bist_scan_en(
        n1), .bist_scan_inputs(bist_scan_inputs), .bisttop_scan_conf_out(
        conf_scan_out), .bist_clk(bist_clk), .bist_rst_n(rst_n), .bist_start(
        bist_start), .bist_scan_outputs({ext_scan_out, scan_outputs[27:0]}), 
        .bisttop_scan_conf_in(bisttop_scan_conf_in), .bisttop_scan_conf_en(
        conf_scan_en) );
  clockcontroller U_CLOCKCONTROLLER ( .sys_clk(sys_clk), .bist_clk(bist_clk), 
        .clockconf_scan_out(bisttop_scan_conf_in), .ext_clk(ext_clk), 
        .osc_clk(osc_clk), .rst_n(rst_n), .bist_en(bist_en), .ext_test_en(
        ext_test_en), .bist_scan_en(n1), .ext_scan_en(ext_scan_en), 
        .clockconf_scan_in(conf_scan_in), .clockconf_scan_en(conf_scan_en) );
  or02d1ll U1 ( .a1(n1), .a2(ext_scan_en), .z(scan_en) );
endmodule

