
module clockmux2_1 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n2;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aor22d1ll U2 ( .a1(clk1), .a2(en1), .b1(en2), .b2(clk2), .z(clk_out) );
  aoi21d1ll U3 ( .b1(en1), .b2(n2), .a(clk2), .zn(N5) );
  nr03d1ll U4 ( .a1(clk_sel), .a2(en1), .a3(clk2), .zn(N3) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n2), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n2) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_3 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net254, net256, net258, net259, net262, net265;
  assign net254 = EN;
  assign net256 = CLK;
  assign ENCLK = net258;
  assign net265 = TE;

  an02d1ll main_gate ( .a1(net262), .a2(net256), .z(net258) );
  lanlq1ll latch ( .d(net259), .en(net256), .q(net262) );
  or02d1ll test_or ( .a1(net254), .a2(net265), .z(net259) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_2 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net254, net256, net258, net259, net262, net265;
  assign net254 = EN;
  assign net256 = CLK;
  assign ENCLK = net258;
  assign net265 = TE;

  an02d1ll main_gate ( .a1(net262), .a2(net256), .z(net258) );
  lanlq1ll latch ( .d(net259), .en(net256), .q(net262) );
  or02d1ll test_or ( .a1(net254), .a2(net265), .z(net259) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_1 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net254, net256, net258, net259, net262, net265;
  assign net254 = EN;
  assign net256 = CLK;
  assign ENCLK = net258;
  assign net265 = TE;

  an02d1ll main_gate ( .a1(net262), .a2(net256), .z(net258) );
  lanlq1ll latch ( .d(net259), .en(net256), .q(net262) );
  or02d1ll test_or ( .a1(net254), .a2(net265), .z(net259) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_0 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net254, net256, net258, net259, net262, net265;
  assign net254 = EN;
  assign net256 = CLK;
  assign ENCLK = net258;
  assign net265 = TE;

  an02d1ll main_gate ( .a1(net262), .a2(net256), .z(net258) );
  lanlq1ll latch ( .d(net259), .en(net256), .q(net262) );
  or02d1ll test_or ( .a1(net254), .a2(net265), .z(net259) );
endmodule


module mux_SIZE4_2 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n2;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n2), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n2), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n2), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n2), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n2) );
endmodule


module mux_SIZE4_1 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n2;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n2), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n2), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n2), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n2), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n2) );
endmodule


module mux_SIZE4_0 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n2;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n2), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n2), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n2), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n2), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n2) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_fsm ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net291, net293, net295, net296, net299, net302;
  assign net291 = EN;
  assign net293 = CLK;
  assign ENCLK = net295;
  assign net302 = TE;

  an02d1ll main_gate ( .a1(net299), .a2(net293), .z(net295) );
  lanlq1ll latch ( .d(net296), .en(net293), .q(net299) );
  or02d1ll test_or ( .a1(net291), .a2(net302), .z(net296) );
endmodule


module SNPS_CLOCK_GATE_HIGH_misr ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net220, net222, net224, net225, net228, net231;
  assign net220 = EN;
  assign net222 = CLK;
  assign ENCLK = net224;
  assign net231 = TE;

  an02d1ll main_gate ( .a1(net228), .a2(net222), .z(net224) );
  lanlq1ll latch ( .d(net225), .en(net222), .q(net228) );
  or02d1ll test_or ( .a1(net220), .a2(net231), .z(net225) );
endmodule


module SNPS_CLOCK_GATE_HIGH_lfsr ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net237, net239, net241, net242, net245, net248;
  assign net237 = EN;
  assign net239 = CLK;
  assign ENCLK = net241;
  assign net248 = TE;

  an02d1ll main_gate ( .a1(net245), .a2(net239), .z(net241) );
  lanlq1ll latch ( .d(net242), .en(net239), .q(net245) );
  or02d1ll test_or ( .a1(net237), .a2(net248), .z(net242) );
endmodule


module SNPS_CLOCK_GATE_HIGH_bistcontroller_4 ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net254, net256, net258, net259, net262, net265;
  assign net254 = EN;
  assign net256 = CLK;
  assign ENCLK = net258;
  assign net265 = TE;

  an02d1ll main_gate ( .a1(net262), .a2(net256), .z(net258) );
  lanlq1ll latch ( .d(net259), .en(net256), .q(net262) );
  or02d1ll test_or ( .a1(net254), .a2(net265), .z(net259) );
endmodule


module bistcontroller_fsm ( bist_done, bist_en, bist_scan_en, bist_lfsr_en, 
        bist_misr_en, bist_weight_sel, bist_weight_load, bist_flip_en, 
        bist_flip_load, bitcounter_inc, patterncounter_inc, testcounter_inc, 
        patterncounter_rst, bitcounter_rst, testcounter_rst, misr_enable_set, 
        bist_clk, bist_rst_n, bist_start, bit_counter_r, bits_to_apply_r, 
        pattern_counter_r, pattern_to_apply_r, test_counter_r, conf_r, 
        misr_enable_r );
  output [1:0] bist_weight_sel;
  input [7:0] bit_counter_r;
  input [7:0] bits_to_apply_r;
  input [15:0] pattern_counter_r;
  input [15:0] pattern_to_apply_r;
  input [2:0] test_counter_r;
  input [7:0] conf_r;
  input bist_clk, bist_rst_n, bist_start, misr_enable_r;
  output bist_done, bist_en, bist_scan_en, bist_lfsr_en, bist_misr_en,
         bist_weight_load, bist_flip_en, bist_flip_load, bitcounter_inc,
         patterncounter_inc, testcounter_inc, patterncounter_rst,
         bitcounter_rst, testcounter_rst, misr_enable_set;
  wire   bitcounter_inc, testcounter_inc, bitcounter_rst, N116, net307, n3, n4,
         n5, n6, n7, n12, n13, n14, n15, n17, n18, n19, n20, n21, n22, n23,
         n24, n25, n26, n27, n28, n29, n30, n31, n32, n33, n34, n35, n36, n37,
         n38, n39, n40, n41, n42, n43, n44, n45, n46, n47, n48, n49, n50, n51,
         n52, n53, n54, n55, n56, n57, n58, n59, n60, n61, n62, n63, n64, n65,
         n66, n67, n68, n69, n70, n71, n72, n73, n74, n75, n76, n77, n78, n79,
         n80, n81, n82, n83, n84, n85, n86, n87, n88, n89, n90, n91, n92, n93,
         n94, n95, n96, n97, n98, n99, n100, n101, n1, n2, n8, n9;
  wire   [3:0] currentstate;
  wire   [3:0] nextstate;
  assign bist_scan_en = bitcounter_inc;
  assign bist_lfsr_en = bitcounter_inc;
  assign patterncounter_rst = testcounter_inc;
  assign patterncounter_inc = bitcounter_rst;

  dfcrq1ll \currentstate_reg[0]  ( .d(nextstate[0]), .cp(net307), .cdn(
        bist_rst_n), .q(currentstate[0]) );
  dfcrq1ll \currentstate_reg[1]  ( .d(nextstate[1]), .cp(net307), .cdn(
        bist_rst_n), .q(currentstate[1]) );
  dfcrn1ll \currentstate_reg[2]  ( .d(nextstate[2]), .cp(net307), .cdn(
        bist_rst_n), .qn(n3) );
  aon211d1ll U5 ( .c1(conf_r[0]), .c2(n5), .b(n6), .a(n7), .zn(nextstate[2])
         );
  oai211d1ll U12 ( .c1(currentstate[0]), .c2(currentstate[1]), .a(n19), .b(n12), .zn(nextstate[0]) );
  aoi31d1ll U14 ( .b1(bitcounter_rst), .b2(n13), .b3(n14), .a(n21), .zn(n19)
         );
  oan211d1ll U15 ( .c1(conf_r[4]), .c2(n22), .b(n23), .a(n24), .zn(n21) );
  nr03d1ll U16 ( .a1(n25), .a2(n26), .a3(n27), .zn(n23) );
  oai22d1ll U17 ( .a1(conf_r[2]), .a2(n28), .b1(conf_r[6]), .b2(n29), .zn(n27)
         );
  oai22d1ll U18 ( .a1(conf_r[5]), .a2(n30), .b1(conf_r[3]), .b2(n31), .zn(n26)
         );
  oai22d1ll U19 ( .a1(conf_r[1]), .a2(n15), .b1(conf_r[7]), .b2(n32), .zn(n25)
         );
  nr04d1ll U21 ( .a1(n35), .a2(n36), .a3(n37), .a4(n38), .zn(n14) );
  oai221d1ll U22 ( .b1(n39), .b2(pattern_counter_r[0]), .c1(n40), .c2(
        pattern_counter_r[1]), .a(n41), .zn(n38) );
  aoi22d1ll U23 ( .a1(pattern_counter_r[0]), .a2(n39), .b1(
        pattern_counter_r[1]), .b2(n40), .zn(n41) );
  oai221d1ll U26 ( .b1(n42), .b2(pattern_counter_r[2]), .c1(n43), .c2(
        pattern_counter_r[3]), .a(n44), .zn(n37) );
  aoi22d1ll U27 ( .a1(pattern_counter_r[2]), .a2(n42), .b1(
        pattern_counter_r[3]), .b2(n43), .zn(n44) );
  oai221d1ll U30 ( .b1(n45), .b2(pattern_counter_r[4]), .c1(n46), .c2(
        pattern_counter_r[5]), .a(n47), .zn(n36) );
  aoi22d1ll U31 ( .a1(pattern_counter_r[4]), .a2(n45), .b1(
        pattern_counter_r[5]), .b2(n46), .zn(n47) );
  oai221d1ll U34 ( .b1(n48), .b2(pattern_counter_r[6]), .c1(n49), .c2(
        pattern_counter_r[7]), .a(n50), .zn(n35) );
  aoi22d1ll U35 ( .a1(pattern_counter_r[6]), .a2(n48), .b1(
        pattern_counter_r[7]), .b2(n49), .zn(n50) );
  nr04d1ll U38 ( .a1(n51), .a2(n52), .a3(n53), .a4(n54), .zn(n13) );
  oai221d1ll U39 ( .b1(n55), .b2(pattern_counter_r[10]), .c1(n56), .c2(
        pattern_counter_r[11]), .a(n57), .zn(n54) );
  aoi22d1ll U40 ( .a1(pattern_counter_r[10]), .a2(n55), .b1(
        pattern_counter_r[11]), .b2(n56), .zn(n57) );
  oai221d1ll U43 ( .b1(n58), .b2(pattern_counter_r[12]), .c1(n59), .c2(
        pattern_counter_r[13]), .a(n60), .zn(n53) );
  aoi22d1ll U44 ( .a1(pattern_counter_r[12]), .a2(n58), .b1(
        pattern_counter_r[13]), .b2(n59), .zn(n60) );
  oai221d1ll U47 ( .b1(n61), .b2(pattern_counter_r[14]), .c1(n62), .c2(
        pattern_counter_r[15]), .a(n63), .zn(n52) );
  aoi22d1ll U48 ( .a1(pattern_counter_r[14]), .a2(n61), .b1(
        pattern_counter_r[15]), .b2(n62), .zn(n63) );
  oai221d1ll U51 ( .b1(n64), .b2(pattern_counter_r[8]), .c1(n65), .c2(
        pattern_counter_r[9]), .a(n66), .zn(n51) );
  aoi22d1ll U52 ( .a1(pattern_counter_r[8]), .a2(n64), .b1(
        pattern_counter_r[9]), .b2(n65), .zn(n66) );
  aoi21d1ll U59 ( .b1(n69), .b2(n17), .a(n24), .zn(bist_weight_sel[0]) );
  aoi21d1ll U61 ( .b1(n18), .b2(n17), .a(n24), .zn(bist_weight_load) );
  aoi21d1ll U62 ( .b1(conf_r[2]), .b2(n71), .a(n72), .zn(n17) );
  aoi211d1ll U66 ( .c1(conf_r[4]), .c2(n73), .a(n74), .b(n70), .zn(n18) );
  oai21d1ll U67 ( .b1(n75), .b2(n29), .a(n76), .zn(n70) );
  nr04d1ll U87 ( .a1(n24), .a2(n83), .a3(n34), .a4(n81), .zn(bist_done) );
  aoi21d1ll U93 ( .b1(n4), .b2(n84), .a(bitcounter_inc), .zn(N116) );
  oai221d1ll U100 ( .b1(n90), .b2(bit_counter_r[2]), .c1(n91), .c2(
        bit_counter_r[3]), .a(n92), .zn(n89) );
  aoi22d1ll U101 ( .a1(bit_counter_r[2]), .a2(n90), .b1(bit_counter_r[3]), 
        .b2(n91), .zn(n92) );
  oai221d1ll U104 ( .b1(n93), .b2(bit_counter_r[0]), .c1(n94), .c2(
        bit_counter_r[1]), .a(n95), .zn(n88) );
  aoi22d1ll U105 ( .a1(bit_counter_r[0]), .a2(n93), .b1(bit_counter_r[1]), 
        .b2(n94), .zn(n95) );
  oai221d1ll U108 ( .b1(n96), .b2(bit_counter_r[6]), .c1(n97), .c2(
        bit_counter_r[7]), .a(n98), .zn(n87) );
  aoi22d1ll U109 ( .a1(bit_counter_r[6]), .a2(n96), .b1(bit_counter_r[7]), 
        .b2(n97), .zn(n98) );
  oai221d1ll U112 ( .b1(n99), .b2(bit_counter_r[4]), .c1(n100), .c2(
        bit_counter_r[5]), .a(n101), .zn(n86) );
  aoi22d1ll U113 ( .a1(bit_counter_r[4]), .a2(n99), .b1(bit_counter_r[5]), 
        .b2(n100), .zn(n101) );
  nr03d1ll U117 ( .a1(currentstate[0]), .a2(currentstate[2]), .a3(
        currentstate[1]), .zn(n4) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_fsm clk_gate_currentstate_reg ( .CLK(
        bist_clk), .EN(N116), .ENCLK(net307), .TE(1'b0) );
  inv0d1ll U115 ( .i(bits_to_apply_r[4]), .zn(n99) );
  inv0d1ll U114 ( .i(bits_to_apply_r[5]), .zn(n100) );
  inv0d1ll U111 ( .i(bits_to_apply_r[6]), .zn(n96) );
  inv0d1ll U110 ( .i(bits_to_apply_r[7]), .zn(n97) );
  inv0d1ll U107 ( .i(bits_to_apply_r[0]), .zn(n93) );
  inv0d1ll U106 ( .i(bits_to_apply_r[1]), .zn(n94) );
  inv0d1ll U103 ( .i(bits_to_apply_r[2]), .zn(n90) );
  inv0d1ll U102 ( .i(bits_to_apply_r[3]), .zn(n91) );
  inv0d1ll U95 ( .i(n20), .zn(n85) );
  nd02d1ll U71 ( .a1(test_counter_r[0]), .a2(n78), .zn(n22) );
  inv0d1ll U90 ( .i(test_counter_r[2]), .zn(n83) );
  nd02d1ll U83 ( .a1(n77), .a2(n34), .zn(n30) );
  nr02d1ll U81 ( .a1(n30), .a2(n82), .zn(n74) );
  nd02d1ll U68 ( .a1(test_counter_r[0]), .a2(n77), .zn(n29) );
  nd02d1ll U64 ( .a1(test_counter_r[0]), .a2(n33), .zn(n28) );
  nd02d1ll U79 ( .a1(n78), .a2(n34), .zn(n31) );
  nr02d1ll U77 ( .a1(n31), .a2(n80), .zn(n72) );
  an02d1ll U4 ( .a1(n4), .a2(bist_start), .z(testcounter_rst) );
  nd02d1ll U20 ( .a1(n33), .a2(n34), .zn(n15) );
  nd02d1ll U13 ( .a1(conf_r[0]), .a2(n20), .zn(n12) );
  an02d1ll U55 ( .a1(n20), .a2(n67), .z(misr_enable_set) );
  nr04d1ll U99 ( .a1(n86), .a2(n87), .a3(n88), .a4(n89), .zn(n67) );
  oai211d1ll U85 ( .c1(currentstate[2]), .c2(n5), .a(n68), .b(n7), .zn(bist_en) );
  an02d1ll U72 ( .a1(bitcounter_inc), .a2(misr_enable_r), .z(bist_misr_en) );
  nr02d1ll U80 ( .a1(test_counter_r[2]), .a2(n81), .zn(n78) );
  nr02d1ll U84 ( .a1(test_counter_r[1]), .a2(n83), .zn(n77) );
  nr02d1ll U76 ( .a1(n74), .a2(n72), .zn(n79) );
  nr02d1ll U96 ( .a1(currentstate[2]), .a2(n68), .zn(n20) );
  inv0d1ll U116 ( .i(bist_start), .zn(n84) );
  nr03d1ll U92 ( .a1(currentstate[2]), .a2(currentstate[1]), .a3(n5), .zn(
        testcounter_inc) );
  inv0d1ll U88 ( .i(test_counter_r[1]), .zn(n81) );
  inv0d1ll U70 ( .i(n22), .zn(n73) );
  inv0d1ll U82 ( .i(conf_r[5]), .zn(n82) );
  inv0d1ll U69 ( .i(conf_r[6]), .zn(n75) );
  nd12d1ll U74 ( .a1(n32), .a2(conf_r[7]), .zn(n76) );
  inv0d1ll U63 ( .i(n28), .zn(n71) );
  inv0d1ll U78 ( .i(conf_r[3]), .zn(n80) );
  inv0d1ll U54 ( .i(pattern_to_apply_r[8]), .zn(n64) );
  inv0d1ll U53 ( .i(pattern_to_apply_r[9]), .zn(n65) );
  inv0d1ll U50 ( .i(pattern_to_apply_r[14]), .zn(n61) );
  inv0d1ll U49 ( .i(pattern_to_apply_r[15]), .zn(n62) );
  inv0d1ll U46 ( .i(pattern_to_apply_r[12]), .zn(n58) );
  inv0d1ll U45 ( .i(pattern_to_apply_r[13]), .zn(n59) );
  inv0d1ll U42 ( .i(pattern_to_apply_r[10]), .zn(n55) );
  inv0d1ll U41 ( .i(pattern_to_apply_r[11]), .zn(n56) );
  inv0d1ll U37 ( .i(pattern_to_apply_r[6]), .zn(n48) );
  inv0d1ll U36 ( .i(pattern_to_apply_r[7]), .zn(n49) );
  inv0d1ll U33 ( .i(pattern_to_apply_r[4]), .zn(n45) );
  inv0d1ll U32 ( .i(pattern_to_apply_r[5]), .zn(n46) );
  inv0d1ll U29 ( .i(pattern_to_apply_r[2]), .zn(n42) );
  inv0d1ll U28 ( .i(pattern_to_apply_r[3]), .zn(n43) );
  inv0d1ll U25 ( .i(pattern_to_apply_r[0]), .zn(n39) );
  inv0d1ll U24 ( .i(pattern_to_apply_r[1]), .zn(n40) );
  nr02d1ll U58 ( .a1(n18), .a2(n24), .zn(bist_weight_sel[1]) );
  inv0d1ll U60 ( .i(n70), .zn(n69) );
  nd02d1ll U97 ( .a1(currentstate[1]), .a2(n5), .zn(n68) );
  inv0d1ll U91 ( .i(testcounter_inc), .zn(n24) );
  nr02d1ll U94 ( .a1(n67), .a2(n85), .zn(bitcounter_inc) );
  aoi21d1ll U73 ( .b1(n79), .b2(n76), .a(n24), .zn(bist_flip_en) );
  inv0d1ll U98 ( .i(currentstate[0]), .zn(n5) );
  nd02d0ll U6 ( .a1(currentstate[1]), .a2(n3), .zn(n6) );
  nr02d1ll U65 ( .a1(test_counter_r[2]), .a2(test_counter_r[1]), .zn(n33) );
  inv0d1ll U89 ( .i(test_counter_r[0]), .zn(n34) );
  nd12d1ll U86 ( .a1(currentstate[1]), .a2(currentstate[2]), .zn(n7) );
  nd03d1ll U75 ( .a1(n34), .a2(test_counter_r[1]), .a3(test_counter_r[2]), 
        .zn(n32) );
  nr02d1ll U56 ( .a1(n3), .a2(n68), .zn(bitcounter_rst) );
  nd02d0ll U3 ( .a1(n14), .a2(n13), .zn(n1) );
  inv0d0ll U7 ( .i(conf_r[1]), .zn(n2) );
  oai211d1ll U8 ( .c1(n15), .c2(n2), .a(n17), .b(n18), .zn(n8) );
  aoi22d1ll U9 ( .a1(bitcounter_rst), .a2(n1), .b1(testcounter_inc), .b2(n8), 
        .zn(n9) );
  oai211d1ll U10 ( .c1(n5), .c2(n7), .a(n12), .b(n9), .zn(nextstate[1]) );
  inv0d1ll U11 ( .i(n3), .zn(currentstate[2]) );
endmodule


module SNPS_CLOCK_GATE_HIGH_clockcontroller ( CLK, EN, ENCLK, TE );
  input CLK, EN, TE;
  output ENCLK;
  wire   net203, net205, net207, net208, net211, net214;
  assign net203 = EN;
  assign net205 = CLK;
  assign ENCLK = net207;
  assign net214 = TE;

  an02d1ll main_gate ( .a1(net211), .a2(net205), .z(net207) );
  lanlq1ll latch ( .d(net208), .en(net205), .q(net211) );
  or02d1ll test_or ( .a1(net203), .a2(net214), .z(net208) );
endmodule


module clockmux2_0 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n2, n3, n4, n5;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aoi21d1ll U3 ( .b1(en1), .b2(n2), .a(clk2), .zn(N5) );
  nr03d1ll U4 ( .a1(clk_sel), .a2(en1), .a3(clk2), .zn(N3) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n2), .zn(N0) );
  inv0d1ll U2 ( .i(clk_sel), .zn(n2) );
  inv0d1ll U7 ( .i(en2), .zn(n5) );
  oai21d1ll U8 ( .b1(n5), .b2(n4), .a(n3), .zn(clk_out) );
  nd02d1ll U9 ( .a1(clk1), .a2(en1), .zn(n3) );
  inv0d1ll U10 ( .i(clk2), .zn(n4) );
endmodule


module clockmux2_2 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n1;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aor22d1ll U2 ( .a1(clk1), .a2(en1), .b1(en2), .b2(clk2), .z(clk_out) );
  aoi21d1ll U3 ( .b1(en1), .b2(n1), .a(clk2), .zn(N5) );
  nr03d1ll U4 ( .a1(clk_sel), .a2(en1), .a3(clk2), .zn(N3) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n1), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n1) );
endmodule


module clockmux2_3 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n1;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n1), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n1) );
  nd02d0ll U2 ( .a1(en1), .a2(n1), .zn(N5) );
  nr02d1ll U3 ( .a1(clk_sel), .a2(en1), .zn(N3) );
  an02d1ll U4 ( .a1(clk1), .a2(en1), .z(clk_out) );
endmodule


module clockmux2_4 ( clk_out, clk1, clk2, clk_sel );
  input clk1, clk2, clk_sel;
  output clk_out;
  wire   en2, N0, en1, N2, N3, N5, n1;

  lanhq1ll en2_reg ( .e(N5), .d(N3), .q(en2) );
  lanhq1ll en1_reg ( .e(N2), .d(N0), .q(en1) );
  aor22d1ll U2 ( .a1(clk1), .a2(en1), .b1(en2), .b2(clk2), .z(clk_out) );
  aoi21d1ll U3 ( .b1(en1), .b2(n1), .a(clk2), .zn(N5) );
  nr03d1ll U4 ( .a1(clk_sel), .a2(en1), .a3(clk2), .zn(N3) );
  aoi21d1ll U5 ( .b1(clk_sel), .b2(en2), .a(clk1), .zn(N2) );
  nr03d1ll U6 ( .a1(clk1), .a2(en2), .a3(n1), .zn(N0) );
  inv0d1ll U7 ( .i(clk_sel), .zn(n1) );
endmodule


module misr ( misr_so, misr_clk, misr_rst_n, misr_en, misr_load, misr_si, 
        misr_in );
  input [15:0] misr_in;
  input misr_clk, misr_rst_n, misr_en, misr_load, misr_si;
  output misr_so;
  wire   N1, N18, N19, N20, N21, N22, N23, N24, N25, N26, N27, N28, N29, N30,
         N31, N32, N33, net236, n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11,
         n12, n13, n14, n15, n16, n17, n18, n19, n20, n21, n22;
  wire   [15:1] misr_value;

  dfcrq1ll \misr_value_reg[0]  ( .d(N18), .cp(net236), .cdn(misr_rst_n), .q(
        misr_so) );
  dfcrq1ll \misr_value_reg[15]  ( .d(N33), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[15]) );
  dfcrq1ll \misr_value_reg[14]  ( .d(N32), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[14]) );
  dfcrq1ll \misr_value_reg[13]  ( .d(N31), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[13]) );
  dfcrq1ll \misr_value_reg[12]  ( .d(N30), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[12]) );
  dfcrq1ll \misr_value_reg[11]  ( .d(N29), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[11]) );
  dfcrq1ll \misr_value_reg[10]  ( .d(N28), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[10]) );
  dfcrq1ll \misr_value_reg[9]  ( .d(N27), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[9]) );
  dfcrq1ll \misr_value_reg[8]  ( .d(N26), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[8]) );
  dfcrq1ll \misr_value_reg[7]  ( .d(N25), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[7]) );
  dfcrq1ll \misr_value_reg[6]  ( .d(N24), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[6]) );
  dfcrq1ll \misr_value_reg[5]  ( .d(N23), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[5]) );
  dfcrq1ll \misr_value_reg[4]  ( .d(N22), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[4]) );
  dfcrq1ll \misr_value_reg[3]  ( .d(N21), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[3]) );
  dfcrq1ll \misr_value_reg[2]  ( .d(N20), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[2]) );
  dfcrq1ll \misr_value_reg[1]  ( .d(N19), .cp(net236), .cdn(misr_rst_n), .q(
        misr_value[1]) );
  aon211d1ll U2 ( .c1(misr_so), .c2(misr_in[0]), .b(n1), .a(n2), .zn(N33) );
  oai21d1ll U4 ( .b1(misr_in[0]), .b2(misr_so), .a(n3), .zn(n1) );
  oaim22d1ll U5 ( .a1(n4), .a2(misr_value[15]), .b1(n4), .b2(misr_value[15]), 
        .zn(N32) );
  oai31d1ll U7 ( .b1(misr_load), .b2(misr_value[14]), .b3(n5), .a(n6), .zn(N31) );
  oai21d1ll U8 ( .b1(misr_load), .b2(n5), .a(misr_value[14]), .zn(n6) );
  aoim22d1ll U9 ( .a1(misr_in[2]), .a2(n7), .b1(n7), .b2(misr_in[2]), .zn(n5)
         );
  oai31d1ll U10 ( .b1(misr_load), .b2(misr_value[13]), .b3(n8), .a(n9), .zn(
        N30) );
  oai21d1ll U11 ( .b1(misr_load), .b2(n8), .a(misr_value[13]), .zn(n9) );
  aoim22d1ll U12 ( .a1(misr_in[3]), .a2(n7), .b1(n7), .b2(misr_in[3]), .zn(n8)
         );
  oaim22d1ll U13 ( .a1(n10), .a2(misr_value[12]), .b1(n10), .b2(misr_value[12]), .zn(N29) );
  oai31d1ll U15 ( .b1(misr_load), .b2(misr_value[11]), .b3(n11), .a(n12), .zn(
        N28) );
  oai21d1ll U16 ( .b1(misr_load), .b2(n11), .a(misr_value[11]), .zn(n12) );
  aoim22d1ll U17 ( .a1(misr_in[5]), .a2(n7), .b1(n7), .b2(misr_in[5]), .zn(n11) );
  oaim22d1ll U19 ( .a1(n13), .a2(misr_value[10]), .b1(n13), .b2(misr_value[10]), .zn(N27) );
  oaim22d1ll U21 ( .a1(n14), .a2(misr_value[9]), .b1(n14), .b2(misr_value[9]), 
        .zn(N26) );
  oaim22d1ll U23 ( .a1(n15), .a2(misr_value[8]), .b1(n15), .b2(misr_value[8]), 
        .zn(N25) );
  oaim22d1ll U25 ( .a1(n16), .a2(misr_value[7]), .b1(n16), .b2(misr_value[7]), 
        .zn(N24) );
  oaim22d1ll U27 ( .a1(n17), .a2(misr_value[6]), .b1(n17), .b2(misr_value[6]), 
        .zn(N23) );
  oaim22d1ll U29 ( .a1(n18), .a2(misr_value[5]), .b1(n18), .b2(misr_value[5]), 
        .zn(N22) );
  oaim22d1ll U31 ( .a1(n19), .a2(misr_value[4]), .b1(n19), .b2(misr_value[4]), 
        .zn(N21) );
  oaim22d1ll U33 ( .a1(n20), .a2(misr_value[3]), .b1(n20), .b2(misr_value[3]), 
        .zn(N20) );
  oaim22d1ll U35 ( .a1(n21), .a2(misr_value[2]), .b1(n21), .b2(misr_value[2]), 
        .zn(N19) );
  oaim22d1ll U37 ( .a1(n22), .a2(misr_value[1]), .b1(n22), .b2(misr_value[1]), 
        .zn(N18) );
  SNPS_CLOCK_GATE_HIGH_misr clk_gate_misr_value_reg ( .CLK(misr_clk), .EN(N1), 
        .ENCLK(net236), .TE(1'b0) );
  or02d1ll U40 ( .a1(misr_en), .a2(misr_load), .z(N1) );
  inv0d1ll U18 ( .i(misr_so), .zn(n7) );
  nd02d1ll U3 ( .a1(misr_load), .a2(misr_si), .zn(n2) );
  nd02d1ll U38 ( .a1(n3), .a2(misr_in[15]), .zn(n22) );
  nd02d1ll U24 ( .a1(n3), .a2(misr_in[8]), .zn(n15) );
  nd02d1ll U32 ( .a1(n3), .a2(misr_in[12]), .zn(n19) );
  nd02d1ll U30 ( .a1(n3), .a2(misr_in[11]), .zn(n18) );
  nd02d1ll U36 ( .a1(n3), .a2(misr_in[14]), .zn(n21) );
  nd02d1ll U20 ( .a1(n3), .a2(misr_in[6]), .zn(n13) );
  nd02d1ll U26 ( .a1(n3), .a2(misr_in[9]), .zn(n16) );
  nd02d1ll U34 ( .a1(n3), .a2(misr_in[13]), .zn(n20) );
  nd02d1ll U22 ( .a1(n3), .a2(misr_in[7]), .zn(n14) );
  nd02d1ll U14 ( .a1(n3), .a2(misr_in[4]), .zn(n10) );
  nd02d1ll U28 ( .a1(n3), .a2(misr_in[10]), .zn(n17) );
  nd02d1ll U6 ( .a1(n3), .a2(misr_in[1]), .zn(n4) );
  inv0d1ll U39 ( .i(misr_load), .zn(n3) );
endmodule


module concentrator ( concentrator_out, concentrator_in );
  output [15:0] concentrator_out;
  input [15:0] concentrator_in;

  assign concentrator_out[15] = concentrator_in[15];
  assign concentrator_out[14] = concentrator_in[14];
  assign concentrator_out[13] = concentrator_in[13];
  assign concentrator_out[12] = concentrator_in[12];
  assign concentrator_out[11] = concentrator_in[11];
  assign concentrator_out[10] = concentrator_in[10];
  assign concentrator_out[9] = concentrator_in[9];
  assign concentrator_out[8] = concentrator_in[8];
  assign concentrator_out[7] = concentrator_in[7];
  assign concentrator_out[6] = concentrator_in[6];
  assign concentrator_out[5] = concentrator_in[5];
  assign concentrator_out[4] = concentrator_in[4];
  assign concentrator_out[3] = concentrator_in[3];
  assign concentrator_out[2] = concentrator_in[2];
  assign concentrator_out[1] = concentrator_in[1];
  assign concentrator_out[0] = concentrator_in[0];

endmodule


module weighting ( weighting_out, weighting_in, weighting_sel );
  output [15:0] weighting_out;
  input [15:0] weighting_in;
  input [1:0] weighting_sel;
  wire   n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16,
         n17, n18, n19, n20, n21, n22, n23, n24, n25, n26, n27, n28, n29, n30,
         n31, n32, n33, n34, n35, n36, n37;

  oan211d1ll U1 ( .c1(n1), .c2(n2), .b(n3), .a(n4), .zn(weighting_out[9]) );
  oan211d1ll U2 ( .c1(n5), .c2(weighting_in[12]), .b(weighting_in[11]), .a(n6), 
        .zn(n1) );
  oan211d1ll U3 ( .c1(n7), .c2(n4), .b(n3), .a(n8), .zn(weighting_out[8]) );
  oan211d1ll U5 ( .c1(n5), .c2(weighting_in[11]), .b(weighting_in[10]), .a(n6), 
        .zn(n7) );
  oan211d1ll U6 ( .c1(n9), .c2(n8), .b(n3), .a(n10), .zn(weighting_out[7]) );
  oan211d1ll U8 ( .c1(n5), .c2(weighting_in[10]), .b(weighting_in[9]), .a(n6), 
        .zn(n9) );
  oan211d1ll U9 ( .c1(n11), .c2(n10), .b(n3), .a(n12), .zn(weighting_out[6])
         );
  oan211d1ll U11 ( .c1(n5), .c2(weighting_in[9]), .b(weighting_in[8]), .a(n6), 
        .zn(n11) );
  oan211d1ll U12 ( .c1(n13), .c2(n12), .b(n3), .a(n14), .zn(weighting_out[5])
         );
  oan211d1ll U14 ( .c1(n5), .c2(weighting_in[8]), .b(weighting_in[7]), .a(n6), 
        .zn(n13) );
  oan211d1ll U15 ( .c1(n15), .c2(n14), .b(n3), .a(n16), .zn(weighting_out[4])
         );
  oan211d1ll U17 ( .c1(n5), .c2(weighting_in[7]), .b(weighting_in[6]), .a(n6), 
        .zn(n15) );
  oan211d1ll U18 ( .c1(n17), .c2(n16), .b(n3), .a(n18), .zn(weighting_out[3])
         );
  oan211d1ll U20 ( .c1(n5), .c2(weighting_in[6]), .b(weighting_in[5]), .a(n6), 
        .zn(n17) );
  oan211d1ll U21 ( .c1(n19), .c2(n18), .b(n3), .a(n20), .zn(weighting_out[2])
         );
  oan211d1ll U23 ( .c1(n5), .c2(weighting_in[5]), .b(weighting_in[4]), .a(n6), 
        .zn(n19) );
  oan211d1ll U24 ( .c1(n21), .c2(n20), .b(n3), .a(n22), .zn(weighting_out[1])
         );
  oan211d1ll U26 ( .c1(n5), .c2(weighting_in[4]), .b(weighting_in[3]), .a(n6), 
        .zn(n21) );
  oan211d1ll U27 ( .c1(n23), .c2(n24), .b(n3), .a(n25), .zn(weighting_out[15])
         );
  oan211d1ll U28 ( .c1(weighting_in[2]), .c2(n5), .b(weighting_in[1]), .a(n6), 
        .zn(n23) );
  oan211d1ll U29 ( .c1(n26), .c2(n25), .b(n3), .a(n27), .zn(weighting_out[14])
         );
  oan211d1ll U31 ( .c1(weighting_in[1]), .c2(n5), .b(weighting_in[0]), .a(n6), 
        .zn(n26) );
  oan211d1ll U32 ( .c1(n28), .c2(n27), .b(n3), .a(n29), .zn(weighting_out[13])
         );
  oan211d1ll U34 ( .c1(weighting_in[0]), .c2(n5), .b(weighting_in[15]), .a(n6), 
        .zn(n28) );
  oan211d1ll U35 ( .c1(n30), .c2(n29), .b(n3), .a(n31), .zn(weighting_out[12])
         );
  oan211d1ll U37 ( .c1(n5), .c2(weighting_in[15]), .b(weighting_in[14]), .a(n6), .zn(n30) );
  oan211d1ll U38 ( .c1(n32), .c2(n31), .b(n3), .a(n33), .zn(weighting_out[11])
         );
  oan211d1ll U40 ( .c1(n5), .c2(weighting_in[14]), .b(weighting_in[13]), .a(n6), .zn(n32) );
  oan211d1ll U41 ( .c1(n34), .c2(n33), .b(n3), .a(n2), .zn(weighting_out[10])
         );
  oan211d1ll U44 ( .c1(n5), .c2(weighting_in[13]), .b(weighting_in[12]), .a(n6), .zn(n34) );
  oan211d1ll U45 ( .c1(n35), .c2(n22), .b(n3), .a(n24), .zn(weighting_out[0])
         );
  oan211d1ll U49 ( .c1(weighting_in[3]), .c2(n5), .b(weighting_in[2]), .a(n6), 
        .zn(n35) );
  inv0d1ll U53 ( .i(weighting_sel[1]), .zn(n37) );
  inv0d1ll U51 ( .i(weighting_sel[0]), .zn(n36) );
  inv0d1ll U36 ( .i(weighting_in[13]), .zn(n29) );
  inv0d1ll U39 ( .i(weighting_in[12]), .zn(n31) );
  inv0d1ll U4 ( .i(weighting_in[9]), .zn(n4) );
  inv0d1ll U7 ( .i(weighting_in[8]), .zn(n8) );
  inv0d1ll U46 ( .i(weighting_in[0]), .zn(n24) );
  inv0d1ll U30 ( .i(weighting_in[15]), .zn(n25) );
  inv0d1ll U43 ( .i(weighting_in[11]), .zn(n33) );
  inv0d1ll U42 ( .i(weighting_in[10]), .zn(n2) );
  inv0d1ll U48 ( .i(weighting_in[1]), .zn(n22) );
  inv0d1ll U19 ( .i(weighting_in[4]), .zn(n16) );
  inv0d1ll U22 ( .i(weighting_in[3]), .zn(n18) );
  inv0d1ll U16 ( .i(weighting_in[5]), .zn(n14) );
  inv0d1ll U13 ( .i(weighting_in[6]), .zn(n12) );
  inv0d1ll U33 ( .i(weighting_in[14]), .zn(n27) );
  inv0d1ll U10 ( .i(weighting_in[7]), .zn(n10) );
  inv0d1ll U25 ( .i(weighting_in[2]), .zn(n20) );
  nr02d1ll U47 ( .a1(weighting_sel[1]), .a2(n36), .zn(n6) );
  nr02d1ll U50 ( .a1(weighting_sel[0]), .a2(n37), .zn(n5) );
  nd02d1ll U52 ( .a1(n36), .a2(n37), .zn(n3) );
endmodule


module flipping ( flipping_out, flipping_in, flipping_sel );
  output [15:0] flipping_out;
  input [15:0] flipping_in;
  input [15:0] flipping_sel;


  aoim22d1ll U1 ( .a1(flipping_sel[9]), .a2(flipping_in[9]), .b1(
        flipping_in[9]), .b2(flipping_sel[9]), .zn(flipping_out[9]) );
  aoim22d1ll U2 ( .a1(flipping_sel[8]), .a2(flipping_in[8]), .b1(
        flipping_in[8]), .b2(flipping_sel[8]), .zn(flipping_out[8]) );
  aoim22d1ll U3 ( .a1(flipping_sel[7]), .a2(flipping_in[7]), .b1(
        flipping_in[7]), .b2(flipping_sel[7]), .zn(flipping_out[7]) );
  aoim22d1ll U4 ( .a1(flipping_sel[6]), .a2(flipping_in[6]), .b1(
        flipping_in[6]), .b2(flipping_sel[6]), .zn(flipping_out[6]) );
  aoim22d1ll U5 ( .a1(flipping_sel[5]), .a2(flipping_in[5]), .b1(
        flipping_in[5]), .b2(flipping_sel[5]), .zn(flipping_out[5]) );
  aoim22d1ll U6 ( .a1(flipping_sel[4]), .a2(flipping_in[4]), .b1(
        flipping_in[4]), .b2(flipping_sel[4]), .zn(flipping_out[4]) );
  aoim22d1ll U7 ( .a1(flipping_sel[3]), .a2(flipping_in[3]), .b1(
        flipping_in[3]), .b2(flipping_sel[3]), .zn(flipping_out[3]) );
  aoim22d1ll U8 ( .a1(flipping_sel[2]), .a2(flipping_in[2]), .b1(
        flipping_in[2]), .b2(flipping_sel[2]), .zn(flipping_out[2]) );
  aoim22d1ll U9 ( .a1(flipping_sel[1]), .a2(flipping_in[1]), .b1(
        flipping_in[1]), .b2(flipping_sel[1]), .zn(flipping_out[1]) );
  aoim22d1ll U10 ( .a1(flipping_sel[15]), .a2(flipping_in[15]), .b1(
        flipping_in[15]), .b2(flipping_sel[15]), .zn(flipping_out[15]) );
  aoim22d1ll U11 ( .a1(flipping_sel[14]), .a2(flipping_in[14]), .b1(
        flipping_in[14]), .b2(flipping_sel[14]), .zn(flipping_out[14]) );
  aoim22d1ll U12 ( .a1(flipping_sel[13]), .a2(flipping_in[13]), .b1(
        flipping_in[13]), .b2(flipping_sel[13]), .zn(flipping_out[13]) );
  aoim22d1ll U13 ( .a1(flipping_sel[12]), .a2(flipping_in[12]), .b1(
        flipping_in[12]), .b2(flipping_sel[12]), .zn(flipping_out[12]) );
  aoim22d1ll U14 ( .a1(flipping_sel[11]), .a2(flipping_in[11]), .b1(
        flipping_in[11]), .b2(flipping_sel[11]), .zn(flipping_out[11]) );
  aoim22d1ll U15 ( .a1(flipping_sel[10]), .a2(flipping_in[10]), .b1(
        flipping_in[10]), .b2(flipping_sel[10]), .zn(flipping_out[10]) );
  aoim22d1ll U16 ( .a1(flipping_sel[0]), .a2(flipping_in[0]), .b1(
        flipping_in[0]), .b2(flipping_sel[0]), .zn(flipping_out[0]) );
endmodule


module phaseshifter ( phaseshifter_out, phaseshifter_in );
  output [15:0] phaseshifter_out;
  input [15:0] phaseshifter_in;
  wire   phaseshifter_in_15, phaseshifter_in_14, phaseshifter_in_13,
         phaseshifter_in_12, phaseshifter_in_11, n1, n2, n3, n4, n5, n6, n7,
         n8, n9, n10, n11, n12, n13, n14, n15, n17, n18, n19, n20, n21, n22,
         n24, n25, n26, n16, n23;
  assign phaseshifter_in_15 = phaseshifter_in[15];
  assign phaseshifter_in_14 = phaseshifter_in[14];
  assign phaseshifter_in_13 = phaseshifter_in[13];
  assign phaseshifter_in_12 = phaseshifter_in[12];
  assign phaseshifter_in_11 = phaseshifter_in[11];

  aoim22d1ll U1 ( .a1(n1), .a2(n2), .b1(n2), .b2(n1), .zn(phaseshifter_out[9])
         );
  aoi22d1ll U2 ( .a1(phaseshifter_in_13), .a2(n3), .b1(n4), .b2(n5), .zn(
        phaseshifter_out[8]) );
  aoi22d1ll U4 ( .a1(n2), .a2(n6), .b1(n7), .b2(n8), .zn(phaseshifter_out[7])
         );
  aoi22d1ll U6 ( .a1(phaseshifter_in[8]), .a2(n9), .b1(n10), .b2(n11), .zn(
        phaseshifter_out[6]) );
  oai22d1ll U9 ( .a1(n13), .a2(n8), .b1(n2), .b2(phaseshifter_in_12), .zn(n10)
         );
  xr03d1ll U10 ( .a1(phaseshifter_in_15), .a2(phaseshifter_in[1]), .a3(n14), 
        .z(phaseshifter_out[4]) );
  aoim22d1ll U11 ( .a1(phaseshifter_in[5]), .a2(phaseshifter_in_11), .b1(
        phaseshifter_in_11), .b2(phaseshifter_in[5]), .zn(n14) );
  aoim22d1ll U12 ( .a1(n15), .a2(n2), .b1(n2), .b2(n15), .zn(
        phaseshifter_out[3]) );
  oai22d1ll U14 ( .a1(n18), .a2(n11), .b1(phaseshifter_in[8]), .b2(
        phaseshifter_in_14), .zn(n7) );
  aoi22d1ll U17 ( .a1(phaseshifter_in[8]), .a2(n2), .b1(n8), .b2(n11), .zn(n19) );
  aoim22d1ll U20 ( .a1(phaseshifter_in[3]), .a2(phaseshifter_in[4]), .b1(
        phaseshifter_in[4]), .b2(phaseshifter_in[3]), .zn(n2) );
  xr03d1ll U22 ( .a1(phaseshifter_in[2]), .a2(phaseshifter_in[9]), .a3(n1), 
        .z(phaseshifter_out[15]) );
  aoi22d1ll U23 ( .a1(phaseshifter_in[6]), .a2(phaseshifter_in_12), .b1(n13), 
        .b2(n20), .zn(n1) );
  aoi22d1ll U25 ( .a1(phaseshifter_in[9]), .a2(n21), .b1(n22), .b2(n12), .zn(
        phaseshifter_out[14]) );
  oaim22d1ll U29 ( .a1(phaseshifter_in_11), .a2(n17), .b1(n17), .b2(
        phaseshifter_in_11), .zn(n4) );
  aoim22d1ll U30 ( .a1(phaseshifter_in[2]), .a2(phaseshifter_in_15), .b1(
        phaseshifter_in_15), .b2(phaseshifter_in[2]), .zn(n17) );
  xr03d1ll U32 ( .a1(phaseshifter_in_13), .a2(phaseshifter_in[3]), .a3(n24), 
        .z(phaseshifter_out[12]) );
  aoi22d1ll U33 ( .a1(phaseshifter_in[6]), .a2(phaseshifter_in[7]), .b1(n25), 
        .b2(n20), .zn(n24) );
  oaim22d1ll U35 ( .a1(phaseshifter_in[5]), .a2(n26), .b1(n26), .b2(
        phaseshifter_in[5]), .zn(n22) );
  xr03d1ll U37 ( .a1(phaseshifter_in[3]), .a2(phaseshifter_in[9]), .a3(n15), 
        .z(phaseshifter_out[10]) );
  aoim22d1ll U38 ( .a1(phaseshifter_in_15), .a2(phaseshifter_in[8]), .b1(
        phaseshifter_in[8]), .b2(phaseshifter_in_15), .zn(n15) );
  xr03d1ll U39 ( .a1(phaseshifter_in[2]), .a2(phaseshifter_in_13), .a3(n26), 
        .z(phaseshifter_out[0]) );
  aoi22d1ll U40 ( .a1(phaseshifter_in[6]), .a2(phaseshifter_in_14), .b1(n18), 
        .b2(n20), .zn(n26) );
  mx02d1ll U34 ( .i0(n25), .i1(phaseshifter_in[7]), .s(n22), .z(
        phaseshifter_out[11]) );
  mx02d1ll U16 ( .i0(phaseshifter_in_13), .i1(n5), .s(n19), .z(
        phaseshifter_out[1]) );
  mx02d1ll U8 ( .i0(n12), .i1(phaseshifter_in[9]), .s(n10), .z(
        phaseshifter_out[5]) );
  inv0d1ll U24 ( .i(phaseshifter_in_12), .zn(n13) );
  inv0d1ll U41 ( .i(phaseshifter_in[6]), .zn(n20) );
  inv0d1ll U42 ( .i(phaseshifter_in_14), .zn(n18) );
  inv0d1ll U27 ( .i(n22), .zn(n21) );
  inv0d1ll U26 ( .i(phaseshifter_in[9]), .zn(n12) );
  inv0d1ll U36 ( .i(phaseshifter_in[7]), .zn(n25) );
  inv0d1ll U3 ( .i(n4), .zn(n3) );
  inv0d1ll U21 ( .i(phaseshifter_in_13), .zn(n5) );
  inv0d1ll U18 ( .i(phaseshifter_in[8]), .zn(n11) );
  inv0d1ll U19 ( .i(n2), .zn(n8) );
  inv0d1ll U7 ( .i(n10), .zn(n9) );
  inv0d1ll U5 ( .i(n7), .zn(n6) );
  inv0d0ll U13 ( .i(n4), .zn(n16) );
  aoim22d1ll U15 ( .a1(phaseshifter_in[4]), .a2(n16), .b1(n16), .b2(
        phaseshifter_in[4]), .zn(phaseshifter_out[13]) );
  aoim22d1ll U28 ( .a1(n17), .a2(n23), .b1(n23), .b2(n17), .zn(
        phaseshifter_out[2]) );
  inv0d0ll U31 ( .i(n7), .zn(n23) );
endmodule


module lfsr ( lfsr_out, lfsr_so, lfsr_clk, lfsr_rst_n, lfsr_en, lfsr_load, 
        lfsr_si );
  output [15:0] lfsr_out;
  input lfsr_clk, lfsr_rst_n, lfsr_en, lfsr_load, lfsr_si;
  output lfsr_so;
  wire   n5, N1, N5, N6, N7, N8, net253, n1, n2, n3;

  dfcrn1ll \lfsr_value_reg[0]  ( .d(n1), .cp(net253), .cdn(lfsr_rst_n), .qn(
        lfsr_so) );
  dfcrq1ll \lfsr_value_reg[15]  ( .d(N8), .cp(net253), .cdn(lfsr_rst_n), .q(
        lfsr_out[15]) );
  dfcrq1ll \lfsr_value_reg[14]  ( .d(lfsr_out[15]), .cp(net253), .cdn(
        lfsr_rst_n), .q(lfsr_out[14]) );
  dfcrq1ll \lfsr_value_reg[13]  ( .d(N7), .cp(net253), .cdn(lfsr_rst_n), .q(
        lfsr_out[13]) );
  dfcrq1ll \lfsr_value_reg[12]  ( .d(N6), .cp(net253), .cdn(lfsr_rst_n), .q(
        lfsr_out[12]) );
  dfcrq1ll \lfsr_value_reg[11]  ( .d(lfsr_out[12]), .cp(net253), .cdn(
        lfsr_rst_n), .q(lfsr_out[11]) );
  dfcrq1ll \lfsr_value_reg[10]  ( .d(N5), .cp(net253), .cdn(lfsr_rst_n), .q(n5) );
  dfcrq1ll \lfsr_value_reg[9]  ( .d(n5), .cp(net253), .cdn(lfsr_rst_n), .q(
        lfsr_out[9]) );
  dfcrq1ll \lfsr_value_reg[8]  ( .d(lfsr_out[9]), .cp(net253), .cdn(lfsr_rst_n), .q(lfsr_out[8]) );
  dfcrq1ll \lfsr_value_reg[7]  ( .d(lfsr_out[8]), .cp(net253), .cdn(lfsr_rst_n), .q(lfsr_out[7]) );
  dfcrq1ll \lfsr_value_reg[6]  ( .d(lfsr_out[7]), .cp(net253), .cdn(lfsr_rst_n), .q(lfsr_out[6]) );
  dfcrq1ll \lfsr_value_reg[5]  ( .d(lfsr_out[6]), .cp(net253), .cdn(lfsr_rst_n), .q(lfsr_out[5]) );
  dfcrq1ll \lfsr_value_reg[4]  ( .d(lfsr_out[5]), .cp(net253), .cdn(lfsr_rst_n), .q(lfsr_out[4]) );
  dfcrq1ll \lfsr_value_reg[3]  ( .d(lfsr_out[4]), .cp(net253), .cdn(lfsr_rst_n), .q(lfsr_out[3]) );
  dfcrq1ll \lfsr_value_reg[2]  ( .d(lfsr_out[3]), .cp(net253), .cdn(lfsr_rst_n), .q(lfsr_out[2]) );
  dfcrn1ll \lfsr_value_reg[1]  ( .d(lfsr_out[2]), .cp(net253), .cdn(lfsr_rst_n), .qn(n1) );
  aor21d1ll U3 ( .b1(lfsr_load), .b2(lfsr_si), .a(n2), .z(N8) );
  aoim22d1ll U4 ( .a1(n2), .a2(lfsr_out[14]), .b1(lfsr_out[14]), .b2(n2), .zn(
        N7) );
  aoim22d1ll U5 ( .a1(n2), .a2(lfsr_out[13]), .b1(lfsr_out[13]), .b2(n2), .zn(
        N6) );
  aoim22d1ll U6 ( .a1(n2), .a2(lfsr_out[11]), .b1(lfsr_out[11]), .b2(n2), .zn(
        N5) );
  SNPS_CLOCK_GATE_HIGH_lfsr clk_gate_lfsr_value_reg ( .CLK(lfsr_clk), .EN(N1), 
        .ENCLK(net253), .TE(1'b0) );
  nd12d1ll U8 ( .a1(lfsr_load), .a2(lfsr_so), .zn(n3) );
  or02d1ll U9 ( .a1(lfsr_load), .a2(lfsr_en), .z(N1) );
  inv0d1ll U2 ( .i(n1), .zn(lfsr_out[1]) );
  inv0d1ll U7 ( .i(n3), .zn(n2) );
endmodule


module bistcontroller ( bist_done, bist_en, bist_lfsr_en, bist_misr_en, 
        bist_scan_en, bist_weighting_sel, bist_flipping_sel, bist_delaytest, 
        bist_scan_conf_out, bist_start, bist_clk, bist_rst_n, 
        bist_scan_conf_in, bist_scan_conf_en );
  output [1:0] bist_weighting_sel;
  output [15:0] bist_flipping_sel;
  input bist_start, bist_clk, bist_rst_n, bist_scan_conf_in, bist_scan_conf_en;
  output bist_done, bist_en, bist_lfsr_en, bist_misr_en, bist_scan_en,
         bist_delaytest, bist_scan_conf_out;
  wire   n45, misr_enable_r, misr_enable_set, testcounter_rst,
         patterncounter_rst, N11, N12, N13, N14, N15, N16, N17, N18, N19, N20,
         N21, N22, N23, N24, N26, N27, N28, N29, N30, N31, N32, N33, N34, N35,
         N36, N37, N38, N39, N40, N41, N42, N48, N49, N50, N51, N52, N53, N55,
         N56, N57, N58, N59, N60, N61, N62, N63, testcounter_inc, N71, N72,
         N73, N74, bist_weight_load, bist_flip_en, N78, N79, N80, N81, N82,
         N83, N84, N85, N86, N87, N88, N89, N90, N91, N92, N93, net270, net275,
         net280, net285, net290, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12,
         n13, n14, n15, n16, n17, n18, n19, n20, n21, n22, n23, n24, n25, n26,
         n27, n28, n29, n30, n31, n32, n33, n34, n35, \add_x_102_0/carry[2] ,
         \add_x_102_0/carry[3] , \add_x_102_0/carry[4] ,
         \add_x_102_0/carry[5] , \add_x_102_0/carry[6] ,
         \add_x_102_0/carry[7] , \add_x_87_0/carry[2] , \add_x_87_0/carry[3] ,
         \add_x_87_0/carry[4] , \add_x_87_0/carry[5] , \add_x_87_0/carry[6] ,
         \add_x_87_0/carry[7] , \add_x_87_0/carry[8] , \add_x_87_0/carry[9] ,
         \add_x_87_0/carry[10] , \add_x_87_0/carry[11] ,
         \add_x_87_0/carry[12] , \add_x_87_0/carry[13] ,
         \add_x_87_0/carry[14] , \add_x_87_0/carry[15] , n1, n36, n37, n38,
         n39, n42, n43;
  wire   [14:0] flipping_conf_r;
  wire   [15:0] pattern_counter_r;
  wire   [7:0] bit_counter_r;
  wire   [2:0] test_counter_r;
  wire   [1:0] bist_weight_sel;
  wire   [15:0] pattern_to_apply_r;
  wire   [7:0] bits_to_apply_r;
  wire   [7:1] conf_r;

  dfcrq1ll \pattern_to_apply_r_reg[0]  ( .d(bist_scan_conf_in), .cp(net290), 
        .cdn(bist_rst_n), .q(pattern_to_apply_r[0]) );
  dfcrq1ll \pattern_to_apply_r_reg[1]  ( .d(pattern_to_apply_r[0]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[1]) );
  dfcrq1ll \pattern_to_apply_r_reg[2]  ( .d(pattern_to_apply_r[1]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[2]) );
  dfcrq1ll \pattern_to_apply_r_reg[3]  ( .d(pattern_to_apply_r[2]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[3]) );
  dfcrq1ll \pattern_to_apply_r_reg[4]  ( .d(pattern_to_apply_r[3]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[4]) );
  dfcrq1ll \pattern_to_apply_r_reg[5]  ( .d(pattern_to_apply_r[4]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[5]) );
  dfcrq1ll \pattern_to_apply_r_reg[6]  ( .d(pattern_to_apply_r[5]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[6]) );
  dfcrq1ll \pattern_to_apply_r_reg[7]  ( .d(pattern_to_apply_r[6]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[7]) );
  dfcrq1ll \pattern_to_apply_r_reg[8]  ( .d(pattern_to_apply_r[7]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[8]) );
  dfcrq1ll \pattern_to_apply_r_reg[9]  ( .d(pattern_to_apply_r[8]), .cp(net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[9]) );
  dfcrn1ll \pattern_to_apply_r_reg[10]  ( .d(n29), .cp(net290), .cdn(
        bist_rst_n), .qn(pattern_to_apply_r[10]) );
  dfcrq1ll \pattern_to_apply_r_reg[11]  ( .d(pattern_to_apply_r[10]), .cp(
        net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[11]) );
  dfcrq1ll \pattern_to_apply_r_reg[12]  ( .d(pattern_to_apply_r[11]), .cp(
        net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[12]) );
  dfcrq1ll \pattern_to_apply_r_reg[13]  ( .d(pattern_to_apply_r[12]), .cp(
        net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[13]) );
  dfcrq1ll \pattern_to_apply_r_reg[14]  ( .d(pattern_to_apply_r[13]), .cp(
        net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[14]) );
  dfcrq1ll \pattern_to_apply_r_reg[15]  ( .d(pattern_to_apply_r[14]), .cp(
        net290), .cdn(bist_rst_n), .q(pattern_to_apply_r[15]) );
  dfcrq1ll \bits_to_apply_r_reg[0]  ( .d(pattern_to_apply_r[15]), .cp(net290), 
        .cdn(bist_rst_n), .q(bits_to_apply_r[0]) );
  dfcrn1ll \bits_to_apply_r_reg[1]  ( .d(n28), .cp(net290), .cdn(bist_rst_n), 
        .qn(bits_to_apply_r[1]) );
  dfcrn1ll \bits_to_apply_r_reg[2]  ( .d(n27), .cp(net290), .cdn(bist_rst_n), 
        .qn(bits_to_apply_r[2]) );
  dfcrn1ll \bits_to_apply_r_reg[3]  ( .d(n26), .cp(net290), .cdn(bist_rst_n), 
        .qn(bits_to_apply_r[3]) );
  dfcrq1ll \bits_to_apply_r_reg[4]  ( .d(bits_to_apply_r[3]), .cp(net290), 
        .cdn(bist_rst_n), .q(bits_to_apply_r[4]) );
  dfcrn1ll \bits_to_apply_r_reg[5]  ( .d(n25), .cp(net290), .cdn(bist_rst_n), 
        .qn(bits_to_apply_r[5]) );
  dfcrq1ll \bits_to_apply_r_reg[6]  ( .d(bits_to_apply_r[5]), .cp(net290), 
        .cdn(bist_rst_n), .q(bits_to_apply_r[6]) );
  dfcrq1ll \bits_to_apply_r_reg[7]  ( .d(bits_to_apply_r[6]), .cp(net290), 
        .cdn(bist_rst_n), .q(bits_to_apply_r[7]) );
  dfcrq1ll \conf_r_reg[0]  ( .d(bits_to_apply_r[7]), .cp(net290), .cdn(
        bist_rst_n), .q(n45) );
  dfcrn1ll \conf_r_reg[1]  ( .d(n24), .cp(net290), .cdn(bist_rst_n), .qn(
        conf_r[1]) );
  dfcrn1ll \conf_r_reg[2]  ( .d(n23), .cp(net290), .cdn(bist_rst_n), .qn(
        conf_r[2]) );
  dfcrn1ll \conf_r_reg[3]  ( .d(n22), .cp(net290), .cdn(bist_rst_n), .qn(
        conf_r[3]) );
  dfcrn1ll \conf_r_reg[4]  ( .d(n21), .cp(net290), .cdn(bist_rst_n), .qn(
        conf_r[4]) );
  dfcrn1ll \conf_r_reg[5]  ( .d(n20), .cp(net290), .cdn(bist_rst_n), .qn(
        conf_r[5]) );
  dfcrn1ll \conf_r_reg[6]  ( .d(n19), .cp(net290), .cdn(bist_rst_n), .qn(
        conf_r[6]) );
  dfcrn1ll \conf_r_reg[7]  ( .d(n18), .cp(net290), .cdn(bist_rst_n), .qn(
        conf_r[7]) );
  dfcrq1ll misr_enable_r_reg ( .d(n35), .cp(bist_clk), .cdn(bist_rst_n), .q(
        misr_enable_r) );
  dfcrq1ll \test_counter_r_reg[0]  ( .d(N71), .cp(net280), .cdn(bist_rst_n), 
        .q(test_counter_r[0]) );
  dfcrq1ll \test_counter_r_reg[1]  ( .d(N72), .cp(net280), .cdn(bist_rst_n), 
        .q(test_counter_r[1]) );
  dfcrq1ll \test_counter_r_reg[2]  ( .d(N74), .cp(net280), .cdn(bist_rst_n), 
        .q(test_counter_r[2]) );
  dfcrq1ll \pattern_counter_r_reg[15]  ( .d(N42), .cp(net270), .cdn(bist_rst_n), .q(pattern_counter_r[15]) );
  dfcrq1ll \pattern_counter_r_reg[0]  ( .d(N26), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[0]) );
  dfcrq1ll \pattern_counter_r_reg[1]  ( .d(N27), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[1]) );
  dfcrq1ll \pattern_counter_r_reg[2]  ( .d(N28), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[2]) );
  dfcrq1ll \pattern_counter_r_reg[3]  ( .d(N29), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[3]) );
  dfcrq1ll \pattern_counter_r_reg[4]  ( .d(N30), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[4]) );
  dfcrq1ll \pattern_counter_r_reg[5]  ( .d(N31), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[5]) );
  dfcrq1ll \pattern_counter_r_reg[6]  ( .d(N32), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[6]) );
  dfcrq1ll \pattern_counter_r_reg[7]  ( .d(N33), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[7]) );
  dfcrq1ll \pattern_counter_r_reg[8]  ( .d(N34), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[8]) );
  dfcrq1ll \pattern_counter_r_reg[9]  ( .d(N35), .cp(net270), .cdn(bist_rst_n), 
        .q(pattern_counter_r[9]) );
  dfcrq1ll \pattern_counter_r_reg[10]  ( .d(N36), .cp(net270), .cdn(bist_rst_n), .q(pattern_counter_r[10]) );
  dfcrq1ll \pattern_counter_r_reg[11]  ( .d(N37), .cp(net270), .cdn(bist_rst_n), .q(pattern_counter_r[11]) );
  dfcrq1ll \pattern_counter_r_reg[12]  ( .d(N38), .cp(net270), .cdn(bist_rst_n), .q(pattern_counter_r[12]) );
  dfcrq1ll \pattern_counter_r_reg[13]  ( .d(N39), .cp(net270), .cdn(bist_rst_n), .q(pattern_counter_r[13]) );
  dfcrq1ll \pattern_counter_r_reg[14]  ( .d(N40), .cp(net270), .cdn(bist_rst_n), .q(pattern_counter_r[14]) );
  dfcrq1ll \bit_counter_r_reg[7]  ( .d(N63), .cp(net275), .cdn(bist_rst_n), 
        .q(bit_counter_r[7]) );
  dfcrq1ll \bit_counter_r_reg[0]  ( .d(N55), .cp(net275), .cdn(bist_rst_n), 
        .q(bit_counter_r[0]) );
  dfcrq1ll \bit_counter_r_reg[1]  ( .d(N56), .cp(net275), .cdn(bist_rst_n), 
        .q(bit_counter_r[1]) );
  dfcrq1ll \bit_counter_r_reg[2]  ( .d(N57), .cp(net275), .cdn(bist_rst_n), 
        .q(bit_counter_r[2]) );
  dfcrq1ll \bit_counter_r_reg[3]  ( .d(N58), .cp(net275), .cdn(bist_rst_n), 
        .q(bit_counter_r[3]) );
  dfcrq1ll \bit_counter_r_reg[4]  ( .d(N59), .cp(net275), .cdn(bist_rst_n), 
        .q(bit_counter_r[4]) );
  dfcrq1ll \bit_counter_r_reg[5]  ( .d(N60), .cp(net275), .cdn(bist_rst_n), 
        .q(bit_counter_r[5]) );
  dfcrq1ll \bit_counter_r_reg[6]  ( .d(N61), .cp(net275), .cdn(bist_rst_n), 
        .q(bit_counter_r[6]) );
  dfcrq1ll \bist_weighting_sel_reg[0]  ( .d(bist_weight_sel[0]), .cp(net285), 
        .cdn(bist_rst_n), .q(bist_weighting_sel[0]) );
  dfcrq1ll \bist_weighting_sel_reg[1]  ( .d(bist_weight_sel[1]), .cp(net285), 
        .cdn(bist_rst_n), .q(bist_weighting_sel[1]) );
  dfcrn1ll \flipping_conf_r_reg[0]  ( .d(n17), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[0]) );
  dfcrn1ll \flipping_conf_r_reg[1]  ( .d(n16), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[1]) );
  dfcrn1ll \flipping_conf_r_reg[2]  ( .d(n15), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[2]) );
  dfcrn1ll \flipping_conf_r_reg[3]  ( .d(n14), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[3]) );
  dfcrn1ll \flipping_conf_r_reg[4]  ( .d(n13), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[4]) );
  dfcrn1ll \flipping_conf_r_reg[5]  ( .d(n12), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[5]) );
  dfcrn1ll \flipping_conf_r_reg[6]  ( .d(n11), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[6]) );
  dfcrn1ll \flipping_conf_r_reg[7]  ( .d(n10), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[7]) );
  dfcrn1ll \flipping_conf_r_reg[8]  ( .d(n9), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[8]) );
  dfcrn1ll \flipping_conf_r_reg[9]  ( .d(n8), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[9]) );
  dfcrn1ll \flipping_conf_r_reg[10]  ( .d(n7), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[10]) );
  dfcrn1ll \flipping_conf_r_reg[11]  ( .d(n6), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[11]) );
  dfcrn1ll \flipping_conf_r_reg[12]  ( .d(n5), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[12]) );
  dfcrn1ll \flipping_conf_r_reg[13]  ( .d(n4), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[13]) );
  dfcrn1ll \flipping_conf_r_reg[14]  ( .d(n3), .cp(net290), .cdn(bist_rst_n), 
        .qn(flipping_conf_r[14]) );
  dfcrn1ll \flipping_conf_r_reg[15]  ( .d(n2), .cp(net290), .cdn(bist_rst_n), 
        .qn(bist_scan_conf_out) );
  dfcrq1ll \bist_flipping_sel_reg[15]  ( .d(N93), .cp(net285), .cdn(bist_rst_n), .q(bist_flipping_sel[15]) );
  dfcrq1ll \bist_flipping_sel_reg[14]  ( .d(N92), .cp(net285), .cdn(bist_rst_n), .q(bist_flipping_sel[14]) );
  dfcrq1ll \bist_flipping_sel_reg[13]  ( .d(N91), .cp(net285), .cdn(bist_rst_n), .q(bist_flipping_sel[13]) );
  dfcrq1ll \bist_flipping_sel_reg[12]  ( .d(N90), .cp(net285), .cdn(bist_rst_n), .q(bist_flipping_sel[12]) );
  dfcrq1ll \bist_flipping_sel_reg[11]  ( .d(N89), .cp(net285), .cdn(bist_rst_n), .q(bist_flipping_sel[11]) );
  dfcrq1ll \bist_flipping_sel_reg[10]  ( .d(N88), .cp(net285), .cdn(bist_rst_n), .q(bist_flipping_sel[10]) );
  dfcrq1ll \bist_flipping_sel_reg[9]  ( .d(N87), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[9]) );
  dfcrq1ll \bist_flipping_sel_reg[8]  ( .d(N86), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[8]) );
  dfcrq1ll \bist_flipping_sel_reg[7]  ( .d(N85), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[7]) );
  dfcrq1ll \bist_flipping_sel_reg[6]  ( .d(N84), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[6]) );
  dfcrq1ll \bist_flipping_sel_reg[5]  ( .d(N83), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[5]) );
  dfcrq1ll \bist_flipping_sel_reg[4]  ( .d(N82), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[4]) );
  dfcrq1ll \bist_flipping_sel_reg[3]  ( .d(N81), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[3]) );
  dfcrq1ll \bist_flipping_sel_reg[2]  ( .d(N80), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[2]) );
  dfcrq1ll \bist_flipping_sel_reg[1]  ( .d(N79), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[1]) );
  dfcrq1ll \bist_flipping_sel_reg[0]  ( .d(N78), .cp(net285), .cdn(bist_rst_n), 
        .q(bist_flipping_sel[0]) );
  aor21d1ll U31 ( .b1(misr_enable_r), .b2(n30), .a(misr_enable_set), .z(n35)
         );
  aoi31d1ll U48 ( .b1(test_counter_r[2]), .b2(test_counter_r[0]), .b3(
        test_counter_r[1]), .a(n31), .zn(N74) );
  aon211d1ll U49 ( .c1(test_counter_r[0]), .c2(test_counter_r[1]), .b(
        test_counter_r[2]), .a(testcounter_inc), .zn(n31) );
  aoi221d1ll U52 ( .b1(test_counter_r[0]), .b2(test_counter_r[1]), .c1(n33), 
        .c2(n34), .a(n32), .zn(N72) );
  bistcontroller_fsm U_BISTCONTROLLER_FSM ( .bist_done(bist_done), .bist_en(
        bist_en), .bist_scan_en(bist_scan_en), .bist_lfsr_en(bist_lfsr_en), 
        .bist_misr_en(bist_misr_en), .bist_weight_sel(bist_weight_sel), 
        .bist_weight_load(bist_weight_load), .bist_flip_en(bist_flip_en), 
        .bitcounter_inc(n39), .patterncounter_inc(n43), .testcounter_inc(
        testcounter_inc), .patterncounter_rst(patterncounter_rst), 
        .bitcounter_rst(n42), .testcounter_rst(testcounter_rst), 
        .misr_enable_set(misr_enable_set), .bist_clk(bist_clk), .bist_rst_n(
        bist_rst_n), .bist_start(bist_start), .bit_counter_r(bit_counter_r), 
        .bits_to_apply_r(bits_to_apply_r), .pattern_counter_r(
        pattern_counter_r), .pattern_to_apply_r(pattern_to_apply_r), 
        .test_counter_r(test_counter_r), .conf_r({conf_r, n45}), 
        .misr_enable_r(misr_enable_r) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_4 clk_gate_pattern_counter_r_reg ( .CLK(
        bist_clk), .EN(N41), .ENCLK(net270), .TE(1'b0) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_3 clk_gate_bit_counter_r_reg ( .CLK(
        bist_clk), .EN(N62), .ENCLK(net275), .TE(1'b0) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_2 clk_gate_test_counter_r_reg ( .CLK(
        bist_clk), .EN(N73), .ENCLK(net280), .TE(1'b0) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_1 clk_gate_bist_weighting_sel_reg ( 
        .CLK(bist_clk), .EN(bist_weight_load), .ENCLK(net285), .TE(1'b0) );
  SNPS_CLOCK_GATE_HIGH_bistcontroller_0 clk_gate_pattern_to_apply_r_reg ( 
        .CLK(bist_clk), .EN(bist_scan_conf_en), .ENCLK(net290), .TE(1'b0) );
  or02d1ll U67 ( .a1(n43), .a2(patterncounter_rst), .z(N41) );
  inv0d1ll U56 ( .i(testcounter_inc), .zn(n32) );
  inv0d1ll U51 ( .i(testcounter_rst), .zn(n30) );
  nd02d1ll U50 ( .a1(n32), .a2(n30), .zn(N73) );
  an02d1ll U68 ( .a1(n43), .a2(N24), .z(N40) );
  an02d1ll U60 ( .a1(n39), .a2(N52), .z(N60) );
  an02d1ll U64 ( .a1(n39), .a2(N48), .z(N56) );
  an02d1ll U59 ( .a1(n39), .a2(N53), .z(N61) );
  an02d1ll U63 ( .a1(n39), .a2(N49), .z(N57) );
  an02d1ll U62 ( .a1(n39), .a2(N50), .z(N58) );
  an02d1ll U61 ( .a1(n39), .a2(N51), .z(N59) );
  an02d1ll U69 ( .a1(n43), .a2(N23), .z(N39) );
  an02d1ll U70 ( .a1(n43), .a2(N22), .z(N38) );
  an02d1ll U71 ( .a1(n43), .a2(N21), .z(N37) );
  an02d1ll U72 ( .a1(n43), .a2(N20), .z(N36) );
  an02d1ll U78 ( .a1(n43), .a2(N14), .z(N30) );
  an02d1ll U80 ( .a1(n43), .a2(N12), .z(N28) );
  an02d1ll U73 ( .a1(n43), .a2(N19), .z(N35) );
  an02d1ll U79 ( .a1(n43), .a2(N13), .z(N29) );
  an02d1ll U76 ( .a1(n43), .a2(N16), .z(N32) );
  an02d1ll U74 ( .a1(n43), .a2(N18), .z(N34) );
  an02d1ll U77 ( .a1(n43), .a2(N15), .z(N31) );
  an02d1ll U81 ( .a1(n43), .a2(N11), .z(N27) );
  an02d1ll U75 ( .a1(n43), .a2(N17), .z(N33) );
  inv0d1ll U53 ( .i(test_counter_r[1]), .zn(n34) );
  or02d1ll U58 ( .a1(n39), .a2(n42), .z(N62) );
  an02d1ll U32 ( .a1(bist_flip_en), .a2(bist_scan_conf_out), .z(N93) );
  an02d1ll U40 ( .a1(bist_flip_en), .a2(flipping_conf_r[7]), .z(N85) );
  an02d1ll U34 ( .a1(bist_flip_en), .a2(flipping_conf_r[13]), .z(N91) );
  an02d1ll U33 ( .a1(bist_flip_en), .a2(flipping_conf_r[14]), .z(N92) );
  an02d1ll U46 ( .a1(bist_flip_en), .a2(flipping_conf_r[1]), .z(N79) );
  an02d1ll U39 ( .a1(bist_flip_en), .a2(flipping_conf_r[8]), .z(N86) );
  an02d1ll U45 ( .a1(bist_flip_en), .a2(flipping_conf_r[2]), .z(N80) );
  an02d1ll U43 ( .a1(bist_flip_en), .a2(flipping_conf_r[4]), .z(N82) );
  an02d1ll U35 ( .a1(bist_flip_en), .a2(flipping_conf_r[12]), .z(N90) );
  an02d1ll U47 ( .a1(bist_flip_en), .a2(flipping_conf_r[0]), .z(N78) );
  an02d1ll U37 ( .a1(bist_flip_en), .a2(flipping_conf_r[10]), .z(N88) );
  an02d1ll U41 ( .a1(bist_flip_en), .a2(flipping_conf_r[6]), .z(N84) );
  an02d1ll U44 ( .a1(bist_flip_en), .a2(flipping_conf_r[3]), .z(N81) );
  an02d1ll U36 ( .a1(bist_flip_en), .a2(flipping_conf_r[11]), .z(N89) );
  an02d1ll U38 ( .a1(bist_flip_en), .a2(flipping_conf_r[9]), .z(N87) );
  an02d1ll U42 ( .a1(bist_flip_en), .a2(flipping_conf_r[5]), .z(N83) );
  nr02d1ll U55 ( .a1(test_counter_r[0]), .a2(n32), .zn(N71) );
  inv0d1ll U24 ( .i(conf_r[1]), .zn(n23) );
  inv0d1ll U25 ( .i(n45), .zn(n24) );
  inv0d1ll U23 ( .i(conf_r[2]), .zn(n22) );
  inv0d1ll U21 ( .i(conf_r[4]), .zn(n20) );
  inv0d1ll U20 ( .i(conf_r[5]), .zn(n19) );
  inv0d1ll U22 ( .i(conf_r[3]), .zn(n21) );
  inv0d1ll U19 ( .i(conf_r[6]), .zn(n18) );
  inv0d1ll U26 ( .i(bits_to_apply_r[4]), .zn(n25) );
  inv0d1ll U30 ( .i(pattern_to_apply_r[9]), .zn(n29) );
  inv0d1ll U29 ( .i(bits_to_apply_r[0]), .zn(n28) );
  inv0d1ll U8 ( .i(flipping_conf_r[9]), .zn(n7) );
  inv0d1ll U16 ( .i(flipping_conf_r[1]), .zn(n15) );
  inv0d1ll U15 ( .i(flipping_conf_r[2]), .zn(n14) );
  inv0d1ll U14 ( .i(flipping_conf_r[3]), .zn(n13) );
  inv0d1ll U4 ( .i(flipping_conf_r[13]), .zn(n3) );
  inv0d1ll U13 ( .i(flipping_conf_r[4]), .zn(n12) );
  inv0d1ll U12 ( .i(flipping_conf_r[5]), .zn(n11) );
  inv0d1ll U5 ( .i(flipping_conf_r[12]), .zn(n4) );
  inv0d1ll U11 ( .i(flipping_conf_r[6]), .zn(n10) );
  inv0d1ll U10 ( .i(flipping_conf_r[7]), .zn(n9) );
  inv0d1ll U6 ( .i(flipping_conf_r[11]), .zn(n5) );
  inv0d1ll U9 ( .i(flipping_conf_r[8]), .zn(n8) );
  inv0d1ll U3 ( .i(flipping_conf_r[14]), .zn(n2) );
  inv0d1ll U17 ( .i(flipping_conf_r[0]), .zn(n16) );
  inv0d1ll U7 ( .i(flipping_conf_r[10]), .zn(n6) );
  inv0d1ll U27 ( .i(bits_to_apply_r[2]), .zn(n26) );
  inv0d1ll U28 ( .i(bits_to_apply_r[1]), .zn(n27) );
  inv0d0ll U54 ( .i(test_counter_r[0]), .zn(n33) );
  ah01d1ll \add_x_102_0/U1_1_6  ( .a(bit_counter_r[6]), .b(
        \add_x_102_0/carry[6] ), .co(\add_x_102_0/carry[7] ), .s(N53) );
  ah01d1ll \add_x_102_0/U1_1_5  ( .a(bit_counter_r[5]), .b(
        \add_x_102_0/carry[5] ), .co(\add_x_102_0/carry[6] ), .s(N52) );
  ah01d1ll \add_x_102_0/U1_1_4  ( .a(bit_counter_r[4]), .b(
        \add_x_102_0/carry[4] ), .co(\add_x_102_0/carry[5] ), .s(N51) );
  ah01d1ll \add_x_102_0/U1_1_3  ( .a(bit_counter_r[3]), .b(
        \add_x_102_0/carry[3] ), .co(\add_x_102_0/carry[4] ), .s(N50) );
  ah01d1ll \add_x_102_0/U1_1_2  ( .a(bit_counter_r[2]), .b(
        \add_x_102_0/carry[2] ), .co(\add_x_102_0/carry[3] ), .s(N49) );
  ah01d1ll \add_x_102_0/U1_1_1  ( .a(bit_counter_r[1]), .b(bit_counter_r[0]), 
        .co(\add_x_102_0/carry[2] ), .s(N48) );
  ah01d1ll \add_x_87_0/U1_1_14  ( .a(pattern_counter_r[14]), .b(
        \add_x_87_0/carry[14] ), .co(\add_x_87_0/carry[15] ), .s(N24) );
  ah01d1ll \add_x_87_0/U1_1_13  ( .a(pattern_counter_r[13]), .b(
        \add_x_87_0/carry[13] ), .co(\add_x_87_0/carry[14] ), .s(N23) );
  ah01d1ll \add_x_87_0/U1_1_12  ( .a(pattern_counter_r[12]), .b(
        \add_x_87_0/carry[12] ), .co(\add_x_87_0/carry[13] ), .s(N22) );
  ah01d1ll \add_x_87_0/U1_1_11  ( .a(pattern_counter_r[11]), .b(
        \add_x_87_0/carry[11] ), .co(\add_x_87_0/carry[12] ), .s(N21) );
  ah01d1ll \add_x_87_0/U1_1_10  ( .a(pattern_counter_r[10]), .b(
        \add_x_87_0/carry[10] ), .co(\add_x_87_0/carry[11] ), .s(N20) );
  ah01d1ll \add_x_87_0/U1_1_9  ( .a(pattern_counter_r[9]), .b(
        \add_x_87_0/carry[9] ), .co(\add_x_87_0/carry[10] ), .s(N19) );
  ah01d1ll \add_x_87_0/U1_1_8  ( .a(pattern_counter_r[8]), .b(
        \add_x_87_0/carry[8] ), .co(\add_x_87_0/carry[9] ), .s(N18) );
  ah01d1ll \add_x_87_0/U1_1_7  ( .a(pattern_counter_r[7]), .b(
        \add_x_87_0/carry[7] ), .co(\add_x_87_0/carry[8] ), .s(N17) );
  ah01d1ll \add_x_87_0/U1_1_6  ( .a(pattern_counter_r[6]), .b(
        \add_x_87_0/carry[6] ), .co(\add_x_87_0/carry[7] ), .s(N16) );
  ah01d1ll \add_x_87_0/U1_1_5  ( .a(pattern_counter_r[5]), .b(
        \add_x_87_0/carry[5] ), .co(\add_x_87_0/carry[6] ), .s(N15) );
  ah01d1ll \add_x_87_0/U1_1_4  ( .a(pattern_counter_r[4]), .b(
        \add_x_87_0/carry[4] ), .co(\add_x_87_0/carry[5] ), .s(N14) );
  ah01d1ll \add_x_87_0/U1_1_3  ( .a(pattern_counter_r[3]), .b(
        \add_x_87_0/carry[3] ), .co(\add_x_87_0/carry[4] ), .s(N13) );
  ah01d1ll \add_x_87_0/U1_1_2  ( .a(pattern_counter_r[2]), .b(
        \add_x_87_0/carry[2] ), .co(\add_x_87_0/carry[3] ), .s(N12) );
  ah01d1ll \add_x_87_0/U1_1_1  ( .a(pattern_counter_r[1]), .b(
        pattern_counter_r[0]), .co(\add_x_87_0/carry[2] ), .s(N11) );
  inv0d1ll U18 ( .i(conf_r[7]), .zn(n17) );
  inv0d0ll U57 ( .i(n39), .zn(n1) );
  nr02d0ll U65 ( .a1(bit_counter_r[0]), .a2(n1), .zn(N55) );
  inv0d0ll U66 ( .i(n43), .zn(n36) );
  nr02d0ll U82 ( .a1(pattern_counter_r[0]), .a2(n36), .zn(N26) );
  oai21d1ll U83 ( .b1(\add_x_102_0/carry[7] ), .b2(bit_counter_r[7]), .a(n39), 
        .zn(n37) );
  aoi21d1ll U84 ( .b1(\add_x_102_0/carry[7] ), .b2(bit_counter_r[7]), .a(n37), 
        .zn(N63) );
  oai21d1ll U85 ( .b1(\add_x_87_0/carry[15] ), .b2(pattern_counter_r[15]), .a(
        n43), .zn(n38) );
  aoi21d1ll U86 ( .b1(\add_x_87_0/carry[15] ), .b2(pattern_counter_r[15]), .a(
        n38), .zn(N42) );
endmodule


module clockcontroller ( sys_clk, bist_clk, clockconf_scan_out, ext_clk, 
        osc_clk, rst_n, bist_en, ext_test_en, bist_scan_en, ext_scan_en, 
        clockconf_scan_in, clockconf_scan_en );
  input ext_clk, osc_clk, rst_n, bist_en, ext_test_en, bist_scan_en,
         ext_scan_en, clockconf_scan_in, clockconf_scan_en;
  output sys_clk, bist_clk, clockconf_scan_out;
  wire   N16, N17, N18, N19, N20, N21, N22, osc_clk_div, bist_scan_clk,
         scan_en, scan_enable_pipeline_sel, test_en, test_clk, lc_clk,
         scan_clk, net219, n1, n2, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13,
         n14, n15, n16, n17, n18, n19, \add_x_126_0/carry[2] ,
         \add_x_126_0/carry[3] , \add_x_126_0/carry[4] ,
         \add_x_126_0/carry[5] , \add_x_126_0/carry[6] ;
  wire   [1:0] mode;
  wire   [2:0] osc_clk_div_sel;
  wire   [1:0] bist_scan_clk_div_sel;
  wire   [6:0] osc_clockdivider;
  wire   [3:0] scan_enable_pipeline;

  dfnrq1ll \osc_clockdivider_reg[0]  ( .d(N16), .cp(osc_clk), .q(
        osc_clockdivider[0]) );
  dfnrq1ll \osc_clockdivider_reg[1]  ( .d(N17), .cp(osc_clk), .q(
        osc_clockdivider[1]) );
  dfnrq1ll \osc_clockdivider_reg[2]  ( .d(N18), .cp(osc_clk), .q(
        osc_clockdivider[2]) );
  dfnrq1ll \osc_clockdivider_reg[3]  ( .d(N19), .cp(osc_clk), .q(
        osc_clockdivider[3]) );
  dfnrq1ll \osc_clockdivider_reg[4]  ( .d(N20), .cp(osc_clk), .q(
        osc_clockdivider[4]) );
  dfnrq1ll \osc_clockdivider_reg[5]  ( .d(N21), .cp(osc_clk), .q(
        osc_clockdivider[5]) );
  dfnrq1ll \osc_clockdivider_reg[6]  ( .d(N22), .cp(osc_clk), .q(
        osc_clockdivider[6]) );
  dfcrn1ll \clockconf_reg[1]  ( .d(n2), .cp(net219), .cdn(rst_n), .qn(mode[1])
         );
  dfcrq1ll \clockconf_reg[2]  ( .d(mode[1]), .cp(net219), .cdn(rst_n), .q(
        osc_clk_div_sel[0]) );
  dfcrn1ll \clockconf_reg[3]  ( .d(n12), .cp(net219), .cdn(rst_n), .qn(
        osc_clk_div_sel[1]) );
  dfcrn1ll \clockconf_reg[4]  ( .d(n11), .cp(net219), .cdn(rst_n), .qn(
        osc_clk_div_sel[2]) );
  dfcrn1ll \clockconf_reg[5]  ( .d(n1), .cp(net219), .cdn(rst_n), .qn(
        bist_scan_clk_div_sel[0]) );
  dfcrn1ll \clockconf_reg[6]  ( .d(n19), .cp(net219), .cdn(rst_n), .qn(
        bist_scan_clk_div_sel[1]) );
  dfcrn1ll \clockconf_reg[7]  ( .d(n18), .cp(net219), .cdn(rst_n), .qn(
        clockconf_scan_out) );
  dfcrq1ll \scan_enable_pipeline_reg[0]  ( .d(scan_en), .cp(osc_clk_div), 
        .cdn(rst_n), .q(scan_enable_pipeline[0]) );
  dfcrq1ll \scan_enable_pipeline_reg[1]  ( .d(scan_enable_pipeline[0]), .cp(
        osc_clk_div), .cdn(rst_n), .q(scan_enable_pipeline[1]) );
  dfcrq1ll \scan_enable_pipeline_reg[2]  ( .d(scan_enable_pipeline[1]), .cp(
        osc_clk_div), .cdn(rst_n), .q(scan_enable_pipeline[2]) );
  dfcrq1ll \scan_enable_pipeline_reg[3]  ( .d(scan_enable_pipeline[2]), .cp(
        osc_clk_div), .cdn(rst_n), .q(scan_enable_pipeline[3]) );
  oai22d1ll U7 ( .a1(scan_enable_pipeline[2]), .a2(n4), .b1(
        scan_enable_pipeline[1]), .b2(n5), .zn(scan_enable_pipeline_sel) );
  oaim21d1ll U12 ( .b1(n9), .b2(n10), .a(osc_clk_div_sel[2]), .zn(n8) );
  oai221d1ll U13 ( .b1(osc_clk_div_sel[1]), .b2(osc_clockdivider[3]), .c1(n11), 
        .c2(osc_clockdivider[5]), .a(n12), .zn(n10) );
  oai221d1ll U14 ( .b1(osc_clk_div_sel[1]), .b2(osc_clockdivider[4]), .c1(n11), 
        .c2(osc_clockdivider[6]), .a(osc_clk_div_sel[0]), .zn(n9) );
  oai221d1ll U15 ( .b1(osc_clk_div_sel[1]), .b2(osc_clk), .c1(n11), .c2(
        osc_clockdivider[1]), .a(n12), .zn(n7) );
  oai221d1ll U17 ( .b1(osc_clk_div_sel[1]), .b2(osc_clockdivider[0]), .c1(n11), 
        .c2(osc_clockdivider[2]), .a(osc_clk_div_sel[0]), .zn(n6) );
  oaim21d1ll U20 ( .b1(n16), .b2(n17), .a(clockconf_scan_out), .zn(n15) );
  oai221d1ll U21 ( .b1(n18), .b2(osc_clockdivider[5]), .c1(
        bist_scan_clk_div_sel[1]), .c2(osc_clockdivider[3]), .a(n19), .zn(n17)
         );
  oai221d1ll U22 ( .b1(n18), .b2(osc_clockdivider[6]), .c1(
        bist_scan_clk_div_sel[1]), .c2(osc_clockdivider[4]), .a(
        bist_scan_clk_div_sel[0]), .zn(n16) );
  oai221d1ll U23 ( .b1(n18), .b2(osc_clockdivider[1]), .c1(
        bist_scan_clk_div_sel[1]), .c2(osc_clk), .a(n19), .zn(n14) );
  oai221d1ll U25 ( .b1(n18), .b2(osc_clockdivider[2]), .c1(
        bist_scan_clk_div_sel[1]), .c2(osc_clockdivider[0]), .a(
        bist_scan_clk_div_sel[0]), .zn(n13) );
  clockmux2_4 U_CLOCKMUX2_0 ( .clk_out(sys_clk), .clk1(test_clk), .clk2(
        osc_clk_div), .clk_sel(test_en) );
  clockmux2_3 U_CLOCKMUX2_1 ( .clk_out(lc_clk), .clk1(osc_clk_div), .clk2(1'b0), .clk_sel(scan_enable_pipeline_sel) );
  clockmux2_2 U_CLOCKMUX2_2 ( .clk_out(test_clk), .clk1(scan_clk), .clk2(
        lc_clk), .clk_sel(scan_en) );
  clockmux2_1 U_CLOCKMUX2_3 ( .clk_out(bist_clk), .clk1(ext_clk), .clk2(
        bist_scan_clk), .clk_sel(ext_test_en) );
  clockmux2_0 U_CLOCKMUX2_4 ( .clk_out(scan_clk), .clk1(bist_scan_clk), .clk2(
        ext_clk), .clk_sel(bist_en) );
  SNPS_CLOCK_GATE_HIGH_clockcontroller clk_gate_clockconf_reg ( .CLK(bist_clk), 
        .EN(clockconf_scan_en), .ENCLK(net219), .TE(1'b0) );
  inv0d1ll U24 ( .i(bist_scan_clk_div_sel[0]), .zn(n19) );
  inv0d1ll U16 ( .i(osc_clk_div_sel[0]), .zn(n12) );
  aon211d1ll U19 ( .c1(n13), .c2(n14), .b(clockconf_scan_out), .a(n15), .zn(
        bist_scan_clk) );
  inv0d1ll U18 ( .i(osc_clk_div_sel[1]), .zn(n11) );
  aon211d1ll U11 ( .c1(n6), .c2(n7), .b(osc_clk_div_sel[2]), .a(n8), .zn(
        osc_clk_div) );
  or02d1ll U6 ( .a1(bist_en), .a2(ext_test_en), .z(test_en) );
  inv0d1ll U3 ( .i(osc_clk_div_sel[2]), .zn(n1) );
  inv0d1ll U26 ( .i(bist_scan_clk_div_sel[1]), .zn(n18) );
  or02d1ll U10 ( .a1(bist_scan_en), .a2(ext_scan_en), .z(scan_en) );
  ah01d1ll \add_x_126_0/U1_1_5  ( .a(osc_clockdivider[5]), .b(
        \add_x_126_0/carry[5] ), .co(\add_x_126_0/carry[6] ), .s(N21) );
  ah01d1ll \add_x_126_0/U1_1_4  ( .a(osc_clockdivider[4]), .b(
        \add_x_126_0/carry[4] ), .co(\add_x_126_0/carry[5] ), .s(N20) );
  ah01d1ll \add_x_126_0/U1_1_3  ( .a(osc_clockdivider[3]), .b(
        \add_x_126_0/carry[3] ), .co(\add_x_126_0/carry[4] ), .s(N19) );
  ah01d1ll \add_x_126_0/U1_1_2  ( .a(osc_clockdivider[2]), .b(
        \add_x_126_0/carry[2] ), .co(\add_x_126_0/carry[3] ), .s(N18) );
  ah01d1ll \add_x_126_0/U1_1_1  ( .a(osc_clockdivider[1]), .b(
        osc_clockdivider[0]), .co(\add_x_126_0/carry[2] ), .s(N17) );
  nd02d0ll U9 ( .a1(scan_enable_pipeline[3]), .a2(mode[1]), .zn(n4) );
  nd02d0ll U8 ( .a1(scan_enable_pipeline[2]), .a2(mode[0]), .zn(n5) );
  dfprb1ll \clockconf_reg[0]  ( .d(clockconf_scan_in), .cp(net219), .sdn(rst_n), .q(mode[0]), .qn(n2) );
  inv0d0ll U4 ( .i(osc_clockdivider[0]), .zn(N16) );
  aoim22d1ll U5 ( .a1(\add_x_126_0/carry[6] ), .a2(osc_clockdivider[6]), .b1(
        osc_clockdivider[6]), .b2(\add_x_126_0/carry[6] ), .zn(N22) );
endmodule


module bisttop ( bist_en, bist_done, bist_scan_en, bist_scan_inputs, 
        bisttop_scan_conf_out, bist_clk, bist_rst_n, bist_start, 
        bist_scan_outputs, bisttop_scan_conf_in, bisttop_scan_conf_en );
  output [15:0] bist_scan_inputs;
  input [15:0] bist_scan_outputs;
  input bist_clk, bist_rst_n, bist_start, bisttop_scan_conf_in,
         bisttop_scan_conf_en;
  output bist_en, bist_done, bist_scan_en, bisttop_scan_conf_out;
  wire   misr_en, misr_si, lfsr_si, n1;
  wire   [15:0] phaseshifter_in;
  wire   [15:0] weighting_in;
  wire   [15:0] flipping_in;
  wire   [15:0] misr_in;
  wire   [15:0] flipping_sel;
  wire   [1:0] weighting_sel;
  wire   SYNOPSYS_UNCONNECTED__0, SYNOPSYS_UNCONNECTED__1;

  bistcontroller U_BISTCONTROLLER ( .bist_done(bist_done), .bist_en(bist_en), 
        .bist_lfsr_en(n1), .bist_misr_en(misr_en), .bist_scan_en(bist_scan_en), 
        .bist_weighting_sel(weighting_sel), .bist_flipping_sel(flipping_sel), 
        .bist_scan_conf_out(lfsr_si), .bist_start(bist_start), .bist_clk(
        bist_clk), .bist_rst_n(bist_rst_n), .bist_scan_conf_in(
        bisttop_scan_conf_in), .bist_scan_conf_en(bisttop_scan_conf_en) );
  lfsr U_LFSR ( .lfsr_out({phaseshifter_in[15:11], SYNOPSYS_UNCONNECTED__0, 
        phaseshifter_in[9:1], SYNOPSYS_UNCONNECTED__1}), .lfsr_so(misr_si), 
        .lfsr_clk(bist_clk), .lfsr_rst_n(bist_rst_n), .lfsr_en(n1), 
        .lfsr_load(bisttop_scan_conf_en), .lfsr_si(lfsr_si) );
  phaseshifter U_PHASESHIFTER ( .phaseshifter_out(weighting_in), 
        .phaseshifter_in({phaseshifter_in[15:11], 1'b0, phaseshifter_in[9:1], 
        1'b0}) );
  flipping U_FLIPPING ( .flipping_out(bist_scan_inputs), .flipping_in(
        flipping_in), .flipping_sel(flipping_sel) );
  weighting U_WEIGHTING ( .weighting_out(flipping_in), .weighting_in(
        weighting_in), .weighting_sel(weighting_sel) );
  concentrator U_CONSENTRATOR ( .concentrator_out(misr_in), .concentrator_in(
        bist_scan_outputs) );
  misr U_MISR ( .misr_so(bisttop_scan_conf_out), .misr_clk(bist_clk), 
        .misr_rst_n(bist_rst_n), .misr_en(misr_en), .misr_load(
        bisttop_scan_conf_en), .misr_si(misr_si), .misr_in(misr_in) );
endmodule


module mux_SIZE4_3 ( out, sel, ina, inb );
  output [3:0] out;
  input [3:0] ina;
  input [3:0] inb;
  input sel;
  wire   n2;

  aor22d1ll U1 ( .a1(sel), .a2(ina[3]), .b1(inb[3]), .b2(n2), .z(out[3]) );
  aor22d1ll U2 ( .a1(sel), .a2(ina[2]), .b1(inb[2]), .b2(n2), .z(out[2]) );
  aor22d1ll U3 ( .a1(sel), .a2(ina[1]), .b1(inb[1]), .b2(n2), .z(out[1]) );
  aor22d1ll U4 ( .a1(sel), .a2(ina[0]), .b1(inb[0]), .b2(n2), .z(out[0]) );
  inv0d1ll U5 ( .i(sel), .zn(n2) );
endmodule


module chip ( bist_done, conf_scan_out, scan_inputs, scan_en, ext_scan_out, 
        sys_clk, rst_n, ext_clk, bist_start, ext_test_en, ext_scan_en, 
        ext_scan_in, conf_scan_en, conf_scan_in, scan_outputs, osc_clk );
  output [15:0] scan_inputs;
  output [3:0] ext_scan_out;
  input [3:0] ext_scan_in;
  input [15:0] scan_outputs;
  input rst_n, ext_clk, bist_start, ext_test_en, ext_scan_en, conf_scan_en,
         conf_scan_in, osc_clk;
  output bist_done, conf_scan_out, scan_en, sys_clk;
  wire   bisttop_scan_conf_in, bist_clk, n1, n2;
  wire   [15:0] bist_scan_inputs;
  assign ext_scan_out[3] = scan_outputs[15];
  assign ext_scan_out[2] = scan_outputs[14];
  assign ext_scan_out[1] = scan_outputs[13];
  assign ext_scan_out[0] = scan_outputs[12];

  mux_SIZE4_3 U_MUX_0 ( .out(scan_inputs[3:0]), .sel(n2), .ina(
        bist_scan_inputs[3:0]), .inb(ext_scan_in) );
  mux_SIZE4_2 \muxing[1].U_MUX_  ( .out(scan_inputs[7:4]), .sel(n2), .ina(
        bist_scan_inputs[7:4]), .inb(scan_outputs[3:0]) );
  mux_SIZE4_1 \muxing[2].U_MUX_  ( .out(scan_inputs[11:8]), .sel(n2), .ina(
        bist_scan_inputs[11:8]), .inb(scan_outputs[7:4]) );
  mux_SIZE4_0 \muxing[3].U_MUX_  ( .out(scan_inputs[15:12]), .sel(n2), .ina(
        bist_scan_inputs[15:12]), .inb(scan_outputs[11:8]) );
  bisttop U_BISTTOP ( .bist_en(n2), .bist_done(bist_done), .bist_scan_en(n1), 
        .bist_scan_inputs(bist_scan_inputs), .bisttop_scan_conf_out(
        conf_scan_out), .bist_clk(bist_clk), .bist_rst_n(rst_n), .bist_start(
        bist_start), .bist_scan_outputs({ext_scan_out, scan_outputs[11:0]}), 
        .bisttop_scan_conf_in(bisttop_scan_conf_in), .bisttop_scan_conf_en(
        conf_scan_en) );
  clockcontroller U_CLOCKCONTROLLER ( .sys_clk(sys_clk), .bist_clk(bist_clk), 
        .clockconf_scan_out(bisttop_scan_conf_in), .ext_clk(ext_clk), 
        .osc_clk(osc_clk), .rst_n(rst_n), .bist_en(n2), .ext_test_en(
        ext_test_en), .bist_scan_en(n1), .ext_scan_en(ext_scan_en), 
        .clockconf_scan_in(conf_scan_in), .clockconf_scan_en(conf_scan_en) );
  or02d1ll U1 ( .a1(n1), .a2(ext_scan_en), .z(scan_en) );
endmodule

