// Verilog pattern output written by  TetraMAX (TM)  Y-2006.06-SP2-i060901_230703 
// Date: Tue Apr 15 10:56:11 2008
// Module tested: spi_co_processor

//   Uncollapsed Transition Fault Summary Report
// -----------------------------------------------
// fault class                     code   #faults
// ------------------------------  ----  ---------
// Detected                         DT      34727
//   detected_by_simulation         DS     (33107)
//   detected_by_implication        DI      (1620)
// Possibly detected                PT          0
// Undetectable                     UD         46
//   undetectable-redundant         UR        (46)
// ATPG untestable                  AU        195
//   atpg_untestable-not_detected   AN       (195)
// Not detected                     ND         72
//   not-observed                   NO        (72)
// -----------------------------------------------
// total faults                             35040
// test coverage                            99.24%
// -----------------------------------------------
// 
//            Pattern Summary Report
// -----------------------------------------------
// #internal patterns                         687
//     #basic_scan patterns                     1
//     #fast_sequential patterns              686
// -----------------------------------------------
// 
// rule  severity  #fails  description
// ----  --------  ------  ---------------------------------
// B7    warning        4  undriven module output pin
// B8    warning       21  unconnected module input pin
// B9    warning        7  undriven module internal net
// B10   warning       11  unconnected module internal net
// V14   warning        1  missing state
// 
// clock_name        off  usage
// ----------------  ---  --------------------------
// clk                0   master shift nonscan_DLAT 
// rst_n              1   
// 
// port_name         constraint_value
// ----------------  ---------------
// rst_n               1
// test_se             0
// 
// There are no equivalent pins
// There are no net connections

`timescale 1 ns / 1 ns

//
// --- NOTE: Remove the comment to define 'tmax_iddq' to activate processing of IDDQ events
//     Or use '+define+tmax_iddq' on the verilog compile line
//
//`define tmax_iddq

//
// --- User adjustable extension to state sequencer table for debug purposes.
//     Adjusts oversizing of 'memdrv[]' to make room for manually inserted values.
//
`ifdef tmax_state_dbg
   /* user has used compile time overide of form:  +define+tmax_state_dbg=10 */
`else
   /* default to 5 */
   `define tmax_state_dbg 5
`endif

module tb ;
   parameter NAMELENGTH = 200; // max length of names reported in fails
   parameter LENMAX = 25, NSHIFTS = 25; // LENMAX for serial
   parameter LENSERIAL = 25, NCHAINS = 16;
   parameter SHBEG = 0, SHEND = 0;
   integer nofails, bit, cbit, pattern, lastpattern, chain, idx;
   integer error_banner; // flag for tracking displayed error banner
   integer loads;        // number of load_unloads for current pattern
   integer patm1;        // pattern - 1
   integer patp1;        // pattern + lastpattern
   integer prev_pat;     // previous pattern number
   integer report_interval; // report pattern progress every Nth pattern
   integer verbose;      // message verbosity level
   parameter NINPUTS = 22, NOUTPUTS = 19;
   wire [0:NOUTPUTS-1] PO; reg [0:NOUTPUTS-1] ALLPOS, XPCT, MASK;
   reg [0:NINPUTS-1] PI, ALLPIS;
   integer scn, pis, pos, drv, mbyte;
   reg [0:NINPUTS-1] mempis [1:1373];
   reg [0:NOUTPUTS-1] mempos [1:1374];
   reg [7:0] drval, memdrv [1:10303+`tmax_state_dbg];
   reg [0:LENSERIAL-1] memscn [1:32992];
   reg [0:8*(NAMELENGTH-1)] POnames [0:NOUTPUTS-1];
   reg [0:8*(NAMELENGTH-1)] CHAINnames [0:NCHAINS-1];
   reg [0:8*(NAMELENGTH-1)] CHAINpins [0:NCHAINS-1];
   reg [0:LENSERIAL-1] LOAD0, LOADSH0, LOAD1, LOADSH1, LOAD2, LOADSH2, LOAD3,
   LOADSH3, LOAD4, LOADSH4, LOAD5, LOADSH5, LOAD6, LOADSH6, LOAD7, LOADSH7, LOAD8,
   LOADSH8, LOAD9, LOADSH9, LOAD10, LOADSH10, LOAD11, LOADSH11, LOAD12, LOADSH12,
   LOAD13, LOADSH13, LOAD14, LOADSH14, LOAD15, LOADSH15;
   reg [0:LENMAX-1] UNL, UNLOAD[0:NCHAINS-1];
   reg [0:LENMAX-1] UNLM, UNLMSK[0:NCHAINS-1], SHBEGM[0:NCHAINS-1];
   reg [0:LENMAX-1] SERIALM;
   reg [0:LENMAX-1] INPINV[0:NCHAINS-1], OUTINV[0:NCHAINS-1];
   wire [0:NCHAINS-1] SCANOUT;
   event IDDQ;

   wire sdo;
   wire rst_n;
   wire clk;
   wire sdi;
   wire ss_n;
   wire sclk;
   wire test_se;
   wire test_si1;
   wire test_so1;
   wire test_si2;
   wire test_so2;
   wire test_si3;
   wire test_so3;
   wire test_si4;
   wire test_so4;
   wire test_si5;
   wire test_so5;
   wire test_si6;
   wire test_so6;
   wire test_si7;
   wire test_so7;
   wire test_si8;
   wire test_so8;
   wire test_si9;
   wire test_so9;
   wire test_si10;
   wire test_so10;
   wire test_si11;
   wire test_so11;
   wire test_si12;
   wire test_so12;
   wire test_si13;
   wire test_so13;
   wire test_si14;
   wire test_si15;
   wire test_so15;
   wire test_si16;
   wire test_so16;
   wire [2:0] debug;

   // map PI[] vector to DUT inputs and bidis
   assign rst_n = PI[0];
   assign clk = PI[1];
   assign sdi = PI[2];
   assign ss_n = PI[3];
   assign sclk = PI[4];
   assign test_se = PI[5];
   assign test_si1 = PI[6];
   assign test_si2 = PI[7];
   assign test_si3 = PI[8];
   assign test_si4 = PI[9];
   assign test_si5 = PI[10];
   assign test_si6 = PI[11];
   assign test_si7 = PI[12];
   assign test_si8 = PI[13];
   assign test_si9 = PI[14];
   assign test_si10 = PI[15];
   assign test_si11 = PI[16];
   assign test_si12 = PI[17];
   assign test_si13 = PI[18];
   assign test_si14 = PI[19];
   assign test_si15 = PI[20];
   assign test_si16 = PI[21];

   // map DUT outputs and bidis to PO[] vector
   assign
      PO[0] = sdo ,
      PO[1] = debug[2] ,
      PO[2] = debug[1] ,
      PO[3] = debug[0] ,
      PO[4] = test_so1 ,
      PO[5] = test_so2 ,
      PO[6] = test_so3 ,
      PO[7] = test_so4 ,
      PO[8] = test_so5 ,
      PO[9] = test_so6 ,
      PO[10] = test_so7 ,
      PO[11] = test_so8 ,
      PO[12] = test_so9 ,
      PO[13] = test_so10 ,
      PO[14] = test_so11 ,
      PO[15] = test_so12 ,
      PO[16] = test_so13 ,
      PO[17] = test_so15 ,
      PO[18] = test_so16 ;

   // instantiate the design into the testbench
   spi_co_processor dut (
      .sdo(sdo),
      .debug(debug),
      .rst_n(rst_n),
      .clk(clk),
      .sdi(sdi),
      .ss_n(ss_n),
      .sclk(sclk),
      .test_se(test_se),
      .test_si1(test_si1),
      .test_so1(test_so1),
      .test_si2(test_si2),
      .test_so2(test_so2),
      .test_si3(test_si3),
      .test_so3(test_so3),
      .test_si4(test_si4),
      .test_so4(test_so4),
      .test_si5(test_si5),
      .test_so5(test_so5),
      .test_si6(test_si6),
      .test_so6(test_so6),
      .test_si7(test_si7),
      .test_so7(test_so7),
      .test_si8(test_si8),
      .test_so8(test_so8),
      .test_si9(test_si9),
      .test_so9(test_so9),
      .test_si10(test_si10),
      .test_so10(test_so10),
      .test_si11(test_si11),
      .test_so11(test_so11),
      .test_si12(test_si12),
      .test_so12(test_so12),
      .test_si13(test_si13),
      .test_so13(test_so13),
      .test_si14(test_si14),
      .test_si15(test_si15),
      .test_so15(test_so15),
      .test_si16(test_si16),
      .test_so16(test_so16)   );

   event pulse_clk;
   always @ pulse_clk begin
      #45 PI[1] = 1; #10 PI[1] = 0;   // clk
   end

   event pulse_rst_n;
   always @ pulse_rst_n begin
      #45 PI[0] = 0; #10 PI[0] = 1;   // rst_n
   end


   integer errshown;
   event measurePO;
   always @ measurePO begin
      if (((XPCT&MASK) !== (ALLPOS&MASK)) || (XPCT !== (~(~XPCT)))) begin
         errshown = 0;
         for (bit = 0; bit < NOUTPUTS; bit=bit + 1) begin
            if (MASK[bit]==1'b1) begin
               if (XPCT[bit] !== ALLPOS[bit]) begin
                  if (errshown==0) $display("\n// *** ERROR during capture pattern %0d, T=%t", pattern, $time);
                  $display("  %0d %0s (exp=%b, got=%b)", pattern, POnames[bit], XPCT[bit], ALLPOS[bit]);
                  nofails = nofails + 1; errshown = 1;
               end
            end
         end
      end
   end

   event forcePI_default_WFT;
   always @ forcePI_default_WFT begin
      PI = ALLPIS;
   end
   event measurePO_default_WFT;
   always @ measurePO_default_WFT begin
      #40;
      ALLPOS = PO;
      #0; #0 -> measurePO;
      `ifdef tmax_iddq
         #0; ->IDDQ;
      `endif
   end

   event force_scanin;
   always @ force_scanin begin
      PI[6] <= LOAD0[bit];
      PI[7] <= LOAD1[bit];
      PI[8] <= LOAD2[bit];
      PI[9] <= LOAD3[bit];
      PI[10] <= LOAD4[bit];
      PI[11] <= LOAD5[bit];
      PI[12] <= LOAD6[bit];
      PI[13] <= LOAD7[bit];
      PI[14] <= LOAD8[bit];
      PI[15] <= LOAD9[bit];
      PI[16] <= LOAD10[bit];
      PI[17] <= LOAD11[bit];
      PI[18] <= LOAD12[bit];
      PI[19] <= LOAD13[bit];
      PI[20] <= LOAD14[bit];
      PI[21] <= LOAD15[bit];
   end

   assign SCANOUT[0] = test_so1,  SCANOUT[1] = test_so2,  SCANOUT[2] = test_so3,
           SCANOUT[3] = test_so4,  SCANOUT[4] = test_so5,  SCANOUT[5] = test_so6,
           SCANOUT[6] = test_so7,  SCANOUT[7] = test_so8,  SCANOUT[8] = test_so9,
           SCANOUT[9] = test_so10,  SCANOUT[10] = test_so11,  SCANOUT[11] = test_so12,
           SCANOUT[12] = test_so13,  SCANOUT[13] = debug[2],  SCANOUT[14] = test_so15,
           SCANOUT[15] = test_so16;

   event measure_scanout;
   always @ measure_scanout begin
      if ((NSHIFTS < LENMAX) && (bit >= SHBEG)) cbit = bit - LENMAX + NSHIFTS + 1 + SHBEG;
      else cbit = bit; // because parallel does NSHIFTS + 1 shifts
      idx = cbit + 0;
      for (chain = 0; chain < 16; chain=chain + 1) begin
         UNL = UNLOAD[chain]; UNLM = UNLMSK[chain];
         if ((UNL[idx]&UNLM[idx]) !== (SCANOUT[chain]&UNLM[idx])) begin
            patp1 = pattern + lastpattern;  patm1 = patp1 - 1;
            if (error_banner != pattern) begin
               if (lastpattern == 0) $display("\n// *** ERROR during scan pattern %0d (detected during load of pattern %0d)", patm1, patp1);
               else $display("\n// *** ERROR during scan pattern %0d (detected during final pattern unload)", patm1);
               error_banner = pattern;
            end
            $display("  %0d %0s %0d (exp=%b, got=%b)  // pin %0s, scan cell %0d, T=%t",
               patm1, CHAINnames[chain], cbit, UNL[idx], SCANOUT[chain], CHAINpins[chain], cbit, $time);
            nofails = nofails + 1;
         end
      end
   end


   always @ IDDQ begin
   `ifdef tmax_iddq
      $ssi_iddq("strobe_try");
      $ssi_iddq("status drivers leaky tb.leaky");
   `endif
   end

   event capture;
   always @ capture begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
   end

   event capture_clk;
   always @ capture_clk begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
      #145 PI[1] = 1; // clk
      #10 PI[1] = 0; // clk
   end

   event capture_rst_n;
   always @ capture_rst_n begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
      #145 PI[0] = 0; // rst_n
      #10 PI[0] = 1; // rst_n
   end

   task shift;
   begin
      if (verbose >= 4) $display("// %t :    shift %0d", $time, bit);
      #0 PI[0] = 1; // rst_n
      ->force_scanin;
      #40; ->measure_scanout;
      #5 PI[1] = 1; // clk
      #10 PI[1] = 0; // clk
      #45;
   end
   endtask

   event test_setup;
   always @ test_setup begin
      #0 PI[1] = 0; // clk
      #0 PI[0] = 1; // rst_n
      #0 PI[4] = 1'bX; // sclk
      #0 PI[2] = 1'bX; // sdi
      #0 PI[3] = 1'bX; // ss_n
      #0 PI[5] = 1'bX; // test_se
      #0 PI[6] = 1'bX; // test_si1
      #0 PI[7] = 1'bX; // test_si2
      #0 PI[8] = 1'bX; // test_si3
      #0 PI[9] = 1'bX; // test_si4
      #0 PI[10] = 1'bX; // test_si5
      #0 PI[11] = 1'bX; // test_si6
      #0 PI[12] = 1'bX; // test_si7
      #0 PI[13] = 1'bX; // test_si8
      #0 PI[14] = 1'bX; // test_si9
      #0 PI[15] = 1'bX; // test_si10
      #0 PI[16] = 1'bX; // test_si11
      #0 PI[17] = 1'bX; // test_si12
      #0 PI[18] = 1'bX; // test_si13
      #0 PI[19] = 1'bX; // test_si14
      #0 PI[20] = 1'bX; // test_si15
      #0 PI[21] = 1'bX; // test_si16
      #100 PI[5] = 0; // test_se
   end


   task multiple_shift;
   begin
      bit = bit-1;
      error_banner = -2;
      while (bit+1 < LENMAX-SHEND) begin
         bit = bit+1;
         shift;
      end
   end
   endtask

   event load_unload;
   always @ load_unload begin
      if (pattern != prev_pat) begin
         loads = 1;
         prev_pat = pattern;
         if ((verbose >= 2) && (pattern % report_interval == 0))
            $display("// %t : ...begin scan load for pattern %0d", $time, pattern);
         end
      else begin
         loads = loads + 1;
         if ((verbose >= 2) && (pattern % report_interval == 0))
            $display("// %t : ...begin scan load for pattern %0d, load %0d", $time, pattern, loads);
      end

      #0 PI[1] = 0; // clk
      #0 PI[0] = 1; // rst_n
      #0 PI[6] = 1'bX; // test_si1
      #0 PI[7] = 1'bX; // test_si2
      #0 PI[8] = 1'bX; // test_si3
      #0 PI[9] = 1'bX; // test_si4
      #0 PI[10] = 1'bX; // test_si5
      #0 PI[11] = 1'bX; // test_si6
      #0 PI[12] = 1'bX; // test_si7
      #0 PI[13] = 1'bX; // test_si8
      #0 PI[14] = 1'bX; // test_si9
      #0 PI[15] = 1'bX; // test_si10
      #0 PI[16] = 1'bX; // test_si11
      #0 PI[17] = 1'bX; // test_si12
      #0 PI[18] = 1'bX; // test_si13
      #0 PI[19] = 1'bX; // test_si14
      #0 PI[20] = 1'bX; // test_si15
      #0 PI[21] = 1'bX; // test_si16
      #0 PI[5] = 1; // test_se
      #0 PI[4] = 1'bX; // sclk
      #0 PI[2] = 1'bX; // sdi
      #0 PI[3] = 1'bX; // ss_n
      #100;
      // end of load_unload preamble
      bit = SHBEG; multiple_shift;
   end


   task mbyte_task;
      reg[7:0] mc, mb;
      begin
         mc = memdrv[drv]; drv = drv + 1;
         mbyte = 0;
         repeat (mc) begin
            mb = memdrv[drv]; drv = drv + 1;
            mbyte = (mbyte << 8) + mb;
         end
      end
   endtask

   initial begin

      //
      // --- establish a default time format for %t
      //
      $timeformat(-9,2," ns",18);

      //
      // --- default verbosity to 2 but also allow user override by
      //     using '+define+tmax_msg=N' on verilog compile line.
      //
      `ifdef tmax_msg
         verbose = `tmax_msg ;
      `else
         verbose = 2 ;
      `endif

      //
      // --- default pattern reporting interval to 5 but also allow user
      //     override by using '+define+tmax_rpt=N' on verilog compile line.
      //
      `ifdef tmax_rpt
         report_interval = `tmax_rpt ;
      `else
         report_interval = 5 ;
      `endif

      //
      // --- support generating Extened VCD output by using
      //     '+define+tmax_vcde' on verilog compile line.
      //
      `ifdef tmax_vcde
         // extended VCD, see IEEE Verilog P1364.1-1999 Draft 2
         if (verbose >= 2) $display("// %t : opening Extended VCD output file", $time);
         $dumpports( dut, "sim_vcde.out");
      `endif

      //
      // --- IDDQ PLI initialization
      //     User may activite by using '+define+tmax_iddq' on verilog compile line.
      //     Or by defining `tmax_iddq in this file.
      //
      `ifdef tmax_iddq
         if (verbose >= 3) $display("// %t : Initializing IDDQ PLI", $time);
         $ssi_iddq("dut tb.dut");
         $ssi_iddq("verb on");
         $ssi_iddq("cycle 0");
         //
         // --- User may select one of the following two methods for fault seeding:
         //     #1 faults seeded by PLI (default)
         //     #2 faults supplied in a file
         //     Comment out the unused lines as needed (precede with '//').
         //     Replace the 'FAULTLIST_FILE' string with the actual file pathname.
         //
         $ssi_iddq("seed SA tb.dut");   // no file, faults seeded by PLI
         //
         // $ssi_iddq("scope tb.dut");   // set scope for faults from a file
         // $ssi_iddq("read_tmax FAULTLIST_FILE"); // read faults from a file
         //
      `endif

      POnames[0] = "sdo";
      POnames[1] = "debug[2]";
      POnames[2] = "debug[1]";
      POnames[3] = "debug[0]";
      POnames[4] = "test_so1";
      POnames[5] = "test_so2";
      POnames[6] = "test_so3";
      POnames[7] = "test_so4";
      POnames[8] = "test_so5";
      POnames[9] = "test_so6";
      POnames[10] = "test_so7";
      POnames[11] = "test_so8";
      POnames[12] = "test_so9";
      POnames[13] = "test_so10";
      POnames[14] = "test_so11";
      POnames[15] = "test_so12";
      POnames[16] = "test_so13";
      POnames[17] = "test_so15";
      POnames[18] = "test_so16";
      CHAINnames[0] = "1";
      CHAINnames[1] = "2";
      CHAINnames[2] = "3";
      CHAINnames[3] = "4";
      CHAINnames[4] = "5";
      CHAINnames[5] = "6";
      CHAINnames[6] = "7";
      CHAINnames[7] = "8";
      CHAINnames[8] = "9";
      CHAINnames[9] = "10";
      CHAINnames[10] = "11";
      CHAINnames[11] = "12";
      CHAINnames[12] = "13";
      CHAINnames[13] = "14";
      CHAINnames[14] = "15";
      CHAINnames[15] = "16";
      CHAINpins[0] = "test_so1";
      CHAINpins[1] = "test_so2";
      CHAINpins[2] = "test_so3";
      CHAINpins[3] = "test_so4";
      CHAINpins[4] = "test_so5";
      CHAINpins[5] = "test_so6";
      CHAINpins[6] = "test_so7";
      CHAINpins[7] = "test_so8";
      CHAINpins[8] = "test_so9";
      CHAINpins[9] = "test_so10";
      CHAINpins[10] = "test_so11";
      CHAINpins[11] = "test_so12";
      CHAINpins[12] = "test_so13";
      CHAINpins[13] = "debug[2]";
      CHAINpins[14] = "test_so15";
      CHAINpins[15] = "test_so16";
      SERIALM = 25'b0000000000000000000000000;
      nofails = 0; pattern = -1; lastpattern = 0;
      prev_pat = -2; error_banner = -2;

      if (verbose >=1) $display("// %t : Begin test_setup", $time);
      ->test_setup;
      #200; // 200

      if (verbose >= 3) $display("// %t : reading pattern scan data file", $time);
      $readmemh("pat/atpg_patterns_ser.scn", memscn);
      if (verbose >= 3) $display("// %t : reading pattern PI data file", $time);
      $readmemb("pat/atpg_patterns_ser.pis", mempis);
      if (verbose >= 3) $display("// %t : reading pattern PO data file", $time);
      $readmemb("pat/atpg_patterns_ser.pos", mempos);
      if (verbose >= 3) $display("// %t : reading pattern sequencer file", $time);
      $readmemh("pat/atpg_patterns_ser.seq", memdrv);
      scn = 1; pis = 1; pos = 1; drv = 1;

      /*** Scan test ***/

      if (verbose >= 1) $display("// %t : Begin patterns, first pattern = 0", $time);
      pattern = -1; lastpattern = 0;
      while (lastpattern >=0) begin
         drval = memdrv[drv];
         if (verbose >= 5) $display("// %t : 0x%0h is %0d sequencer value",$time,drval,drv);
         drv = drv + 1;
         case (drval)
            'h0: begin pattern = pattern + 1; end
            'h1: begin lastpattern = 1; end
            'h2: lastpattern = -1; // break
            'h3: begin #0 PI = mempis[pis]; pis = pis + 1; end
            'h4: begin ALLPIS = mempis[pis]; pis = pis + 1; end
            'h5: begin XPCT = mempos[pos]; pos = pos + 1; MASK = mempos[pos]; pos = pos + 1; end
            'h6: MASK = 19'b0;
            'h7: begin
               LOAD0 = memscn[scn]; scn = scn + 1;
               LOAD1 = memscn[scn]; scn = scn + 1;
               LOAD2 = memscn[scn]; scn = scn + 1;
               LOAD3 = memscn[scn]; scn = scn + 1;
               LOAD4 = memscn[scn]; scn = scn + 1;
               LOAD5 = memscn[scn]; scn = scn + 1;
               LOAD6 = memscn[scn]; scn = scn + 1;
               LOAD7 = memscn[scn]; scn = scn + 1;
               LOAD8 = memscn[scn]; scn = scn + 1;
               LOAD9 = memscn[scn]; scn = scn + 1;
               LOAD10 = memscn[scn]; scn = scn + 1;
               LOAD11 = memscn[scn]; scn = scn + 1;
               LOAD12 = memscn[scn]; scn = scn + 1;
               LOAD13 = memscn[scn]; scn = scn + 1;
               LOAD14 = memscn[scn]; scn = scn + 1;
               LOAD15 = memscn[scn]; scn = scn + 1;
                 end
            'h8: begin
               UNLOAD[0] = memscn[scn]; scn = scn + 1;
               UNLMSK[0] = memscn[scn]; scn = scn + 1;
               UNLOAD[1] = memscn[scn]; scn = scn + 1;
               UNLMSK[1] = memscn[scn]; scn = scn + 1;
               UNLOAD[2] = memscn[scn]; scn = scn + 1;
               UNLMSK[2] = memscn[scn]; scn = scn + 1;
               UNLOAD[3] = memscn[scn]; scn = scn + 1;
               UNLMSK[3] = memscn[scn]; scn = scn + 1;
               UNLOAD[4] = memscn[scn]; scn = scn + 1;
               UNLMSK[4] = memscn[scn]; scn = scn + 1;
               UNLOAD[5] = memscn[scn]; scn = scn + 1;
               UNLMSK[5] = memscn[scn]; scn = scn + 1;
               UNLOAD[6] = memscn[scn]; scn = scn + 1;
               UNLMSK[6] = memscn[scn]; scn = scn + 1;
               UNLOAD[7] = memscn[scn]; scn = scn + 1;
               UNLMSK[7] = memscn[scn]; scn = scn + 1;
               UNLOAD[8] = memscn[scn]; scn = scn + 1;
               UNLMSK[8] = memscn[scn]; scn = scn + 1;
               UNLOAD[9] = memscn[scn]; scn = scn + 1;
               UNLMSK[9] = memscn[scn]; scn = scn + 1;
               UNLOAD[10] = memscn[scn]; scn = scn + 1;
               UNLMSK[10] = memscn[scn]; scn = scn + 1;
               UNLOAD[11] = memscn[scn]; scn = scn + 1;
               UNLMSK[11] = memscn[scn]; scn = scn + 1;
               UNLOAD[12] = memscn[scn]; scn = scn + 1;
               UNLMSK[12] = memscn[scn]; scn = scn + 1;
               UNLOAD[13] = memscn[scn]; scn = scn + 1;
               UNLMSK[13] = memscn[scn]; scn = scn + 1;
               UNLOAD[14] = memscn[scn]; scn = scn + 1;
               UNLMSK[14] = memscn[scn]; scn = scn + 1;
               UNLOAD[15] = memscn[scn]; scn = scn + 1;
               UNLMSK[15] = memscn[scn]; scn = scn + 1;
                 end
            'h9: begin
               UNLMSK[0] = 25'b0;
               UNLMSK[1] = 25'b0;
               UNLMSK[2] = 25'b0;
               UNLMSK[3] = 25'b0;
               UNLMSK[4] = 25'b0;
               UNLMSK[5] = 25'b0;
               UNLMSK[6] = 25'b0;
               UNLMSK[7] = 25'b0;
               UNLMSK[8] = 25'b0;
               UNLMSK[9] = 25'b0;
               UNLMSK[10] = 25'b0;
               UNLMSK[11] = 25'b0;
               UNLMSK[12] = 25'b0;
               UNLMSK[13] = 25'b0;
               UNLMSK[14] = 25'b0;
               UNLMSK[15] = 25'b0;
                 end
            'hA: #100;
            'hB: #60;
            'hF: begin #0; ->pulse_clk; end
            'h10: begin #0; ->pulse_rst_n; end
            'h11: begin #0; ->measurePO; #0; end
            'h12: begin #0; ->forcePI_default_WFT; #0; end
            'h13: begin #0; ->measurePO_default_WFT; #0; end
            'h14: begin #0; ->force_scanin; #0; end
            'h15: begin #0; ->measure_scanout; #0; end
            'h16: begin #0; ->IDDQ; #0; end
            'h17: begin #0; ->capture; #200; end
            'h18: begin #0; ->capture_clk; #300; end
            'h19: begin #0; ->capture_rst_n; #300; end
            'h1A: begin #0; shift; #0; end
            'h1B: begin #0; ->test_setup; #200; end
            'h1C: begin #0; multiple_shift; #0; end
            'h1D: begin #0; ->load_unload; #2600; end
            'hF0: begin verbose = 0; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF1: begin verbose = 1; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF2: begin verbose = 2; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF3: begin verbose = 3; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF4: begin verbose = 4; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF5: begin verbose = 5; $display("// %t : verbosity = %0d", $time, verbose); end
            default: begin $display($time, " Unrecognized code %0h", drval); $finish; end
         endcase
      end /* while */
      $display("// %t : Simulation of %0d patterns completed with %0d errors\n", $time, pattern+1, nofails);
      if (verbose >=2) $finish(2);
      /* else */ $finish(0);
   end
endmodule
