// Verilog pattern output written by  TetraMAX (TM)  Y-2006.06-SP5-i070113_081354 
// Date: Thu Apr  3 11:14:30 2008
// Module tested: spi_co_processor

//     Uncollapsed Stuck Fault Summary Report
// -----------------------------------------------
// fault class                     code   #faults
// ------------------------------  ----  ---------
// Detected                         DT      39062
//   detected_by_simulation         DS     (35849)
//   detected_by_implication        DI      (3213)
// Possibly detected                PT          0
// Undetectable                     UD        109
//   undetectable-blocked           UB         (8)
//   undetectable-redundant         UR       (101)
// ATPG untestable                  AU         50
//   atpg_untestable-not_detected   AN        (50)
// Not detected                     ND         11
//   not-observed                   NO        (11)
// -----------------------------------------------
// total faults                             39232
// test coverage                            99.84%
// -----------------------------------------------
// 
//            Pattern Summary Report
// -----------------------------------------------
// #internal patterns                         250
//     #basic_scan patterns                   250
// -----------------------------------------------
// 
// rule  severity  #fails  description
// ----  --------  ------  ---------------------------------
// B8    warning       17  unconnected module input pin
// B9    warning        1  undriven module internal net
// B10   warning        1  unconnected module internal net
// 
// clock_name        off  usage
// ----------------  ---  --------------------------
// clk                0   master shift nonscan_DLAT 
// rst_n              1   master set reset 
// 
// There are no constraint ports
// There are no equivalent pins
// There are no net connections

`timescale 1 ns / 1 ns

//
// --- NOTE: Remove the comment to define 'tmax_iddq' to activate processing of IDDQ events
//     Or use '+define+tmax_iddq' on the verilog compile line
//
//`define tmax_iddq

//
// --- User adjustable extension to state sequencer table for debug purposes.
//     Adjusts oversizing of 'memdrv[]' to make room for manually inserted values.
//
`ifdef tmax_state_dbg
   /* user has used compile time overide of form:  +define+tmax_state_dbg=10 */
`else
   /* default to 5 */
   `define tmax_state_dbg 5
`endif

module tb ;
   parameter NAMELENGTH = 200; // max length of names reported in fails
   parameter LENMAX = 24, NSHIFTS = 5; // LENMAX for serial
   parameter LENSERIAL = 24, NCHAINS = 16;
   parameter SHBEG = 0, SHEND = 0;
   integer nofails, bit, cbit, pattern, lastpattern, chain, idx;
   integer error_banner; // flag for tracking displayed error banner
   integer loads;        // number of load_unloads for current pattern
   integer patm1;        // pattern - 1
   integer patp1;        // pattern + lastpattern
   integer prev_pat;     // previous pattern number
   integer report_interval; // report pattern progress every Nth pattern
   integer verbose;      // message verbosity level
   parameter NINPUTS = 22, NOUTPUTS = 20;
   wire [0:NOUTPUTS-1] PO; reg [0:NOUTPUTS-1] ALLPOS, XPCT, MASK;
   reg [0:NINPUTS-1] PI, ALLPIS;
   integer scn, pis, pos, drv, mbyte;
   reg [0:NINPUTS-1] mempis [1:250];
   reg [0:NOUTPUTS-1] mempos [1:500];
   reg [7:0] drval, memdrv [1:2752+`tmax_state_dbg];
   reg [0:LENSERIAL-1] memscn [1:12016];
   reg [0:8*(NAMELENGTH-1)] POnames [0:NOUTPUTS-1];
   reg [0:8*(NAMELENGTH-1)] CHAINnames [0:NCHAINS-1];
   reg [0:8*(NAMELENGTH-1)] CHAINpins [0:NCHAINS-1];
   reg [0:LENSERIAL-1] LOAD0, LOADSH0, LOAD1, LOADSH1, LOAD2, LOADSH2, LOAD3,
   LOADSH3, LOAD4, LOADSH4, LOAD5, LOADSH5, LOAD6, LOADSH6, LOAD7, LOADSH7, LOAD8,
   LOADSH8, LOAD9, LOADSH9, LOAD10, LOADSH10, LOAD11, LOADSH11, LOAD12, LOADSH12,
   LOAD13, LOADSH13, LOAD14, LOADSH14, LOAD15, LOADSH15;
   reg [0:LENMAX-1] UNL, UNLOAD[0:NCHAINS-1];
   reg [0:LENMAX-1] UNLM, UNLMSK[0:NCHAINS-1], SHBEGM[0:NCHAINS-1];
   reg [0:LENMAX-1] SERIALM;
   reg [0:LENMAX-1] INPINV[0:NCHAINS-1], OUTINV[0:NCHAINS-1];
   wire [0:NCHAINS-1] SCANOUT;
   wire [0:LENMAX-1] CHAINOUT0, CHAINOUT1, CHAINOUT2, CHAINOUT3, CHAINOUT4, CHAINOUT5,
   CHAINOUT6, CHAINOUT7, CHAINOUT8, CHAINOUT9, CHAINOUT10, CHAINOUT11, CHAINOUT12,
   CHAINOUT13, CHAINOUT14, CHAINOUT15;
   reg [0:LENMAX-1] CHOUT, CHAINOUT[0:NCHAINS-1];
   event IDDQ;

   wire sdo;
   wire rst_n;
   wire clk;
   wire sdi;
   wire ss_n;
   wire sclk;
   wire test_se;
   wire test_si1;
   wire test_so1;
   wire test_si2;
   wire test_so2;
   wire test_si3;
   wire test_so3;
   wire test_si4;
   wire test_so4;
   wire test_si5;
   wire test_so5;
   wire test_si6;
   wire test_so6;
   wire test_si7;
   wire test_so7;
   wire test_si8;
   wire test_so8;
   wire test_si9;
   wire test_so9;
   wire test_si10;
   wire test_so10;
   wire test_si11;
   wire test_so11;
   wire test_si12;
   wire test_so12;
   wire test_si13;
   wire test_so13;
   wire test_si14;
   wire test_so14;
   wire test_si15;
   wire test_so15;
   wire test_si16;
   wire test_so16;
   wire [2:0] debug;

   // map PI[] vector to DUT inputs and bidis
   assign rst_n = PI[0];
   assign clk = PI[1];
   assign sdi = PI[2];
   assign ss_n = PI[3];
   assign sclk = PI[4];
   assign test_se = PI[5];
   assign test_si1 = PI[6];
   assign test_si2 = PI[7];
   assign test_si3 = PI[8];
   assign test_si4 = PI[9];
   assign test_si5 = PI[10];
   assign test_si6 = PI[11];
   assign test_si7 = PI[12];
   assign test_si8 = PI[13];
   assign test_si9 = PI[14];
   assign test_si10 = PI[15];
   assign test_si11 = PI[16];
   assign test_si12 = PI[17];
   assign test_si13 = PI[18];
   assign test_si14 = PI[19];
   assign test_si15 = PI[20];
   assign test_si16 = PI[21];

   // map DUT outputs and bidis to PO[] vector
   assign
      PO[0] = sdo ,
      PO[1] = debug[2] ,
      PO[2] = debug[1] ,
      PO[3] = debug[0] ,
      PO[4] = test_so1 ,
      PO[5] = test_so2 ,
      PO[6] = test_so3 ,
      PO[7] = test_so4 ,
      PO[8] = test_so5 ,
      PO[9] = test_so6 ,
      PO[10] = test_so7 ,
      PO[11] = test_so8 ,
      PO[12] = test_so9 ,
      PO[13] = test_so10 ,
      PO[14] = test_so11 ,
      PO[15] = test_so12 ,
      PO[16] = test_so13 ,
      PO[17] = test_so14 ,
      PO[18] = test_so15 ,
      PO[19] = test_so16 ;

   // instantiate the design into the testbench
   spi_co_processor dut (
      .sdo(sdo),
      .debug(debug),
      .rst_n(rst_n),
      .clk(clk),
      .sdi(sdi),
      .ss_n(ss_n),
      .sclk(sclk),
      .test_se(test_se),
      .test_si1(test_si1),
      .test_so1(test_so1),
      .test_si2(test_si2),
      .test_so2(test_so2),
      .test_si3(test_si3),
      .test_so3(test_so3),
      .test_si4(test_si4),
      .test_so4(test_so4),
      .test_si5(test_si5),
      .test_so5(test_so5),
      .test_si6(test_si6),
      .test_so6(test_so6),
      .test_si7(test_si7),
      .test_so7(test_so7),
      .test_si8(test_si8),
      .test_so8(test_so8),
      .test_si9(test_si9),
      .test_so9(test_so9),
      .test_si10(test_si10),
      .test_so10(test_so10),
      .test_si11(test_si11),
      .test_so11(test_so11),
      .test_si12(test_si12),
      .test_so12(test_so12),
      .test_si13(test_si13),
      .test_so13(test_so13),
      .test_si14(test_si14),
      .test_so14(test_so14),
      .test_si15(test_si15),
      .test_so15(test_so15),
      .test_si16(test_si16),
      .test_so16(test_so16)   );

   event pulse_clk;
   always @ pulse_clk begin
      #45 PI[1] = 1; #10 PI[1] = 0;   // clk
   end

   event pulse_rst_n;
   always @ pulse_rst_n begin
      #45 PI[0] = 0; #10 PI[0] = 1;   // rst_n
   end


   integer errshown;
   event measurePO;
   always @ measurePO begin
      if (((XPCT&MASK) !== (ALLPOS&MASK)) || (XPCT !== (~(~XPCT)))) begin
         errshown = 0;
         for (bit = 0; bit < NOUTPUTS; bit=bit + 1) begin
            if (MASK[bit]==1'b1) begin
               if (XPCT[bit] !== ALLPOS[bit]) begin
                  if (errshown==0) $display("\n// *** ERROR during capture pattern %0d, T=%t", pattern, $time);
                  $display("  %0d %0s (exp=%b, got=%b)", pattern, POnames[bit], XPCT[bit], ALLPOS[bit]);
                  nofails = nofails + 1; errshown = 1;
               end
            end
         end
      end
   end

   event forcePI_default_WFT;
   always @ forcePI_default_WFT begin
      PI = ALLPIS;
   end
   event measurePO_default_WFT;
   always @ measurePO_default_WFT begin
      #40;
      ALLPOS = PO;
      #0; #0 -> measurePO;
      `ifdef tmax_iddq
         #0; ->IDDQ;
      `endif
   end

   event force_scanin;
   always @ force_scanin begin
      PI[6] <= LOAD0[bit];
      PI[7] <= LOAD1[bit];
      PI[8] <= LOAD2[bit];
      PI[9] <= LOAD3[bit];
      PI[10] <= LOAD4[bit];
      PI[11] <= LOAD5[bit];
      PI[12] <= LOAD6[bit];
      PI[13] <= LOAD7[bit];
      PI[14] <= LOAD8[bit];
      PI[15] <= LOAD9[bit];
      PI[16] <= LOAD10[bit];
      PI[17] <= LOAD11[bit];
      PI[18] <= LOAD12[bit];
      PI[19] <= LOAD13[bit];
      PI[20] <= LOAD14[bit];
      PI[21] <= LOAD15[bit];
   end

   assign SCANOUT[0] = test_so1,  SCANOUT[1] = test_so2,  SCANOUT[2] = test_so3,
           SCANOUT[3] = test_so4,  SCANOUT[4] = test_so5,  SCANOUT[5] = test_so6,
           SCANOUT[6] = test_so7,  SCANOUT[7] = test_so8,  SCANOUT[8] = test_so9,
           SCANOUT[9] = test_so10,  SCANOUT[10] = test_so11,  SCANOUT[11] = test_so12,
           SCANOUT[12] = test_so13,  SCANOUT[13] = test_so14,  SCANOUT[14] = test_so15,
           SCANOUT[15] = test_so16;

   event measure_scanout;
   always @ measure_scanout begin
      if ((NSHIFTS < LENMAX) && (bit >= SHBEG)) cbit = bit - LENMAX + NSHIFTS + 1 + SHBEG;
      else cbit = bit; // because parallel does NSHIFTS + 1 shifts
      idx = cbit + 0;
      for (chain = 0; chain < 16; chain=chain + 1) begin
         UNL = UNLOAD[chain]; UNLM = UNLMSK[chain];
         if ((UNL[idx]&UNLM[idx]) !== (SCANOUT[chain]&UNLM[idx])) begin
            patp1 = pattern + lastpattern;  patm1 = patp1 - 1;
            if (error_banner != pattern) begin
               if (lastpattern == 0) $display("\n// *** ERROR during scan pattern %0d (detected during load of pattern %0d)", patm1, patp1);
               else $display("\n// *** ERROR during scan pattern %0d (detected during final pattern unload)", patm1);
               error_banner = pattern;
            end
            $display("  %0d %0s %0d (exp=%b, got=%b)  // pin %0s, scan cell %0d, T=%t",
               patm1, CHAINnames[chain], cbit, UNL[idx], SCANOUT[chain], CHAINpins[chain], cbit, $time);
            nofails = nofails + 1;
         end
      end
   end


   always @ IDDQ begin
   `ifdef tmax_iddq
      $ssi_iddq("strobe_try");
      $ssi_iddq("status drivers leaky tb.leaky");
   `endif
   end

   event capture;
   always @ capture begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
   end

   event capture_clk;
   always @ capture_clk begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
      #145 PI[1] = 1; // clk
      #10 PI[1] = 0; // clk
   end

   event capture_rst_n;
   always @ capture_rst_n begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
      #145 PI[0] = 0; // rst_n
      #10 PI[0] = 1; // rst_n
   end

   task shift;
   begin
      if (verbose >= 4) $display("// %t :    shift %0d", $time, bit);
      #0 PI[0] = 1; // rst_n
      ->force_scanin;
      #40; ->measure_scanout;
      #5 PI[1] = 1; // clk
      #10 PI[1] = 0; // clk
      #45;
   end
   endtask

   event test_setup;
   always @ test_setup begin
      #0 PI[1] = 0; // clk
      #0 PI[0] = 1; // rst_n
      #0 PI[4] = 1'bX; // sclk
      #0 PI[2] = 1'bX; // sdi
      #0 PI[3] = 1'bX; // ss_n
      #0 PI[5] = 1'bX; // test_se
      #0 PI[6] = 1'bX; // test_si1
      #0 PI[7] = 1'bX; // test_si2
      #0 PI[8] = 1'bX; // test_si3
      #0 PI[9] = 1'bX; // test_si4
      #0 PI[10] = 1'bX; // test_si5
      #0 PI[11] = 1'bX; // test_si6
      #0 PI[12] = 1'bX; // test_si7
      #0 PI[13] = 1'bX; // test_si8
      #0 PI[14] = 1'bX; // test_si9
      #0 PI[15] = 1'bX; // test_si10
      #0 PI[16] = 1'bX; // test_si11
      #0 PI[17] = 1'bX; // test_si12
      #0 PI[18] = 1'bX; // test_si13
      #0 PI[19] = 1'bX; // test_si14
      #0 PI[20] = 1'bX; // test_si15
      #0 PI[21] = 1'bX; // test_si16
   end


   task multiple_shift;
   begin
      bit = bit-1;
      error_banner = -2;
      while (bit+1 < LENMAX-SHEND) begin
         bit = bit+1;
         shift;
      end
   end
   endtask

   assign CHAINOUT0 = { dut.U_REGISTERFILE.\regfile_reg[0][23] .q, 
          dut.U_REGISTERFILE.\regfile_reg[0][22] .q, dut.U_REGISTERFILE.\regfile_reg[0][21] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][20] .q, dut.U_REGISTERFILE.\regfile_reg[0][19] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][18] .q, dut.U_REGISTERFILE.\regfile_reg[0][17] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][16] .q, dut.U_REGISTERFILE.\regfile_reg[0][15] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][14] .q, dut.U_REGISTERFILE.\regfile_reg[0][13] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][12] .q, dut.U_REGISTERFILE.\regfile_reg[0][11] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][10] .q, dut.U_REGISTERFILE.\regfile_reg[0][9] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][8] .q, dut.U_REGISTERFILE.\regfile_reg[0][7] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][6] .q, dut.U_REGISTERFILE.\regfile_reg[0][5] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][4] .q, dut.U_REGISTERFILE.\regfile_reg[0][3] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][2] .q, dut.U_REGISTERFILE.\regfile_reg[0][1] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][0] .q };
   assign CHAINOUT1 = { dut.U_REGISTERFILE.\regfile_reg[1][15] .q, 
          dut.U_REGISTERFILE.\regfile_reg[1][14] .q, dut.U_REGISTERFILE.\regfile_reg[1][13] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][12] .q, dut.U_REGISTERFILE.\regfile_reg[1][11] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][10] .q, dut.U_REGISTERFILE.\regfile_reg[1][9] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][8] .q, dut.U_REGISTERFILE.\regfile_reg[1][7] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][6] .q, dut.U_REGISTERFILE.\regfile_reg[1][5] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][4] .q, dut.U_REGISTERFILE.\regfile_reg[1][3] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][2] .q, dut.U_REGISTERFILE.\regfile_reg[1][1] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][0] .q, dut.U_REGISTERFILE.\regfile_reg[0][31] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][30] .q, dut.U_REGISTERFILE.\regfile_reg[0][29] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][28] .q, dut.U_REGISTERFILE.\regfile_reg[0][27] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][26] .q, dut.U_REGISTERFILE.\regfile_reg[0][25] .q,
          dut.U_REGISTERFILE.\regfile_reg[0][24] .q };
   assign CHAINOUT2 = { dut.U_REGISTERFILE.\regfile_reg[2][7] .q, 
          dut.U_REGISTERFILE.\regfile_reg[2][6] .q, dut.U_REGISTERFILE.\regfile_reg[2][5] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][4] .q, dut.U_REGISTERFILE.\regfile_reg[2][3] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][2] .q, dut.U_REGISTERFILE.\regfile_reg[2][1] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][0] .q, dut.U_REGISTERFILE.\regfile_reg[1][31] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][30] .q, dut.U_REGISTERFILE.\regfile_reg[1][29] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][28] .q, dut.U_REGISTERFILE.\regfile_reg[1][27] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][26] .q, dut.U_REGISTERFILE.\regfile_reg[1][25] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][24] .q, dut.U_REGISTERFILE.\regfile_reg[1][23] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][22] .q, dut.U_REGISTERFILE.\regfile_reg[1][21] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][20] .q, dut.U_REGISTERFILE.\regfile_reg[1][19] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][18] .q, dut.U_REGISTERFILE.\regfile_reg[1][17] .q,
          dut.U_REGISTERFILE.\regfile_reg[1][16] .q };
   assign CHAINOUT3 = { dut.U_REGISTERFILE.\regfile_reg[2][31] .q, 
          dut.U_REGISTERFILE.\regfile_reg[2][30] .q, dut.U_REGISTERFILE.\regfile_reg[2][29] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][28] .q, dut.U_REGISTERFILE.\regfile_reg[2][27] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][26] .q, dut.U_REGISTERFILE.\regfile_reg[2][25] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][24] .q, dut.U_REGISTERFILE.\regfile_reg[2][23] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][22] .q, dut.U_REGISTERFILE.\regfile_reg[2][21] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][20] .q, dut.U_REGISTERFILE.\regfile_reg[2][19] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][18] .q, dut.U_REGISTERFILE.\regfile_reg[2][17] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][16] .q, dut.U_REGISTERFILE.\regfile_reg[2][15] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][14] .q, dut.U_REGISTERFILE.\regfile_reg[2][13] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][12] .q, dut.U_REGISTERFILE.\regfile_reg[2][11] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][10] .q, dut.U_REGISTERFILE.\regfile_reg[2][9] .q,
          dut.U_REGISTERFILE.\regfile_reg[2][8] .q };
   assign CHAINOUT4 = { dut.U_REGISTERFILE.\regfile_reg[3][23] .q, 
          dut.U_REGISTERFILE.\regfile_reg[3][22] .q, dut.U_REGISTERFILE.\regfile_reg[3][21] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][20] .q, dut.U_REGISTERFILE.\regfile_reg[3][19] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][18] .q, dut.U_REGISTERFILE.\regfile_reg[3][17] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][16] .q, dut.U_REGISTERFILE.\regfile_reg[3][15] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][14] .q, dut.U_REGISTERFILE.\regfile_reg[3][13] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][12] .q, dut.U_REGISTERFILE.\regfile_reg[3][11] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][10] .q, dut.U_REGISTERFILE.\regfile_reg[3][9] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][8] .q, dut.U_REGISTERFILE.\regfile_reg[3][7] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][6] .q, dut.U_REGISTERFILE.\regfile_reg[3][5] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][4] .q, dut.U_REGISTERFILE.\regfile_reg[3][3] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][2] .q, dut.U_REGISTERFILE.\regfile_reg[3][1] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][0] .q };
   assign CHAINOUT5 = { dut.U_REGISTERFILE.\regfile_reg[4][15] .q, 
          dut.U_REGISTERFILE.\regfile_reg[4][14] .q, dut.U_REGISTERFILE.\regfile_reg[4][13] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][12] .q, dut.U_REGISTERFILE.\regfile_reg[4][11] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][10] .q, dut.U_REGISTERFILE.\regfile_reg[4][9] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][8] .q, dut.U_REGISTERFILE.\regfile_reg[4][7] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][6] .q, dut.U_REGISTERFILE.\regfile_reg[4][5] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][4] .q, dut.U_REGISTERFILE.\regfile_reg[4][3] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][2] .q, dut.U_REGISTERFILE.\regfile_reg[4][1] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][0] .q, dut.U_REGISTERFILE.\regfile_reg[3][31] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][30] .q, dut.U_REGISTERFILE.\regfile_reg[3][29] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][28] .q, dut.U_REGISTERFILE.\regfile_reg[3][27] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][26] .q, dut.U_REGISTERFILE.\regfile_reg[3][25] .q,
          dut.U_REGISTERFILE.\regfile_reg[3][24] .q };
   assign CHAINOUT6 = { dut.U_REGISTERFILE.\regfile_reg[5][7] .q, 
          dut.U_REGISTERFILE.\regfile_reg[5][6] .q, dut.U_REGISTERFILE.\regfile_reg[5][5] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][4] .q, dut.U_REGISTERFILE.\regfile_reg[5][3] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][2] .q, dut.U_REGISTERFILE.\regfile_reg[5][1] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][0] .q, dut.U_REGISTERFILE.\regfile_reg[4][31] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][30] .q, dut.U_REGISTERFILE.\regfile_reg[4][29] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][28] .q, dut.U_REGISTERFILE.\regfile_reg[4][27] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][26] .q, dut.U_REGISTERFILE.\regfile_reg[4][25] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][24] .q, dut.U_REGISTERFILE.\regfile_reg[4][23] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][22] .q, dut.U_REGISTERFILE.\regfile_reg[4][21] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][20] .q, dut.U_REGISTERFILE.\regfile_reg[4][19] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][18] .q, dut.U_REGISTERFILE.\regfile_reg[4][17] .q,
          dut.U_REGISTERFILE.\regfile_reg[4][16] .q };
   assign CHAINOUT7 = { dut.U_REGISTERFILE.\regfile_reg[5][31] .q, 
          dut.U_REGISTERFILE.\regfile_reg[5][30] .q, dut.U_REGISTERFILE.\regfile_reg[5][29] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][28] .q, dut.U_REGISTERFILE.\regfile_reg[5][27] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][26] .q, dut.U_REGISTERFILE.\regfile_reg[5][25] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][24] .q, dut.U_REGISTERFILE.\regfile_reg[5][23] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][22] .q, dut.U_REGISTERFILE.\regfile_reg[5][21] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][20] .q, dut.U_REGISTERFILE.\regfile_reg[5][19] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][18] .q, dut.U_REGISTERFILE.\regfile_reg[5][17] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][16] .q, dut.U_REGISTERFILE.\regfile_reg[5][15] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][14] .q, dut.U_REGISTERFILE.\regfile_reg[5][13] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][12] .q, dut.U_REGISTERFILE.\regfile_reg[5][11] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][10] .q, dut.U_REGISTERFILE.\regfile_reg[5][9] .q,
          dut.U_REGISTERFILE.\regfile_reg[5][8] .q };
   assign CHAINOUT8 = { dut.U_REGISTERFILE.\regfile_reg[6][23] .q, 
          dut.U_REGISTERFILE.\regfile_reg[6][22] .q, dut.U_REGISTERFILE.\regfile_reg[6][21] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][20] .q, dut.U_REGISTERFILE.\regfile_reg[6][19] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][18] .q, dut.U_REGISTERFILE.\regfile_reg[6][17] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][16] .q, dut.U_REGISTERFILE.\regfile_reg[6][15] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][14] .q, dut.U_REGISTERFILE.\regfile_reg[6][13] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][12] .q, dut.U_REGISTERFILE.\regfile_reg[6][11] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][10] .q, dut.U_REGISTERFILE.\regfile_reg[6][9] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][8] .q, dut.U_REGISTERFILE.\regfile_reg[6][7] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][6] .q, dut.U_REGISTERFILE.\regfile_reg[6][5] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][4] .q, dut.U_REGISTERFILE.\regfile_reg[6][3] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][2] .q, dut.U_REGISTERFILE.\regfile_reg[6][1] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][0] .q };
   assign CHAINOUT9 = { dut.U_REGISTERFILE.\regfile_reg[7][14] .q, 
          dut.U_REGISTERFILE.\regfile_reg[7][13] .q, dut.U_REGISTERFILE.\regfile_reg[7][12] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][11] .q, dut.U_REGISTERFILE.\regfile_reg[7][10] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][9] .q, dut.U_REGISTERFILE.\regfile_reg[7][8] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][7] .q, dut.U_REGISTERFILE.\regfile_reg[7][6] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][5] .q, dut.U_REGISTERFILE.\regfile_reg[7][4] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][3] .q, dut.U_REGISTERFILE.\regfile_reg[7][2] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][1] .q, dut.U_REGISTERFILE.\regfile_reg[7][0] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][31] .q, dut.U_REGISTERFILE.\regfile_reg[6][30] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][29] .q, dut.U_REGISTERFILE.\regfile_reg[6][28] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][27] .q, dut.U_REGISTERFILE.\regfile_reg[6][26] .q,
          dut.U_REGISTERFILE.\regfile_reg[6][25] .q, dut.U_REGISTERFILE.\regfile_reg[6][24] .q,
          1'b0 };
   assign CHAINOUT10 = { dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[0] .qn,
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sdi_buf_reg[1] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sdi_buf_reg[0] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[2] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[1] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[0] .q, 
          dut.U_REGISTERFILE.\regfile_reg[7][31] .q, dut.U_REGISTERFILE.\regfile_reg[7][30] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][29] .q, dut.U_REGISTERFILE.\regfile_reg[7][28] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][27] .q, dut.U_REGISTERFILE.\regfile_reg[7][26] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][25] .q, dut.U_REGISTERFILE.\regfile_reg[7][24] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][23] .q, dut.U_REGISTERFILE.\regfile_reg[7][22] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][21] .q, dut.U_REGISTERFILE.\regfile_reg[7][20] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][19] .q, dut.U_REGISTERFILE.\regfile_reg[7][18] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][17] .q, dut.U_REGISTERFILE.\regfile_reg[7][16] .q,
          dut.U_REGISTERFILE.\regfile_reg[7][15] .q, 1'b0 };
   assign CHAINOUT11 = { dut.U_SPI_CO_PROC_IF.\databufin_reg[6] .q, 
          dut.U_SPI_CO_PROC_IF.\databufin_reg[5] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[4] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[3] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[2] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[1] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[0] .q,
          dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[2] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[1] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[0] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\ss_n_buf_reg[1] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\ss_n_buf_reg[0] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[7] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[6] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[5] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[4] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[3] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[2] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[1] .q, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[0] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.shiftcountlast_reg.qn, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[2] .qn, 
          dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[1] .qn, 1'b0 };
   assign CHAINOUT12 = { dut.U_SPI_CO_PROC_IF.\databufin_reg[29] .q, 
          dut.U_SPI_CO_PROC_IF.\databufin_reg[28] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[27] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[26] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[25] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[24] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[23] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[22] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[21] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[20] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[19] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[18] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[17] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[16] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[15] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[14] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[13] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[12] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[11] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[10] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[9] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[8] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[7] .q,
          1'b0 };
   assign CHAINOUT13 = { dut.U_SPI_CO_PROC_IF.\databufout_reg[28] .q, 
          dut.U_SPI_CO_PROC_IF.\databufout_reg[27] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[26] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[25] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[24] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[23] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[22] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[21] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[20] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[19] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[18] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[17] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[16] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[15] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[14] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[13] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[12] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[11] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[10] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[9] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[8] .q,
          dut.U_SPI_CO_PROC_IF.\databufin_reg[31] .q, dut.U_SPI_CO_PROC_IF.\databufin_reg[30] .q,
          1'b0 };
   assign CHAINOUT14 = { dut.\instructionreg_reg[0] .q, dut.U_SPI_CO_PROC_IF.\instrbuf_reg[15] .qn,
          dut.U_SPI_CO_PROC_IF.\instrbuf_reg[14] .qn, dut.U_SPI_CO_PROC_IF.\instrbuf_reg[13] .qn,
          dut.U_SPI_CO_PROC_IF.\instrbuf_reg[12] .qn, dut.U_SPI_CO_PROC_IF.\instrbuf_reg[11] .qn,
          dut.U_SPI_CO_PROC_IF.\instrbuf_reg[10] .qn, dut.U_SPI_CO_PROC_IF.\instrbuf_reg[9] .qn,
          dut.U_SPI_CO_PROC_IF.\instrbuf_reg[8] .qn, dut.U_SPI_CO_PROC_IF.\instrbuf_reg[7] .q,
          dut.U_SPI_CO_PROC_IF.\instrbuf_reg[6] .q, dut.U_SPI_CO_PROC_IF.\instrbuf_reg[5] .q,
          dut.U_SPI_CO_PROC_IF.\instrbuf_reg[4] .q, dut.U_SPI_CO_PROC_IF.\instrbuf_reg[3] .q,
          dut.U_SPI_CO_PROC_IF.\instrbuf_reg[2] .q, dut.U_SPI_CO_PROC_IF.\instrbuf_reg[1] .q,
          dut.U_SPI_CO_PROC_IF.\instrbuf_reg[0] .q, dut.U_SPI_CO_PROC_IF.datacounterlast_reg.q,
          dut.U_SPI_CO_PROC_IF.\datacounter_reg[1] .qn, dut.U_SPI_CO_PROC_IF.\datacounter_reg[0] .qn,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[31] .q, dut.U_SPI_CO_PROC_IF.\databufout_reg[30] .q,
          dut.U_SPI_CO_PROC_IF.\databufout_reg[29] .q, 1'b0 };
   assign CHAINOUT15 = { dut.\statusreg_alu_reg[7] .q, dut.\statusreg_alu_reg[6] .q,
          dut.\statusreg_alu_reg[5] .q, dut.\statusreg_alu_reg[4] .q, dut.\statusreg_alu_reg[3] .q,
          dut.\statusreg_alu_reg[2] .q, dut.\statusreg_alu_reg[1] .q, dut.\statusreg_alu_reg[0] .q,
          dut.\instructionreg_reg[15] .q, dut.\instructionreg_reg[14] .q, 
          dut.\instructionreg_reg[13] .q, dut.\instructionreg_reg[12] .q, 
          dut.\instructionreg_reg[11] .q, dut.\instructionreg_reg[10] .q, 
          dut.\instructionreg_reg[9] .q, dut.\instructionreg_reg[8] .q, 
          dut.\instructionreg_reg[7] .q, dut.\instructionreg_reg[6] .q, 
          dut.\instructionreg_reg[5] .q, dut.\instructionreg_reg[4] .q, 
          dut.\instructionreg_reg[3] .q, dut.\instructionreg_reg[2] .q, 
          dut.\instructionreg_reg[1] .q, 1'b0 };

   event load_unload;
   always @ load_unload begin
      if (pattern != prev_pat) begin
         loads = 1;
         prev_pat = pattern;
         if ((verbose >= 2) && (pattern % report_interval == 0))
            $display("// %t : ...begin scan load for pattern %0d", $time, pattern);
         end
      else begin
         loads = loads + 1;
         if ((verbose >= 2) && (pattern % report_interval == 0))
            $display("// %t : ...begin scan load for pattern %0d, load %0d", $time, pattern, loads);
      end

      #0 PI[1] = 0; // clk
      #0 PI[0] = 1; // rst_n
      #0 PI[6] = 1'bX; // test_si1
      #0 PI[7] = 1'bX; // test_si2
      #0 PI[8] = 1'bX; // test_si3
      #0 PI[9] = 1'bX; // test_si4
      #0 PI[10] = 1'bX; // test_si5
      #0 PI[11] = 1'bX; // test_si6
      #0 PI[12] = 1'bX; // test_si7
      #0 PI[13] = 1'bX; // test_si8
      #0 PI[14] = 1'bX; // test_si9
      #0 PI[15] = 1'bX; // test_si10
      #0 PI[16] = 1'bX; // test_si11
      #0 PI[17] = 1'bX; // test_si12
      #0 PI[18] = 1'bX; // test_si13
      #0 PI[19] = 1'bX; // test_si14
      #0 PI[20] = 1'bX; // test_si15
      #0 PI[21] = 1'bX; // test_si16
      #0 PI[5] = 1; // test_se
      #0 PI[4] = 1'bX; // sclk
      #0 PI[2] = 1'bX; // sdi
      #0 PI[3] = 1'bX; // ss_n
      #100;
      // end of load_unload preamble

      // gather current scan cell output bit values
      CHAINOUT[0] = (CHAINOUT0 ^ SHBEGM[0]) >> SHBEG;
      CHAINOUT[1] = (CHAINOUT1 ^ SHBEGM[1]) >> SHBEG;
      CHAINOUT[2] = (CHAINOUT2 ^ SHBEGM[2]) >> SHBEG;
      CHAINOUT[3] = (CHAINOUT3 ^ SHBEGM[3]) >> SHBEG;
      CHAINOUT[4] = (CHAINOUT4 ^ SHBEGM[4]) >> SHBEG;
      CHAINOUT[5] = (CHAINOUT5 ^ SHBEGM[5]) >> SHBEG;
      CHAINOUT[6] = (CHAINOUT6 ^ SHBEGM[6]) >> SHBEG;
      CHAINOUT[7] = (CHAINOUT7 ^ SHBEGM[7]) >> SHBEG;
      CHAINOUT[8] = (CHAINOUT8 ^ SHBEGM[8]) >> SHBEG;
      CHAINOUT[9] = (CHAINOUT9 ^ SHBEGM[9]) >> SHBEG;
      CHAINOUT[10] = (CHAINOUT10 ^ SHBEGM[10]) >> SHBEG;
      CHAINOUT[11] = (CHAINOUT11 ^ SHBEGM[11]) >> SHBEG;
      CHAINOUT[12] = (CHAINOUT12 ^ SHBEGM[12]) >> SHBEG;
      CHAINOUT[13] = (CHAINOUT13 ^ SHBEGM[13]) >> SHBEG;
      CHAINOUT[14] = (CHAINOUT14 ^ SHBEGM[14]) >> SHBEG;
      CHAINOUT[15] = (CHAINOUT15 ^ SHBEGM[15]) >> SHBEG;
      #0;

      // compare actual vs. expected values
      for (chain = 0; chain < 16; chain=chain + 1) begin
         UNL = UNLOAD[chain]; UNLM = UNLMSK[chain] & SERIALM; CHOUT = CHAINOUT[chain] ^ OUTINV[chain];
         if ((UNL&UNLM) !== (CHOUT&UNLM)) begin
            patp1 = pattern + lastpattern;  patm1 = patp1 - 1;
            if (lastpattern == 0) $display("\n// *** ERROR during scan pattern %0d (detected during load of pattern %0d), T=%t", patm1, patp1, $time );
            else                  $display("\n// *** ERROR during scan pattern %0d (detected during final pattern unload), T=%t", patm1, $time );
            for (bit = NSHIFTS+SHBEG; bit < LENMAX; bit=bit + 1) begin
               if ((UNL[bit]&UNLM[bit]) !== (CHOUT[bit]&UNLM[bit])) begin
                  $display("  %0d %0s %0d (exp=%b, got=%b)  // pin %0s, scan cell %0d",
                      patm1, CHAINnames[chain], bit, UNL[bit], CHOUT[bit], CHAINpins[chain], bit);
                  nofails = nofails + 1;
               end
            end
         end
      end
      #0;

      // force bits of scan chain 0
      LOADSH0 = (LOAD0 >> NSHIFTS) ^ INPINV[0];
      //force dut.U_REGISTERFILE.\regfile_reg[0][23] .sd = LOADSH0[0];
      //force dut.U_REGISTERFILE.\regfile_reg[0][22] .sd = LOADSH0[1];
      //force dut.U_REGISTERFILE.\regfile_reg[0][21] .sd = LOADSH0[2];
      //force dut.U_REGISTERFILE.\regfile_reg[0][20] .sd = LOADSH0[3];
      //force dut.U_REGISTERFILE.\regfile_reg[0][19] .sd = LOADSH0[4];
      force dut.U_REGISTERFILE.\regfile_reg[0][18] .sd = LOADSH0[5];
      force dut.U_REGISTERFILE.\regfile_reg[0][17] .sd = LOADSH0[6];
      force dut.U_REGISTERFILE.\regfile_reg[0][16] .sd = LOADSH0[7];
      force dut.U_REGISTERFILE.\regfile_reg[0][15] .sd = LOADSH0[8];
      force dut.U_REGISTERFILE.\regfile_reg[0][14] .sd = LOADSH0[9];
      force dut.U_REGISTERFILE.\regfile_reg[0][13] .sd = LOADSH0[10];
      force dut.U_REGISTERFILE.\regfile_reg[0][12] .sd = LOADSH0[11];
      force dut.U_REGISTERFILE.\regfile_reg[0][11] .sd = LOADSH0[12];
      force dut.U_REGISTERFILE.\regfile_reg[0][10] .sd = LOADSH0[13];
      force dut.U_REGISTERFILE.\regfile_reg[0][9] .sd = LOADSH0[14];
      force dut.U_REGISTERFILE.\regfile_reg[0][8] .sd = LOADSH0[15];
      force dut.U_REGISTERFILE.\regfile_reg[0][7] .sd = LOADSH0[16];
      force dut.U_REGISTERFILE.\regfile_reg[0][6] .sd = LOADSH0[17];
      force dut.U_REGISTERFILE.\regfile_reg[0][5] .sd = LOADSH0[18];
      force dut.U_REGISTERFILE.\regfile_reg[0][4] .sd = LOADSH0[19];
      force dut.U_REGISTERFILE.\regfile_reg[0][3] .sd = LOADSH0[20];
      force dut.U_REGISTERFILE.\regfile_reg[0][2] .sd = LOADSH0[21];
      force dut.U_REGISTERFILE.\regfile_reg[0][1] .sd = LOADSH0[22];
      force dut.U_REGISTERFILE.\regfile_reg[0][0] .sd = LOADSH0[23];

      // force bits of scan chain 1
      LOADSH1 = (LOAD1 >> NSHIFTS) ^ INPINV[1];
      //force dut.U_REGISTERFILE.\regfile_reg[1][15] .sd = LOADSH1[0];
      //force dut.U_REGISTERFILE.\regfile_reg[1][14] .sd = LOADSH1[1];
      //force dut.U_REGISTERFILE.\regfile_reg[1][13] .sd = LOADSH1[2];
      //force dut.U_REGISTERFILE.\regfile_reg[1][12] .sd = LOADSH1[3];
      //force dut.U_REGISTERFILE.\regfile_reg[1][11] .sd = LOADSH1[4];
      force dut.U_REGISTERFILE.\regfile_reg[1][10] .sd = LOADSH1[5];
      force dut.U_REGISTERFILE.\regfile_reg[1][9] .sd = LOADSH1[6];
      force dut.U_REGISTERFILE.\regfile_reg[1][8] .sd = LOADSH1[7];
      force dut.U_REGISTERFILE.\regfile_reg[1][7] .sd = LOADSH1[8];
      force dut.U_REGISTERFILE.\regfile_reg[1][6] .sd = LOADSH1[9];
      force dut.U_REGISTERFILE.\regfile_reg[1][5] .sd = LOADSH1[10];
      force dut.U_REGISTERFILE.\regfile_reg[1][4] .sd = LOADSH1[11];
      force dut.U_REGISTERFILE.\regfile_reg[1][3] .sd = LOADSH1[12];
      force dut.U_REGISTERFILE.\regfile_reg[1][2] .sd = LOADSH1[13];
      force dut.U_REGISTERFILE.\regfile_reg[1][1] .sd = LOADSH1[14];
      force dut.U_REGISTERFILE.\regfile_reg[1][0] .sd = LOADSH1[15];
      force dut.U_REGISTERFILE.\regfile_reg[0][31] .sd = LOADSH1[16];
      force dut.U_REGISTERFILE.\regfile_reg[0][30] .sd = LOADSH1[17];
      force dut.U_REGISTERFILE.\regfile_reg[0][29] .sd = LOADSH1[18];
      force dut.U_REGISTERFILE.\regfile_reg[0][28] .sd = LOADSH1[19];
      force dut.U_REGISTERFILE.\regfile_reg[0][27] .sd = LOADSH1[20];
      force dut.U_REGISTERFILE.\regfile_reg[0][26] .sd = LOADSH1[21];
      force dut.U_REGISTERFILE.\regfile_reg[0][25] .sd = LOADSH1[22];
      force dut.U_REGISTERFILE.\regfile_reg[0][24] .sd = LOADSH1[23];

      // force bits of scan chain 2
      LOADSH2 = (LOAD2 >> NSHIFTS) ^ INPINV[2];
      //force dut.U_REGISTERFILE.\regfile_reg[2][7] .sd = LOADSH2[0];
      //force dut.U_REGISTERFILE.\regfile_reg[2][6] .sd = LOADSH2[1];
      //force dut.U_REGISTERFILE.\regfile_reg[2][5] .sd = LOADSH2[2];
      //force dut.U_REGISTERFILE.\regfile_reg[2][4] .sd = LOADSH2[3];
      //force dut.U_REGISTERFILE.\regfile_reg[2][3] .sd = LOADSH2[4];
      force dut.U_REGISTERFILE.\regfile_reg[2][2] .sd = LOADSH2[5];
      force dut.U_REGISTERFILE.\regfile_reg[2][1] .sd = LOADSH2[6];
      force dut.U_REGISTERFILE.\regfile_reg[2][0] .sd = LOADSH2[7];
      force dut.U_REGISTERFILE.\regfile_reg[1][31] .sd = LOADSH2[8];
      force dut.U_REGISTERFILE.\regfile_reg[1][30] .sd = LOADSH2[9];
      force dut.U_REGISTERFILE.\regfile_reg[1][29] .sd = LOADSH2[10];
      force dut.U_REGISTERFILE.\regfile_reg[1][28] .sd = LOADSH2[11];
      force dut.U_REGISTERFILE.\regfile_reg[1][27] .sd = LOADSH2[12];
      force dut.U_REGISTERFILE.\regfile_reg[1][26] .sd = LOADSH2[13];
      force dut.U_REGISTERFILE.\regfile_reg[1][25] .sd = LOADSH2[14];
      force dut.U_REGISTERFILE.\regfile_reg[1][24] .sd = LOADSH2[15];
      force dut.U_REGISTERFILE.\regfile_reg[1][23] .sd = LOADSH2[16];
      force dut.U_REGISTERFILE.\regfile_reg[1][22] .sd = LOADSH2[17];
      force dut.U_REGISTERFILE.\regfile_reg[1][21] .sd = LOADSH2[18];
      force dut.U_REGISTERFILE.\regfile_reg[1][20] .sd = LOADSH2[19];
      force dut.U_REGISTERFILE.\regfile_reg[1][19] .sd = LOADSH2[20];
      force dut.U_REGISTERFILE.\regfile_reg[1][18] .sd = LOADSH2[21];
      force dut.U_REGISTERFILE.\regfile_reg[1][17] .sd = LOADSH2[22];
      force dut.U_REGISTERFILE.\regfile_reg[1][16] .sd = LOADSH2[23];

      // force bits of scan chain 3
      LOADSH3 = (LOAD3 >> NSHIFTS) ^ INPINV[3];
      //force dut.U_REGISTERFILE.\regfile_reg[2][31] .sd = LOADSH3[0];
      //force dut.U_REGISTERFILE.\regfile_reg[2][30] .sd = LOADSH3[1];
      //force dut.U_REGISTERFILE.\regfile_reg[2][29] .sd = LOADSH3[2];
      //force dut.U_REGISTERFILE.\regfile_reg[2][28] .sd = LOADSH3[3];
      //force dut.U_REGISTERFILE.\regfile_reg[2][27] .sd = LOADSH3[4];
      force dut.U_REGISTERFILE.\regfile_reg[2][26] .sd = LOADSH3[5];
      force dut.U_REGISTERFILE.\regfile_reg[2][25] .sd = LOADSH3[6];
      force dut.U_REGISTERFILE.\regfile_reg[2][24] .sd = LOADSH3[7];
      force dut.U_REGISTERFILE.\regfile_reg[2][23] .sd = LOADSH3[8];
      force dut.U_REGISTERFILE.\regfile_reg[2][22] .sd = LOADSH3[9];
      force dut.U_REGISTERFILE.\regfile_reg[2][21] .sd = LOADSH3[10];
      force dut.U_REGISTERFILE.\regfile_reg[2][20] .sd = LOADSH3[11];
      force dut.U_REGISTERFILE.\regfile_reg[2][19] .sd = LOADSH3[12];
      force dut.U_REGISTERFILE.\regfile_reg[2][18] .sd = LOADSH3[13];
      force dut.U_REGISTERFILE.\regfile_reg[2][17] .sd = LOADSH3[14];
      force dut.U_REGISTERFILE.\regfile_reg[2][16] .sd = LOADSH3[15];
      force dut.U_REGISTERFILE.\regfile_reg[2][15] .sd = LOADSH3[16];
      force dut.U_REGISTERFILE.\regfile_reg[2][14] .sd = LOADSH3[17];
      force dut.U_REGISTERFILE.\regfile_reg[2][13] .sd = LOADSH3[18];
      force dut.U_REGISTERFILE.\regfile_reg[2][12] .sd = LOADSH3[19];
      force dut.U_REGISTERFILE.\regfile_reg[2][11] .sd = LOADSH3[20];
      force dut.U_REGISTERFILE.\regfile_reg[2][10] .sd = LOADSH3[21];
      force dut.U_REGISTERFILE.\regfile_reg[2][9] .sd = LOADSH3[22];
      force dut.U_REGISTERFILE.\regfile_reg[2][8] .sd = LOADSH3[23];

      // force bits of scan chain 4
      LOADSH4 = (LOAD4 >> NSHIFTS) ^ INPINV[4];
      //force dut.U_REGISTERFILE.\regfile_reg[3][23] .sd = LOADSH4[0];
      //force dut.U_REGISTERFILE.\regfile_reg[3][22] .sd = LOADSH4[1];
      //force dut.U_REGISTERFILE.\regfile_reg[3][21] .sd = LOADSH4[2];
      //force dut.U_REGISTERFILE.\regfile_reg[3][20] .sd = LOADSH4[3];
      //force dut.U_REGISTERFILE.\regfile_reg[3][19] .sd = LOADSH4[4];
      force dut.U_REGISTERFILE.\regfile_reg[3][18] .sd = LOADSH4[5];
      force dut.U_REGISTERFILE.\regfile_reg[3][17] .sd = LOADSH4[6];
      force dut.U_REGISTERFILE.\regfile_reg[3][16] .sd = LOADSH4[7];
      force dut.U_REGISTERFILE.\regfile_reg[3][15] .sd = LOADSH4[8];
      force dut.U_REGISTERFILE.\regfile_reg[3][14] .sd = LOADSH4[9];
      force dut.U_REGISTERFILE.\regfile_reg[3][13] .sd = LOADSH4[10];
      force dut.U_REGISTERFILE.\regfile_reg[3][12] .sd = LOADSH4[11];
      force dut.U_REGISTERFILE.\regfile_reg[3][11] .sd = LOADSH4[12];
      force dut.U_REGISTERFILE.\regfile_reg[3][10] .sd = LOADSH4[13];
      force dut.U_REGISTERFILE.\regfile_reg[3][9] .sd = LOADSH4[14];
      force dut.U_REGISTERFILE.\regfile_reg[3][8] .sd = LOADSH4[15];
      force dut.U_REGISTERFILE.\regfile_reg[3][7] .sd = LOADSH4[16];
      force dut.U_REGISTERFILE.\regfile_reg[3][6] .sd = LOADSH4[17];
      force dut.U_REGISTERFILE.\regfile_reg[3][5] .sd = LOADSH4[18];
      force dut.U_REGISTERFILE.\regfile_reg[3][4] .sd = LOADSH4[19];
      force dut.U_REGISTERFILE.\regfile_reg[3][3] .sd = LOADSH4[20];
      force dut.U_REGISTERFILE.\regfile_reg[3][2] .sd = LOADSH4[21];
      force dut.U_REGISTERFILE.\regfile_reg[3][1] .sd = LOADSH4[22];
      force dut.U_REGISTERFILE.\regfile_reg[3][0] .sd = LOADSH4[23];

      // force bits of scan chain 5
      LOADSH5 = (LOAD5 >> NSHIFTS) ^ INPINV[5];
      //force dut.U_REGISTERFILE.\regfile_reg[4][15] .sd = LOADSH5[0];
      //force dut.U_REGISTERFILE.\regfile_reg[4][14] .sd = LOADSH5[1];
      //force dut.U_REGISTERFILE.\regfile_reg[4][13] .sd = LOADSH5[2];
      //force dut.U_REGISTERFILE.\regfile_reg[4][12] .sd = LOADSH5[3];
      //force dut.U_REGISTERFILE.\regfile_reg[4][11] .sd = LOADSH5[4];
      force dut.U_REGISTERFILE.\regfile_reg[4][10] .sd = LOADSH5[5];
      force dut.U_REGISTERFILE.\regfile_reg[4][9] .sd = LOADSH5[6];
      force dut.U_REGISTERFILE.\regfile_reg[4][8] .sd = LOADSH5[7];
      force dut.U_REGISTERFILE.\regfile_reg[4][7] .sd = LOADSH5[8];
      force dut.U_REGISTERFILE.\regfile_reg[4][6] .sd = LOADSH5[9];
      force dut.U_REGISTERFILE.\regfile_reg[4][5] .sd = LOADSH5[10];
      force dut.U_REGISTERFILE.\regfile_reg[4][4] .sd = LOADSH5[11];
      force dut.U_REGISTERFILE.\regfile_reg[4][3] .sd = LOADSH5[12];
      force dut.U_REGISTERFILE.\regfile_reg[4][2] .sd = LOADSH5[13];
      force dut.U_REGISTERFILE.\regfile_reg[4][1] .sd = LOADSH5[14];
      force dut.U_REGISTERFILE.\regfile_reg[4][0] .sd = LOADSH5[15];
      force dut.U_REGISTERFILE.\regfile_reg[3][31] .sd = LOADSH5[16];
      force dut.U_REGISTERFILE.\regfile_reg[3][30] .sd = LOADSH5[17];
      force dut.U_REGISTERFILE.\regfile_reg[3][29] .sd = LOADSH5[18];
      force dut.U_REGISTERFILE.\regfile_reg[3][28] .sd = LOADSH5[19];
      force dut.U_REGISTERFILE.\regfile_reg[3][27] .sd = LOADSH5[20];
      force dut.U_REGISTERFILE.\regfile_reg[3][26] .sd = LOADSH5[21];
      force dut.U_REGISTERFILE.\regfile_reg[3][25] .sd = LOADSH5[22];
      force dut.U_REGISTERFILE.\regfile_reg[3][24] .sd = LOADSH5[23];

      // force bits of scan chain 6
      LOADSH6 = (LOAD6 >> NSHIFTS) ^ INPINV[6];
      //force dut.U_REGISTERFILE.\regfile_reg[5][7] .sd = LOADSH6[0];
      //force dut.U_REGISTERFILE.\regfile_reg[5][6] .sd = LOADSH6[1];
      //force dut.U_REGISTERFILE.\regfile_reg[5][5] .sd = LOADSH6[2];
      //force dut.U_REGISTERFILE.\regfile_reg[5][4] .sd = LOADSH6[3];
      //force dut.U_REGISTERFILE.\regfile_reg[5][3] .sd = LOADSH6[4];
      force dut.U_REGISTERFILE.\regfile_reg[5][2] .sd = LOADSH6[5];
      force dut.U_REGISTERFILE.\regfile_reg[5][1] .sd = LOADSH6[6];
      force dut.U_REGISTERFILE.\regfile_reg[5][0] .sd = LOADSH6[7];
      force dut.U_REGISTERFILE.\regfile_reg[4][31] .sd = LOADSH6[8];
      force dut.U_REGISTERFILE.\regfile_reg[4][30] .sd = LOADSH6[9];
      force dut.U_REGISTERFILE.\regfile_reg[4][29] .sd = LOADSH6[10];
      force dut.U_REGISTERFILE.\regfile_reg[4][28] .sd = LOADSH6[11];
      force dut.U_REGISTERFILE.\regfile_reg[4][27] .sd = LOADSH6[12];
      force dut.U_REGISTERFILE.\regfile_reg[4][26] .sd = LOADSH6[13];
      force dut.U_REGISTERFILE.\regfile_reg[4][25] .sd = LOADSH6[14];
      force dut.U_REGISTERFILE.\regfile_reg[4][24] .sd = LOADSH6[15];
      force dut.U_REGISTERFILE.\regfile_reg[4][23] .sd = LOADSH6[16];
      force dut.U_REGISTERFILE.\regfile_reg[4][22] .sd = LOADSH6[17];
      force dut.U_REGISTERFILE.\regfile_reg[4][21] .sd = LOADSH6[18];
      force dut.U_REGISTERFILE.\regfile_reg[4][20] .sd = LOADSH6[19];
      force dut.U_REGISTERFILE.\regfile_reg[4][19] .sd = LOADSH6[20];
      force dut.U_REGISTERFILE.\regfile_reg[4][18] .sd = LOADSH6[21];
      force dut.U_REGISTERFILE.\regfile_reg[4][17] .sd = LOADSH6[22];
      force dut.U_REGISTERFILE.\regfile_reg[4][16] .sd = LOADSH6[23];

      // force bits of scan chain 7
      LOADSH7 = (LOAD7 >> NSHIFTS) ^ INPINV[7];
      //force dut.U_REGISTERFILE.\regfile_reg[5][31] .sd = LOADSH7[0];
      //force dut.U_REGISTERFILE.\regfile_reg[5][30] .sd = LOADSH7[1];
      //force dut.U_REGISTERFILE.\regfile_reg[5][29] .sd = LOADSH7[2];
      //force dut.U_REGISTERFILE.\regfile_reg[5][28] .sd = LOADSH7[3];
      //force dut.U_REGISTERFILE.\regfile_reg[5][27] .sd = LOADSH7[4];
      force dut.U_REGISTERFILE.\regfile_reg[5][26] .sd = LOADSH7[5];
      force dut.U_REGISTERFILE.\regfile_reg[5][25] .sd = LOADSH7[6];
      force dut.U_REGISTERFILE.\regfile_reg[5][24] .sd = LOADSH7[7];
      force dut.U_REGISTERFILE.\regfile_reg[5][23] .sd = LOADSH7[8];
      force dut.U_REGISTERFILE.\regfile_reg[5][22] .sd = LOADSH7[9];
      force dut.U_REGISTERFILE.\regfile_reg[5][21] .sd = LOADSH7[10];
      force dut.U_REGISTERFILE.\regfile_reg[5][20] .sd = LOADSH7[11];
      force dut.U_REGISTERFILE.\regfile_reg[5][19] .sd = LOADSH7[12];
      force dut.U_REGISTERFILE.\regfile_reg[5][18] .sd = LOADSH7[13];
      force dut.U_REGISTERFILE.\regfile_reg[5][17] .sd = LOADSH7[14];
      force dut.U_REGISTERFILE.\regfile_reg[5][16] .sd = LOADSH7[15];
      force dut.U_REGISTERFILE.\regfile_reg[5][15] .sd = LOADSH7[16];
      force dut.U_REGISTERFILE.\regfile_reg[5][14] .sd = LOADSH7[17];
      force dut.U_REGISTERFILE.\regfile_reg[5][13] .sd = LOADSH7[18];
      force dut.U_REGISTERFILE.\regfile_reg[5][12] .sd = LOADSH7[19];
      force dut.U_REGISTERFILE.\regfile_reg[5][11] .sd = LOADSH7[20];
      force dut.U_REGISTERFILE.\regfile_reg[5][10] .sd = LOADSH7[21];
      force dut.U_REGISTERFILE.\regfile_reg[5][9] .sd = LOADSH7[22];
      force dut.U_REGISTERFILE.\regfile_reg[5][8] .sd = LOADSH7[23];

      // force bits of scan chain 8
      LOADSH8 = (LOAD8 >> NSHIFTS) ^ INPINV[8];
      //force dut.U_REGISTERFILE.\regfile_reg[6][23] .sd = LOADSH8[0];
      //force dut.U_REGISTERFILE.\regfile_reg[6][22] .sd = LOADSH8[1];
      //force dut.U_REGISTERFILE.\regfile_reg[6][21] .sd = LOADSH8[2];
      //force dut.U_REGISTERFILE.\regfile_reg[6][20] .sd = LOADSH8[3];
      //force dut.U_REGISTERFILE.\regfile_reg[6][19] .sd = LOADSH8[4];
      force dut.U_REGISTERFILE.\regfile_reg[6][18] .sd = LOADSH8[5];
      force dut.U_REGISTERFILE.\regfile_reg[6][17] .sd = LOADSH8[6];
      force dut.U_REGISTERFILE.\regfile_reg[6][16] .sd = LOADSH8[7];
      force dut.U_REGISTERFILE.\regfile_reg[6][15] .sd = LOADSH8[8];
      force dut.U_REGISTERFILE.\regfile_reg[6][14] .sd = LOADSH8[9];
      force dut.U_REGISTERFILE.\regfile_reg[6][13] .sd = LOADSH8[10];
      force dut.U_REGISTERFILE.\regfile_reg[6][12] .sd = LOADSH8[11];
      force dut.U_REGISTERFILE.\regfile_reg[6][11] .sd = LOADSH8[12];
      force dut.U_REGISTERFILE.\regfile_reg[6][10] .sd = LOADSH8[13];
      force dut.U_REGISTERFILE.\regfile_reg[6][9] .sd = LOADSH8[14];
      force dut.U_REGISTERFILE.\regfile_reg[6][8] .sd = LOADSH8[15];
      force dut.U_REGISTERFILE.\regfile_reg[6][7] .sd = LOADSH8[16];
      force dut.U_REGISTERFILE.\regfile_reg[6][6] .sd = LOADSH8[17];
      force dut.U_REGISTERFILE.\regfile_reg[6][5] .sd = LOADSH8[18];
      force dut.U_REGISTERFILE.\regfile_reg[6][4] .sd = LOADSH8[19];
      force dut.U_REGISTERFILE.\regfile_reg[6][3] .sd = LOADSH8[20];
      force dut.U_REGISTERFILE.\regfile_reg[6][2] .sd = LOADSH8[21];
      force dut.U_REGISTERFILE.\regfile_reg[6][1] .sd = LOADSH8[22];
      force dut.U_REGISTERFILE.\regfile_reg[6][0] .sd = LOADSH8[23];

      // force bits of scan chain 9
      LOADSH9 = (LOAD9 >> NSHIFTS) ^ INPINV[9];
      //force dut.U_REGISTERFILE.\regfile_reg[7][14] .sd = LOADSH9[1];
      //force dut.U_REGISTERFILE.\regfile_reg[7][13] .sd = LOADSH9[2];
      //force dut.U_REGISTERFILE.\regfile_reg[7][12] .sd = LOADSH9[3];
      //force dut.U_REGISTERFILE.\regfile_reg[7][11] .sd = LOADSH9[4];
      //force dut.U_REGISTERFILE.\regfile_reg[7][10] .sd = LOADSH9[5];
      force dut.U_REGISTERFILE.\regfile_reg[7][9] .sd = LOADSH9[6];
      force dut.U_REGISTERFILE.\regfile_reg[7][8] .sd = LOADSH9[7];
      force dut.U_REGISTERFILE.\regfile_reg[7][7] .sd = LOADSH9[8];
      force dut.U_REGISTERFILE.\regfile_reg[7][6] .sd = LOADSH9[9];
      force dut.U_REGISTERFILE.\regfile_reg[7][5] .sd = LOADSH9[10];
      force dut.U_REGISTERFILE.\regfile_reg[7][4] .sd = LOADSH9[11];
      force dut.U_REGISTERFILE.\regfile_reg[7][3] .sd = LOADSH9[12];
      force dut.U_REGISTERFILE.\regfile_reg[7][2] .sd = LOADSH9[13];
      force dut.U_REGISTERFILE.\regfile_reg[7][1] .sd = LOADSH9[14];
      force dut.U_REGISTERFILE.\regfile_reg[7][0] .sd = LOADSH9[15];
      force dut.U_REGISTERFILE.\regfile_reg[6][31] .sd = LOADSH9[16];
      force dut.U_REGISTERFILE.\regfile_reg[6][30] .sd = LOADSH9[17];
      force dut.U_REGISTERFILE.\regfile_reg[6][29] .sd = LOADSH9[18];
      force dut.U_REGISTERFILE.\regfile_reg[6][28] .sd = LOADSH9[19];
      force dut.U_REGISTERFILE.\regfile_reg[6][27] .sd = LOADSH9[20];
      force dut.U_REGISTERFILE.\regfile_reg[6][26] .sd = LOADSH9[21];
      force dut.U_REGISTERFILE.\regfile_reg[6][25] .sd = LOADSH9[22];
      force dut.U_REGISTERFILE.\regfile_reg[6][24] .sd = LOADSH9[23];

      // force bits of scan chain 10
      LOADSH10 = (LOAD10 >> NSHIFTS) ^ INPINV[10];
      //force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[0] .sd = LOADSH10[1];
      //force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sdi_buf_reg[1] .sd = LOADSH10[2];
      //force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sdi_buf_reg[0] .sd = LOADSH10[3];
      //force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[2] .sd = LOADSH10[4];
      //force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[1] .sd = LOADSH10[5];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[0] .sd = LOADSH10[6];
      force dut.U_REGISTERFILE.\regfile_reg[7][31] .sd = LOADSH10[7];
      force dut.U_REGISTERFILE.\regfile_reg[7][30] .sd = LOADSH10[8];
      force dut.U_REGISTERFILE.\regfile_reg[7][29] .sd = LOADSH10[9];
      force dut.U_REGISTERFILE.\regfile_reg[7][28] .sd = LOADSH10[10];
      force dut.U_REGISTERFILE.\regfile_reg[7][27] .sd = LOADSH10[11];
      force dut.U_REGISTERFILE.\regfile_reg[7][26] .sd = LOADSH10[12];
      force dut.U_REGISTERFILE.\regfile_reg[7][25] .sd = LOADSH10[13];
      force dut.U_REGISTERFILE.\regfile_reg[7][24] .sd = LOADSH10[14];
      force dut.U_REGISTERFILE.\regfile_reg[7][23] .sd = LOADSH10[15];
      force dut.U_REGISTERFILE.\regfile_reg[7][22] .sd = LOADSH10[16];
      force dut.U_REGISTERFILE.\regfile_reg[7][21] .sd = LOADSH10[17];
      force dut.U_REGISTERFILE.\regfile_reg[7][20] .sd = LOADSH10[18];
      force dut.U_REGISTERFILE.\regfile_reg[7][19] .sd = LOADSH10[19];
      force dut.U_REGISTERFILE.\regfile_reg[7][18] .sd = LOADSH10[20];
      force dut.U_REGISTERFILE.\regfile_reg[7][17] .sd = LOADSH10[21];
      force dut.U_REGISTERFILE.\regfile_reg[7][16] .sd = LOADSH10[22];
      force dut.U_REGISTERFILE.\regfile_reg[7][15] .sd = LOADSH10[23];

      // force bits of scan chain 11
      LOADSH11 = (LOAD11 >> NSHIFTS) ^ INPINV[11];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[6] .sd = LOADSH11[1];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[5] .sd = LOADSH11[2];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[4] .sd = LOADSH11[3];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[3] .sd = LOADSH11[4];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[2] .sd = LOADSH11[5];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[1] .sd = LOADSH11[6];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[0] .sd = LOADSH11[7];
      force dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[2] .sd = LOADSH11[8];
      force dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[1] .sd = LOADSH11[9];
      force dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[0] .sd = LOADSH11[10];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\ss_n_buf_reg[1] .sd = LOADSH11[11];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\ss_n_buf_reg[0] .sd = LOADSH11[12];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[7] .sd = LOADSH11[13];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[6] .sd = LOADSH11[14];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[5] .sd = LOADSH11[15];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[4] .sd = LOADSH11[16];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[3] .sd = LOADSH11[17];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[2] .sd = LOADSH11[18];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[1] .sd = LOADSH11[19];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[0] .sd = LOADSH11[20];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.shiftcountlast_reg.sd = LOADSH11[21];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[2] .sd = LOADSH11[22];
      force dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[1] .sd = LOADSH11[23];

      // force bits of scan chain 12
      LOADSH12 = (LOAD12 >> NSHIFTS) ^ INPINV[12];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[29] .sd = LOADSH12[1];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[28] .sd = LOADSH12[2];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[27] .sd = LOADSH12[3];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[26] .sd = LOADSH12[4];
      //force dut.U_SPI_CO_PROC_IF.\databufin_reg[25] .sd = LOADSH12[5];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[24] .sd = LOADSH12[6];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[23] .sd = LOADSH12[7];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[22] .sd = LOADSH12[8];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[21] .sd = LOADSH12[9];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[20] .sd = LOADSH12[10];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[19] .sd = LOADSH12[11];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[18] .sd = LOADSH12[12];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[17] .sd = LOADSH12[13];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[16] .sd = LOADSH12[14];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[15] .sd = LOADSH12[15];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[14] .sd = LOADSH12[16];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[13] .sd = LOADSH12[17];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[12] .sd = LOADSH12[18];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[11] .sd = LOADSH12[19];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[10] .sd = LOADSH12[20];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[9] .sd = LOADSH12[21];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[8] .sd = LOADSH12[22];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[7] .sd = LOADSH12[23];

      // force bits of scan chain 13
      LOADSH13 = (LOAD13 >> NSHIFTS) ^ INPINV[13];
      //force dut.U_SPI_CO_PROC_IF.\databufout_reg[28] .sd = LOADSH13[1];
      //force dut.U_SPI_CO_PROC_IF.\databufout_reg[27] .sd = LOADSH13[2];
      //force dut.U_SPI_CO_PROC_IF.\databufout_reg[26] .sd = LOADSH13[3];
      //force dut.U_SPI_CO_PROC_IF.\databufout_reg[25] .sd = LOADSH13[4];
      //force dut.U_SPI_CO_PROC_IF.\databufout_reg[24] .sd = LOADSH13[5];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[23] .sd = LOADSH13[6];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[22] .sd = LOADSH13[7];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[21] .sd = LOADSH13[8];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[20] .sd = LOADSH13[9];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[19] .sd = LOADSH13[10];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[18] .sd = LOADSH13[11];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[17] .sd = LOADSH13[12];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[16] .sd = LOADSH13[13];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[15] .sd = LOADSH13[14];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[14] .sd = LOADSH13[15];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[13] .sd = LOADSH13[16];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[12] .sd = LOADSH13[17];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[11] .sd = LOADSH13[18];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[10] .sd = LOADSH13[19];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[9] .sd = LOADSH13[20];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[8] .sd = LOADSH13[21];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[31] .sd = LOADSH13[22];
      force dut.U_SPI_CO_PROC_IF.\databufin_reg[30] .sd = LOADSH13[23];

      // force bits of scan chain 14
      LOADSH14 = (LOAD14 >> NSHIFTS) ^ INPINV[14];
      //force dut.\instructionreg_reg[0] .sd = LOADSH14[1];
      //force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[15] .sd = LOADSH14[2];
      //force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[14] .sd = LOADSH14[3];
      //force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[13] .sd = LOADSH14[4];
      //force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[12] .sd = LOADSH14[5];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[11] .sd = LOADSH14[6];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[10] .sd = LOADSH14[7];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[9] .sd = LOADSH14[8];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[8] .sd = LOADSH14[9];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[7] .sd = LOADSH14[10];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[6] .sd = LOADSH14[11];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[5] .sd = LOADSH14[12];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[4] .sd = LOADSH14[13];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[3] .sd = LOADSH14[14];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[2] .sd = LOADSH14[15];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[1] .sd = LOADSH14[16];
      force dut.U_SPI_CO_PROC_IF.\instrbuf_reg[0] .sd = LOADSH14[17];
      force dut.U_SPI_CO_PROC_IF.datacounterlast_reg.sd = LOADSH14[18];
      force dut.U_SPI_CO_PROC_IF.\datacounter_reg[1] .sd = LOADSH14[19];
      force dut.U_SPI_CO_PROC_IF.\datacounter_reg[0] .sd = LOADSH14[20];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[31] .sd = LOADSH14[21];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[30] .sd = LOADSH14[22];
      force dut.U_SPI_CO_PROC_IF.\databufout_reg[29] .sd = LOADSH14[23];

      // force bits of scan chain 15
      LOADSH15 = (LOAD15 >> NSHIFTS) ^ INPINV[15];
      //force dut.\statusreg_alu_reg[7] .sd = LOADSH15[1];
      //force dut.\statusreg_alu_reg[6] .sd = LOADSH15[2];
      //force dut.\statusreg_alu_reg[5] .sd = LOADSH15[3];
      //force dut.\statusreg_alu_reg[4] .sd = LOADSH15[4];
      //force dut.\statusreg_alu_reg[3] .sd = LOADSH15[5];
      force dut.\statusreg_alu_reg[2] .sd = LOADSH15[6];
      force dut.\statusreg_alu_reg[1] .sd = LOADSH15[7];
      force dut.\statusreg_alu_reg[0] .sd = LOADSH15[8];
      force dut.\instructionreg_reg[15] .sd = LOADSH15[9];
      force dut.\instructionreg_reg[14] .sd = LOADSH15[10];
      force dut.\instructionreg_reg[13] .sd = LOADSH15[11];
      force dut.\instructionreg_reg[12] .sd = LOADSH15[12];
      force dut.\instructionreg_reg[11] .sd = LOADSH15[13];
      force dut.\instructionreg_reg[10] .sd = LOADSH15[14];
      force dut.\instructionreg_reg[9] .sd = LOADSH15[15];
      force dut.\instructionreg_reg[8] .sd = LOADSH15[16];
      force dut.\instructionreg_reg[7] .sd = LOADSH15[17];
      force dut.\instructionreg_reg[6] .sd = LOADSH15[18];
      force dut.\instructionreg_reg[5] .sd = LOADSH15[19];
      force dut.\instructionreg_reg[4] .sd = LOADSH15[20];
      force dut.\instructionreg_reg[3] .sd = LOADSH15[21];
      force dut.\instructionreg_reg[2] .sd = LOADSH15[22];
      force dut.\instructionreg_reg[1] .sd = LOADSH15[23];
      #0;

      // apply single shift pulse with force's in place
      bit = LENMAX - NSHIFTS - 1;
      shift;

      // release bits of scan chain 0
      //release dut.U_REGISTERFILE.\regfile_reg[0][23] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[0][22] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[0][21] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[0][20] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[0][19] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][18] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][17] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][16] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][15] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][14] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][13] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][12] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][11] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][10] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][9] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][8] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][7] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][6] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][5] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][4] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][3] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][2] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][1] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][0] .sd;

      // release bits of scan chain 1
      //release dut.U_REGISTERFILE.\regfile_reg[1][15] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[1][14] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[1][13] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[1][12] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[1][11] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][10] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][9] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][8] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][7] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][6] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][5] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][4] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][3] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][2] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][1] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][0] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][31] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][30] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][29] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][28] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][27] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][26] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][25] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[0][24] .sd;

      // release bits of scan chain 2
      //release dut.U_REGISTERFILE.\regfile_reg[2][7] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[2][6] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[2][5] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[2][4] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[2][3] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][2] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][1] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][0] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][31] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][30] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][29] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][28] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][27] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][26] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][25] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][24] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][23] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][22] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][21] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][20] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][19] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][18] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][17] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[1][16] .sd;

      // release bits of scan chain 3
      //release dut.U_REGISTERFILE.\regfile_reg[2][31] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[2][30] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[2][29] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[2][28] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[2][27] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][26] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][25] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][24] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][23] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][22] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][21] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][20] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][19] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][18] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][17] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][16] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][15] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][14] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][13] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][12] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][11] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][10] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][9] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[2][8] .sd;

      // release bits of scan chain 4
      //release dut.U_REGISTERFILE.\regfile_reg[3][23] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[3][22] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[3][21] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[3][20] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[3][19] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][18] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][17] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][16] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][15] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][14] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][13] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][12] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][11] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][10] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][9] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][8] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][7] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][6] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][5] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][4] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][3] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][2] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][1] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][0] .sd;

      // release bits of scan chain 5
      //release dut.U_REGISTERFILE.\regfile_reg[4][15] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[4][14] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[4][13] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[4][12] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[4][11] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][10] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][9] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][8] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][7] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][6] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][5] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][4] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][3] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][2] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][1] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][0] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][31] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][30] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][29] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][28] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][27] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][26] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][25] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[3][24] .sd;

      // release bits of scan chain 6
      //release dut.U_REGISTERFILE.\regfile_reg[5][7] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[5][6] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[5][5] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[5][4] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[5][3] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][2] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][1] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][0] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][31] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][30] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][29] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][28] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][27] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][26] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][25] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][24] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][23] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][22] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][21] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][20] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][19] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][18] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][17] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[4][16] .sd;

      // release bits of scan chain 7
      //release dut.U_REGISTERFILE.\regfile_reg[5][31] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[5][30] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[5][29] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[5][28] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[5][27] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][26] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][25] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][24] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][23] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][22] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][21] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][20] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][19] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][18] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][17] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][16] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][15] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][14] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][13] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][12] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][11] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][10] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][9] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[5][8] .sd;

      // release bits of scan chain 8
      //release dut.U_REGISTERFILE.\regfile_reg[6][23] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[6][22] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[6][21] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[6][20] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[6][19] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][18] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][17] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][16] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][15] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][14] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][13] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][12] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][11] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][10] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][9] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][8] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][7] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][6] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][5] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][4] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][3] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][2] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][1] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][0] .sd;

      // release bits of scan chain 9
      //release dut.U_REGISTERFILE.\regfile_reg[7][14] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[7][13] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[7][12] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[7][11] .sd;
      //release dut.U_REGISTERFILE.\regfile_reg[7][10] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][9] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][8] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][7] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][6] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][5] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][4] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][3] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][2] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][1] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][0] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][31] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][30] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][29] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][28] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][27] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][26] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][25] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[6][24] .sd;

      // release bits of scan chain 10
      //release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[0] .sd;
      //release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sdi_buf_reg[1] .sd;
      //release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sdi_buf_reg[0] .sd;
      //release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[2] .sd;
      //release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[1] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\sclk_buf_reg[0] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][31] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][30] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][29] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][28] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][27] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][26] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][25] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][24] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][23] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][22] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][21] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][20] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][19] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][18] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][17] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][16] .sd;
      release dut.U_REGISTERFILE.\regfile_reg[7][15] .sd;

      // release bits of scan chain 11
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[6] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[5] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[4] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[3] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[2] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[1] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[0] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[2] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[1] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPI_CO_PROC_FSM.\currentstate_reg[0] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\ss_n_buf_reg[1] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\ss_n_buf_reg[0] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[7] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[6] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[5] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[4] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[3] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[2] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[1] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftreg_reg[0] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.shiftcountlast_reg.sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[2] .sd;
      release dut.U_SPI_CO_PROC_IF.U_SPISLAVE.\shiftcount_reg[1] .sd;

      // release bits of scan chain 12
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[29] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[28] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[27] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[26] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufin_reg[25] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[24] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[23] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[22] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[21] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[20] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[19] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[18] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[17] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[16] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[15] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[14] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[13] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[12] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[11] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[10] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[9] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[8] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[7] .sd;

      // release bits of scan chain 13
      //release dut.U_SPI_CO_PROC_IF.\databufout_reg[28] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufout_reg[27] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufout_reg[26] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufout_reg[25] .sd;
      //release dut.U_SPI_CO_PROC_IF.\databufout_reg[24] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[23] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[22] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[21] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[20] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[19] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[18] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[17] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[16] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[15] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[14] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[13] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[12] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[11] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[10] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[9] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[8] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[31] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufin_reg[30] .sd;

      // release bits of scan chain 14
      //release dut.\instructionreg_reg[0] .sd;
      //release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[15] .sd;
      //release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[14] .sd;
      //release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[13] .sd;
      //release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[12] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[11] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[10] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[9] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[8] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[7] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[6] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[5] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[4] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[3] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[2] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[1] .sd;
      release dut.U_SPI_CO_PROC_IF.\instrbuf_reg[0] .sd;
      release dut.U_SPI_CO_PROC_IF.datacounterlast_reg.sd;
      release dut.U_SPI_CO_PROC_IF.\datacounter_reg[1] .sd;
      release dut.U_SPI_CO_PROC_IF.\datacounter_reg[0] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[31] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[30] .sd;
      release dut.U_SPI_CO_PROC_IF.\databufout_reg[29] .sd;

      // release bits of scan chain 15
      //release dut.\statusreg_alu_reg[7] .sd;
      //release dut.\statusreg_alu_reg[6] .sd;
      //release dut.\statusreg_alu_reg[5] .sd;
      //release dut.\statusreg_alu_reg[4] .sd;
      //release dut.\statusreg_alu_reg[3] .sd;
      release dut.\statusreg_alu_reg[2] .sd;
      release dut.\statusreg_alu_reg[1] .sd;
      release dut.\statusreg_alu_reg[0] .sd;
      release dut.\instructionreg_reg[15] .sd;
      release dut.\instructionreg_reg[14] .sd;
      release dut.\instructionreg_reg[13] .sd;
      release dut.\instructionreg_reg[12] .sd;
      release dut.\instructionreg_reg[11] .sd;
      release dut.\instructionreg_reg[10] .sd;
      release dut.\instructionreg_reg[9] .sd;
      release dut.\instructionreg_reg[8] .sd;
      release dut.\instructionreg_reg[7] .sd;
      release dut.\instructionreg_reg[6] .sd;
      release dut.\instructionreg_reg[5] .sd;
      release dut.\instructionreg_reg[4] .sd;
      release dut.\instructionreg_reg[3] .sd;
      release dut.\instructionreg_reg[2] .sd;
      release dut.\instructionreg_reg[1] .sd;
      #0;

      // handle potential of last N bits shifted serially
      if (NSHIFTS > SHEND) begin
         bit = LENMAX-NSHIFTS; multiple_shift;
      end
   end

   `ifdef tmax_serial_timing
      parameter load_delay = 2500; // equivalent serial simulation load_unload time advance
   `else
      parameter load_delay = 700; // minimal load_unload time advance
   `endif

   task mbyte_task;
      reg[7:0] mc, mb;
      begin
         mc = memdrv[drv]; drv = drv + 1;
         mbyte = 0;
         repeat (mc) begin
            mb = memdrv[drv]; drv = drv + 1;
            mbyte = (mbyte << 8) + mb;
         end
      end
   endtask

   initial begin

      //
      // --- establish a default time format for %t
      //
      $timeformat(-9,2," ns",18);

      //
      // --- default verbosity to 2 but also allow user override by
      //     using '+define+tmax_msg=N' on verilog compile line.
      //
      `ifdef tmax_msg
         verbose = `tmax_msg ;
      `else
         verbose = 2 ;
      `endif

      //
      // --- default pattern reporting interval to 5 but also allow user
      //     override by using '+define+tmax_rpt=N' on verilog compile line.
      //
      `ifdef tmax_rpt
         report_interval = `tmax_rpt ;
      `else
         report_interval = 5 ;
      `endif

      //
      // --- support generating Extened VCD output by using
      //     '+define+tmax_vcde' on verilog compile line.
      //
      `ifdef tmax_vcde
         // extended VCD, see IEEE Verilog P1364.1-1999 Draft 2
         if (verbose >= 2) $display("// %t : opening Extended VCD output file", $time);
         $dumpports( dut, "sim_vcde.out");
      `endif

      //
      // --- IDDQ PLI initialization
      //     User may activite by using '+define+tmax_iddq' on verilog compile line.
      //     Or by defining `tmax_iddq in this file.
      //
      `ifdef tmax_iddq
         if (verbose >= 3) $display("// %t : Initializing IDDQ PLI", $time);
         $ssi_iddq("dut tb.dut");
         $ssi_iddq("verb on");
         $ssi_iddq("cycle 0");
         //
         // --- User may select one of the following two methods for fault seeding:
         //     #1 faults seeded by PLI (default)
         //     #2 faults supplied in a file
         //     Comment out the unused lines as needed (precede with '//').
         //     Replace the 'FAULTLIST_FILE' string with the actual file pathname.
         //
         $ssi_iddq("seed SA tb.dut");   // no file, faults seeded by PLI
         //
         // $ssi_iddq("scope tb.dut");   // set scope for faults from a file
         // $ssi_iddq("read_tmax FAULTLIST_FILE"); // read faults from a file
         //
      `endif

      POnames[0] = "sdo";
      POnames[1] = "debug[2]";
      POnames[2] = "debug[1]";
      POnames[3] = "debug[0]";
      POnames[4] = "test_so1";
      POnames[5] = "test_so2";
      POnames[6] = "test_so3";
      POnames[7] = "test_so4";
      POnames[8] = "test_so5";
      POnames[9] = "test_so6";
      POnames[10] = "test_so7";
      POnames[11] = "test_so8";
      POnames[12] = "test_so9";
      POnames[13] = "test_so10";
      POnames[14] = "test_so11";
      POnames[15] = "test_so12";
      POnames[16] = "test_so13";
      POnames[17] = "test_so14";
      POnames[18] = "test_so15";
      POnames[19] = "test_so16";
      CHAINnames[0] = "1";
      CHAINnames[1] = "2";
      CHAINnames[2] = "3";
      CHAINnames[3] = "4";
      CHAINnames[4] = "5";
      CHAINnames[5] = "6";
      CHAINnames[6] = "7";
      CHAINnames[7] = "8";
      CHAINnames[8] = "9";
      CHAINnames[9] = "10";
      CHAINnames[10] = "11";
      CHAINnames[11] = "12";
      CHAINnames[12] = "13";
      CHAINnames[13] = "14";
      CHAINnames[14] = "15";
      CHAINnames[15] = "16";
      CHAINpins[0] = "test_so1";
      CHAINpins[1] = "test_so2";
      CHAINpins[2] = "test_so3";
      CHAINpins[3] = "test_so4";
      CHAINpins[4] = "test_so5";
      CHAINpins[5] = "test_so6";
      CHAINpins[6] = "test_so7";
      CHAINpins[7] = "test_so8";
      CHAINpins[8] = "test_so9";
      CHAINpins[9] = "test_so10";
      CHAINpins[10] = "test_so11";
      CHAINpins[11] = "test_so12";
      CHAINpins[12] = "test_so13";
      CHAINpins[13] = "test_so14";
      CHAINpins[14] = "test_so15";
      CHAINpins[15] = "test_so16";
      SERIALM = 24'b000001111111111111111111;
      INPINV[0] = 24'b000000000000000000000000;
      OUTINV[0] = 24'b000000000000000000000000;
      SHBEGM[0] = 24'b000000000000000000000000;
      INPINV[1] = 24'b000000000000000000000000;
      OUTINV[1] = 24'b000000000000000000000000;
      SHBEGM[1] = 24'b000000000000000000000000;
      INPINV[2] = 24'b000000000000000000000000;
      OUTINV[2] = 24'b000000000000000000000000;
      SHBEGM[2] = 24'b000000000000000000000000;
      INPINV[3] = 24'b000000000000000000000000;
      OUTINV[3] = 24'b000000000000000000000000;
      SHBEGM[3] = 24'b000000000000000000000000;
      INPINV[4] = 24'b000000000000000000000000;
      OUTINV[4] = 24'b000000000000000000000000;
      SHBEGM[4] = 24'b000000000000000000000000;
      INPINV[5] = 24'b000000000000000000000000;
      OUTINV[5] = 24'b000000000000000000000000;
      SHBEGM[5] = 24'b000000000000000000000000;
      INPINV[6] = 24'b000000000000000000000000;
      OUTINV[6] = 24'b000000000000000000000000;
      SHBEGM[6] = 24'b000000000000000000000000;
      INPINV[7] = 24'b000000000000000000000000;
      OUTINV[7] = 24'b000000000000000000000000;
      SHBEGM[7] = 24'b000000000000000000000000;
      INPINV[8] = 24'b000000000000000000000000;
      OUTINV[8] = 24'b000000000000000000000000;
      SHBEGM[8] = 24'b000000000000000000000000;
      INPINV[9] = 24'b000000000000000000000000;
      OUTINV[9] = 24'b000000000000000000000000;
      SHBEGM[9] = 24'b000000000000000000000000;
      INPINV[10] = 24'b000000000000000000000000;
      OUTINV[10] = 24'b100000000000000000000000;
      SHBEGM[10] = 24'b000000000000000000000000;
      INPINV[11] = 24'b000000001011101010101010;
      OUTINV[11] = 24'b000000001011100110001010;
      SHBEGM[11] = 24'b000000000000000000000000;
      INPINV[12] = 24'b000000000000000000000000;
      OUTINV[12] = 24'b000000000000000000000000;
      SHBEGM[12] = 24'b000000000000000000000000;
      INPINV[13] = 24'b000000000000000000000000;
      OUTINV[13] = 24'b000000000000000000000000;
      SHBEGM[13] = 24'b000000000000000000000000;
      INPINV[14] = 24'b001010101000000000010000;
      OUTINV[14] = 24'b001010101000000000010000;
      SHBEGM[14] = 24'b000000000000000000000000;
      INPINV[15] = 24'b000000000000000000000000;
      OUTINV[15] = 24'b000000000000000000000000;
      SHBEGM[15] = 24'b000000000000000000000000;
      nofails = 0; pattern = -1; lastpattern = 0;
      prev_pat = -2; error_banner = -2;

      if (verbose >=1) $display("// %t : Begin test_setup", $time);
      ->test_setup;
      #200; // 200

      if (verbose >= 3) $display("// %t : reading pattern scan data file", $time);
      $readmemh("pat/atpg_patterns_par.scn", memscn);
      if (verbose >= 3) $display("// %t : reading pattern PI data file", $time);
      $readmemb("pat/atpg_patterns_par.pis", mempis);
      if (verbose >= 3) $display("// %t : reading pattern PO data file", $time);
      $readmemb("pat/atpg_patterns_par.pos", mempos);
      if (verbose >= 3) $display("// %t : reading pattern sequencer file", $time);
      $readmemh("pat/atpg_patterns_par.seq", memdrv);
      scn = 1; pis = 1; pos = 1; drv = 1;

      /*** Scan test ***/

      if (verbose >= 1) $display("// %t : Begin patterns, first pattern = 0", $time);
      pattern = -1; lastpattern = 0;
      while (lastpattern >=0) begin
         drval = memdrv[drv];
         if (verbose >= 5) $display("// %t : 0x%0h is %0d sequencer value",$time,drval,drv);
         drv = drv + 1;
         case (drval)
            'h0: begin pattern = pattern + 1; end
            'h1: begin lastpattern = 1; end
            'h2: lastpattern = -1; // break
            'h3: begin #0 PI = mempis[pis]; pis = pis + 1; end
            'h4: begin ALLPIS = mempis[pis]; pis = pis + 1; end
            'h5: begin XPCT = mempos[pos]; pos = pos + 1; MASK = mempos[pos]; pos = pos + 1; end
            'h6: MASK = 20'b0;
            'h7: begin
               LOAD0 = memscn[scn]; scn = scn + 1;
               LOAD1 = memscn[scn]; scn = scn + 1;
               LOAD2 = memscn[scn]; scn = scn + 1;
               LOAD3 = memscn[scn]; scn = scn + 1;
               LOAD4 = memscn[scn]; scn = scn + 1;
               LOAD5 = memscn[scn]; scn = scn + 1;
               LOAD6 = memscn[scn]; scn = scn + 1;
               LOAD7 = memscn[scn]; scn = scn + 1;
               LOAD8 = memscn[scn]; scn = scn + 1;
               LOAD9 = memscn[scn]; scn = scn + 1;
               LOAD10 = memscn[scn]; scn = scn + 1;
               LOAD11 = memscn[scn]; scn = scn + 1;
               LOAD12 = memscn[scn]; scn = scn + 1;
               LOAD13 = memscn[scn]; scn = scn + 1;
               LOAD14 = memscn[scn]; scn = scn + 1;
               LOAD15 = memscn[scn]; scn = scn + 1;
                 end
            'h8: begin
               UNLOAD[0] = memscn[scn]; scn = scn + 1;
               UNLMSK[0] = memscn[scn]; scn = scn + 1;
               UNLOAD[1] = memscn[scn]; scn = scn + 1;
               UNLMSK[1] = memscn[scn]; scn = scn + 1;
               UNLOAD[2] = memscn[scn]; scn = scn + 1;
               UNLMSK[2] = memscn[scn]; scn = scn + 1;
               UNLOAD[3] = memscn[scn]; scn = scn + 1;
               UNLMSK[3] = memscn[scn]; scn = scn + 1;
               UNLOAD[4] = memscn[scn]; scn = scn + 1;
               UNLMSK[4] = memscn[scn]; scn = scn + 1;
               UNLOAD[5] = memscn[scn]; scn = scn + 1;
               UNLMSK[5] = memscn[scn]; scn = scn + 1;
               UNLOAD[6] = memscn[scn]; scn = scn + 1;
               UNLMSK[6] = memscn[scn]; scn = scn + 1;
               UNLOAD[7] = memscn[scn]; scn = scn + 1;
               UNLMSK[7] = memscn[scn]; scn = scn + 1;
               UNLOAD[8] = memscn[scn]; scn = scn + 1;
               UNLMSK[8] = memscn[scn]; scn = scn + 1;
               UNLOAD[9] = memscn[scn]; scn = scn + 1;
               UNLMSK[9] = memscn[scn]; scn = scn + 1;
               UNLOAD[10] = memscn[scn]; scn = scn + 1;
               UNLMSK[10] = memscn[scn]; scn = scn + 1;
               UNLOAD[11] = memscn[scn]; scn = scn + 1;
               UNLMSK[11] = memscn[scn]; scn = scn + 1;
               UNLOAD[12] = memscn[scn]; scn = scn + 1;
               UNLMSK[12] = memscn[scn]; scn = scn + 1;
               UNLOAD[13] = memscn[scn]; scn = scn + 1;
               UNLMSK[13] = memscn[scn]; scn = scn + 1;
               UNLOAD[14] = memscn[scn]; scn = scn + 1;
               UNLMSK[14] = memscn[scn]; scn = scn + 1;
               UNLOAD[15] = memscn[scn]; scn = scn + 1;
               UNLMSK[15] = memscn[scn]; scn = scn + 1;
                 end
            'h9: begin
               UNLMSK[0] = 24'b0;
               UNLMSK[1] = 24'b0;
               UNLMSK[2] = 24'b0;
               UNLMSK[3] = 24'b0;
               UNLMSK[4] = 24'b0;
               UNLMSK[5] = 24'b0;
               UNLMSK[6] = 24'b0;
               UNLMSK[7] = 24'b0;
               UNLMSK[8] = 24'b0;
               UNLMSK[9] = 24'b0;
               UNLMSK[10] = 24'b0;
               UNLMSK[11] = 24'b0;
               UNLMSK[12] = 24'b0;
               UNLMSK[13] = 24'b0;
               UNLMSK[14] = 24'b0;
               UNLMSK[15] = 24'b0;
                 end
            'hA: #100;
            'hB: #60;
            'hF: begin #0; ->pulse_clk; end
            'h10: begin #0; ->pulse_rst_n; end
            'h11: begin #0; ->measurePO; #0; end
            'h12: begin #0; ->forcePI_default_WFT; #0; end
            'h13: begin #0; ->measurePO_default_WFT; #0; end
            'h14: begin #0; ->force_scanin; #0; end
            'h15: begin #0; ->measure_scanout; #0; end
            'h16: begin #0; ->IDDQ; #0; end
            'h17: begin #0; ->capture; #200; end
            'h18: begin #0; ->capture_clk; #300; end
            'h19: begin #0; ->capture_rst_n; #300; end
            'h1A: begin #0; shift; #0; end
            'h1B: begin #0; ->test_setup; #200; end
            'h1C: begin #0; multiple_shift; #0; end
            'h1D: begin #0; ->load_unload; #load_delay; end
            'hF0: begin verbose = 0; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF1: begin verbose = 1; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF2: begin verbose = 2; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF3: begin verbose = 3; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF4: begin verbose = 4; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF5: begin verbose = 5; $display("// %t : verbosity = %0d", $time, verbose); end
            default: begin $display($time, " Unrecognized code %0h", drval); $finish; end
         endcase
      end /* while */
      $display("// %t : Simulation of %0d patterns completed with %0d errors\n", $time, pattern+1, nofails);
      if (verbose >=2) $finish(2);
      /* else */ $finish(0);
   end
endmodule
