// Verilog pattern output written by  TetraMAX (TM)  Y-2006.06-SP2-i060901_230703 
// Date: Wed Apr 23 11:17:20 2008
// Module tested: spi_co_processor

//     Uncollapsed Stuck Fault Summary Report
// -----------------------------------------------
// fault class                     code   #faults
// ------------------------------  ----  ---------
// Detected                         DT     101545
//   detected_by_simulation         DS     (95259)
//   detected_by_implication        DI      (6286)
// Possibly detected                PT          0
// Undetectable                     UD         72
//   undetectable-tied              UT         (5)
//   undetectable-redundant         UR        (67)
// ATPG untestable                  AU          3
//   atpg_untestable-not_detected   AN         (3)
// Not detected                     ND         50
//   not-observed                   NO        (50)
// -----------------------------------------------
// total faults                            101670
// test coverage                            99.95%
// -----------------------------------------------
// 
//            Pattern Summary Report
// -----------------------------------------------
// #internal patterns                         276
//     #basic_scan patterns                   276
// -----------------------------------------------
// 
// rule  severity  #fails  description
// ----  --------  ------  ---------------------------------
// B7    warning        4  undriven module output pin
// B8    warning       21  unconnected module input pin
// B9    warning       10  undriven module internal net
// B10   warning       14  unconnected module internal net
// 
// clock_name        off  usage
// ----------------  ---  --------------------------
// clk                0   master shift nonscan_DLAT 
// rst_n              1   master reset 
// 
// There are no constraint ports
// There are no equivalent pins
// There are no net connections

`timescale 1 ns / 1 ns

//
// --- NOTE: Remove the comment to define 'tmax_iddq' to activate processing of IDDQ events
//     Or use '+define+tmax_iddq' on the verilog compile line
//
//`define tmax_iddq

//
// --- User adjustable extension to state sequencer table for debug purposes.
//     Adjusts oversizing of 'memdrv[]' to make room for manually inserted values.
//
`ifdef tmax_state_dbg
   /* user has used compile time overide of form:  +define+tmax_state_dbg=10 */
`else
   /* default to 5 */
   `define tmax_state_dbg 5
`endif

module tb ;
   parameter NAMELENGTH = 200; // max length of names reported in fails
   parameter LENMAX = 23, NSHIFTS = 23; // LENMAX for serial
   parameter LENSERIAL = 23, NCHAINS = 32;
   parameter SHBEG = 0, SHEND = 0;
   integer nofails, bit, cbit, pattern, lastpattern, chain, idx;
   integer error_banner; // flag for tracking displayed error banner
   integer loads;        // number of load_unloads for current pattern
   integer patm1;        // pattern - 1
   integer patp1;        // pattern + lastpattern
   integer prev_pat;     // previous pattern number
   integer report_interval; // report pattern progress every Nth pattern
   integer verbose;      // message verbosity level
   parameter NINPUTS = 38, NOUTPUTS = 35;
   wire [0:NOUTPUTS-1] PO; reg [0:NOUTPUTS-1] ALLPOS, XPCT, MASK;
   reg [0:NINPUTS-1] PI, ALLPIS;
   integer scn, pis, pos, drv, mbyte;
   reg [0:NINPUTS-1] mempis [1:276];
   reg [0:NOUTPUTS-1] mempos [1:552];
   reg [7:0] drval, memdrv [1:3038+`tmax_state_dbg];
   reg [0:LENSERIAL-1] memscn [1:26528];
   reg [0:8*(NAMELENGTH-1)] POnames [0:NOUTPUTS-1];
   reg [0:8*(NAMELENGTH-1)] CHAINnames [0:NCHAINS-1];
   reg [0:8*(NAMELENGTH-1)] CHAINpins [0:NCHAINS-1];
   reg [0:LENSERIAL-1] LOAD0, LOADSH0, LOAD1, LOADSH1, LOAD2, LOADSH2, LOAD3,
   LOADSH3, LOAD4, LOADSH4, LOAD5, LOADSH5, LOAD6, LOADSH6, LOAD7, LOADSH7, LOAD8,
   LOADSH8, LOAD9, LOADSH9, LOAD10, LOADSH10, LOAD11, LOADSH11, LOAD12, LOADSH12,
   LOAD13, LOADSH13, LOAD14, LOADSH14, LOAD15, LOADSH15, LOAD16, LOADSH16, LOAD17,
   LOADSH17, LOAD18, LOADSH18, LOAD19, LOADSH19, LOAD20, LOADSH20, LOAD21,
   LOADSH21, LOAD22, LOADSH22, LOAD23, LOADSH23, LOAD24, LOADSH24, LOAD25,
   LOADSH25, LOAD26, LOADSH26, LOAD27, LOADSH27, LOAD28, LOADSH28, LOAD29,
   LOADSH29, LOAD30, LOADSH30, LOAD31, LOADSH31;
   reg [0:LENMAX-1] UNL, UNLOAD[0:NCHAINS-1];
   reg [0:LENMAX-1] UNLM, UNLMSK[0:NCHAINS-1], SHBEGM[0:NCHAINS-1];
   reg [0:LENMAX-1] SERIALM;
   reg [0:LENMAX-1] INPINV[0:NCHAINS-1], OUTINV[0:NCHAINS-1];
   wire [0:NCHAINS-1] SCANOUT;
   event IDDQ;

   wire sdo;
   wire rst_n;
   wire clk;
   wire sdi;
   wire ss_n;
   wire sclk;
   wire test_se;
   wire test_si1;
   wire test_so1;
   wire test_si2;
   wire test_so2;
   wire test_si3;
   wire test_so3;
   wire test_si4;
   wire test_so4;
   wire test_si5;
   wire test_so5;
   wire test_si6;
   wire test_so6;
   wire test_si7;
   wire test_so7;
   wire test_si8;
   wire test_so8;
   wire test_si9;
   wire test_so9;
   wire test_si10;
   wire test_so10;
   wire test_si11;
   wire test_so11;
   wire test_si12;
   wire test_so12;
   wire test_si13;
   wire test_so13;
   wire test_si14;
   wire test_so14;
   wire test_si15;
   wire test_so15;
   wire test_si16;
   wire test_so16;
   wire test_si17;
   wire test_so17;
   wire test_si18;
   wire test_so18;
   wire test_si19;
   wire test_so19;
   wire test_si20;
   wire test_so20;
   wire test_si21;
   wire test_so21;
   wire test_si22;
   wire test_so22;
   wire test_si23;
   wire test_so23;
   wire test_si24;
   wire test_so24;
   wire test_si25;
   wire test_so25;
   wire test_si26;
   wire test_so26;
   wire test_si27;
   wire test_so27;
   wire test_si28;
   wire test_so28;
   wire test_si29;
   wire test_si30;
   wire test_so30;
   wire test_si31;
   wire test_so31;
   wire test_si32;
   wire test_so32;
   wire [2:0] debug;

   // map PI[] vector to DUT inputs and bidis
   assign rst_n = PI[0];
   assign clk = PI[1];
   assign sdi = PI[2];
   assign ss_n = PI[3];
   assign sclk = PI[4];
   assign test_se = PI[5];
   assign test_si1 = PI[6];
   assign test_si2 = PI[7];
   assign test_si3 = PI[8];
   assign test_si4 = PI[9];
   assign test_si5 = PI[10];
   assign test_si6 = PI[11];
   assign test_si7 = PI[12];
   assign test_si8 = PI[13];
   assign test_si9 = PI[14];
   assign test_si10 = PI[15];
   assign test_si11 = PI[16];
   assign test_si12 = PI[17];
   assign test_si13 = PI[18];
   assign test_si14 = PI[19];
   assign test_si15 = PI[20];
   assign test_si16 = PI[21];
   assign test_si17 = PI[22];
   assign test_si18 = PI[23];
   assign test_si19 = PI[24];
   assign test_si20 = PI[25];
   assign test_si21 = PI[26];
   assign test_si22 = PI[27];
   assign test_si23 = PI[28];
   assign test_si24 = PI[29];
   assign test_si25 = PI[30];
   assign test_si26 = PI[31];
   assign test_si27 = PI[32];
   assign test_si28 = PI[33];
   assign test_si29 = PI[34];
   assign test_si30 = PI[35];
   assign test_si31 = PI[36];
   assign test_si32 = PI[37];

   // map DUT outputs and bidis to PO[] vector
   assign
      PO[0] = sdo ,
      PO[1] = debug[2] ,
      PO[2] = debug[1] ,
      PO[3] = debug[0] ,
      PO[4] = test_so1 ,
      PO[5] = test_so2 ,
      PO[6] = test_so3 ,
      PO[7] = test_so4 ,
      PO[8] = test_so5 ,
      PO[9] = test_so6 ,
      PO[10] = test_so7 ,
      PO[11] = test_so8 ,
      PO[12] = test_so9 ,
      PO[13] = test_so10 ,
      PO[14] = test_so11 ,
      PO[15] = test_so12 ,
      PO[16] = test_so13 ,
      PO[17] = test_so14 ,
      PO[18] = test_so15 ,
      PO[19] = test_so16 ,
      PO[20] = test_so17 ,
      PO[21] = test_so18 ,
      PO[22] = test_so19 ,
      PO[23] = test_so20 ,
      PO[24] = test_so21 ,
      PO[25] = test_so22 ,
      PO[26] = test_so23 ,
      PO[27] = test_so24 ,
      PO[28] = test_so25 ,
      PO[29] = test_so26 ,
      PO[30] = test_so27 ,
      PO[31] = test_so28 ;
   assign
      PO[32] = test_so30 ,
      PO[33] = test_so31 ,
      PO[34] = test_so32 ;

   // instantiate the design into the testbench
   spi_co_processor dut (
      .sdo(sdo),
      .debug(debug),
      .rst_n(rst_n),
      .clk(clk),
      .sdi(sdi),
      .ss_n(ss_n),
      .sclk(sclk),
      .test_se(test_se),
      .test_si1(test_si1),
      .test_so1(test_so1),
      .test_si2(test_si2),
      .test_so2(test_so2),
      .test_si3(test_si3),
      .test_so3(test_so3),
      .test_si4(test_si4),
      .test_so4(test_so4),
      .test_si5(test_si5),
      .test_so5(test_so5),
      .test_si6(test_si6),
      .test_so6(test_so6),
      .test_si7(test_si7),
      .test_so7(test_so7),
      .test_si8(test_si8),
      .test_so8(test_so8),
      .test_si9(test_si9),
      .test_so9(test_so9),
      .test_si10(test_si10),
      .test_so10(test_so10),
      .test_si11(test_si11),
      .test_so11(test_so11),
      .test_si12(test_si12),
      .test_so12(test_so12),
      .test_si13(test_si13),
      .test_so13(test_so13),
      .test_si14(test_si14),
      .test_so14(test_so14),
      .test_si15(test_si15),
      .test_so15(test_so15),
      .test_si16(test_si16),
      .test_so16(test_so16),
      .test_si17(test_si17),
      .test_so17(test_so17),
      .test_si18(test_si18),
      .test_so18(test_so18),
      .test_si19(test_si19),
      .test_so19(test_so19),
      .test_si20(test_si20),
      .test_so20(test_so20),
      .test_si21(test_si21),
      .test_so21(test_so21),
      .test_si22(test_si22),
      .test_so22(test_so22),
      .test_si23(test_si23),
      .test_so23(test_so23),
      .test_si24(test_si24),
      .test_so24(test_so24),
      .test_si25(test_si25),
      .test_so25(test_so25),
      .test_si26(test_si26),
      .test_so26(test_so26),
      .test_si27(test_si27),
      .test_so27(test_so27),
      .test_si28(test_si28),
      .test_so28(test_so28),
      .test_si29(test_si29),
      .test_si30(test_si30),
      .test_so30(test_so30),
      .test_si31(test_si31),
      .test_so31(test_so31),
      .test_si32(test_si32),
      .test_so32(test_so32)   );

   event pulse_clk;
   always @ pulse_clk begin
      #45 PI[1] = 1; #10 PI[1] = 0;   // clk
   end

   event pulse_rst_n;
   always @ pulse_rst_n begin
      #45 PI[0] = 0; #10 PI[0] = 1;   // rst_n
   end


   integer errshown;
   event measurePO;
   always @ measurePO begin
      if (((XPCT&MASK) !== (ALLPOS&MASK)) || (XPCT !== (~(~XPCT)))) begin
         errshown = 0;
         for (bit = 0; bit < NOUTPUTS; bit=bit + 1) begin
            if (MASK[bit]==1'b1) begin
               if (XPCT[bit] !== ALLPOS[bit]) begin
                  if (errshown==0) $display("\n// *** ERROR during capture pattern %0d, T=%t", pattern, $time);
                  $display("  %0d %0s (exp=%b, got=%b)", pattern, POnames[bit], XPCT[bit], ALLPOS[bit]);
                  nofails = nofails + 1; errshown = 1;
               end
            end
         end
      end
   end

   event forcePI_default_WFT;
   always @ forcePI_default_WFT begin
      PI = ALLPIS;
   end
   event measurePO_default_WFT;
   always @ measurePO_default_WFT begin
      #40;
      ALLPOS = PO;
      #0; #0 -> measurePO;
      `ifdef tmax_iddq
         #0; ->IDDQ;
      `endif
   end

   event force_scanin;
   always @ force_scanin begin
      PI[6] <= LOAD0[bit];
      PI[7] <= LOAD1[bit];
      PI[8] <= LOAD2[bit];
      PI[9] <= LOAD3[bit];
      PI[10] <= LOAD4[bit];
      PI[11] <= LOAD5[bit];
      PI[12] <= LOAD6[bit];
      PI[13] <= LOAD7[bit];
      PI[14] <= LOAD8[bit];
      PI[15] <= LOAD9[bit];
      PI[16] <= LOAD10[bit];
      PI[17] <= LOAD11[bit];
      PI[18] <= LOAD12[bit];
      PI[19] <= LOAD13[bit];
      PI[20] <= LOAD14[bit];
      PI[21] <= LOAD15[bit];
      PI[22] <= LOAD16[bit];
      PI[23] <= LOAD17[bit];
      PI[24] <= LOAD18[bit];
      PI[25] <= LOAD19[bit];
      PI[26] <= LOAD20[bit];
      PI[27] <= LOAD21[bit];
      PI[28] <= LOAD22[bit];
      PI[29] <= LOAD23[bit];
      PI[30] <= LOAD24[bit];
      PI[31] <= LOAD25[bit];
      PI[32] <= LOAD26[bit];
      PI[33] <= LOAD27[bit];
      PI[34] <= LOAD28[bit];
      PI[35] <= LOAD29[bit];
      PI[36] <= LOAD30[bit];
      PI[37] <= LOAD31[bit];
   end

   assign SCANOUT[0] = test_so1,  SCANOUT[1] = test_so2,  SCANOUT[2] = test_so3,
           SCANOUT[3] = test_so4,  SCANOUT[4] = test_so5,  SCANOUT[5] = test_so6,
           SCANOUT[6] = test_so7,  SCANOUT[7] = test_so8,  SCANOUT[8] = test_so9,
           SCANOUT[9] = test_so10,  SCANOUT[10] = test_so11,  SCANOUT[11] = test_so12,
           SCANOUT[12] = test_so13,  SCANOUT[13] = test_so14,  SCANOUT[14] = test_so15,
           SCANOUT[15] = test_so16,  SCANOUT[16] = test_so17,  SCANOUT[17] = test_so18,
           SCANOUT[18] = test_so19,  SCANOUT[19] = test_so20,  SCANOUT[20] = test_so21,
           SCANOUT[21] = test_so22,  SCANOUT[22] = test_so23,  SCANOUT[23] = test_so24,
           SCANOUT[24] = test_so25,  SCANOUT[25] = test_so26,  SCANOUT[26] = test_so27,
           SCANOUT[27] = test_so28,  SCANOUT[28] = debug[2],  SCANOUT[29] = test_so30,
           SCANOUT[30] = test_so31,  SCANOUT[31] = test_so32;

   event measure_scanout;
   always @ measure_scanout begin
      if ((NSHIFTS < LENMAX) && (bit >= SHBEG)) cbit = bit - LENMAX + NSHIFTS + 1 + SHBEG;
      else cbit = bit; // because parallel does NSHIFTS + 1 shifts
      idx = cbit + 0;
      for (chain = 0; chain < 32; chain=chain + 1) begin
         UNL = UNLOAD[chain]; UNLM = UNLMSK[chain];
         if ((UNL[idx]&UNLM[idx]) !== (SCANOUT[chain]&UNLM[idx])) begin
            patp1 = pattern + lastpattern;  patm1 = patp1 - 1;
            if (error_banner != pattern) begin
               if (lastpattern == 0) $display("\n// *** ERROR during scan pattern %0d (detected during load of pattern %0d)", patm1, patp1);
               else $display("\n// *** ERROR during scan pattern %0d (detected during final pattern unload)", patm1);
               error_banner = pattern;
            end
            $display("  %0d %0s %0d (exp=%b, got=%b)  // pin %0s, scan cell %0d, T=%t",
               patm1, CHAINnames[chain], cbit, UNL[idx], SCANOUT[chain], CHAINpins[chain], cbit, $time);
            nofails = nofails + 1;
         end
      end
   end


   always @ IDDQ begin
   `ifdef tmax_iddq
      $ssi_iddq("strobe_try");
      $ssi_iddq("status drivers leaky tb.leaky");
   `endif
   end

   event capture;
   always @ capture begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
   end

   event capture_clk;
   always @ capture_clk begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
      #145 PI[1] = 1; // clk
      #10 PI[1] = 0; // clk
   end

   event capture_rst_n;
   always @ capture_rst_n begin
      ->forcePI_default_WFT;
      #100; ->measurePO_default_WFT;
      #145 PI[0] = 0; // rst_n
      #10 PI[0] = 1; // rst_n
   end

   task shift;
   begin
      if (verbose >= 4) $display("// %t :    shift %0d", $time, bit);
      #0 PI[0] = 1; // rst_n
      ->force_scanin;
      #40; ->measure_scanout;
      #5 PI[1] = 1; // clk
      #10 PI[1] = 0; // clk
      #45;
   end
   endtask

   event test_setup;
   always @ test_setup begin
      #0 PI[1] = 0; // clk
      #0 PI[0] = 1; // rst_n
      #0 PI[4] = 1'bX; // sclk
      #0 PI[2] = 1'bX; // sdi
      #0 PI[3] = 1'bX; // ss_n
      #0 PI[5] = 1'bX; // test_se
      #0 PI[6] = 1'bX; // test_si1
      #0 PI[7] = 1'bX; // test_si2
      #0 PI[8] = 1'bX; // test_si3
      #0 PI[9] = 1'bX; // test_si4
      #0 PI[10] = 1'bX; // test_si5
      #0 PI[11] = 1'bX; // test_si6
      #0 PI[12] = 1'bX; // test_si7
      #0 PI[13] = 1'bX; // test_si8
      #0 PI[14] = 1'bX; // test_si9
      #0 PI[15] = 1'bX; // test_si10
      #0 PI[16] = 1'bX; // test_si11
      #0 PI[17] = 1'bX; // test_si12
      #0 PI[18] = 1'bX; // test_si13
      #0 PI[19] = 1'bX; // test_si14
      #0 PI[20] = 1'bX; // test_si15
      #0 PI[21] = 1'bX; // test_si16
      #0 PI[22] = 1'bX; // test_si17
      #0 PI[23] = 1'bX; // test_si18
      #0 PI[24] = 1'bX; // test_si19
      #0 PI[25] = 1'bX; // test_si20
      #0 PI[26] = 1'bX; // test_si21
      #0 PI[27] = 1'bX; // test_si22
      #0 PI[28] = 1'bX; // test_si23
      #0 PI[29] = 1'bX; // test_si24
      #0 PI[30] = 1'bX; // test_si25
      #0 PI[31] = 1'bX; // test_si26
      #0 PI[32] = 1'bX; // test_si27
      #0 PI[33] = 1'bX; // test_si28
      #0 PI[34] = 1'bX; // test_si29
      #0 PI[35] = 1'bX; // test_si30
      #0 PI[36] = 1'bX; // test_si31
      #0 PI[37] = 1'bX; // test_si32
   end


   task multiple_shift;
   begin
      bit = bit-1;
      error_banner = -2;
      while (bit+1 < LENMAX-SHEND) begin
         bit = bit+1;
         shift;
      end
   end
   endtask

   event load_unload;
   always @ load_unload begin
      if (pattern != prev_pat) begin
         loads = 1;
         prev_pat = pattern;
         if ((verbose >= 2) && (pattern % report_interval == 0))
            $display("// %t : ...begin scan load for pattern %0d", $time, pattern);
         end
      else begin
         loads = loads + 1;
         if ((verbose >= 2) && (pattern % report_interval == 0))
            $display("// %t : ...begin scan load for pattern %0d, load %0d", $time, pattern, loads);
      end

      #0 PI[1] = 0; // clk
      #0 PI[0] = 1; // rst_n
      #0 PI[6] = 1'bX; // test_si1
      #0 PI[7] = 1'bX; // test_si2
      #0 PI[8] = 1'bX; // test_si3
      #0 PI[9] = 1'bX; // test_si4
      #0 PI[10] = 1'bX; // test_si5
      #0 PI[11] = 1'bX; // test_si6
      #0 PI[12] = 1'bX; // test_si7
      #0 PI[13] = 1'bX; // test_si8
      #0 PI[14] = 1'bX; // test_si9
      #0 PI[15] = 1'bX; // test_si10
      #0 PI[16] = 1'bX; // test_si11
      #0 PI[17] = 1'bX; // test_si12
      #0 PI[18] = 1'bX; // test_si13
      #0 PI[19] = 1'bX; // test_si14
      #0 PI[20] = 1'bX; // test_si15
      #0 PI[21] = 1'bX; // test_si16
      #0 PI[22] = 1'bX; // test_si17
      #0 PI[23] = 1'bX; // test_si18
      #0 PI[24] = 1'bX; // test_si19
      #0 PI[25] = 1'bX; // test_si20
      #0 PI[26] = 1'bX; // test_si21
      #0 PI[27] = 1'bX; // test_si22
      #0 PI[28] = 1'bX; // test_si23
      #0 PI[29] = 1'bX; // test_si24
      #0 PI[30] = 1'bX; // test_si25
      #0 PI[31] = 1'bX; // test_si26
      #0 PI[32] = 1'bX; // test_si27
      #0 PI[33] = 1'bX; // test_si28
      #0 PI[34] = 1'bX; // test_si29
      #0 PI[35] = 1'bX; // test_si30
      #0 PI[36] = 1'bX; // test_si31
      #0 PI[37] = 1'bX; // test_si32
      #0 PI[5] = 1; // test_se
      #0 PI[4] = 1'bX; // sclk
      #0 PI[2] = 1'bX; // sdi
      #0 PI[3] = 1'bX; // ss_n
      #100;
      // end of load_unload preamble
      bit = SHBEG; multiple_shift;
   end


   task mbyte_task;
      reg[7:0] mc, mb;
      begin
         mc = memdrv[drv]; drv = drv + 1;
         mbyte = 0;
         repeat (mc) begin
            mb = memdrv[drv]; drv = drv + 1;
            mbyte = (mbyte << 8) + mb;
         end
      end
   endtask

   initial begin

      //
      // --- establish a default time format for %t
      //
      $timeformat(-9,2," ns",18);

      //
      // --- default verbosity to 2 but also allow user override by
      //     using '+define+tmax_msg=N' on verilog compile line.
      //
      `ifdef tmax_msg
         verbose = `tmax_msg ;
      `else
         verbose = 2 ;
      `endif

      //
      // --- default pattern reporting interval to 5 but also allow user
      //     override by using '+define+tmax_rpt=N' on verilog compile line.
      //
      `ifdef tmax_rpt
         report_interval = `tmax_rpt ;
      `else
         report_interval = 5 ;
      `endif

      //
      // --- support generating Extened VCD output by using
      //     '+define+tmax_vcde' on verilog compile line.
      //
      `ifdef tmax_vcde
         // extended VCD, see IEEE Verilog P1364.1-1999 Draft 2
         if (verbose >= 2) $display("// %t : opening Extended VCD output file", $time);
         $dumpports( dut, "sim_vcde.out");
      `endif

      //
      // --- IDDQ PLI initialization
      //     User may activite by using '+define+tmax_iddq' on verilog compile line.
      //     Or by defining `tmax_iddq in this file.
      //
      `ifdef tmax_iddq
         if (verbose >= 3) $display("// %t : Initializing IDDQ PLI", $time);
         $ssi_iddq("dut tb.dut");
         $ssi_iddq("verb on");
         $ssi_iddq("cycle 0");
         //
         // --- User may select one of the following two methods for fault seeding:
         //     #1 faults seeded by PLI (default)
         //     #2 faults supplied in a file
         //     Comment out the unused lines as needed (precede with '//').
         //     Replace the 'FAULTLIST_FILE' string with the actual file pathname.
         //
         $ssi_iddq("seed SA tb.dut");   // no file, faults seeded by PLI
         //
         // $ssi_iddq("scope tb.dut");   // set scope for faults from a file
         // $ssi_iddq("read_tmax FAULTLIST_FILE"); // read faults from a file
         //
      `endif

      POnames[0] = "sdo";
      POnames[1] = "debug[2]";
      POnames[2] = "debug[1]";
      POnames[3] = "debug[0]";
      POnames[4] = "test_so1";
      POnames[5] = "test_so2";
      POnames[6] = "test_so3";
      POnames[7] = "test_so4";
      POnames[8] = "test_so5";
      POnames[9] = "test_so6";
      POnames[10] = "test_so7";
      POnames[11] = "test_so8";
      POnames[12] = "test_so9";
      POnames[13] = "test_so10";
      POnames[14] = "test_so11";
      POnames[15] = "test_so12";
      POnames[16] = "test_so13";
      POnames[17] = "test_so14";
      POnames[18] = "test_so15";
      POnames[19] = "test_so16";
      POnames[20] = "test_so17";
      POnames[21] = "test_so18";
      POnames[22] = "test_so19";
      POnames[23] = "test_so20";
      POnames[24] = "test_so21";
      POnames[25] = "test_so22";
      POnames[26] = "test_so23";
      POnames[27] = "test_so24";
      POnames[28] = "test_so25";
      POnames[29] = "test_so26";
      POnames[30] = "test_so27";
      POnames[31] = "test_so28";
      POnames[32] = "test_so30";
      POnames[33] = "test_so31";
      POnames[34] = "test_so32";
      CHAINnames[0] = "1";
      CHAINnames[1] = "2";
      CHAINnames[2] = "3";
      CHAINnames[3] = "4";
      CHAINnames[4] = "5";
      CHAINnames[5] = "6";
      CHAINnames[6] = "7";
      CHAINnames[7] = "8";
      CHAINnames[8] = "9";
      CHAINnames[9] = "10";
      CHAINnames[10] = "11";
      CHAINnames[11] = "12";
      CHAINnames[12] = "13";
      CHAINnames[13] = "14";
      CHAINnames[14] = "15";
      CHAINnames[15] = "16";
      CHAINnames[16] = "17";
      CHAINnames[17] = "18";
      CHAINnames[18] = "19";
      CHAINnames[19] = "20";
      CHAINnames[20] = "21";
      CHAINnames[21] = "22";
      CHAINnames[22] = "23";
      CHAINnames[23] = "24";
      CHAINnames[24] = "25";
      CHAINnames[25] = "26";
      CHAINnames[26] = "27";
      CHAINnames[27] = "28";
      CHAINnames[28] = "29";
      CHAINnames[29] = "30";
      CHAINnames[30] = "31";
      CHAINnames[31] = "32";
      CHAINpins[0] = "test_so1";
      CHAINpins[1] = "test_so2";
      CHAINpins[2] = "test_so3";
      CHAINpins[3] = "test_so4";
      CHAINpins[4] = "test_so5";
      CHAINpins[5] = "test_so6";
      CHAINpins[6] = "test_so7";
      CHAINpins[7] = "test_so8";
      CHAINpins[8] = "test_so9";
      CHAINpins[9] = "test_so10";
      CHAINpins[10] = "test_so11";
      CHAINpins[11] = "test_so12";
      CHAINpins[12] = "test_so13";
      CHAINpins[13] = "test_so14";
      CHAINpins[14] = "test_so15";
      CHAINpins[15] = "test_so16";
      CHAINpins[16] = "test_so17";
      CHAINpins[17] = "test_so18";
      CHAINpins[18] = "test_so19";
      CHAINpins[19] = "test_so20";
      CHAINpins[20] = "test_so21";
      CHAINpins[21] = "test_so22";
      CHAINpins[22] = "test_so23";
      CHAINpins[23] = "test_so24";
      CHAINpins[24] = "test_so25";
      CHAINpins[25] = "test_so26";
      CHAINpins[26] = "test_so27";
      CHAINpins[27] = "test_so28";
      CHAINpins[28] = "debug[2]";
      CHAINpins[29] = "test_so30";
      CHAINpins[30] = "test_so31";
      CHAINpins[31] = "test_so32";
      SERIALM = 23'b00000000000000000000000;
      nofails = 0; pattern = -1; lastpattern = 0;
      prev_pat = -2; error_banner = -2;

      if (verbose >=1) $display("// %t : Begin test_setup", $time);
      ->test_setup;
      #200; // 200

      if (verbose >= 3) $display("// %t : reading pattern scan data file", $time);
      $readmemh("pat/atpg_patterns_ser.scn", memscn);
      if (verbose >= 3) $display("// %t : reading pattern PI data file", $time);
      $readmemb("pat/atpg_patterns_ser.pis", mempis);
      if (verbose >= 3) $display("// %t : reading pattern PO data file", $time);
      $readmemb("pat/atpg_patterns_ser.pos", mempos);
      if (verbose >= 3) $display("// %t : reading pattern sequencer file", $time);
      $readmemh("pat/atpg_patterns_ser.seq", memdrv);
      scn = 1; pis = 1; pos = 1; drv = 1;

      /*** Scan test ***/

      if (verbose >= 1) $display("// %t : Begin patterns, first pattern = 0", $time);
      pattern = -1; lastpattern = 0;
      while (lastpattern >=0) begin
         drval = memdrv[drv];
         if (verbose >= 5) $display("// %t : 0x%0h is %0d sequencer value",$time,drval,drv);
         drv = drv + 1;
         case (drval)
            'h0: begin pattern = pattern + 1; end
            'h1: begin lastpattern = 1; end
            'h2: lastpattern = -1; // break
            'h3: begin #0 PI = mempis[pis]; pis = pis + 1; end
            'h4: begin ALLPIS = mempis[pis]; pis = pis + 1; end
            'h5: begin XPCT = mempos[pos]; pos = pos + 1; MASK = mempos[pos]; pos = pos + 1; end
            'h6: MASK = 35'b0;
            'h7: begin
               LOAD0 = memscn[scn]; scn = scn + 1;
               LOAD1 = memscn[scn]; scn = scn + 1;
               LOAD2 = memscn[scn]; scn = scn + 1;
               LOAD3 = memscn[scn]; scn = scn + 1;
               LOAD4 = memscn[scn]; scn = scn + 1;
               LOAD5 = memscn[scn]; scn = scn + 1;
               LOAD6 = memscn[scn]; scn = scn + 1;
               LOAD7 = memscn[scn]; scn = scn + 1;
               LOAD8 = memscn[scn]; scn = scn + 1;
               LOAD9 = memscn[scn]; scn = scn + 1;
               LOAD10 = memscn[scn]; scn = scn + 1;
               LOAD11 = memscn[scn]; scn = scn + 1;
               LOAD12 = memscn[scn]; scn = scn + 1;
               LOAD13 = memscn[scn]; scn = scn + 1;
               LOAD14 = memscn[scn]; scn = scn + 1;
               LOAD15 = memscn[scn]; scn = scn + 1;
               LOAD16 = memscn[scn]; scn = scn + 1;
               LOAD17 = memscn[scn]; scn = scn + 1;
               LOAD18 = memscn[scn]; scn = scn + 1;
               LOAD19 = memscn[scn]; scn = scn + 1;
               LOAD20 = memscn[scn]; scn = scn + 1;
               LOAD21 = memscn[scn]; scn = scn + 1;
               LOAD22 = memscn[scn]; scn = scn + 1;
               LOAD23 = memscn[scn]; scn = scn + 1;
               LOAD24 = memscn[scn]; scn = scn + 1;
               LOAD25 = memscn[scn]; scn = scn + 1;
               LOAD26 = memscn[scn]; scn = scn + 1;
               LOAD27 = memscn[scn]; scn = scn + 1;
               LOAD28 = memscn[scn]; scn = scn + 1;
               LOAD29 = memscn[scn]; scn = scn + 1;
               LOAD30 = memscn[scn]; scn = scn + 1;
               LOAD31 = memscn[scn]; scn = scn + 1;
                 end
            'h8: begin
               UNLOAD[0] = memscn[scn]; scn = scn + 1;
               UNLMSK[0] = memscn[scn]; scn = scn + 1;
               UNLOAD[1] = memscn[scn]; scn = scn + 1;
               UNLMSK[1] = memscn[scn]; scn = scn + 1;
               UNLOAD[2] = memscn[scn]; scn = scn + 1;
               UNLMSK[2] = memscn[scn]; scn = scn + 1;
               UNLOAD[3] = memscn[scn]; scn = scn + 1;
               UNLMSK[3] = memscn[scn]; scn = scn + 1;
               UNLOAD[4] = memscn[scn]; scn = scn + 1;
               UNLMSK[4] = memscn[scn]; scn = scn + 1;
               UNLOAD[5] = memscn[scn]; scn = scn + 1;
               UNLMSK[5] = memscn[scn]; scn = scn + 1;
               UNLOAD[6] = memscn[scn]; scn = scn + 1;
               UNLMSK[6] = memscn[scn]; scn = scn + 1;
               UNLOAD[7] = memscn[scn]; scn = scn + 1;
               UNLMSK[7] = memscn[scn]; scn = scn + 1;
               UNLOAD[8] = memscn[scn]; scn = scn + 1;
               UNLMSK[8] = memscn[scn]; scn = scn + 1;
               UNLOAD[9] = memscn[scn]; scn = scn + 1;
               UNLMSK[9] = memscn[scn]; scn = scn + 1;
               UNLOAD[10] = memscn[scn]; scn = scn + 1;
               UNLMSK[10] = memscn[scn]; scn = scn + 1;
               UNLOAD[11] = memscn[scn]; scn = scn + 1;
               UNLMSK[11] = memscn[scn]; scn = scn + 1;
               UNLOAD[12] = memscn[scn]; scn = scn + 1;
               UNLMSK[12] = memscn[scn]; scn = scn + 1;
               UNLOAD[13] = memscn[scn]; scn = scn + 1;
               UNLMSK[13] = memscn[scn]; scn = scn + 1;
               UNLOAD[14] = memscn[scn]; scn = scn + 1;
               UNLMSK[14] = memscn[scn]; scn = scn + 1;
               UNLOAD[15] = memscn[scn]; scn = scn + 1;
               UNLMSK[15] = memscn[scn]; scn = scn + 1;
               UNLOAD[16] = memscn[scn]; scn = scn + 1;
               UNLMSK[16] = memscn[scn]; scn = scn + 1;
               UNLOAD[17] = memscn[scn]; scn = scn + 1;
               UNLMSK[17] = memscn[scn]; scn = scn + 1;
               UNLOAD[18] = memscn[scn]; scn = scn + 1;
               UNLMSK[18] = memscn[scn]; scn = scn + 1;
               UNLOAD[19] = memscn[scn]; scn = scn + 1;
               UNLMSK[19] = memscn[scn]; scn = scn + 1;
               UNLOAD[20] = memscn[scn]; scn = scn + 1;
               UNLMSK[20] = memscn[scn]; scn = scn + 1;
               UNLOAD[21] = memscn[scn]; scn = scn + 1;
               UNLMSK[21] = memscn[scn]; scn = scn + 1;
               UNLOAD[22] = memscn[scn]; scn = scn + 1;
               UNLMSK[22] = memscn[scn]; scn = scn + 1;
               UNLOAD[23] = memscn[scn]; scn = scn + 1;
               UNLMSK[23] = memscn[scn]; scn = scn + 1;
               UNLOAD[24] = memscn[scn]; scn = scn + 1;
               UNLMSK[24] = memscn[scn]; scn = scn + 1;
               UNLOAD[25] = memscn[scn]; scn = scn + 1;
               UNLMSK[25] = memscn[scn]; scn = scn + 1;
               UNLOAD[26] = memscn[scn]; scn = scn + 1;
               UNLMSK[26] = memscn[scn]; scn = scn + 1;
               UNLOAD[27] = memscn[scn]; scn = scn + 1;
               UNLMSK[27] = memscn[scn]; scn = scn + 1;
               UNLOAD[28] = memscn[scn]; scn = scn + 1;
               UNLMSK[28] = memscn[scn]; scn = scn + 1;
               UNLOAD[29] = memscn[scn]; scn = scn + 1;
               UNLMSK[29] = memscn[scn]; scn = scn + 1;
               UNLOAD[30] = memscn[scn]; scn = scn + 1;
               UNLMSK[30] = memscn[scn]; scn = scn + 1;
               UNLOAD[31] = memscn[scn]; scn = scn + 1;
               UNLMSK[31] = memscn[scn]; scn = scn + 1;
                 end
            'h9: begin
               UNLMSK[0] = 23'b0;
               UNLMSK[1] = 23'b0;
               UNLMSK[2] = 23'b0;
               UNLMSK[3] = 23'b0;
               UNLMSK[4] = 23'b0;
               UNLMSK[5] = 23'b0;
               UNLMSK[6] = 23'b0;
               UNLMSK[7] = 23'b0;
               UNLMSK[8] = 23'b0;
               UNLMSK[9] = 23'b0;
               UNLMSK[10] = 23'b0;
               UNLMSK[11] = 23'b0;
               UNLMSK[12] = 23'b0;
               UNLMSK[13] = 23'b0;
               UNLMSK[14] = 23'b0;
               UNLMSK[15] = 23'b0;
               UNLMSK[16] = 23'b0;
               UNLMSK[17] = 23'b0;
               UNLMSK[18] = 23'b0;
               UNLMSK[19] = 23'b0;
               UNLMSK[20] = 23'b0;
               UNLMSK[21] = 23'b0;
               UNLMSK[22] = 23'b0;
               UNLMSK[23] = 23'b0;
               UNLMSK[24] = 23'b0;
               UNLMSK[25] = 23'b0;
               UNLMSK[26] = 23'b0;
               UNLMSK[27] = 23'b0;
               UNLMSK[28] = 23'b0;
               UNLMSK[29] = 23'b0;
               UNLMSK[30] = 23'b0;
               UNLMSK[31] = 23'b0;
                 end
            'hA: #100;
            'hB: #60;
            'hF: begin #0; ->pulse_clk; end
            'h10: begin #0; ->pulse_rst_n; end
            'h11: begin #0; ->measurePO; #0; end
            'h12: begin #0; ->forcePI_default_WFT; #0; end
            'h13: begin #0; ->measurePO_default_WFT; #0; end
            'h14: begin #0; ->force_scanin; #0; end
            'h15: begin #0; ->measure_scanout; #0; end
            'h16: begin #0; ->IDDQ; #0; end
            'h17: begin #0; ->capture; #200; end
            'h18: begin #0; ->capture_clk; #300; end
            'h19: begin #0; ->capture_rst_n; #300; end
            'h1A: begin #0; shift; #0; end
            'h1B: begin #0; ->test_setup; #200; end
            'h1C: begin #0; multiple_shift; #0; end
            'h1D: begin #0; ->load_unload; #2400; end
            'hF0: begin verbose = 0; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF1: begin verbose = 1; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF2: begin verbose = 2; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF3: begin verbose = 3; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF4: begin verbose = 4; $display("// %t : verbosity = %0d", $time, verbose); end
            'hF5: begin verbose = 5; $display("// %t : verbosity = %0d", $time, verbose); end
            default: begin $display($time, " Unrecognized code %0h", drval); $finish; end
         endcase
      end /* while */
      $display("// %t : Simulation of %0d patterns completed with %0d errors\n", $time, pattern+1, nofails);
      if (verbose >=2) $finish(2);
      /* else */ $finish(0);
   end
endmodule
