/** INCLUDE **/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>

/** DEFINE **/

#define F_CPU 3686400 //use clock generator on stk500

#define UART_BAUD 115200

#ifndef _AVR_SPI_CO_PROC_
#define _AVR_SPI_CO_PROC_
#define DDR_SPI DDRB
#define DD_MOSI PB5
#define DD_SCK PB7
#define DD_SS PB4
#define SSP PB4
#endif // _AVR_SPI_CO_PROC_

#ifndef _SPIPACK_
#define _SPIPACK_
struct spipack {
	uint8_t instr[2];
	uint8_t data[4];
};
#endif // _SPIPACK_

#ifndef _SPI_CMD_
#define _SPI_CMD_
//CPU instructions
#define  NOP        0
#define  WRITE      4
#define  READ       8
#define  WRITESREG  12
#define  READSREG   16
#define  MOV        20
#define  ADD        32
#define  ADC        36
#define  SUB        40
#define  SBC        44
#define  MUL        48
#define  DIV        52
#define  MAC        56
#define  LSL        68
#define  LSR        72
#define  ROL        76
#define  ROR        80
#define  AND        84
#define  OR         88
#define  XOR        92
#define  INV        96

//register addresses
#define  R0         0
#define  R1         1
#define  R2         2
#define  R3         3
#define  R4         4
#define  R5         5
#define  R6         6
#define  R7         7
#define  RX         0
#endif // _SPI_CMD_


/** Prototypes **/
