module testdut(/*AUTOARG*/
   // Outputs
   scan_outputs, 
   // Inputs
   sys_clk, rst_n, scan_en, scan_inputs
   );

   `include "chip_params.v"

   //outputs
   output [NUM_SCAN_CHAINS-1:0] scan_outputs;
   
   //inputs
   input 			sys_clk;
   input 			rst_n;
   input 			scan_en;
   input [NUM_SCAN_CHAINS-1:0] 	scan_inputs;

   /*AUTOREG*/
   // Beginning of automatic regs (for this module's undeclared outputs)
   // End of automatics

   /*AUTOWIRE*/
   // Beginning of automatic wires (for undeclared instantiated-module outputs)
   // End of automatics

   reg [NUM_SCAN_CHAINS-1:0] 	scanchains[LEN_SCAN_CHAINS-1:0];
	  
   integer 		       i;

   assign 		       scan_outputs = scanchains[LEN_SCAN_CHAINS-1];
   
   
   always @ (posedge sys_clk or negedge rst_n)
     begin
	if (rst_n == 1'b0)
	  begin
	     for (i = 0; i < LEN_SCAN_CHAINS; i = i + 1)
	       scanchains[i] <= {{NUM_SCAN_CHAINS}{1'b0}};
	  end
	else
	  begin
	     if (scan_en == 1'b1)
	       for (i = 0; i < LEN_SCAN_CHAINS; i = i + 1)
		 if (i == 0)
		   scanchains[i] <= scan_inputs;
		 else
		   scanchains[i] <= scanchains[i-1];
	     else
	       for (i = 0; i < LEN_SCAN_CHAINS; i = i + 1)
		 scanchains[i] <= scanchains[i] + 1;
	  end // else: !if(rst_n == 1'b0)
     end // always @ (posedge clk)

endmodule // testdut


